   // DicsData.cpp: implementation of the CDicsDataBase class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Dics.h"
#include "DicsDataBase.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// General information.
void CGenInfo::ClearInfo()
{
	bAuto			= TRUE;				// 1 : Auto, 0 : Manual (Navigation Button)
	bCleanOut		= FALSE;			// 1 : Clean out, 0 : Normal;
	bCycleStop		= FALSE;			// Cycle Stop (Command Button)
	bPause			= FALSE;			// Pause (Command Button)
	bUlTimeOut      = FALSE;
	bUlNotReady     = FALSE;
	bAkInterlock	= FALSE;
	bIdleRunning	= FALSE;			// Idle Running (Yes / No)
	bEqpInitReq		= FALSE;
	bEqpInitComp	= FALSE;
	bEmo			= FALSE;
	bCoverOpen		= FALSE;
	bDoorOpen		= FALSE;
	bLdDoorOpen		= FALSE;
	bUlDoorOpen		= FALSE;
	bSaftyDoorOpen	= FALSE;
	bLeakSensor		= FALSE;
	bAreaSensor		= FALSE;
	bIonizerAlarm	= FALSE;
	bFfuAlarm		= FALSE;
	bSbjStop        = FALSE; 
	bEnableCommLog	= FALSE;		// Log Option in DicsView List box
	bEnableEqpLog	= FALSE;		// Log Option in DicsView List box
	bRecipeBodyChanged = FALSE;
	bLdUnitGlassStart = FALSE;
	bDirectRecv		= FALSE;
	nTotalGlassNo	= 0;			// Historical glass number
	nGlassNo		= 0;			// Equipment Glass Number
	nJobMode		= 0;			// 1 : Pass Mode, 0 ; Normal (Command Button)
	nRealTactTime	= 0;	
	nMaxEqpGlassNo	= 0;
	sRecipeId		= "";			// Using Recipe No, pDoc->m_sRecipeNo : Use for DB
	nRecipeId       = 0; //JUN_RESUME
	sOpId			= "TEST";
	bDiECO			= FALSE;	// 240730 halesu
	bAkECO			= FALSE;	// 240730 halesu
}

// Apply to whole equipment.
void CEqpInfo::ClearInfo()
{
	for( int i = 0; i < MAX_EQP_STATE_NO; i++ )
		nLdState[i] = nEqpState[i] = 0;		// Run, Stop, Idle, Down, Pause, Alarm, Warning, Warning To Much
	nUnitNo				= 0;
	cEqpState			= 'I';				// modeRUN = 'R', modeIDLE = 'I', modeDOWN = 'D'
	cLdState			= 'I';				// modeRUN = 'R', modeIDLE = 'I', modeDOWN = 'D'
	cCtlMode			= 'F';				// 'F' : Offline, 'L' : Online Local, 'R' : Online Remote
	cTrsMode			= CPortInfo::modeAGV;
	cOpMode				= '1';				// opNORMAL = '1', opRECOVERY = '3', opPARTICLE = '6'

	for( i = 0 ; i < MAX_GLS_EXIST_SENSOR_NO; i++ )
	{
		fSensorOnScore[i]  = 1.0;
		fSensorOffScore[i] = 1.0;
	}
}

// Pump
void CIfPump::ClearInfo()
{
	bDiStart = FALSE;
	for( int i=0; i<MAX_CHEMICAL_TYPE_NO; i++ ) bChemicalStart[i] = FALSE;
}

// EUV
void CIfEuv::ClearInfo()
{
	bLampOnComp	= FALSE;
	bLampOnFail	= FALSE;
	bLampAlarm  = FALSE;
	bLampPause  = FALSE;
	bEuvUtilAlarm = FALSE;//2008.08.26 kimgun
	for( int i=0; i<MAX_LAMP_NO; i++ ) 
	{
		nLampOnTime[i]		 		= 0;
	}

	for( i=0; i<MAX_LAMP_INTENSITY_NO; i++ ) 
	{
		nLampIntensity[i]			= 0;
		bLampIntensityCheckReq[i]	= 0;
		bLampIntensityCheckComp[i]	= 0;
		bLampIntensityCheckFail[i]	= 0;
		fLampIntensity[i]			= 0.0;
	}
}

// 
void CIfHpmj::ClearInfo()
{

}

// BROKEN SCAN 
void CIfScan::ClearInfo()
{
	for( int i=0; i<MAX_SCAN_NO; i++) 
	{
		bGlassBroken[i] = FALSE;
		sStatus[i]		 = "";
	}
}

void CSeqFlag::ClearInfo()
{
	for( int i=0; i<MAX_CV_NO; i++ )
	{
		bCvStop[i + IF_UNIT_LD] = FALSE;
		for( int j=0; j<MAX_STOP_COUNT_NO; j++ )
		{
			nRollerState[j][i + IF_UNIT_LD]		= CDicsCvSeq::cvSTOP;
			nRollerStateAll[j][i + IF_UNIT_LD]	= CDicsCvSeq::cvSTOP;
			bSeqStopState[j][i + IF_UNIT_LD]	= FALSE;
		}
	}

	// Clear the m_SeqFlag structure
	bInitServo			= FALSE;
	bSemiAutoMove		= FALSE;
	bServoMove			= FALSE;

	bTimeOver			= TRUE;
	bStopCount1			= FALSE;
	bStopCount2			= FALSE;
	bGlassOutComp1		= FALSE;
	bGlassOutComp2		= FALSE;
	bGlassGetComp       = FALSE;
	bUlUnitRecvReady    = FALSE;
	bUlHandAlarm		= FALSE; 
	bPreRecvReady       = FALSE;
	bUlTiltUpReady		= FALSE;	// 091221 halesu
	bUnloadProcess		= FALSE;	// 110824 halesu

}

// interface flag
void CIfUnit::ClearInfo()
{
	bInReady				= FALSE;
	bOutReady				= FALSE;
	bInComp					= FALSE;
	bOutComp				= FALSE;
	bWaitPos				= FALSE;
	bInError				= FALSE;
	bOutError				= FALSE;
	bSeqStop				= FALSE;
	bInSick					= FALSE; 
	bOutSick				= FALSE; 
	bSubInSick				= FALSE; 
	bSubOutSick				= FALSE; 
	bInLogicCheckIgnore		= FALSE;
	bOutLogicCheckIgnore	= FALSE;
	bRecoveryReq			= FALSE;

	bRecvReady				= FALSE; 
	bSendReady				= FALSE; 
	bRecvComp				= FALSE; 
	bSendComp				= FALSE; 
	bRecvPosComp			= FALSE; 
	bSendPosComp			= FALSE; 
}

void CJobCond::ClearInfo()
{
	nTactTime = 0;
	nCvSpeed = 0;
	nInCvSpeed = 0;
	nOutCvSpeed = 0;
	bJobProcessUse = FALSE;
	for( int i=0; i<MAX_RB_NO; i++ )
	{
		bRbUse[i] = FALSE;
		nRbSpeed[i] = 0;
		bRbDir[i] = FALSE;
	}

	for( i = 0 ; i < MAX_CV_NO ; i ++ )
	{
		for( int j = 0 ; j < maxSPEED_TYPE ; j ++ )
		{
			nCvSpeedSet[i][j] = 0;
		}
	}
	
	for( i=0; i<MAX_RB_GAP_SERVO_NO; i++ ) dRbGap[i] = 0.0;
	
	for( i=0; i<MAX_LAMP_CONTROL_NO; i++ ) bEuvUse[i] = FALSE;
}

// CIM Interface.
void CIfCimInfo::ClearInfo()
{
	bRcpCheckMode			= FALSE;
	bGlassDataCheckMode		= FALSE;
	bGlassDataChekResultOk  = FALSE;
	bInlineMode				= FALSE;
	nHostStatus				= -1;
	nUpStreamStatus			= -1;
	nDnStreamStatus			= -1;
	bMelsecParaChangeReq	= TRUE; 
	bTimeCalReq				= FALSE;
	bRecipeDeleteReq		= FALSE;
	bRecipeDeleteReply		= FALSE;
	nDeleteRecipeNo			= 0; 
	bRecipeBodyChangeReq	= FALSE;
	nChangeRecipeId			= 0;	
	bGlassDataLostReq		= FALSE;
	bGlassDataLostReply		= FALSE;
	nLostUnitNo				= 0;
	nRecoveryUnitNo			= 0;
	nRecoveryListNo			= 1;
	bGlassDataRecoveryReq	= FALSE;
	nGlassDataRecoveryReply	= 0;
	bGlassDataReq			= FALSE;
	bGlassDataReqReply		= FALSE;
	bApdReportReq			= FALSE;
	bApdReportComp			= FALSE;
	sOperatorId				= "TEST";
	bOperatorIdReport       = FALSE;
	nSelectedOpIdNo         = 0;
	sDateTime				= "";
	nAlarmId				= 0;
	nAlarmCode				= 0;
	cAlarmLevel				= 'S';
	sAlarmText				= "";
	sAlarmTime				= "";
	nAlarmUnitNo			= -1;
	bAlarmSetReq			= FALSE;
	bAlarmResetReq			= FALSE;
	bAlarmSetComp			= FALSE;
	bAlarmResetComp			= FALSE;
	cCtlMode				= 'D';	// 'D' : Offline, 'B' : Online Monitor, 'A' : Online Control
	bCtlModeChangeReq		= FALSE;
	bCtlModeChangeComp		= FALSE;
	bForceRecvCompReq		= FALSE;
	bForceRecvInitReq		= FALSE;
	bForceSendCompReq		= FALSE;
	bForceSendInitReq		= FALSE;
	nTransDataIndex			= 0;

	for( int i=0; i<2; i++)
		bTransDataReport[i]	= FALSE;
	for( i=0; i<MAX_PORT_NO; i++ )
	{
		bKeyInCstIdComp[i]		= FALSE;
	}
}

// Loader Sequence Interface.
void CIfLoaderInfo::ClearInfo()
{
	for( int i=0; i<MAX_PORT_NO; i++ )
	{
		cPortMode[i]			= CPortInfo::modeENABLE;
		bPortModeChangeReq[i]	= FALSE;
		bPortModeChangeComp[i]	= FALSE;
		cTrsMode[i]				= CPortInfo::modeAGV;
		bTrsModeChangeReq[i]	= FALSE;
		bTrsModeChangeLoaderReq[i] = FALSE;
		bTrsModeChangeComp[i]	= FALSE;
		bLdReq[i]				= FALSE;
		bLdComp[i]				= FALSE;
		bUlReq[i]				= FALSE;
		bUlComp[i]				= FALSE;
		bProcessStartReq[i]		= FALSE;
		bProcessStartComp[i]	= FALSE;
		bPortCancelReq[i]		= FALSE;
		bPortCancelComp[i]		= FALSE;
		bPortAbortReq[i]		= FALSE;
		bPortAbortComp[i]		= FALSE;
	}

	bGlassPutReq			= FALSE;
	bGlassGetReq			= FALSE;
	bGlassPutComp			= FALSE;
	bGlassGetComp			= FALSE;
	bScrapReq				= FALSE;
	nScrapPortNo			= 1;
	nScrapSlotNo			= 1;	
}

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CDicsDataBase::CDicsDataBase()
{
	CDicsApp* pApp = (CDicsApp*)AfxGetApp();

	// Port Info
	for( int i=0; i<MAX_PORT_NO; i++ )
		m_PortInfo[i].ClearPortInfo();
	// GLS_INFO
	for( i=0; i<2*MAX_IF_NO; i++ )
		m_GlsInfo[i].ClearGlassInfo();
	m_GlsInfoRecv.ClearGlassInfo();
	m_GlsInfoSend.ClearGlassInfo();
	m_GlsLotEndInfo.ClearGlassInfo();
	
	// Interface Flag Reset
	for( int j=0; j<rcvMAX_RECV_BIT_NO; j++ )
	{
		m_IfRecv.bBit[j] = FALSE;
	}
	for( j=0; j<sndMAX_SEND_BIT_NO; j++ )
	{
		m_IfSend.bBit[j] = FALSE;
	}

	// Login 
	CString szEntry;
#ifndef _MY_DEBUG
	m_LoginInfo.nCurUserLevel	= idOP;
	m_LoginInfo.sCurUserID		= "OPERATOR";
#else
	m_LoginInfo.nCurUserLevel	= idENGINEER;
	m_LoginInfo.sCurUserID		= "ENGINEER";
#endif

//-------------------------------------------------------------------------------

	m_IniConfiguration.Open("DicsInfo","GenInfo");

	i = 0;
	szEntry.Format( "VALID%02d", i );
	if( !m_IniConfiguration.GetIntValue("USER_INFO", szEntry, 0 ) )
	{
		szEntry.Format( "VALID%02d", i );
		m_IniConfiguration.GetIntValue("USER_INFO", szEntry, 1 );
//		m_LoginInfo.bIsValid[i] = TRUE;//2008.09.22 kimgun
		
		szEntry.Format( "USERID%02d", i );
		m_IniConfiguration.GetIntValue("USER_INFO", szEntry, 0 );

		m_IniConfiguration.GetStringValue("USER_INFO",szEntry, "ADMIN");
//		m_LoginInfo.sCurUserID = m_LoginInfo.sUserID[i] = "ADMIN";//2008.09.22 kimgun

		szEntry.Format( "PASS%02d", i );
		m_IniConfiguration.SetStringValue( "USER_INFO", szEntry, "111111" , TRUE);		
//		m_LoginInfo.sPassword[i] = "111111";//2008.09.22 kimgun

		szEntry.Format( "LEVEL%02d", i );
		m_IniConfiguration.SetIntValue( "USER_INFO", szEntry, idENGINEER , TRUE);	
//		m_LoginInfo.nCurUserLevel = idENGINEER;//2008.09.22 kimgun
	}

//-------------------------------------------------------------------------------
	for( i = 0 ; i < MAX_ACCOUNT_NO ; i ++ )
	{
		szEntry.Format( "VALID%02d", i );
		m_LoginInfo.bIsValid[i] = m_IniConfiguration.GetIntValue( "USER_INFO", (LPCTSTR)szEntry, 0 );
		
		szEntry.Format( "USERID%02d", i );
		m_LoginInfo.sUserID[i] = m_IniConfiguration.GetStringValue( "USER_INFO", (LPCTSTR)szEntry, "" );

		szEntry.Format( "PASS%02d", i );
		m_LoginInfo.sPassword[i] = m_IniConfiguration.GetStringValue( "USER_INFO", (LPCTSTR)szEntry, "" );

		szEntry.Format( "LEVEL%02d", i );
		m_LoginInfo.nUserLevel[i] = m_IniConfiguration.GetIntValue( "USER_INFO", (LPCTSTR)szEntry, idOP );
	}
//-------------------------------------------------------------------------------
}

CDicsDataBase::~CDicsDataBase()
{
	
}

//---------------------------------------------------------------------------
// Set the glass data => Maybe it will be called at In Unit when a glass is received.
//---------------------------------------------------------------------------
void CDicsDataBase::SetGlassData( int i, int nGlassNo )
{
	m_GlsInfo[i].bIsValid = TRUE;	// Unloading Ϸ  FALSE
	m_GlsInfo[i].bProcessed	= FALSE;

	m_GlsInfo[i].nGlassNo = nGlassNo;	
	WriteProfileGlassData( i );
}

//---------------------------------------------------------------------------
// Move the glass data
//---------------------------------------------------------------------------
void CDicsDataBase::MoveGlassData(int nFrom, int nTo)
{	
	m_GlsInfo[nTo] = m_GlsInfo[nFrom];
	DeleteGlassData( nFrom );
	WriteProfileGlassData( nTo );
	
}

//---------------------------------------------------------------------------
// Delete the flag
//---------------------------------------------------------------------------
void CDicsDataBase::DeleteGlassData(int i, BOOL bDelete)
{
	CDicsApp* pApp = (CDicsApp*)AfxGetApp();
	CString szEntry;
	CString szSection;
	szSection.Format( "GLASS DATA (%d)", i );

	if( bDelete ) m_GlsInfo[i].bIsValid = FALSE;
	else m_GlsInfo[i].bIsValid = TRUE;
	
	szEntry.Format( "bIsValid%d", i );
	m_GlsInfo[i].m_IniConfiguration.SetIntValue( szSection, szEntry, m_GlsInfo[i].bIsValid , TRUE);

//	szEntry.Format( "bIsValid%d", i );
//	pApp->WriteProfileInt( "GLS_DATA", (LPCTSTR)szEntry, m_GlsInfo[i].bIsValid );
}

//---------------------------------------------------------------------------
// Delete all the glass data from profile
//---------------------------------------------------------------------------
void CDicsDataBase::ClearGlassData()
{
	CString sEntry;
	CString szSection;
	
	for( int i=0; i<2*MAX_IF_NO; i++ )
	{
		szSection.Format( "GLASS DATA (%d)", i );
		m_GlsInfo[i].bIsValid = FALSE;
		sEntry.Format( "bIsValid%d", i );
		m_GlsInfo[i].m_IniConfiguration.SetIntValue( szSection, sEntry, 0 , TRUE);
	}
}

//---------------------------------------------------------------------------
// Save the data to profile
//---------------------------------------------------------------------------
void CDicsDataBase::WriteProfileGlassData( int i )
{
	m_GlsInfo[i].WriteProfileGlassData(i);
}

//---------------------------------------------------------------------------
// Get the glass data from profile
//---------------------------------------------------------------------------
void CDicsDataBase::GetProfileGlassData(int i)
{
	m_GlsInfo[i].GetProfileGlassData(i);
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void CDicsDataBase::ClearPortInfo( int i )
{
	m_PortInfo[i].ClearPortInfo();
}

//---------------------------------------------------------------------------
// FindGlassNo()
// Max Glass No : MAX_EQP_GLASS_NO
// We have to find the glass number which is not assigned number for the current glasses.
//---------------------------------------------------------------------------
int CDicsDataBase::FindGlassNo()
{
	for( int i=0; i<MAX_EQP_GLASS_NO; i++ )
	{
		for( int j=0; j<2*MAX_UNIT_NO; j++ )
		{
			if( m_GlsInfo[j%2 + (j/2)*2].bIsValid )
			{
				if( i == m_GlsInfo[j%2 + (j/2)*2].nGlassNo ) break;
			}
		}
		if( j == 2 * MAX_UNIT_NO ) break;
	}

	if( i == MAX_EQP_GLASS_NO )
	{
		i = m_GlsInfo[0].nGlassNo;
	}
	return i;
}

//---------------------------------------------------------------------------
//----- User ID & Password
//---------------------------------------------------------------------------
// AddUser(int nLevel, CString sID, CString sPassword)
//---------------------------------------------------------------------------
BOOL CDicsDataBase::AddUser(int nLevel, CString sID, CString sPassword)
{
	CDicsApp* pApp = (CDicsApp*)AfxGetApp();
	CString szEntry;
	
	if( sID.GetLength() == 0 ) return FALSE;
	
	for( int i = 0 ; i < MAX_ACCOUNT_NO ; i ++ )
	{
		if( sID == m_LoginInfo.sUserID[i] ) 
		{
			szEntry.Format( "ID : %s Exist Already", sID );
			AfxMessageBox( (LPCTSTR)szEntry );
			return FALSE;
		}
	}

	for( i = 0 ; i < MAX_ACCOUNT_NO ; i ++ )
	{
		if( !m_LoginInfo.bIsValid[i] ) break;
	}
	if ( i == MAX_ACCOUNT_NO ) return FALSE;

	// Default arguments
	
	szEntry.Format( "VALID%02d", i );
	m_IniConfiguration.SetIntValue( "USER_INFO", szEntry, 1 , TRUE);
	m_LoginInfo.bIsValid[i] = TRUE;
	
	szEntry.Format( "USERID%02d", i );
	m_IniConfiguration.SetStringValue( "USER_INFO", (LPCTSTR)szEntry, (LPCTSTR)sID , TRUE);
	m_LoginInfo.sCurUserID = m_LoginInfo.sUserID[i] = sID;

	// Default arguments
	szEntry.Format( "PASS%02d", i );
	m_IniConfiguration.SetStringValue( "USER_INFO", (LPCTSTR)szEntry, (LPCTSTR)sPassword , TRUE);	
	m_LoginInfo.sPassword[i] = sPassword;

	szEntry.Format( "LEVEL%02d", i );
	m_IniConfiguration.SetIntValue( "USER_INFO", (LPCTSTR)szEntry, nLevel , TRUE);	
	m_LoginInfo.nUserLevel[i] = nLevel;
	
	return TRUE;
}

//---------------------------------------------------------------------------
// RemUser(CString sID, CString sPassword)
//---------------------------------------------------------------------------
BOOL CDicsDataBase::RemUser(CString sID, CString sPassword)
{
	for( int i = 0 ; i < MAX_ACCOUNT_NO ; i ++ )
	{
		if( sID == m_LoginInfo.sUserID[i] )
		{
			if( sPassword != m_LoginInfo.sPassword[i] )
				return FALSE;
		}
	}
	if( i == MAX_ACCOUNT_NO ) return FALSE;

	CDicsApp* pApp = (CDicsApp*)AfxGetApp();
	CString szEntry;
	
	szEntry.Format( "VALID%02d", i );
	m_IniConfiguration.SetStringValue( "USER_INFO", (LPCTSTR)szEntry, 0 , TRUE);	
	m_LoginInfo.bIsValid[i] = FALSE;

	return TRUE;
}

//---------------------------------------------------------------------------
// Login(CString sID, CString sPassword)
//---------------------------------------------------------------------------
BOOL CDicsDataBase::Login(CString sID, CString sPassword)
{	
	CString sBuf;
	CDicsApp* pApp = (CDicsApp*)AfxGetApp();
	CString szEntry;

	if( sID.GetLength() == 0 ) return FALSE;

	if( sID == "ADMIN" )
	{
		sBuf = m_IniConfiguration.GetStringValue("PASSWORD",(LPCTSTR)sID, "654321"); 
		if( sPassword == sBuf || sPassword == "DMS21" || sPassword == "dms21" ) 
		{
			m_LoginInfo.nCurUserLevel = idADMIN;
			m_LoginInfo.sCurUserID.Format( "%s", sID );
			return TRUE;
		}
		else return FALSE;	
	}
	else if( sID == "ENGINEER" )
	{
		sBuf = m_IniConfiguration.GetStringValue("PASSWORD",(LPCTSTR)sID, "654321"); 
		if( sPassword == sBuf || sPassword == "DMS21" || sPassword == "dms21" ) 
		{
			m_LoginInfo.nCurUserLevel = idENGINEER;
			m_LoginInfo.sCurUserID.Format( "%s", sID );
			return TRUE;
		}
		else return FALSE;
	}
	else if( sID == "MAINT" )
	{
		sBuf = m_IniConfiguration.GetStringValue("PASSWORD",(LPCTSTR)sID, "111111");
		
		if( sPassword == sBuf || sPassword == "DMS21" || sPassword == "dms21" ) 
		{
			m_LoginInfo.nCurUserLevel = idMAINT;
			m_LoginInfo.sCurUserID.Format( "%s", sID );
			return TRUE;
		}
		else return FALSE;
	}
	else if( sID == "OPERATOR" )
	{
		m_LoginInfo.nCurUserLevel = idOP;
		m_LoginInfo.sCurUserID.Format( "%s", sID );
		return TRUE;
	}
	return FALSE;
}

//---------------------------------------------------------------------------
// ChangePassword(CString sID, CString sPassword)
//---------------------------------------------------------------------------
void CDicsDataBase::ChangePassword(CString sID, CString sPassword)
{
	m_IniConfiguration.Open("DicsInfo","GenInfo");
	CString sBuf;
	CDicsApp* pApp = (CDicsApp*)AfxGetApp();
	CString szEntry;

	if( sID.GetLength() == 0 ) return;
	
	if( sID == "ADMIN" )
	{

		m_IniConfiguration.SetStringValue( "PASSWORD", (LPCTSTR)sID, (LPCTSTR)sPassword , TRUE);	
	}
	else if( sID == "ENGINEER" )
	{
		m_IniConfiguration.SetStringValue( "PASSWORD", (LPCTSTR)sID, (LPCTSTR)sPassword , TRUE);	
	}
	else if( sID == "MAINT" )
	{
		m_IniConfiguration.SetStringValue( "PASSWORD", (LPCTSTR)sID, (LPCTSTR)sPassword , TRUE);	
	}
}

void CDicsDataBase::ResetUpStreamIF()
{
	// Interface Flag Reset
	for( int j=0; j<rcvMAX_RECV_BIT_NO; j++ )
	{
		m_IfRecv.bBit[j] = FALSE;
	}
}

void CDicsDataBase::ResetDnStreamIF()
{
	for( int j=0; j<sndMAX_SEND_BIT_NO; j++ )
		m_IfSend.bBit[j] = FALSE;
}
CTraceData::CTraceData( )
{
	uTraceId			= 0;
	dSamplePeriod		= 0.0;
	uSampleCommand		= 0;
	uSampleNo			= 0;
	uGroupSize			= 0;
	nS2F23ListSize		= 0;
	bTraceDataStartReq	= FALSE;
	bTraceDataStopReq	= FALSE;
	bTraceDataReportReq = FALSE;
	for( int i = 0; i < MAX_TRACE_DATA_NO; i++ )
	{
		nTraceList[MAX_TRACE_DATA_NO] = 0;
	}
//	m_nTotalSample		= 0;
//	m_nReportGroupSize	= 0;
//	m_nSvCnt			= 0;
//	m_nSampleCnt		= 0;
//	m_nGroupCnt			= 0;

//	m_pSvId				= NULL;
//	m_pSvVal			= NULL;
}

CTraceData::~CTraceData( )
{
/*	if( m_pSvId ) delete []m_pSvId;
	if( m_pSvVal)
	{
		for( int i = 0 ; i < m_nReportGroupSize ; i++ )
		{
			delete []m_pSvVal[i];
		}
	}
	delete m_pSvVal; */
}
