// DicsView.cpp : implementation of the CDicsView class
//

#include "stdafx.h"
#include "Dics.h"

#include "DicsDoc.h"
#include "DicsView.h"
#include "View\SetupView.h"
#include "Dlg\DlgEditCstId.h"
#include "MainFrm.h"
#include "Dlg\DlgEditCstId.h"
#include "Dlg\DlgSetCurPos.h"
#include "Dlg\CimTestDlg.h"
#include "Dlg\DlgLoaderTest.h"
#include "Dlg\DlgOpCall.h"

#include "SplashWindow.h"

//#include "DlgLostGlassList.h"
#include "Database\DaoLostGlassSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDicsView

IMPLEMENT_DYNCREATE(CDicsView, CFormView)

BEGIN_MESSAGE_MAP(CDicsView, CFormView)
	//{{AFX_MSG_MAP(CDicsView)
	ON_WM_DESTROY()
	ON_WM_CREATE()
	ON_WM_RBUTTONDOWN()
	ON_WM_TIMER()
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_CHECK_COMM_LOG, OnCheckCommLog)
	ON_BN_CLICKED(IDC_CHECK_EQP_LOG, OnCheckEqpLog)
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
	ON_MESSAGE( WM_SETUP_VIEW, OnSetupView )
	ON_MESSAGE( WM_DEVICENET_MONITOR, OnDevicenetMonitor )
	ON_MESSAGE( WM_SEL_CHANGE_TAB, OnSelChangeTab )
	ON_MESSAGE( WM_JOBS_VIEW_SELECT_TAB, OnSelectTab )
	ON_MESSAGE( WM_EQP_LOG, OnEqpLog )
	ON_MESSAGE( WM_HOST_LOG, OnHostLog )
	ON_MESSAGE( WM_ALARM, OnAlarm )
	ON_MESSAGE( WM_TACT_TIME, OnTactTime )
	ON_MESSAGE( WM_GLASS_NO, OnGlassNo )
	ON_MESSAGE( WM_SET_RECIPE, OnSetRecipe )
	ON_MESSAGE( WM_EQP_MESSAGE, OnEqpMessage )
	ON_MESSAGE( WM_JOBS_VIEW, OnJobsView )
	ON_MESSAGE( WM_EDIT_CSTID_INFO, OnEditCstIdInfo )
	ON_MESSAGE( WM_DIW_IDLE_RUNNING_PROGRESS, OnIdleRunningProgress )
	ON_MESSAGE( WM_EUV_ON_PROGRESS, OnEuvOnProgress )
	ON_MESSAGE( WM_AI1_VALUE, OnAIValue )
	ON_MESSAGE( WM_INIT_STATUS, OnInitStatus )
	ON_MESSAGE( WM_LOST_GLASS_ADD, OnLostGlassAdd )
	ON_MESSAGE( WM_LOST_GLASS_RECOVERY, OnLostGlassRecovery )
	ON_MESSAGE( WM_EUV_COMM, OnEuvComm )
	ON_MESSAGE( WM_SECS_MSG, OnSecsMsg )
	ON_MESSAGE( WM_SOCKET_OPEN, OnSocketOpen )
	ON_MESSAGE( WM_SOCKET_OPEN1, OnSocketOpen1 )
	ON_MESSAGE( WM_TEST_MODE_SET, OnTestModeSet )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDicsView construction/destruction

CDicsView::CDicsView()
	: CFormView(CDicsView::IDD)
{
	//{{AFX_DATA_INIT(CDicsView)
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_pCimSeq			= NULL;
	m_pCimSeq1			= NULL;
	m_pMainSeq			= NULL;
	m_pEqpStateSeq		= NULL;
	m_pPumpSeq			= NULL;
	m_pEuvSeq			= NULL;
	m_pCvSeq			= NULL;
	m_pCvSeq1			= NULL;
	m_pTrSeq			= NULL;
	m_pIfSeq			= NULL;
	m_pCommonIntrSeq	= NULL;
	m_pGaugeIntrSeq		= NULL;
	m_pRbSeq			= NULL;
	m_pScanSeq          = NULL;

	m_pHost				= NULL;	
	m_pSocketSeq		= NULL;
	m_pPlasmaSeq		= NULL;
	m_pHpmjSeq			= NULL;
	m_pHostSFLog		= NULL;
	m_pHostLoadSDFLog	= NULL;
	m_pHostHexLog		= NULL;

	m_pHost1			= NULL;
	m_pHost1SFLog		= NULL;
	m_pHost1LoadSDFLog	= NULL;
	m_pHost1HexLog		= NULL;

	m_pTimer			= NULL;
	m_pDevice			= NULL;

	m_pMelsec			= NULL;

	m_pDlgInitStatus	= NULL;
	m_pDlgEditStatus	= NULL;

	m_pDicsData			= NULL;
	m_pMmc				= NULL;
	m_pGlassAni			= NULL;

	m_pEqpAssy			= NULL;
//	m_pAI1				= NULL;

	m_pTabJobsMainView			= NULL;
//	m_pTabJobsCimView			= NULL;
	m_pTabJobsInterfaceView		= NULL;
//	m_pTabJobsLoaderView		= NULL;
	m_pTabJobsPipingView		= NULL;
	m_pTabJobsEuvStatusView		= NULL;
//	m_pTabJobsApStatusView		= NULL;
//	m_pTabJobHpmjStatusView		= NULL;
	m_pTabJobsProcessDataView	= NULL;

	m_bStartCount		= FALSE;
	m_nTactTime			= 0;
	m_nSelectedTab		= 0;

	m_nUserChangeTime   = 0;

	m_pntCurPos.x		= 0;
	m_pntCurPos.y		= 0;
//	m_pCommVCR  = NULL;
	m_pCommEuv = NULL;
	m_pFlowCtrl = NULL;
}

CDicsView::~CDicsView()
{
	GetDocument()->SetDicsView( NULL );
}

void CDicsView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDicsView)
	DDX_Control(pDX, IDC_HOST_LOG, m_listHostLog);
	DDX_Control(pDX, IDC_ERROR_LIST, m_listError);
	DDX_Control(pDX, IDC_EQP_LOG, m_listEqpLog);
	DDX_Control(pDX, IDC_TAB_JOBS, m_tabCtrl);
 	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_CHECK_COMM_LOG, m_macEnableCommLog );
	DDX_Control(pDX, IDC_CHECK_EQP_LOG, m_macEnableEqpLog );
}

BOOL CDicsView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDicsView diagnostics

#ifdef _DEBUG
void CDicsView::AssertValid() const
{
	CFormView::AssertValid();
}

void CDicsView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CDicsDoc* CDicsView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDicsDoc)));
	return (CDicsDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDicsView message handlers

//--------------------------------------------------------------------------------
// OnDestroy
// MainSequence EqpStateSeq, XCtlDevicenet Thread ϰ 
// ==> MainSequence ̰, EqpStateSeq δ.
// ׷ EqpStateSeq XCtlDevicenet Thread ϰ ֱ 
// EqpStateSeq  ̰ XCtlDevicenet Thread ׿ Ѵ.
//--------------------------------------------------------------------------------
void CDicsView::OnDestroy() 
{
	Log.TextOut( "APP \t-\t-\t\t\t----------------------------------------------------------", XLog::stampDateTime );
	Log.TextOut( "APP \t-\t-\t\t\t"_TITLE, XLog::stampDateTime );
	Log.TextOut( "APP \t-\t-\t\t\t----------------------------------------------------------", XLog::stampDateTime );

	CFormView::OnDestroy();

	m_pEqpAssy->m_TimerStart.Set(0, OFF); // halesu


	KillTimer( TIMER_TACT_TIME );
	KillTimer( TIMER_USER_CHECK );
	KillTimer( TIMER_CURSOR_CHECK );
	KillTimer( TIMER_UPDATE_VIEW );
	KillTimer( TIMER_COMM_FLOW_METER );
//	KillTimer( TIMER_SOCKET_OPEN );


	CSplashWnd * pSplashWnd = new CSplashWnd(IDB_BITMAP_SPLASH_END,1000);
#ifndef _MY_DEBUG
	pSplashWnd->Create();
#endif
	
	if( m_pDlgInitStatus ) 
	{
//		if( m_pDlgInitStatus->IsWindowVisible() ) 
		m_pDlgInitStatus->DestroyWindow();
	}

	if( m_pHpmjSeq )
	{
		m_pHpmjSeq->Kill();
		delete m_pHpmjSeq;
	}

	if( m_pIfSeq )
	{
		m_pIfSeq->Kill();
		delete m_pIfSeq;
	}
	
	if( m_pScanSeq )
	{
		m_pScanSeq->Kill();
		delete m_pScanSeq;
	}
	//2008.12.01 kimgun memory leak cvseq ġ 
	if( m_pTrSeq )
	{
		m_pTrSeq->Kill();
		delete m_pTrSeq;
	}

	if( m_pCvSeq )
	{
		m_pCvSeq->Kill();
		delete m_pCvSeq;
	}
	//2008.12.01 kimgun memory leak cvseqڷ ġ 
	if( m_pPumpSeq ) 
	{
		m_pPumpSeq->Kill();
		delete m_pPumpSeq;
	}
	if( m_pCvSeq1 )
	{
		m_pCvSeq1->Kill();
		delete m_pCvSeq1;
	}

	if( m_pCimSeq ) 
	{
		m_pCimSeq->Kill();
		delete m_pCimSeq;
	}

	if( m_pCimSeq1 ) 
	{
		m_pCimSeq1->Kill();
		delete m_pCimSeq1;
	}
	 
	if( m_pSocketSeq )
	{
		m_pSocketSeq->Kill(); 
		delete m_pSocketSeq;
	}

	if( m_pSocketSeq1 )
	{
		m_pSocketSeq1->Kill(); 
		delete m_pSocketSeq1;
	}


#ifndef _NO_RB
	if( m_pRbSeq )
	{
		m_pRbSeq->Kill();
		delete m_pRbSeq;
	}
#endif
	if( m_pMainSeq ) 
	{
		m_pMainSeq->Kill();
		delete m_pMainSeq;
	}

	if( m_pCommonIntrSeq ) 
	{
		m_pCommonIntrSeq->Kill();
		delete m_pCommonIntrSeq;
	}

	if( m_pGaugeIntrSeq ) 
	{
		m_pGaugeIntrSeq->Kill();
		delete m_pGaugeIntrSeq;
	}

	if( m_pPlasmaSeq )
	{
		m_pPlasmaSeq->Kill();
		delete m_pPlasmaSeq;
	}

#ifndef _NO_EUV
	if( m_pEuvSeq ) 
	{
		m_pEuvSeq->Kill();
		delete m_pEuvSeq;
	}
#endif
	if( m_pFlowCtrl )
	{
		m_pFlowCtrl->ClosePort();
		delete m_pFlowCtrl;
	}
	
	if( m_pHost ) 
	{
		m_pHost->End();
		delete m_pHost;
	}

	if( m_pHost1 )
	{
		m_pHost1->End();
		delete m_pHost1;
	}

	if( m_pEqpStateSeq ) 
	{
		m_pEqpStateSeq->CloseAlarmItems();
		m_pEqpStateSeq->Kill();
		delete m_pEqpStateSeq;
	}
	
	if( m_pEqpAssy ) //2008.11.03 kimgun EqpStateSeq Ʒ ̵
	{
		delete m_pEqpAssy;
	}

	if( m_pTabJobsMainView ) 
	{
		m_pTabJobsMainView->SendMessage( WM_CLOSE );
		delete m_pTabJobsMainView;
	}
//	if( m_pTabJobsCimView )
//	{
//		m_pTabJobsCimView->SendMessage( WM_CLOSE );
//		delete m_pTabJobsCimView;
//	}
	if( m_pTabJobsInterfaceView ) 
	{
		m_pTabJobsInterfaceView->SendMessage( WM_CLOSE );
		delete m_pTabJobsInterfaceView;
	}
/*	if( m_pTabJobsLoaderView )
	{
		m_pTabJobsLoaderView->SendMessage( WM_CLOSE );
		delete m_pTabJobsLoaderView;
	}*/
	if( m_pTabJobsPipingView ) 
	{
		m_pTabJobsPipingView->SendMessage( WM_CLOSE );
		delete m_pTabJobsPipingView;
	}
	if( m_pTabJobsEuvStatusView ) 
	{
		m_pTabJobsEuvStatusView->SendMessage( WM_CLOSE );
		delete m_pTabJobsEuvStatusView;
	}
	if( m_pTabJobsProcessDataView ) 
	{
		m_pTabJobsProcessDataView->SendMessage( WM_CLOSE );
		delete m_pTabJobsProcessDataView;
	}

	if( m_pDevice )
	{
		m_pDevice->End();
		delete m_pDevice;
	}

	if( m_pMelsec ) 
	{
		m_pMelsec->End();
		delete m_pMelsec;
	}
	
	if( m_pMmc ) delete m_pMmc;	

	if( m_pTimer ) delete m_pTimer;
	
	if( m_pDicsData ) delete m_pDicsData; 
	// Glass Animation
	if( m_pGlassAni )
	{
		m_pGlassAni->SendMessage( WM_CLOSE );
		delete m_pGlassAni;
	}
	//2008.09.02 kimgun ġ ̵.
	if( m_pHostSFLog ) delete m_pHostSFLog;
	if( m_pHostLoadSDFLog ) delete m_pHostLoadSDFLog;
	if( m_pHostHexLog ) delete m_pHostHexLog;

	if( m_pHost1SFLog ) delete m_pHost1SFLog;
	if( m_pHost1LoadSDFLog ) delete m_pHost1LoadSDFLog;
	if( m_pHost1HexLog ) delete m_pHost1HexLog;

//	if( m_pAI1 ) delete m_pAI1;
	
//	if( m_pCommVCR )
//	{
//		m_pCommVCR->ClosePort();
//		delete m_pCommVCR;
//	}

#ifndef _NO_EUV
	if( m_pCommEuv )
	{
		m_pCommEuv->ClosePort();
		delete m_pCommEuv;
	}
#endif
	m_pCimSeq			= NULL;
	m_pCimSeq1			= NULL;
	m_pMainSeq			= NULL;
	m_pCvSeq			= NULL;
	m_pCvSeq1			= NULL;
	m_pTrSeq			= NULL;
	m_pIfSeq			= NULL;
	m_pScanSeq          = NULL;
	m_pRbSeq			= NULL;
	m_pCommonIntrSeq	= NULL;
	m_pGaugeIntrSeq		= NULL;
	m_pSocketSeq		= NULL;
	m_pSocketSeq1		= NULL;
	m_pEqpStateSeq		= NULL;
	m_pPumpSeq			= NULL;
	m_pEuvSeq			= NULL;
	m_pTimer			= NULL;
	m_pDevice			= NULL;
	m_pHost				= NULL;
	m_pHost1			= NULL;
	m_pMelsec			= NULL;
	m_pDlgInitStatus	= NULL;
	m_pDicsData			= NULL;
	m_pMmc				= NULL;
	m_pGlassAni			= NULL;
//	m_pAI1				= NULL;
//	m_pCommVCR			= NULL;
	m_pCommEuv			= NULL;
	m_pTabJobsMainView			= NULL;
//	m_pTabJobsCimView			= NULL;
	m_pTabJobsInterfaceView		= NULL;
//	m_pTabJobsLoaderView		= NULL;
	m_pTabJobsPipingView		= NULL;
	m_pTabJobsEuvStatusView		= NULL;
	m_pTabJobsProcessDataView	= NULL;

	// DB 
	GetDocument()->CloseDoc();

	// Delete Object
	DeleteObject( m_hbrBgColor );

#ifdef _CIM_SKIP
	if( m_pFileMap )
	{
		m_pFileMap->CloseFileMap();
		delete m_pFileMap;
	}	
#endif
	delete pSplashWnd;
}
#include "FactoryLib\DigitalInputs.h"
#include "FactoryLib\DigitalOutputs.h"
#include "FactoryLib\AnalogInputs.h"
#include "FactoryLib\AnalogOutputs.h"

//--------------------------------------------------------------------------------
// OnCreate : Initialize & create
//--------------------------------------------------------------------------------
int CDicsView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFormView::OnCreate(lpCreateStruct) == -1)
		return -1;

	CDicsDoc* pDoc = GetDocument();
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CMainFrame* pMainFrame = (CMainFrame*)pApp->m_pMainWnd;

#ifdef _CIM_SKIP
	m_pFileMap = new CFileMap;
	ASSERT( m_pFileMap );
	m_pFileMap->CreateFileMap();
#endif
	//----------------------------------------------------------------------------
	// Set Views
	pDoc->SetDicsView( this );

	// Create the MMC class
	m_pMmc = new XMmc;
	m_pMmc->Init();

	UINT uPointPC[] = 
	{
		0 * 4,
		0 * 4,
		0 * 4,
		0 * 4,
		0 * 4, 
	};

	// D:\ ã  Return ų°   
	m_pDevice = new XCtlDevice;
	m_Di.ReadMaxNodeSize();

	if( !m_Di.Create( m_pDevice ) ||
		!m_Do.Create( m_pDevice ) ||
		!m_Ai.Create( m_pDevice ) ||
		!m_Ao.Create( m_pDevice ) )
		return -1;

	UINT * uPointDI = m_Di.GetConfiguration();
	UINT * uPointDO = m_Do.GetConfiguration();
	UINT * uPointAI = m_Ai.GetConfiguration();
	UINT * uPointAO = m_Ao.GetConfiguration();
	
	m_pDevice->Start( this, m_Di.GetMaxNodeSize(), uPointAI, uPointAO, uPointDI, uPointDO, uPointPC );

	m_Di.SetDevice( m_pDevice );
	m_Do.SetDevice( m_pDevice );
	m_Ai.SetDevice( m_pDevice );
	m_Ao.SetDevice( m_pDevice );

	//--------------
	m_Di.m_pDi[0].SetSimulationMode( TRUE );
	//--------------

	m_pEqpAssy = new CEqpAssy(&m_Di, &m_Do, &m_Ai, &m_Ao);
	m_pEqpAssy->SetMmc( m_pMmc );
	m_pEqpAssy->SetDevice( m_pDevice );
	m_pEqpAssy->Initialize();

	// Initialize the DB
	pDoc->InitDoc();
	pDoc->m_pSetupItems->SetDevice( m_pDevice );
	pDoc->m_pSetupItems->SetEqpAssy( m_pEqpAssy );
	pDoc->m_pSetupItems->InitSetupItems();

	pDoc->m_pSetupItems->GetRegistryTabInterfaceParaView();
	pDoc->m_pSetupItems->GetRegistryTabInterfaceParaView1();

	m_pMelsec = new XCtlMelsec;
	int nSlotNo = atoi( pDoc->m_pSetupItems->m_sValueInterfacePara[CSetupItems::melsecMELSLOT_NO] );
	BOOL bRv = m_pMelsec->Start( this, nSlotNo, 0 );

	short nNetworkNo	= atoi( pDoc->m_pSetupItems->m_sValueInterfacePara[CSetupItems::melsecNETWORK_NO] );
	short nStationNo	= atoi( pDoc->m_pSetupItems->m_sValueInterfacePara[CSetupItems::melsecSTATION_NO] );
	m_pMelsec->SetMelsecParameter( nNetworkNo, nStationNo, 0, 0, 0, 0 );
	m_pMelsec->SetMelsecParameter( nNetworkNo, nStationNo, nNetworkNo, nStationNo, nNetworkNo, nStationNo );

	//----------------------------------------------------------------------------
	// Timer
 	m_pTimer = new XTimer( MAX_TIMER_NO );

	//----------------------------------------------------------------------------
	// Dics Data Create
	m_pDicsData = new CDicsData();
	m_pDicsData->m_GenInfo.sRecipeId	= GetDocument()->m_sRecipeId;

	//----------------------------------------------------------------------------
	// Glass Ani Create
	m_pGlassAni = new CGlassAni( this );

	//----------------------------------------------------------------------------
	// Host Message definition
	m_pHost = new CHost();
	m_pHost->SetData( m_pDicsData );
	m_pHost->SetEqpAssy( m_pEqpAssy );
	m_pHost->SetDicsView( this );
	m_pHost->SetDevice( m_pDevice );
	m_pHost->SetMelsec( m_pMelsec );
	m_pHost->SetSetupItems( pDoc->m_pSetupItems );
//	m_pHost->SetAI1( m_pAI1 );
	m_pHost->Start( this->GetSafeHwnd() );

	m_pHost1 = new CHost1();
	m_pHost1->SetData( m_pDicsData );
	m_pHost1->SetEqpAssy( m_pEqpAssy );
	m_pHost1->SetDicsView( this );
	m_pHost1->SetDevice( m_pDevice );
	m_pHost1->SetMelsec( m_pMelsec );
	m_pHost1->SetSetupItems( pDoc->m_pSetupItems );
//	m_pHost1->SetAI1( m_pAI1 );
	m_pHost1->Start( this->GetSafeHwnd() );
//	m_pCommVCR = new CCommVCR();
//	m_pCommVCR->OpenPort( this, "COM3", CBR_9600, 8, ONESTOPBIT, NOPARITY, 0 );
#ifndef _MY_DEBUG
	m_pFlowCtrl = new CCommFlowMeter();
	m_pFlowCtrl->OpenPort( this, "COM2", CBR_9600, 8, ONESTOPBIT, NOPARITY, 0 );
	m_pFlowCtrl->SetEqpAssy( m_pEqpAssy );
#else
	m_pFlowCtrl = new CCommFlowMeter();
	m_pFlowCtrl->OpenPort( this, "Emulate", CBR_9600, 8, ONESTOPBIT, NOPARITY, 0 );
	m_pFlowCtrl->SetEqpAssy( m_pEqpAssy );  // minhan 080922
#endif
#ifndef _NO_EUV
	// for ushio euv. EUN 070313
	m_pCommEuv = new CMuxCom;
	if( m_pCommEuv->OpenPort( this, "COM4", CBR_9600, 8, TWOSTOPBITS, NOPARITY, CMuxCom::ccETX ) < 0 )
	{
		AfxMessageBox( "Initialize Error... COM4" );
	}
#endif

	//----------------------------------------------------------------------------
	// Alarm Sequence
	m_pEqpStateSeq = new CEqpStateSequence();
	m_pEqpStateSeq->SetDevice( m_pDevice );
	m_pEqpStateSeq->SetData( m_pDicsData );
	m_pEqpStateSeq->SetMelsec( m_pMelsec );
#ifdef _CIM_SKIP
	m_pEqpStateSeq->SetFileMap( m_pFileMap );
#endif
	m_pEqpStateSeq->SetSetupItems( pDoc->m_pSetupItems );
	m_pEqpStateSeq->OpenAlarmItems();
	m_pEqpStateSeq->Start( this->GetSafeHwnd() );

#ifndef _NO_EUV
	// EUV Sequence 
	m_pEuvSeq = new CEuvSeq();
	m_pEuvSeq->SetOwnerPointer( this );
	m_pEuvSeq->SetCommEuv( m_pCommEuv );
	m_pEuvSeq->Start( this->GetSafeHwnd() );
#endif

	//----------------------------------------------------------------------------
	// Main Sequence
	m_pMainSeq = new CMainSeq();
	m_pMainSeq->SetOwnerPointer( this );
	m_pMainSeq->Start( this->GetSafeHwnd() );

	//----------------------------------------------------------------------------
	// CV Class 
	m_pCvSeq = new CCvSeq();
	m_pCvSeq->SetOwnerPointer( this );
	m_pCvSeq->Start( this->GetSafeHwnd() );

	//----------------------------------------------------------------------------
	// CV Class 
	m_pCvSeq1 = new CCvSeq1();
	m_pCvSeq1->SetOwnerPointer( this );
	m_pCvSeq1->Start( this->GetSafeHwnd() );
	m_pCvSeq1->SetHost1( m_pHost1 );

	//----------------------------------------------------------------------------
	// CV Class 
	m_pTrSeq = new CTrSeq();
	m_pTrSeq->SetOwnerPointer( this );
	m_pTrSeq->Start( this->GetSafeHwnd() );

	//----------------------------------------------------------------------------
	// I/F Class 
	m_pIfSeq = new CInterfaceSeq();
	m_pIfSeq->SetOwnerPointer( this );
	m_pIfSeq->Start( this->GetSafeHwnd() );

	//----------------------------------------------------------------------------
	// CommonInterlock Class 
	m_pCommonIntrSeq = new CCommonInterlockSeq();
	m_pCommonIntrSeq->SetOwnerPointer( this );
	m_pCommonIntrSeq->Start( this->GetSafeHwnd() );

	//----------------------------------------------------------------------------
	// GaugeInterlock Class 
	m_pGaugeIntrSeq = new CGaugeInterlockSeq();
	m_pGaugeIntrSeq->SetOwnerPointer( this );
	m_pGaugeIntrSeq->Start( this->GetSafeHwnd() );
	
#ifndef _NO_RB
	//----------------------------------------------------------------------------
	// R/B Class 
	m_pRbSeq = new CRbSeq();
	m_pRbSeq->SetOwnerPointer( this );
	m_pRbSeq->Start( this->GetSafeHwnd() );
#endif
	//----------------------------------------------------------------------------
	// Cim Sequence
	m_pCimSeq = new CCimSeq();
	m_pCimSeq->SetOwnerPointer( this );
	m_pCimSeq->SetHost( m_pHost );
	m_pCimSeq->SetHost1( m_pHost1 );
	m_pCimSeq->SetMelsec( m_pMelsec );
	m_pCimSeq->SetEqpAssy( m_pEqpAssy );
	m_pCimSeq->Start( this->GetSafeHwnd() );

	// Cim1 Sequence
	m_pCimSeq1 = new CCimSeq1();
	m_pCimSeq1->SetOwnerPointer( this );
	m_pCimSeq1->SetHost1( m_pHost1 );
	m_pCimSeq1->SetEqpAssy( m_pEqpAssy );
	m_pCimSeq1->Start( this->GetSafeHwnd() );

	//----------------------------------------------------------------------------

	//----------------------------------------------------------------------------

	// Loader Sequence
	m_pScanSeq = new CScanSequence();
	m_pScanSeq->SetOwnerPointer( this );
	m_pScanSeq->Start( this->GetSafeHwnd() );

	//----------------------------------------------------------------------------

	// Socket Sequence 
	m_pSocketSeq = new CSocketSeq();
	m_pSocketSeq->Start( this->GetSafeHwnd() );

	//----------------------------------------------------------------------------

	// Socket Sequence1 
	m_pSocketSeq1 = new CSocketSeq1();
	m_pSocketSeq1->Start( this->GetSafeHwnd() );

	//----------------------------------------------------------------------------
	// Pump Sequence
	m_pPumpSeq = new CPumpSeq();
	m_pPumpSeq->SetOwnerPointer( this );
	m_pPumpSeq->Start( this->GetSafeHwnd() );


	m_pPlasmaSeq = new CPlasmaSequence();
	m_pPlasmaSeq->SetOwnerPointer( this );
	m_pPlasmaSeq->Start( this->GetSafeHwnd() );

	m_pHpmjSeq = new CHpmjSequence();
	m_pHpmjSeq->SetOwnerPointer( this );
	m_pHpmjSeq->Start( this->GetSafeHwnd() );



	// Set Dics Data to Title Panel
	pMainFrame->m_wndTitlePanel.SetDicsData( m_pDicsData );
	pMainFrame->SetDevice( m_pDevice );		// ljy_041123
//	pMainFrame->m_wndTitlePanel.m_msgUserID.SetOpMsg( (LPCTSTR) m_pDicsData->m_LoginInfo.sCurUserID );


	pMainFrame->SetMelsec( m_pMelsec );				// ljy_050128 : add
	//----------------------------------------------------------------------------
	Log.TextOut( "APP \t+\t+\t+\t+\t+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++", XLog::stampDateTime );
	Log.TextOut( "APP \t+\t+\t+\t+\t+"_TITLE, XLog::stampDateTime );
	Log.TextOut( "APP \t+\t+\t+\t+\t+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++", XLog::stampDateTime );

	return 0;
}

//--------------------------------------------------------------------------------
// OnInitialUpdate : Initialize
//--------------------------------------------------------------------------------
void CDicsView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	ResizeParentToFit();

	CDicsDoc* pDoc = GetDocument();
	pDoc->m_pSetupItems->SetDevice( m_pDevice );
	pDoc->m_pSetupItems->SetEqpAssy( m_pEqpAssy );
	pDoc->m_pSetupItems->GetRegistryTabJobCondView();
	pDoc->m_pSetupItems->GetRegistryTabInterlockSetView();
	pDoc->m_pSetupItems->GetRegistryTabInterlockSet2View();
	pDoc->m_pSetupItems->GetRegistryTabInterfaceParaView();
//	pDoc->m_pSetupItems->GetRegistryTabHsmsParaView();
	pDoc->m_pSetupItems->GetRegistryTabInterfaceParaView1();
	pDoc->m_pSetupItems->GetRegistryTabCVDistanceSetView();
	pDoc->m_pSetupItems->GetRegistryTabCVMotorParaView();
	pDoc->m_pSetupItems->GetRegistryTabDVParaView();

	// Create the TAB view 
	CRect r;
	GetDlgItem( IDC_TAB_JOBS )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 0, 0, 6, 30 );
	
	m_pTabJobsMainView = new CJobsTabMainView( this, viewJobMain );
	CCreateContext context;
	m_pTabJobsMainView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CJobsTabMainView::IDD, &context);
	m_pTabJobsMainView->SetDevice( m_pDevice );
	m_tabCtrl.AddTab( (CWnd*) m_pTabJobsMainView, "    MAIN VIEW    ", viewJobMain );

//	m_pTabJobsCimView = new CJobsTabCimView( this, viewJobCim );
//	m_pTabJobsCimView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CJobsTabCimView::IDD, &context);
//	m_pTabJobsCimView->SetMelsec( m_pMelsec );
//	m_pTabJobsCimView->SetDevice( m_pDevice );
//	m_tabCtrl.AddTab( (CWnd*) m_pTabJobsCimView, "    CIM VIEW    ", viewJobCim );

	m_pTabJobsInterfaceView = new CJobsTabInterfaceView( this, viewJobInterface );
	m_pTabJobsInterfaceView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CJobsTabInterfaceView::IDD, &context);
	m_pTabJobsInterfaceView->SetMelsec( m_pMelsec );
	m_pTabJobsInterfaceView->SetDevice( m_pDevice );
#ifdef _CIM_SKIP
	m_pTabJobsInterfaceView->SetFileMap( m_pFileMap );
#endif
	m_tabCtrl.AddTab( (CWnd*) m_pTabJobsInterfaceView, "    INTERFACE VIEW    ", viewJobInterface );

//	m_pTabJobsLoaderView = new CJobsTabLoaderView( this, viewJobLoader );
//	m_pTabJobsLoaderView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CJobsTabLoaderView::IDD, &context);
//	m_pTabJobsLoaderView->SetMelsec( m_pMelsec );
//	m_pTabJobsLoaderView->SetDevice( m_pDevice );
//	m_tabCtrl.AddTab( (CWnd*) m_pTabJobsLoaderView, "    LOADER VIEW    ", viewJobLoader );

	m_pTabJobsPipingView = new CJobsTabPipingView( this, viewJobPiping );
	m_pTabJobsPipingView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CJobsTabPipingView::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabJobsPipingView, "    PIPING VIEW    ", viewJobPiping );

	m_tabCtrl.SetSelectedColor( RED_COLOR );
	m_tabCtrl.SetMouseOverColor( GREEN_COLOR );
	m_tabCtrl.SetNormalColor( DARK_GRAY_COLOR );

//	m_pTabJobsApStatusView = new CJobsTabApStatusView( this, viewJobAP );
//	m_pTabJobsApStatusView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CJobsTabApStatusView::IDD, &context);
//	m_tabCtrl.AddTab( (CWnd*) m_pTabJobsApStatusView, "      AP PLASMA VIEW     ", viewJobAP );	


//	m_pTabJobHpmjStatusView = new CJobsTabHpmjStatusView( this, viewJobHpmj );
//	m_pTabJobHpmjStatusView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CJobsTabHpmjStatusView::IDD, &context);
//	m_tabCtrl.AddTab( (CWnd*) m_pTabJobHpmjStatusView, "      HPMJ VIEW     ", viewJobHpmj );	

#ifndef _NO_EUV
	m_pTabJobsEuvStatusView = new CJobsTabEuvStatusView( this, viewJobEuv );
	m_pTabJobsEuvStatusView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CJobsTabEuvStatusView::IDD, &context);
	m_pTabJobsEuvStatusView->SetDevice( m_pDevice );
	m_tabCtrl.AddTab( (CWnd*) m_pTabJobsEuvStatusView, "      EUV VIEW     ", viewJobEuv );
#endif

	m_pTabJobsProcessDataView = new CJobsTabProcessDataView( this, viewJobProcess );	
	m_pTabJobsProcessDataView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CJobsTabProcessDataView::IDD, &context);
	m_pTabJobsProcessDataView->SetDevice( m_pDevice );
	m_tabCtrl.AddTab( (CWnd*) m_pTabJobsProcessDataView, "      PROCESS DATA VIEW     ", viewJobProcess );

//=======================================================================================================	
//********************* HSMS ********************************************
	GetDocument()->SetDicsView( this );

	// Set Log
	m_pHostSFLog = new XLog( "SF", XLog::stampDateTime, TRUE );	// TRUE : Append
	m_pHostLoadSDFLog = new XLog( "LoadSDF", XLog::stampDateTime, TRUE );	// TRUE : Append
	m_pHostHexLog = new XLog( "HEX", XLog::stampDateTime, TRUE );	// TRUE : Append
	m_pHost->SetLog( m_pHostSFLog, m_pHostLoadSDFLog, m_pHostHexLog );
	// HSMS initialize
	m_pHost->SetOwnerWnd( this );

	if( m_pHost->LoadLibrary( "SECS\\Hdc.sdf" ) < 0 )
	{
		CString szErrMsg = "Secs Library [SDF FILE] Loading Failed";
		AfxMessageBox( szErrMsg );
	}
	// ECV value initialize
//	m_pHost->GetECV(); //08HC06
//	m_pHost->GetCEID(); //08HC06

	// Set the initial state variables
	m_pDicsData->m_EqpInfo.cInitCommState = 
		( pDoc->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsINIT_COMM_STATE] == "ENABLE" ) ? '1' : '0';
	m_pDicsData->m_EqpInfo.cInitCtlMode	  =
		( pDoc->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsINIT_CONTROL_STATE] == "OFFLINE" ) ? '0' : \
		( pDoc->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsINIT_CONTROL_STATE] == "LOCAL" ) ? '1' : '2';

	// Automatically change : Comm. State
	m_pDicsData->m_IfCim.cCommState	= m_pDicsData->m_EqpInfo.cInitCommState;
	m_pDicsData->m_IfCim.bCommStateChangeReq = 
		( m_pDicsData->m_EqpInfo.cInitCommState == CDicsData::commENABLE ) ? TRUE : FALSE;

	// Automatically Change : Control Mode
	m_pDicsData->m_IfCim.cCtlMode = 
		( m_pDicsData->m_EqpInfo.cInitCtlMode == '1' ) ? CDicsData::modeMONITOR : \
		( m_pDicsData->m_EqpInfo.cInitCtlMode == '2' ) ? CDicsData::modeCONTROL : CDicsData::modeOFFLINE;
	m_pDicsData->m_IfCim.bCtlModeChangeReq = 
		( m_pDicsData->m_EqpInfo.cInitCtlMode != CDicsData::modeOFFLINE && m_pDicsData->m_IfCim.bCommStateChangeReq ) ? TRUE : FALSE; // minhan_081222
	m_pHost->HSMST3 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsT3] );
	m_pHost->HSMST5 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsT5] );
	m_pHost->HSMST6 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsT6] );
	m_pHost->HSMST7 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsT7] );
	m_pHost->HSMST8 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsT8] );
	m_pHost->HSMST9 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsT9] );
	m_pHost->LinkTestTimer = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsLINK_TEST_TIMER] );
	m_pHost->SetDeviceID( atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsDEVICE_ID] ) );
	m_sIpAddress = GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsIP_ADDRESS];
	m_nPortNumber = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsPORT_NUMBER] );

	if( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsCONNECTION_MODE] == "ACTIVE" )
	{
		m_pHost->m_bActiveMode = TRUE;
		m_pHost->SetRemotePortNo( m_nPortNumber );
	}
	else 
	{
		m_pHost->m_bActiveMode = FALSE;
		m_pHost->SetLocalPortNo( m_nPortNumber );

		OpenSocket( TRUE );
	}

//****************************************** HSMS1 **************************************//
	// HSMS initialize
	// Set Log
	m_pHost1SFLog = new XLog( "SF1", XLog::stampDateTime, TRUE );	// TRUE : Append
	m_pHost1LoadSDFLog = new XLog( "LoadSDF1", XLog::stampDateTime, TRUE );	// TRUE : Append
	m_pHost1HexLog = new XLog( "HEX1", XLog::stampDateTime, TRUE );	// TRUE : Append
	m_pHost1->SetLog( m_pHost1SFLog, m_pHost1LoadSDFLog, m_pHost1HexLog );

	m_pHost1->SetOwnerWnd( this );

	if( m_pHost1->LoadLibrary( "SECS\\Hdc1.sdf" ) < 0 )
	{
		CString szErrMsg = "Secs Library [SDF FILE] Loading Failed";
		AfxMessageBox( szErrMsg );
	}
	// ECV value initialize
//	m_pHost->GetECV(); //08HC06
//	m_pHost->GetCEID(); //08HC06
/*//2008.12.17 kimgun HSMS1  ʿ.
	// Set the initial state variables
	m_pDicsData->m_EqpInfo.cInitCommState1 = 
		( pDoc->m_pSetupItems->m_sValueHsmsPara1[CSetupItems::hsmsINIT_COMM_STATE] == "ENABLE" ) ? '1' : '0';
	m_pDicsData->m_EqpInfo.cInitCtlMode1	  =
		( pDoc->m_pSetupItems->m_sValueHsmsPara1[CSetupItems::hsmsINIT_CONTROL_STATE] == "OFFLINE" ) ? '0' : \
		( pDoc->m_pSetupItems->m_sValueHsmsPara1[CSetupItems::hsmsINIT_CONTROL_STATE] == "LOCAL" ) ? '1' : '2';

	// Automatically change : Comm. State
	m_pDicsData->m_IfCim.cCommState1	= m_pDicsData->m_EqpInfo.cInitCommState1;
	m_pDicsData->m_IfCim.bCommStateChangeReq1 = 
		( m_pDicsData->m_EqpInfo.cInitCommState1 == CDicsData::commENABLE ) ? TRUE : FALSE;

	// Automatically Change : Control Mode
	m_pDicsData->m_IfCim.cCtlMode1 = 
		( m_pDicsData->m_EqpInfo.cInitCtlMode == '1' ) ? CDicsData::modeMONITOR : \
		( m_pDicsData->m_EqpInfo.cInitCtlMode == '2' ) ? CDicsData::modeCONTROL : CDicsData::modeOFFLINE;
	m_pDicsData->m_IfCim.bCtlModeChangeReq = 
		( m_pDicsData->m_EqpInfo.cInitCtlMode != CDicsData::modeOFFLINE ) ? TRUE : FALSE;
*/
	m_pHost1->HSMST3 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara1[CSetupItems::hsmsT3] );
	m_pHost1->HSMST5 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara1[CSetupItems::hsmsT5] );
	m_pHost1->HSMST6 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara1[CSetupItems::hsmsT6] );
	m_pHost1->HSMST7 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara1[CSetupItems::hsmsT7] );
	m_pHost1->HSMST8 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara1[CSetupItems::hsmsT8] );
	m_pHost1->HSMST9 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara1[CSetupItems::hsmsT9] );
	m_pHost1->LinkTestTimer = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara1[CSetupItems::hsmsLINK_TEST_TIMER] );

	m_pHost1->SetDeviceID( atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara1[CSetupItems::hsmsDEVICE_ID] ) );
	m_sIpAddress1 = GetDocument()->m_pSetupItems->m_sValueHsmsPara1[CSetupItems::hsmsIP_ADDRESS];
	m_nPortNumber1 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara1[CSetupItems::hsmsPORT_NUMBER] );

	if( GetDocument()->m_pSetupItems->m_sValueHsmsPara1[CSetupItems::hsmsCONNECTION_MODE] == "ACTIVE" )
	{
		m_pHost1->m_bActiveMode = TRUE;
		m_pHost1->SetRemotePortNo( m_nPortNumber1 );
	}
	else 
	{
		m_pHost1->m_bActiveMode = FALSE;
		m_pHost1->SetLocalPortNo( m_nPortNumber1 );
		OpenSocket1( TRUE );
	}
//**************************************************************************************//

	// Create Solid Brush
	m_hbrBgColor.CreateSolidBrush( LIGHT_YELLOW_COLOR );

	////////////////////////////////////////////////////////////////////////
	// Invisible : all glasses
	for( int i=0; i<MAX_GLASS_NO; i++ ) m_pGlassAni->InitGlassMove( i, 1 );
	
	// Move Unit Position Set
	for( i=0; i<MAX_RBT_ANI_NO; i++ ) m_pGlassAni->InitRbtMove( i, 1 );

	// Log Display
	m_macEnableCommLog.SetCheck( m_pDicsData->m_GenInfo.bEnableCommLog );
	m_macEnableEqpLog.SetCheck( m_pDicsData->m_GenInfo.bEnableEqpLog );

	// For tact time
	// Sequence Run
	// Job1View ϷǸ RunѴ.
}

void CDicsView::SetSeqStart()
{
	m_pMainSeq->SetRecipe2JobCond( m_pDicsData->m_GenInfo.sRecipeId );

	m_pMainSeq->SetSeqRun();
	m_pCvSeq->SetSeqRun();
	m_pCvSeq1->SetSeqRun();
	m_pTrSeq->SetSeqRun();
	m_pIfSeq->SetSeqRun();
#ifndef _NO_RB
	m_pRbSeq->SetSeqRun();
#endif
	m_pCommonIntrSeq->SetSeqRun();
	m_pGaugeIntrSeq->SetSeqRun();
	m_pCimSeq->SetSeqRun();
	m_pCimSeq1->SetSeqRun();
	m_pScanSeq->SetSeqRun();
	m_pSocketSeq->SetSeqRun();
	m_pSocketSeq1->SetSeqRun();
	m_pEqpStateSeq->SetSeqRun();
	m_pPumpSeq->SetSeqRun();
//	m_pPlasmaSeq->SetSeqRun();
//	m_pHpmjSeq->SetSeqRun();
#ifndef _NO_EUV
	m_pEuvSeq->SetSeqRun();
#endif

	// ̶ Timer  Start
	SetTimer( TIMER_TACT_TIME, 1000, NULL );
	SetTimer( TIMER_USER_CHECK, 1000, NULL );
	SetTimer( TIMER_CURSOR_CHECK, 500, NULL );
	SetTimer( TIMER_UPDATE_VIEW , 200, NULL );
	SetTimer( TIMER_COMM_FLOW_METER, 1000, NULL );
}

void CDicsView::SetSeqInitParameter()
{
	m_pGaugeIntrSeq->InitParameter();
}


//--------------------------------------------------------------------------------
// OnInitStatus
//--------------------------------------------------------------------------------
void CDicsView::OnInitStatus( WPARAM wParam, LPARAM lParam )
{
	switch( wParam )
	{
	case MSG_STATUS_DLG_CREATE :
		if( m_pDlgInitStatus != NULL )
		{
			m_pDlgInitStatus->GetFocus();
			m_pDlgInitStatus->ShowWindow( SW_SHOW );
		}
		else
		{
			m_pDlgInitStatus = new CDlgInitStatus();
			ASSERT( m_pDlgInitStatus != NULL );
			m_pDlgInitStatus->Create( IDD_DLG_INIT_STATUS, this );
			m_pDlgInitStatus->ShowWindow( SW_SHOW );
		}
		break;
		
	case MSG_STATUS_DLG_DESTROY :
		if( m_pDlgInitStatus == NULL ) return;
		m_pDlgInitStatus->DestroyWindow();
		break;
		
	case MSG_STATUS_SET_MAIN :	// Main
		if( m_pDlgInitStatus == NULL ) return;
		m_pDlgInitStatus->SetStatusMain( (CString)(LPCTSTR) lParam );
		break;

	case MSG_STATUS_RESET_MAIN :	// Main
		if( m_pDlgInitStatus == NULL ) return;
		m_pDlgInitStatus->ResetStatusMain(  );
		break;
		
	case MSG_STATUS_SET_PUMP :	// Pump
		if( m_pDlgInitStatus == NULL ) return;
		m_pDlgInitStatus->SetStatusPump( (CString)(LPCTSTR) lParam );		
		break;

	case MSG_STATUS_RESET_PUMP :	// Pump
		if( m_pDlgInitStatus == NULL ) return;
		m_pDlgInitStatus->ResetStatusPump( );
		break;
	}
}



//--------------------------------------------------------------------------------
// OnCtlColor
//--------------------------------------------------------------------------------
HBRUSH CDicsView::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CFormView::OnCtlColor(pDC, pWnd, nCtlColor);
	
	UINT id = pWnd->GetDlgCtrlID();
	switch( nCtlColor )
	{
	case CTLCOLOR_LISTBOX:
		if( id == IDC_EQP_LOG || id == IDC_HOST_LOG )
		{
			hbr = m_hbrBgColor;
			pDC->SetBkMode( TRANSPARENT );
			pDC->SetTextColor( BLUE_COLOR );
		}
		else if( id == IDC_ERROR_LIST )
		{
			hbr = m_hbrBgColor;
			pDC->SetBkMode( TRANSPARENT );
			pDC->SetTextColor( RED_COLOR );
		}
		break;
	}
	return hbr;
}

//--------------------------------------------------------------------------------
// OnTimer
//--------------------------------------------------------------------------------
void CDicsView::OnTimer(UINT nIDEvent) 
{
	static BOOL bOldMode = FALSE;					// 140221 halesu
	CDicsDoc* pDoc = (CDicsDoc*) ( GetDocument() );	// 140221 halesu
	BOOL bUse = pDoc->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupINTERLOCK_AUTO_CHECK];	// 140304 halesu

	switch( nIDEvent )
	{
	case TIMER_TACT_TIME:		// counts 1 sec
		if( m_bStartCount && 
			m_pDicsData->m_GenInfo.bAuto &&
			!m_pDicsData->m_GenInfo.bPause &&
			!m_pDicsData->m_SeqFlag.bStopCount1 && 
			!m_pDicsData->m_SeqFlag.bStopCount2 )
		{
			CString sMessage;

			sMessage.Format( "%d sec", m_nTactTime++ );
			m_pTabJobsMainView->m_msgTactTime.SetOpMsg( sMessage );

			if( m_nTactTime >= m_pDicsData->m_JobCond.nTactTime )
			{
				m_pDicsData->m_SeqFlag.bTimeOver = TRUE;
			}
		}
		break;
	case TIMER_USER_CHECK:
		{
			if( m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP )
			{
				m_nUserChangeTime++;

				if( m_nUserChangeTime > ( USER_AUTO_CHANGE * 60 ) )
				{
					m_pDicsData->m_LoginInfo.nCurUserLevel = CDicsData::idOP;
					
					CDicsApp* pApp = (CDicsApp*) AfxGetApp();
					CMainFrame* pMainFrame = (CMainFrame*) pApp->m_pMainWnd;

					pMainFrame->m_wndTitlePanel.m_msgUserID.SetOpMsg( "OPERATOR" );

					m_nUserChangeTime = 0;
#ifdef _AUTO_CHECK
					// 140220 set Door, Bath, Leak interlock "check" when auto mode and user level = operator			
					if( bUse && m_pDicsData->m_GenInfo.bAuto )
					{
						for( int i=0; i<pDoc->m_pSetupItems->m_nItemNoDoorIntr; i++ )
						{
							pDoc->m_pSetupItems->m_nValueDoorIntr[i] = pDoc->m_pSetupItems->m_nValueDoorIntrTemp[i] = 1;
						}
						for( i=0; i<pDoc->m_pSetupItems->m_nItemNoBathCoverIntr; i++ )
						{
							pDoc->m_pSetupItems->m_nValueBathCoverIntr[i] = pDoc->m_pSetupItems->m_nValueBathCoverIntrTemp[i] = 1;
						}
						for( i=0; i<pDoc->m_pSetupItems->m_nItemNoLeakDetectIntr; i++ )
						{
							pDoc->m_pSetupItems->m_nValueLeakDetectIntr[i] = pDoc->m_pSetupItems->m_nValueLeakDetectIntrTemp[i] = 1;
						}
						pDoc->m_pSetupItems->SetRegistryTabInterlockSet2View();
					}
#endif
				}
			}
#ifdef _AUTO_CHECK
			// 140221 set Door, Bath, Leak interlock "check" when auto mode and user level = operator
			if( bUse && !bOldMode && m_pDicsData->m_GenInfo.bAuto && m_pDicsData->m_LoginInfo.nCurUserLevel == CDicsData::idOP )
			{
				for( int i=0; i<pDoc->m_pSetupItems->m_nItemNoDoorIntr; i++ )
				{
					pDoc->m_pSetupItems->m_nValueDoorIntr[i] = pDoc->m_pSetupItems->m_nValueDoorIntrTemp[i] = 1;
				}
				for( i=0; i<pDoc->m_pSetupItems->m_nItemNoBathCoverIntr; i++ )
				{
					pDoc->m_pSetupItems->m_nValueBathCoverIntr[i] = pDoc->m_pSetupItems->m_nValueBathCoverIntrTemp[i] = 1;
				}
				for( i=0; i<pDoc->m_pSetupItems->m_nItemNoLeakDetectIntr; i++ )
				{
					pDoc->m_pSetupItems->m_nValueLeakDetectIntr[i] = pDoc->m_pSetupItems->m_nValueLeakDetectIntrTemp[i] = 1;
				}
				pDoc->m_pSetupItems->SetRegistryTabInterlockSet2View();
			}
			bOldMode = m_pDicsData->m_GenInfo.bAuto;
#endif	
		}
		break;

	case TIMER_CURSOR_CHECK:
		{
			if( m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP )
			{
				POINT pntCursor;

				GetCursorPos(&pntCursor);

				if( pntCursor.x >= ( m_pntCurPos.x + 25 ) ||
					pntCursor.x <= ( m_pntCurPos.x - 25 ) ||
					pntCursor.y >= ( m_pntCurPos.y + 25 ) ||
					pntCursor.y <= ( m_pntCurPos.y - 25 ) )
				{
					m_pntCurPos.x = pntCursor.x;
					m_pntCurPos.y = pntCursor.y;

					m_nUserChangeTime = 0;
				}
			}
		}
		// Aging
		if ( m_pDicsData->m_GenInfo.bAuto && m_pDicsData->m_GenInfo.bEqpInitComp )
		{
			if ( m_pDicsData->m_GenInfo.bCleanOut ) 
			{
				m_pTabJobsMainView->SendMessage( WM_AGING_MODE_STATUS_CHANGED, MODE_CLEAN_OUT );
			}
//			else if ( m_pMainSeq->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupAGING_MODE] )
//			{
//				m_pTabJobsMainView->SendMessage( WM_AGING_MODE_STATUS_CHANGED, MODE_AGING );
//			}
			else if( m_pDicsData->m_GenInfo.bUlNotReady )
			{
				m_pTabJobsMainView->SendMessage( WM_AGING_MODE_STATUS_CHANGED, MODE_UL_TIME_OUT );
			}
			else if( m_pDicsData->m_GenInfo.bDiECO && m_pDicsData->m_GenInfo.bAkECO )	// 250108 halesu
			{
				m_pTabJobsMainView->SendMessage( WM_AGING_MODE_STATUS_CHANGED, MODE_DI_AK_ECO );
			}
			else if( m_pDicsData->m_GenInfo.bDiECO )
			{
				m_pTabJobsMainView->SendMessage( WM_AGING_MODE_STATUS_CHANGED, MODE_DI_ECO );
			}
			else if( m_pDicsData->m_GenInfo.bAkECO )
			{
				m_pTabJobsMainView->SendMessage( WM_AGING_MODE_STATUS_CHANGED, MODE_AK_ECO );
			}
			else 
			{
				m_pTabJobsMainView->SendMessage( WM_AGING_MODE_STATUS_CHANGED, MODE_NONE );
			}
		}
		else 
		{
			m_pTabJobsMainView->SendMessage( WM_AGING_MODE_STATUS_CHANGED, MODE_NONE );
		}
		break;

	case TIMER_UPDATE_VIEW :
		{
#ifdef _MY_DEBUG
			CString sBuf;
			sBuf.Format( "%d", m_pDicsData->m_IfFlag[IF_UNIT_LD].bInComp );
			( (CWnd*)GetDlgItem( IDC_STATIC_DEBUG_TRACE ) )->SetWindowText( (LPCTSTR)sBuf );
#endif
			if( m_nSelectedTab == viewJobMain )		m_pTabJobsMainView->UpdateObjects();
			if( m_nSelectedTab == viewJobPiping )	m_pTabJobsPipingView->UpdateObjects();
			if( m_nSelectedTab == viewJobProcess )	m_pTabJobsProcessDataView->UpdateObjects();
//			if( m_nSelectedTab == viewJobAP )		m_pTabJobsApStatusView->UpdateObjects();
//			if( m_nSelectedTab == viewJobHpmj)      m_pTabJobHpmjStatusView->UpdateObjects();
//			if( m_nSelectedTab == viewJobCim )		m_pTabJobsCimView->UpdateObjects();
#ifndef _NO_EUV
			if( m_nSelectedTab == viewJobEuv )		m_pTabJobsEuvStatusView->UpdateObjects();
#endif
		}
		break;

	case TIMER_COMM_FLOW_METER:
		{
			// dspcrassus - Send Request Data Command to Integral Flow Meter
#ifndef _MY_DEBUG
			m_pFlowCtrl->SendCommand();
#endif
		}
	}
	
	CFormView::OnTimer(nIDEvent);
}


//--------------------------------------------------------------------------------
// OnSetupView
//--------------------------------------------------------------------------------
void CDicsView::OnSetupView(WPARAM wParam, LPARAM lParam)
{
	CDicsDoc* pDoc = GetDocument();
	
	if( pDoc->m_pSetupWnd ) pDoc->m_pSetupView->OnSetupView( wParam, lParam );
}

//---------------------------------------------------------------------------
// OnEqpLog
//---------------------------------------------------------------------------
void CDicsView::OnEqpLog( WPARAM wParam, LPARAM lParam )
{
	CString sBuf = (LPCTSTR) lParam;
	if( m_listEqpLog.GetCount() >= 30 ) m_listEqpLog.DeleteString( 0 );
	int i = m_listEqpLog.AddString( sBuf );
	m_listEqpLog.SetCurSel( i );
}

//---------------------------------------------------------------------------
// OnHostLog
//---------------------------------------------------------------------------
void CDicsView::OnHostLog( WPARAM wParam, LPARAM lParam )
{
	CString sBuf = (LPCTSTR) lParam;
	if( m_listHostLog.GetCount() >= 30 ) m_listHostLog.DeleteString( 0 );
	int i = m_listHostLog.AddString( sBuf );
	m_listHostLog.SetCurSel( i );
}

//---------------------------------------------------------------------------
// alarm message
// 0003 S EMO1 Alarm
//---------------------------------------------------------------------------
#define ALARM_CIPHERS 4 // ALARM ڸ
void CDicsView::OnAlarm( WPARAM wParam, LPARAM lParam )
{
	CString sMessage = "";
	CString sLevel   = "";
	CString sCode    = "";
	int nCode = 0;
	int iIndex = 0;
	int nCnt = 0;//2009.03.11 kimgun
	switch( wParam )
	{
	case ALARM_SET:
		sMessage.Format( "%s", (LPCTSTR) lParam );

		if( sMessage.GetLength() > ALARM_CIPHERS + 1 ) nCode = atoi( sMessage.Mid( 0, ALARM_CIPHERS ) );
		sLevel = sMessage.Mid( ALARM_CIPHERS + 1, 1 );
		sMessage.Delete( 0, ALARM_CIPHERS + 3 );
		GetDocument()->m_pErrHistSet->AddErrData( nCode, sMessage, sLevel );
		sCode.Format( "%04d", nCode );
		
		iIndex = m_listError.FindString( 0, sCode );
		if( iIndex == LB_ERR ) 
		{
			sCode.Format( "%d", nCode );
			m_listError.AddString( sCode + " : " + sMessage );
		}
		break;
	case ALARM_RESET:
		sMessage.Format( "%d", (int) lParam );
		do {// dupicate alarm clear 2009.03.11 kimgun
			iIndex = m_listError.FindString( 0, sMessage );
			if( iIndex != LB_ERR ) 
			{
				m_listError.DeleteString( iIndex );	
			}	
			nCnt++;//iIndex LB_ERR    do while Ż. 
		} while(iIndex != LB_ERR && nCnt < 1000 );
		break;
	case ALARM_RESET_ALL:
		m_listError.ResetContent();
		m_pEqpStateSeq->ResetAlarmAll();
		break;
	}
}

//---------------------------------------------------------------------------
// Set the Tact Time
//---------------------------------------------------------------------------
void CDicsView::OnTactTime( WPARAM wParam, LPARAM lParam )
{
	if( wParam == CMainSeq::ttCOUNT_START ) 
	{//2008.08.26 kimgun
		CString sOldTactTime;
		sOldTactTime.Format("%d Sec",m_nTactTime);
		m_bStartCount = TRUE;
//		m_pTabJobsMainView->m_msgOldTactTime.SetOpMsg( sOldTactTime );
		m_nTactTime = 0;
	}
	else if( wParam == CMainSeq::ttCOUNT_END ) 
	{
		m_bStartCount = FALSE;
		m_nTactTime = 0;

		m_pTabJobsMainView->m_msgTactTime.SetOpMsg( "0 sec" );
	}
}

//---------------------------------------------------------------------------
// Set the Glass No
//---------------------------------------------------------------------------
void CDicsView::OnGlassNo( WPARAM wParam, LPARAM lParam )
{
	m_pTabJobsMainView->SetGlassNo( (int) wParam, (int) lParam );
}

//---------------------------------------------------------------------------
// Transfer status changed
// - What Unit => wParam
// - Glass Exist=> lParam
// - Glass None => lParam
// - Glass No	=> lParam
// lParam : 0161 : Glass No 161 => Glass None
// lParam : 1161 : Glass No 161 => Glass Exist
//---------------------------------------------------------------------------
void CDicsView::OnCvStatusChanged( WPARAM wParam, LPARAM lParam )
{
	CString sData = (CString)(LPCTSTR) lParam;
	if( sData.GetLength() < 4 ) return;

	BOOL bState = sData.GetAt( 0 ) - '0';
	int  nSlotNo = atoi( sData.Mid( 1, 2 ) );
	int  nPortNo = sData.GetAt( 3 ) - '0';
	
	m_pTabJobsMainView->SetCvState( wParam, bState, nSlotNo, nPortNo );
}

//---------------------------------------------------------------------------
// Set Recipe Data
//---------------------------------------------------------------------------
void CDicsView::OnSetRecipe( WPARAM wParam, LPARAM lParam )
{
	// Display the recipe info.
	GetDocument()->SetRecipeId( (CString)(LPCTSTR) lParam );
}

//---------------------------------------------------------------------------
// Display the comm received message
//---------------------------------------------------------------------------
void CDicsView::OnEqpMessage( WPARAM wParam, LPARAM lParam )
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CMainFrame* pMainFrame = (CMainFrame*)pApp->m_pMainWnd;
	CString sMessage = (CString)(LPCTSTR) lParam;

	// Display the Equipment Message
	if( wParam == MSG_TITLEBAR_MESSAGE )
	{
//		pMainFrame->m_wndTitlePanel.m_msgMessage.SetOpMsg( (LPCTSTR) sMessage );
		pMainFrame->AddTitleMessage( sMessage );
	}

	// Set the DeviceNet State
	else if( wParam == MSG_DEVICENET_STATE )
	{
		if( sMessage == "Active" ) 
			pMainFrame->m_wndTitlePanel.m_msgStatus1.SetTextColor( WHITE_COLOR );
		else 
			pMainFrame->m_wndTitlePanel.m_msgStatus1.SetTextColor( RED_COLOR );
		pMainFrame->m_wndTitlePanel.m_msgStatus1.SetOpMsg( (LPCTSTR) lParam );
	}

	// Set the Up Stream State : Host State = Connected, Not Connected
	else if( wParam == MSG_UP_STREAM_STATE )
	{
		if( sMessage == "Connected" ) 
			pMainFrame->m_wndTitlePanel.m_msgStatus2.SetTextColor( BLUE_COLOR );
		else 
			pMainFrame->m_wndTitlePanel.m_msgStatus2.SetTextColor( RED_COLOR );
		pMainFrame->m_wndTitlePanel.m_msgStatus2.SetOpMsg( (LPCTSTR) lParam );

	}
	else if( wParam == MSG_UP_STREAM_STATE1 )
	{
		if( sMessage == "Connected" ) 
			pMainFrame->m_wndTitlePanel.m_msgStatus4.SetTextColor( BLUE_COLOR );
		else 
			pMainFrame->m_wndTitlePanel.m_msgStatus4.SetTextColor( RED_COLOR );
		pMainFrame->m_wndTitlePanel.m_msgStatus4.SetOpMsg( (LPCTSTR) lParam );

	}
	else if( wParam == MSG_DN_STREAM_STATE )
	{
		if( sMessage == "ONLINE" ) 
		{
			pMainFrame->m_wndTitlePanel.m_msgStatus3.SetTextColor( BLUE_COLOR );

			// Set Ld State
			m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateMANUAL] = 0;
		}
		else 
		{
			pMainFrame->m_wndTitlePanel.m_msgStatus3.SetTextColor( RED_COLOR );

			// Set Ld State
			m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateMANUAL] = 1;
		}
		pMainFrame->m_wndTitlePanel.m_msgStatus3.SetOpMsg( (LPCTSTR) sMessage );
	}
	else if( wParam == MSG_HOST_STATE )
	{
		CDicsApp* pApp = (CDicsApp*) AfxGetApp();
		CMainFrame* pMainFrame = (CMainFrame*)pApp->m_pMainWnd;
		CString sMessage = (CString)(LPCTSTR) lParam;

		if( sMessage == "OFFLINE" ) 
		{
			pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetTextColor( RED_COLOR );
			pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetBgColor( WHITE_COLOR );
//			m_pTabJobsTab2View->SetCtrlState( MSG_CTRL_MODE, CDicsData::modeOFFLINE, CDicsData::stateON );
		}
//		else if( sMessage == "MONITOR" ) 
//		{
//			pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetTextColor( BLUE_COLOR );
//			pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetBgColor( YELLOW_COLOR );
//			m_pTabJobsTab2View->SetCtrlState( MSG_CTRL_MODE, CDicsData::modeMONITOR, CDicsData::stateON );
// 		}
		else if( sMessage == "ONLINE" ) 
		{
			pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetTextColor( BLUE_COLOR );
			pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetBgColor( GREEN_COLOR );
//			m_pTabJobsTab2View->SetCtrlState( MSG_CTRL_MODE, CDicsData::modeCONTROL, CDicsData::stateON );
		}
		pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetOpMsg( (LPCTSTR) lParam );
	}
}

//---------------------------------------------------------------------------
// Display the comm received message
//---------------------------------------------------------------------------
void CDicsView::OnJobsView( WPARAM wParam, LPARAM lParam )
{
	if( wParam == MSG_CTRL_MODE )
	{
		CDicsApp* pApp = (CDicsApp*) AfxGetApp();
		CMainFrame* pMainFrame = (CMainFrame*)pApp->m_pMainWnd;
		CString sMessage = (CString)(LPCTSTR) lParam;

		if( sMessage == "Offline" ) 
		{
			pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetTextColor( RED_COLOR );
//			m_pTabJobsTab2View->SetCtrlState( MSG_CTRL_MODE, CDicsData::modeOFFLINE, CDicsData::stateON );
		}
		else if( sMessage == "Online Monitor" ) 
		{
			pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetTextColor( BLUE_COLOR );
// 			m_pTabJobsTab2View->SetCtrlState( MSG_CTRL_MODE, CDicsData::modeMONITOR, CDicsData::stateON );
		}
		else if( sMessage == "Online Control" ) 
		{
			pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetTextColor( BLUE_COLOR );
// 			m_pTabJobsTab2View->SetCtrlState( MSG_CTRL_MODE, CDicsData::modeCONTROL, CDicsData::stateON );
		}
		pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetOpMsg( (LPCTSTR) lParam );
	}
	else if ( wParam == MSG_CIM_MESSAGE )
	{
		CString sData = (CString)(LPCTSTR) lParam;
		int nIndex = sData.Find( "ERROR" );

		m_pTabJobsInterfaceView->m_msgCimMessage.SetOpMsg( sData );
		if( nIndex >= 0 ) 
		{
			m_pTabJobsInterfaceView->m_msgCimMessage.SetTextColor( WHITE_COLOR );
			m_pTabJobsInterfaceView->m_msgCimMessage.SetBgColor( RED_COLOR );
			OnSelectTab( 1, 0L );
		}
		else 
		{
			m_pTabJobsInterfaceView->m_msgCimMessage.SetTextColor( BLUE_COLOR );
			m_pTabJobsInterfaceView->m_msgCimMessage.SetBgColor( LIGHT_YELLOW_COLOR );
		}
	}
	else if( wParam == MSG_TERMINAL_MESSAGE )
	{
		m_pTabJobsInterfaceView->m_msgTerminalMessage.SetTextColor( BLACK_COLOR );
		m_pTabJobsInterfaceView->m_msgTerminalMessage.SetBgColor( WHITE_COLOR );
		m_pTabJobsInterfaceView->m_msgTerminalMessage.SetOpMsg( (LPCTSTR)lParam );
	}
	else if( wParam == MSG_TERMINAL_WARNING )
	{
		m_pTabJobsInterfaceView->m_msgTerminalMessage.SetTextColor( RED_COLOR );
		m_pTabJobsInterfaceView->m_msgTerminalMessage.SetBgColor( BLACK_COLOR );
		m_pTabJobsInterfaceView->m_msgTerminalMessage.SetOpMsg( (LPCTSTR)lParam );
	}
	else if( wParam == MSG_HOST_WARNING )
	{
		CString sData = (CString)(LPCTSTR) lParam;
		// Set the Buzzer
		m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampMELODY1, CEqpStateSequence::lampON );	// Buzzer On
		// Set Tower Lamp
		m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampTOWER_LAMP_R, CEqpStateSequence::lampON );

		CDlgOpCall dlg;
		dlg.m_sOpCall = sData;
		dlg.DoModal();

		// Set the Buzzer
//		m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampMELODY1, CEqpStateSequence::lampOFF );	// Buzzer On
		// Set Tower Lamp
		if( m_pDicsData->m_EqpInfo.cEqpState != CDicsData::modeDOWN )
		{
			m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampTOWER_LAMP_R, CEqpStateSequence::lampOFF );
			m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampMELODY1, CEqpStateSequence::lampOFF );	// Buzzer On
		}
	}
	else if( wParam == MSG_HOST_WARNING1 )
	{
		CString sData = (CString)(LPCTSTR) lParam;
		// Set the Buzzer
		m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampMELODY1, CEqpStateSequence::lampON );	// Buzzer On
		// Set Tower Lamp
		m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampTOWER_LAMP_R, CEqpStateSequence::lampON );

		CDlgOpCall dlg;
		dlg.m_sOpCall = sData;
		dlg.DoModal();

		// Set the Buzzer
//		m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampMELODY1, CEqpStateSequence::lampOFF );	// Buzzer On
		// Set Tower Lamp
		if( m_pDicsData->m_EqpInfo.cEqpState != CDicsData::modeDOWN )
		{
			m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampTOWER_LAMP_R, CEqpStateSequence::lampOFF );
			m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampMELODY1, CEqpStateSequence::lampOFF );	// Buzzer On
		}
	}
	else if( wParam == MSG_HOST_TIMEOUT )
	{
		CString sData = (CString)(LPCTSTR) lParam;
		// Set the Buzzer
		m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampMELODY1, CEqpStateSequence::lampON );	// Buzzer On
		// Set Tower Lamp
		m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampTOWER_LAMP_R, CEqpStateSequence::lampON );

		CDlgOpCall dlg;
		dlg.m_sOpCall = sData;
		dlg.DoModal();

		// Set the Buzzer
//		m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampMELODY1, CEqpStateSequence::lampOFF );	// Buzzer On
		// Set Tower Lamp
		if( m_pDicsData->m_EqpInfo.cEqpState != CDicsData::modeDOWN )
		{
			m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampTOWER_LAMP_R, CEqpStateSequence::lampOFF );
			m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampMELODY1, CEqpStateSequence::lampOFF );	// Buzzer On
		}
	}
/*
	if( wParam == MSG_LOADER_MODE )
	{
//		m_pTabJobsCimView->SetCtrlState( MSG_LOADER_MODE, lParam, CDicsData::stateON );
	}
	else if( wParam == MSG_CTRL_MODE )
	{
		CDicsApp* pApp = (CDicsApp*) AfxGetApp();
		CMainFrame* pMainFrame = (CMainFrame*)pApp->m_pMainWnd;
		CString sMessage = (CString)(LPCTSTR) lParam;

		if( sMessage == "Offline" ) 
		{
			pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetTextColor( RED_COLOR );
			pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetBgColor( WHITE_COLOR );
//			m_pTabJobsCimView->SetCtrlState( MSG_CTRL_MODE, CDicsData::modeOFFLINE, CDicsData::stateON );
		}
		else if( sMessage == "Local" ) 
		{
			pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetTextColor( BLUE_COLOR );
			pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetBgColor( YELLOW_COLOR );
//			m_pTabJobsCimView->SetCtrlState( MSG_CTRL_MODE, CDicsData::modeMONITOR, CDicsData::stateON );
 		}
		else if( sMessage == "Remote" ) 
		{
			pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetTextColor( BLUE_COLOR );
			pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetBgColor( GREEN_COLOR );
//			m_pTabJobsCimView->SetCtrlState( MSG_CTRL_MODE, CDicsData::modeCONTROL, CDicsData::stateON );
		}
		pMainFrame->m_wndTitlePanel.m_msgHostCommStatus.SetOpMsg( (LPCTSTR) lParam );
	}
	else if( wParam == MSG_PORT_MODE )
	{
		int nData = (int) lParam;
		int nIndex = ( nData >> 1 ) & 0xFF;
		char cPortMode = ( nData & 0x01 ) ? CDicsData::modeENABLE : CDicsData::modeDISABLE;

		if( cPortMode == CDicsData::modeENABLE )
			m_pTabJobsMainView->m_stcPortState[nIndex].SetBkColor( WHITE_COLOR );
		else m_pTabJobsMainView->m_stcPortState[nIndex].SetBkColor( RED_COLOR );

		// Set to view
		m_pTabJobsMainView->m_stcPortState[nIndex].SetWindowText( m_pDicsData->m_PortInfo[nIndex].sPortStatus );
//		m_pTabJobsCimView->SetDataToGridLotInfo( nIndex );
//		m_pTabJobsCimView->SetPortMode( nIndex, cPortMode );
	}
	else if( wParam == MSG_TRS_MODE )
	{
		int nData = (int) lParam;
		int nIndex = ( nData >> 1 ) & 0xFF;
		char cTrsMode = ( nData & 0x01 ) ? CDicsData::modeAGV : CDicsData::modeMGV;

		// Set to view
		m_pTabJobsMainView->m_stcTrsMode[nIndex].SetWindowText( ( cTrsMode == CDicsData::modeAGV ) ? "AUTO" : "MANUAL" );
//		m_pTabJobsCimView->SetDataToGridLotInfo( nIndex );
//		m_pTabJobsCimView->SetTrsMode( nIndex, cTrsMode );
	}
	else if ( wParam == MSG_TERMINAL_MESSAGE )
	{
		CString sData = (CString)(LPCTSTR) lParam;
		int nIndex = sData.Find( "HSMS ERROR" );
		if( nIndex >= 0 )
		{
			// Set the Buzzer
			m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampMELODY1, CEqpStateSequence::lampON );	// Buzzer On
			// Set Tower Lamp
			m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampTOWER_LAMP_R, CEqpStateSequence::lampON );

			CDlgOpCall dlg;
			dlg.m_sOpCall = sData;
			dlg.DoModal();

			// Set the Buzzer
			m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampMELODY1, CEqpStateSequence::lampOFF );	// Buzzer On
			// Set Tower Lamp
			if( m_pDicsData->m_EqpInfo.cEqpState != CDicsData::modeDOWN )
				m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampTOWER_LAMP_R, CEqpStateSequence::lampOFF );
		}
//		else m_pTabJobsCimView->SetTerminalMsg( sData );
	}
	else if( wParam == MSG_CIM_MESSAGE )
	{
		CString sData = (CString)(LPCTSTR) lParam;
		int nIndex = sData.Find( "OP CALL" ); //LYS20070911 Cim Test
		int nIndex1 = sData.Find( "ERROR" ); //LYS20070911 Cim Test

		if ( sData == "OK" || nIndex1 >= 0 )
		{
			nIndex1 = sData.Find( "ERROR" );

//			m_pTabJobsCimView->m_msgCimMessage.SetOpMsg( sData );
			if( nIndex1 >= 0 ) 
			{
//				m_pTabJobsCimView->m_msgCimMessage.SetTextColor( WHITE_COLOR );
//				m_pTabJobsCimView->m_msgCimMessage.SetBgColor( RED_COLOR );
				OnSelectTab( 1, 0L );
			}
			else 
			{
//				m_pTabJobsCimView->m_msgCimMessage.SetTextColor( BLUE_COLOR );
//				m_pTabJobsCimView->m_msgCimMessage.SetBgColor( LIGHT_YELLOW_COLOR );
			}
		}
		else if( nIndex >= 0 )
		{
			// Set the Buzzer
			m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampMELODY1, CEqpStateSequence::lampON );	// Buzzer On
			// Set Tower Lamp
			m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampTOWER_LAMP_R, CEqpStateSequence::lampON );

			CDlgOpCall dlg;
			dlg.m_sOpCall = sData;
			dlg.DoModal();

			// Set the Buzzer
			m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampMELODY1, CEqpStateSequence::lampOFF );	// Buzzer On
			// Set Tower Lamp
			if( m_pDicsData->m_EqpInfo.cEqpState != CDicsData::modeDOWN )
				m_pEqpStateSeq->SetLampState( CEqpStateSequence::lampTOWER_LAMP_R, CEqpStateSequence::lampOFF );
		}
	}
	else if( wParam == MSG_GLASS_COUNT )
	{
		// "204/02/21" : Port=2, InNum=04, OutNum=02, Total=21
		CString sData = (CString)(LPCTSTR) lParam;
		int nLen = sData.GetLength();
		if( nLen > 0 ) 
		{
			int nIndex = sData.GetAt( 0 ) - '1';
			m_pTabJobsMainView->m_stcInOutNum[nIndex].SetWindowText( sData.Mid( 1 ) );
		}
	} */
}

//--------------------------------------------------------------------
// Description : Display the devicenet status
//--------------------------------------------------------------------
void CDicsView::OnDevicenetMonitor( WPARAM wParam, LPARAM lParam )
{
	CString sDevicenetState = (CString)(LPCTSTR) lParam;
	static CString sOldDevicenetState = "";

	if( sOldDevicenetState != sDevicenetState )
	{
		CDicsApp* pApp = (CDicsApp*) AfxGetApp();
		CMainFrame* pMainFrame = (CMainFrame*) pApp->m_pMainWnd;

		if( sDevicenetState == "Active" )
			pMainFrame->m_wndTitlePanel.m_msgStatus1.SetBgColor( BLUE_COLOR );
		else pMainFrame->m_wndTitlePanel.m_msgStatus1.SetBgColor( RED_COLOR );
		pMainFrame->m_wndTitlePanel.m_msgStatus1.SetOpMsg( sDevicenetState );

		sOldDevicenetState = sDevicenetState;
	}
}

//---------------------------------------------------------------------------
// OnSelChangeTab
//---------------------------------------------------------------------------
void CDicsView::OnSelChangeTab( WPARAM wParam, LPARAM lParam )
{
	m_nSelectedTab = (int) wParam;
	
	SetToolbar( m_nSelectedTab );
}

//---------------------------------------------------------------------------
// OnSelectTab
//---------------------------------------------------------------------------
void CDicsView::OnSelectTab( WPARAM wParam, LPARAM lParam )
{
	m_tabCtrl.SelectTab( wParam );
	OnSelChangeTab( wParam, lParam );
}

//---------------------------------------------------------------------------
// Display ProgressBar about idle running
//---------------------------------------------------------------------------
void CDicsView::OnIdleRunningProgress( WPARAM wParam, LPARAM lParam )
{
	int nActNo = (int) wParam;
	CString sVal = "";
	static int nTime = 0;

	switch( nActNo )
	{
	case PROGRESS_START :
		nTime = (int)lParam;
		sVal.Format( "%d sec", nTime );
		m_pTabJobsMainView->m_progIdleRun.SetShowText( TRUE );
		m_pTabJobsMainView->m_progIdleRun.SetWindowText( sVal );
		m_pTabJobsMainView->m_progIdleRun.SetRange( 0, (int)lParam * 10 );
		m_pTabJobsMainView->m_progIdleRun.SetPos( 0 );
		m_pTabJobsMainView->m_progIdleRun.SetWindowText( sVal );
		break;
	case PROGRESS_END :
//		m_pTabJobsMainView->m_progIdleRun.SetShowText( FALSE );
		m_pTabJobsMainView->m_progIdleRun.SetWindowText( "0%" );
		m_pTabJobsMainView->m_progIdleRun.SetPos( 0 );
		break;
	case PROGRESS_SET :
		sVal.Format( "%d / %d sec", (DWORD)( lParam / 10 ), nTime );
		m_pTabJobsMainView->m_progIdleRun.SetPos( (int)lParam );
		m_pTabJobsMainView->m_progIdleRun.SetWindowText( sVal );
		break;
	}
}

//---------------------------------------------------------------------------
// Display ProgressBar
//---------------------------------------------------------------------------
void CDicsView::OnEuvOnProgress( WPARAM wParam, LPARAM lParam )
{
	int nActNo = (int) wParam;
	CString sVal = "";
	static int nTime = 0;

   	switch( nActNo )
	{
	case PROGRESS_START :
		nTime = (int)lParam;
		sVal.Format( "%d sec", nTime );
		m_pTabJobsMainView->m_progEuvOn.SetShowText( TRUE );
		m_pTabJobsMainView->m_progEuvOn.SetWindowText( sVal );
		m_pTabJobsMainView->m_progEuvOn.SetRange( 0, nTime * 10 );
		m_pTabJobsMainView->m_progEuvOn.SetPos( 0 );
		m_pTabJobsMainView->m_progEuvOn.SetWindowText( sVal );
		break;

	case PROGRESS_END :
//		m_progEuvOn.SetShowText( FALSE );
		sVal.Format( "%s", "OFF" );
		m_pTabJobsMainView->m_progEuvOn.SetWindowText( sVal );
		m_pTabJobsMainView->m_progEuvOn.SetPos( 0 );
		break;

	case PROGRESS_SET :
		sVal.Format( "%d sec", (int)( lParam ) / 10 );
		m_pTabJobsMainView->m_progEuvOn.SetPos( (int)lParam );
		m_pTabJobsMainView->m_progEuvOn.SetWindowText( sVal );
		break;
	}
}
void CDicsView::OnEuvComm( WPARAM wParam, LPARAM lParam )	//for ushio euv. EUN 070314
{
	switch( lParam )
	{
	case 0:
		if( m_pCommEuv )
		{
			m_pCommEuv->ClosePort();
			delete m_pCommEuv;
		}
		m_pCommEuv = NULL;
		break;
	case 1:
		//ASSERT( m_pCommEuv[0] = new CMuxCom );		
		m_pCommEuv = new CMuxCom;
		ASSERT( m_pCommEuv );
		if( m_pCommEuv->OpenPort( this, "COM4", CBR_9600, 8, TWOSTOPBITS, NOPARITY, CMuxCom::ccETX/*'\r'*/ ) >= 0 )
			m_pEuvSeq->SetCommEuv( m_pCommEuv );
		else 
			delete m_pCommEuv;
		break;
	}
}

//---------------------------------------------------------------------------
// Set the SECS message between eqp. and host.
//---------------------------------------------------------------------------
#include "SECS\XSecsSFCode.h"

void CDicsView::OnSecsMsg( WPARAM wEventName, LPARAM lTranx )
{
	CString szBuf = "";
	char cWait;
	static int nRetryNo = 0;

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CMainFrame* pMainFrame = (CMainFrame*)pApp->m_pMainWnd;
	XSecsTranxThread* pTranx = (XSecsTranxThread*)lTranx;
	int nEvent = (int)wEventName & 0x0F;
	int nPortNo = (int)wEventName >> 4;

	switch( (int)nEvent )
	{
		case XSecsHSMS::smPrimaryOut :
			if( nPortNo == m_nPortNumber )
			{
				if( pTranx->Primary.GetWaitFlag() == XSecsMessage::waitFlagOn ) cWait = 'W';
				else cWait = ' ';
				szBuf.Format( "1st MSG SEND (H<-E) S%dF%d %c    \"%s\"", 
					pTranx->Primary.GetStreamCode(), pTranx->Primary.GetFunctionCode(), 
					cWait, pTranx->GetDescription() );
				HostLogMsg( szBuf );
			}
			else if( nPortNo == m_nPortNumber1 )
			{
				if( pTranx->Primary.GetWaitFlag() == XSecsMessage::waitFlagOn ) cWait = 'W';
				else cWait = ' ';
				szBuf.Format( "1st MSG SEND (H1<-E) S%dF%d %c    \"%s\"", 
					pTranx->Primary.GetStreamCode(), pTranx->Primary.GetFunctionCode(), 
					cWait, pTranx->GetDescription() );
				HostLogMsg( szBuf );
			}
			break;

		case XSecsHSMS::smSecondaryOut :
			if( nPortNo == m_nPortNumber )
			{
				if( pTranx->Secondary.GetWaitFlag() == XSecsMessage::waitFlagOn ) cWait = 'W';
				else cWait = ' ';
				szBuf.Format( "2nd MSG SEND (H<-E) S%dF%d", 
					pTranx->Secondary.GetStreamCode(), pTranx->Secondary.GetFunctionCode() );
				HostLogMsg( szBuf );
			}
			else if( nPortNo == m_nPortNumber1 )
			{
				if( pTranx->Secondary.GetWaitFlag() == XSecsMessage::waitFlagOn ) cWait = 'W';
				else cWait = ' ';
				szBuf.Format( "2nd MSG SEND (H1<-E) S%dF%d", 
					pTranx->Secondary.GetStreamCode(), pTranx->Secondary.GetFunctionCode() );
				HostLogMsg( szBuf );
			}
			break;

		case XSecsHSMS::smPrimaryIn :
			if( nPortNo == m_nPortNumber )
			{
				if( pTranx->Primary.GetWaitFlag() == XSecsMessage::waitFlagOn ) cWait = 'W';
				else cWait = ' ';
				szBuf.Format( "1st MSG RECV (H->E) S%dF%d %c    \"%s\"", 
					pTranx->Primary.GetStreamCode(), pTranx->Primary.GetFunctionCode(),
					cWait, pTranx->GetDescription() );
				HostLogMsg( szBuf );
			}
			else if( nPortNo == m_nPortNumber1 )
			{
				if( pTranx->Primary.GetWaitFlag() == XSecsMessage::waitFlagOn ) cWait = 'W';
				else cWait = ' ';
				szBuf.Format( "1st MSG RECV (H1->E) S%dF%d %c    \"%s\"", 
					pTranx->Primary.GetStreamCode(), pTranx->Primary.GetFunctionCode(),
					cWait, pTranx->GetDescription() );
				HostLogMsg( szBuf );
			}
			break;

		case XSecsHSMS::smSecondaryIn :
			if( nPortNo == m_nPortNumber )
			{
				szBuf.Format( "2nd MSG RECV (H->E) S%dF%d", 
					pTranx->Secondary.GetStreamCode(), pTranx->Secondary.GetFunctionCode() );
				HostLogMsg( szBuf );
			}
			else if( nPortNo == m_nPortNumber1 )
			{
				szBuf.Format( "2nd MSG RECV (H->E) S%dF%d", 
					pTranx->Secondary.GetStreamCode(), pTranx->Secondary.GetFunctionCode() );
				HostLogMsg( szBuf );
			}
			break;

		case XSecsHSMS::smConnected :
			if( nPortNo == m_nPortNumber )
			{
				SendMessage( WM_EQP_MESSAGE, MSG_UP_STREAM_STATE, (LPARAM)(LPCTSTR) "Connected" );
				SetLog( "SECSMSG ", 0, 0, "Socket Connected" );
			}
			else if( nPortNo == m_nPortNumber1 )
			{
				SendMessage( WM_EQP_MESSAGE, MSG_UP_STREAM_STATE1, (LPARAM)(LPCTSTR) "Connected" );
				SetLog( "SECSMSG ", 0, 0, "Socket1 Connected" );
			}
			break;

		case XSecsHSMS::smDisconnected :
			if( nPortNo == m_nPortNumber )
			{
				SendMessage( WM_EQP_MESSAGE, MSG_UP_STREAM_STATE, (LPARAM)(LPCTSTR) "Disconnect" );
				SetLog( "SECSMSG ", 0, 0, "Socket Disconnected" );
			}
			else if( nPortNo == m_nPortNumber1 )
			{
				SendMessage( WM_EQP_MESSAGE, MSG_UP_STREAM_STATE1, (LPARAM)(LPCTSTR) "Disconnect" );
				SetLog( "SECSMSG ", 0, 0, "Socket1 Disconnected" );
			}
			break;

		case XSecsHSMS::smPrimaryOutError :
		case XSecsHSMS::smSecondaryOutError :
			//call operator(buzzer, tower)
			m_pEqpStateSeq->SetLampState( CAlarm::lampTOWER_LAMP_Y, CAlarm::lampTOGGLE );
			m_pEqpStateSeq->SetLampState( CAlarm::lampMELODY2, CAlarm::lampON );

			if( nEvent == XSecsHSMS::smPrimaryOutError )
				szBuf.Format( "S%dF%d Primary message send error : Retry ?\n\n ( YES = Retry , NO = Offline Mode )"
				, pTranx->Primary.GetStreamCode(), pTranx->Primary.GetFunctionCode() );
			else 
				szBuf.Format( "S%dF%d Primary message send error : Retry ?\n\n ( YES = Retry , NO = Offline Mode )"
				, pTranx->Secondary.GetStreamCode(), pTranx->Secondary.GetFunctionCode() );

			SetLog( "SECSMSG ", 0, 0, szBuf );

			if( nPortNo == m_nPortNumber )
			{
				if( AfxMessageBox( szBuf,MB_RETRYCANCEL|MB_ICONQUESTION ) == IDRETRY ) // Retry
				{
					if( !m_pHost->m_bConnected )
						AfxMessageBox ( "Host is disconnected. Send message is impossible!" );					
					else if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE )
						AfxMessageBox ( "Offline mode. Send message is impossible!" );					
					else
					{
						if( nEvent == XSecsHSMS::smSecondaryOutError )		pTranx->SecondaryOut();
						else												pTranx->PrimaryOut();
					}
				}		
				else 	//Offline mode change
				{
					m_pDicsData->m_IfCim.bCtlModeChangeReq = TRUE;
					m_pDicsData->m_IfCim.cCtlMode = CDicsData::modeOFFLINE;
				}
			}
			else if( nPortNo == m_nPortNumber1 )
			{
				if( AfxMessageBox( szBuf,MB_RETRYCANCEL|MB_ICONQUESTION ) == IDRETRY ) // Retry
				{
					if( !m_pHost1->m_bConnected )
						AfxMessageBox ( "Host is disconnected. Send message is impossible!" );					
					else if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE )
						AfxMessageBox ( "Offline mode. Send message is impossible!" );					
					else
					{
						if( nEvent == XSecsHSMS::smSecondaryOutError )		pTranx->SecondaryOut();
						else												pTranx->PrimaryOut();
					}
				}		
				else 	//Offline mode change
				{
//					m_pDicsData->m_IfCim.bCtlModeChangeReq = TRUE;
//					m_pDicsData->m_IfCim.cCtlMode = CDicsData::modeOFFLINE;
				}
			}

			//call operator reset (buzzer, tower)
			m_pEqpStateSeq->SetLampState( CAlarm::lampTOWER_LAMP_Y, CAlarm::lampOFF );
			m_pEqpStateSeq->SetLampState( CAlarm::lampMELODY2, CAlarm::lampOFF );

			SendMessage( WM_JOBS_VIEW, MSG_TERMINAL_MESSAGE, (LPARAM)(LPCTSTR) szBuf );
			SendMessage( WM_JOBS_VIEW_SELECT_TAB, 1, NULL );
			break;
		case XSecsHSMS::smT3Error :
			// Retry Ƚ  ڵ Retry
/*			if( nRetryNo < atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsT3_RETRY_NO] ))
			{
				if( m_pHost->m_bConnected && m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeOFFLINE )
				{
					pTranx->PrimaryOut();
					nRetryNo++;
				}
				break;
			} */
			if( nPortNo == m_nPortNumber )
			{
				if( m_pHost->m_bConnected && m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeOFFLINE ) //S9F9 Frist Send
				{
					pTranx->PrimaryOut();
				}

				//call operator(buzzer, tower)  
				m_pEqpStateSeq->SetLampState( CAlarm::lampTOWER_LAMP_Y, CAlarm::lampTOGGLE );
				m_pEqpStateSeq->SetLampState( CAlarm::lampMELODY2, CAlarm::lampON );

				szBuf.Format( "S%dF%d T3 Timeout Error : Retry (NO : Offline Mode) ?", pTranx->Secondary.GetStreamCode(), pTranx->Secondary.GetFunctionCode() );
				SetLog( "SECSMSG ", 0, 0, szBuf );

				if( AfxMessageBox( szBuf,MB_YESNO|MB_ICONQUESTION ) == IDYES ) // Retry
				{
					if( !m_pHost->m_bConnected )
						AfxMessageBox ( "Host is disconnected. Send message is impossible!" );					
					else if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE )
						AfxMessageBox ( "Offline mode. Send message is impossible!" );					
	//				else
	//					pTranx->PrimaryOut();
				}		
				else 	
				{
					nRetryNo = 0;
					szBuf = "Offline Mode Changed";
					SetLog( "SECSMSG ", 0, 0, szBuf );

					m_pDicsData->m_EqpInfo.cCtlMode = CDicsData::modeOFFLINE;
					m_pDicsData->m_IfCim.cCtlMode = CDicsData::modeOFFLINE;
					SendMessage( WM_JOBS_VIEW, (WPARAM) MSG_CTRL_MODE, (LPARAM)(LPCTSTR) "Offline" );
	//1				m_pCimSeq->m_nSeqCtlModeChangeNo = 20;
				} 

				//call operator reset (buzzer, tower)
				m_pEqpStateSeq->SetLampState( CAlarm::lampTOWER_LAMP_Y, CAlarm::lampOFF );
				m_pEqpStateSeq->SetLampState( CAlarm::lampMELODY2, CAlarm::lampOFF );

				SendMessage( WM_JOBS_VIEW, MSG_TERMINAL_MESSAGE, (LPARAM)(LPCTSTR) szBuf );
				SendMessage( WM_JOBS_VIEW_SELECT_TAB, 1, NULL );
			}
			break; 

/*			szBuf.Format( "S%dF%d T3 Timeout Error : Retry ?", pTranx->Secondary.GetStreamCode(), pTranx->Secondary.GetFunctionCode() );
			SetLog( szBuf );

			if( AfxMessageBox( szBuf,MB_YESNO|MB_ICONQUESTION ) == IDYES ) // Retry
			{
				if( !m_pHost->m_bConnected )
					AfxMessageBox ( "Host is disconnected. Send message is impossible!" );					
				else if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE )
					AfxMessageBox ( "Offline mode. Send message is impossible!" );					
				else
					pTranx->PrimaryOut();
			}		
			else 	
			{
				nRetryNo = 0;
				szBuf.Format( "Reconnect to Back up Host? \n\n ( YES = Back up Host , NO = Offline Mode )" );
				SetLog( szBuf );
				if ( AfxMessageBox( szBuf,MB_YESNO|MB_ICONQUESTION ) == IDYES ) 
				{
					szBuf = "Backup Host Connected";
					SetLog( szBuf );

					m_pDicsData->m_IfCim.cCtlMode = CDicsData::modeOFFLINE;
					m_pDicsData->m_EqpInfo.cCtlMode = CDicsData::modeOFFLINE;

					m_pDicsData->m_IfCim.bBackupHostChange = TRUE;

/*					m_sHostIpAddress = GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsBACKUP_IP_ADDRESS];
					m_nPortNumber = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsBACKUP_PORT_NUMBER] );

					m_pDicsData->m_IfCim.cCtlMode = CDicsData::modeOFFLINE;
					m_pDicsData->m_EqpInfo.cCtlMode = CDicsData::modeOFFLINE;

					m_pHost->S1F65( 1, m_pDicsData->m_IfCim.cCtlMode );  // OFFLine
					szBuf = "S1F65 (EQP->HOST)";
					SetLog( szBuf );

					m_pHost->SecondaryRcvd( "S1F65_1" );
					szBuf = "S1F66 (EQP<-HOST)";
					SetLog( szBuf ); 

					//Back Up Host 翬
					SendMessage( WM_SOCKET_OPEN, 0, CDicsView::smHostDisconnect );	//socket close
					SendMessage( WM_SOCKET_OPEN, 0, CDicsView::smHostConnect );	//socket open

					SendMessage( WM_EQP_MESSAGE, MSG_HOST_INFO, (LPARAM)(LPCTSTR) "Backup" ); */
/*				} 
				else 	//Offline mode change
				{
					szBuf = "NO = Offline Mode Changed";

					m_pDicsData->m_EqpInfo.cCtlMode = CDicsData::modeOFFLINE;
					m_pDicsData->m_IfCim.cCtlMode = CDicsData::modeOFFLINE;
					m_pCimSeq->m_nSeqCtlModeChangeNo = 20;
//					m_pDicsData->m_IfCim.bCtlModeChangeReq = TRUE;
				}
			} 

			//call operator reset (buzzer, tower)
			m_pEqpStateSeq->SetLampState( CAlarm::lampTOWER_LAMP_Y, CAlarm::lampOFF );
			m_pEqpStateSeq->SetLampState( CAlarm::lampMELODY2, CAlarm::lampOFF );

			SendMessage( WM_JOBS_VIEW, MSG_TERMINAL_MESSAGE, (LPARAM)(LPCTSTR) szBuf );
			SendMessage( WM_JOBS_VIEW_SELECT_TAB, 1, NULL );
			break; */
		case XSecsHSMS::smError :
			if( pTranx->Secondary.GetFunctionCode() == 0 ) 
			{
				szBuf.Format( "Abort Transation Receive! (S%dF%d)", 
					pTranx->Secondary.GetStreamCode(), pTranx->Secondary.GetFunctionCode() );
				SendMessage( WM_JOBS_VIEW, MSG_TERMINAL_MESSAGE, (LPARAM)(LPCTSTR) szBuf );
				SendMessage( WM_JOBS_VIEW_SELECT_TAB, 1, NULL );
			}
			else 
			{
				szBuf = "Unregistered Transation Receive!";
				SendMessage( WM_JOBS_VIEW, MSG_TERMINAL_MESSAGE, (LPARAM)(LPCTSTR) szBuf );
				SendMessage( WM_JOBS_VIEW_SELECT_TAB, 1, NULL );
			}
			break;

		case XSecsHSMS::smWarning :
			break;

		//2006.01.27 Youngsik ===>
		// Abort Transaction °Ϳ ... 
		case XSecsHSMS::smAbortTransaction :
			{
				szBuf.Format( "Abort Transaction Receive(S%dF0)", pTranx->Secondary.GetStreamCode() );
				SetLog( "SECSMSG ", 0, 0, szBuf );
				szBuf.Format( "2nd MSG RECV (H->E) S%dF0   Abort Transaction", pTranx->Secondary.GetStreamCode() );
				HostLogMsg((LPCTSTR)szBuf);
			}
			break;
		//2006.01.27 Youngsik <===
	}
}

//---------------------------------------------------------------------------
// set the host log
//---------------------------------------------------------------------------
void CDicsView::HostLogMsg(LPCTSTR lpszMsg)
{
	CString szMsg = "";
	szMsg.Format( "%s", lpszMsg );
	if( m_listHostLog.GetCount() >= 30 ) m_listHostLog.DeleteString( 0 );
	int i = m_listHostLog.AddString( szMsg );
	m_listHostLog.SetCurSel( i );
}

//---------------------------------------------------------------------------
// set the host log
//---------------------------------------------------------------------------
void CDicsView::OnEditCstIdInfo( WPARAM wParam, LPARAM lParam )
{
	CDlgEditCstId dlg;

	dlg.m_sTitle.Format( "PORT%d CST ID", wParam + 1 );
	dlg.DoModal();

	dlg.m_sCstId.MakeUpper();
	m_pDicsData->m_PortInfo[wParam].sCstId = dlg.m_sCstId;
	dlg.m_sOpId.MakeUpper();
	m_pDicsData->m_PortInfo[wParam].sOpId = dlg.m_sOpId;
	m_pDicsData->m_IfCim.bKeyInCstIdComp[wParam] = TRUE;
}

//---------------------------------------------------------------------------
// OnSocketOpen
//---------------------------------------------------------------------------
void CDicsView::OnSocketOpen( WPARAM wParam, LPARAM lParam )
{
	switch(lParam)
	{
	case 0:
		m_pHost->m_bConnected = FALSE;
		m_pHost->m_bSelected = FALSE;
		delete m_pHost->m_pClientSocket;
		m_pHost->m_pClientSocket = NULL;
		break;
	case 1:
		OpenSocket( FALSE );
		break;
	}
}

//---------------------------------------------------------------------------
// OnSocketOpen
//---------------------------------------------------------------------------
void CDicsView::OnSocketOpen1( WPARAM wParam, LPARAM lParam )
{
	switch(lParam)
	{
	case 0:
		m_pHost1->m_bConnected = FALSE;
		m_pHost1->m_bSelected = FALSE;
		delete m_pHost1->m_pClientSocket;
		m_pHost1->m_pClientSocket = NULL;
		break;
	case 1:
		OpenSocket1( FALSE );
		break;
	}
}
//---------------------------------------------------------------------------
// OpenSocket
//---------------------------------------------------------------------------
BOOL CDicsView::OpenSocket(BOOL bShowMsgBox)
{
	if( m_pHost->m_bConnected ) return TRUE;

	if( !m_pHost->Connect( m_sIpAddress, m_nPortNumber, bShowMsgBox ) ) return FALSE;
	return TRUE;
}

BOOL CDicsView::OpenSocket1(BOOL bShowMsgBox)
{
	if( m_pHost1->m_bConnected ) return TRUE;

	if( !m_pHost1->Connect( m_sIpAddress1, m_nPortNumber1, bShowMsgBox ) ) return FALSE;
	return TRUE;
}

void CDicsView::OnAIValue( WPARAM wParam, LPARAM lParam )
{
	float fVal = (float)atof( (LPCTSTR)lParam );

//	m_pAI1->SetOpMsg( (int)wParam, fVal );
}

//---------------------------------------------------------------------------
// SetToolbar
//---------------------------------------------------------------------------
void CDicsView::SetToolbar( int nTab )
{
	// Get document pointer
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CMainFrame* pMainFrame = (CMainFrame*) pApp->m_pMainWnd;
	if( pMainFrame->m_bAuto )
	{	
		// Layout toolbar
		if(nTab == viewJobMain )
		{
			pMainFrame->m_wndCommandToolBar.LoadToolBar( IDR_JOBS );
			pMainFrame->m_wndCommandToolBar.LoadTrueColorToolBar( pMainFrame->m_JobsToolBarImage );
			pMainFrame->RecalcLayout();
			
		}
		else if(nTab == viewJobInterface ) 
		{
			pMainFrame->m_wndCommandToolBar.LoadToolBar( IDR_JOBS_CIM );
			pMainFrame->m_wndCommandToolBar.LoadTrueColorToolBar( pMainFrame->m_JobsCimToolBarImage );
			pMainFrame->RecalcLayout();
		}
		else
		{
			// Layout toolbar
			pMainFrame->m_wndCommandToolBar.LoadToolBar( IDR_JOBS );
			pMainFrame->m_wndCommandToolBar.LoadTrueColorToolBar( pMainFrame->m_JobsToolBarImage );
			pMainFrame->RecalcLayout();
		}
	}
	else
	{
		
	    if( nTab == viewJobPiping )
		{
			if( m_pDicsData->m_GenInfo.bAuto )
			{
				for( int i = 0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++)
				{
					int nOcxId = m_pEqpAssy->m_AnalogInput.m_aiSet[i].uRESID;
					if( nOcxId >= 0 ) m_pTabJobsPipingView->m_ocxAnalogInput[nOcxId].SetPermitAccess( FALSE );
				}
			}
			else if( !m_pDicsData->m_GenInfo.bAuto && m_pDicsData->m_LoginInfo.nCurUserLevel >= CDicsData::idMAINT )
			{
				for( int i = 0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++)
				{
					int nOcxId = m_pEqpAssy->m_AnalogInput.m_aiSet[i].uRESID;
					if( nOcxId >= 0 ) m_pTabJobsPipingView->m_ocxAnalogInput[nOcxId].SetPermitAccess( TRUE );
				}
			}
			pMainFrame->m_wndCommandToolBar.LoadToolBar( IDR_MAINT );
			pMainFrame->m_wndCommandToolBar.LoadTrueColorToolBar( pMainFrame->m_MaintToolBarImage );
		}
/*		else if(nTab == viewJobInterface ) 
		{
			pMainFrame->m_wndCommandToolBar.LoadToolBar( IDR_JOBS_ECS );
			pMainFrame->m_wndCommandToolBar.LoadTrueColorToolBar( pMainFrame->m_JobsCimToolBarImage );
			pMainFrame->RecalcLayout();
		}
*/		else
		{
			pMainFrame->m_wndCommandToolBar.LoadToolBar( IDR_JOBS );
			pMainFrame->m_wndCommandToolBar.LoadTrueColorToolBar( pMainFrame->m_JobsToolBarImage );
		}
	}
}

#include "Dlg\DialogGlassInfo.h"
//--------------------------------------------------------------------------------
// OnRButtonDown : Use it for test only
//--------------------------------------------------------------------------------
void CDicsView::OnRButtonDown(UINT nFlags, CPoint point) 
{	
#ifdef _MY_DEBUG
	m_pEqpStateSeq->m_bAlarmReset = TRUE;
	m_pDicsData->m_IfLoader.bDebugLdReady = TRUE;
	m_pDicsData->m_IfLoader.bGlassPutComp = TRUE;
//	CDlgCimTest dlg;
//	dlg.SetHost( m_pHost );
//	dlg.DoModal();
#endif

//	CDlgCimTest dlg;

//	dlg.SetHost( m_pHost );
//	dlg.DoModal();

//	m_pGlassAni->RbtMove( RBT_LD_UP_HAND_UNIT, CGlassAni::aniLDUP_RECV1 );
//	static int i = 0;
//	m_pGlassAni->StartGlassMove( 0 );
//	m_pGlassAni->GlassMoveRegion( 0, i++, TRUE );
//	if( i > MAX_UNIT_NO * 2 ) i = 0;
//	m_pDicsData->SetGlassData( IF_UNIT_LD*2 + 0, 1 );
	CFormView::OnRButtonDown(nFlags, point);
}

//---------------------------------------------------------------------------
// Delete the glass information
//---------------------------------------------------------------------------
int CDicsView::GlassInfoDelete(int nId ,BOOL bMove)//2008.11.18 kimgun)
{
	int i = nId;

	int nPortNo = m_pDicsData->m_GlsInfo[i].nPortNo;
	int nSlotNo = m_pDicsData->m_GlsInfo[i].nSlotNo;

	if( i / 2 == IF_UNIT_UP_LD )
	{
//		int nRv = m_pTrSeq->GlassInfoDeleteTr();
//		if( nRv != dmOK ) return nRv;
//		m_pIfSeq->InitParameter();
//		m_pIfSeq->ResetInterfaceSignal();

		m_pIfSeq->ResetInterfaceSignalLd();
		m_pIfSeq->m_nSeqGlassRecvNo				= 0;
		SetLog( "GLS_DELE", 0, 0, "INTERFACE SIGNAL(RECV) -> Off" );
	}
#ifndef _NO_UL_HAND
	else if( i / 2 == IF_UNIT_UL_HAND )
	{
		m_pIfSeq->ResetInterfaceSignalUl();
		m_pIfSeq->m_nSeqGlassSendNo				= 0;
		SetLog( "GLS_DELE", 0, 0, "INTERFACE SIGNAL(SEND) -> Off" );
	}	
#else
	else if( i / 2 == IF_UNIT_UL)
	{
		m_pIfSeq->ResetInterfaceSignalUl();
		m_pIfSeq->m_nSeqGlassSendNo				= 0;
		SetLog( "GLS_DELE", 0, 0, "INTERFACE SIGNAL(SEND) -> Off" );
	}
#endif
	if( !bMove )
	//////////////////////////////////////////////////////////////////////////
	//Glass Data  s6f11 ġ UL Ͽ S6f1 ߴ
	{
		m_pHost1->S6F11( i , TRUE );
		//m_pHost1->m_bEventReportReq[IF_UNIT_UL] = TRUE;//2008.11.07 kimgun
		SetLog( "GLS_DELE",nPortNo, nSlotNo, "Glass_In Event Report" );
	}
	//////////////////////////////////////////////////////////////////////////
	// Clear the glass existence
	m_pDicsData->DeleteGlassData( i );

	CString sMessage;
	sMessage.Format( "0%02d%1d", nSlotNo, nPortNo );
	OnCvStatusChanged( i, (LPARAM)(LPCTSTR) sMessage );
	// substrate a glass no
	m_pDicsData->m_GenInfo.nGlassNo -= 1;
	if( m_pDicsData->m_GenInfo.nGlassNo < 0 ) m_pDicsData->m_GenInfo.nGlassNo = 0;
	OnGlassNo( m_pDicsData->m_GenInfo.nGlassNo, 0L );

	// glass move end
	int nGlassNo = m_pDicsData->m_GlsInfo[i].nGlassNo;
	m_pGlassAni->EndGlassMove( nGlassNo );
	m_pGlassAni->GlassMove( nGlassNo, i + 1, FALSE );

	// Set the sequence number again
	m_pTrSeq->InitParameter();
	m_pCvSeq->InitParameter();
	m_pCvSeq1->InitParameter();
	m_pTrSeq->SetSeqNo();
	m_pCvSeq->SetSeqNo();
//	m_pCvSeq1->SetSeqNo();2008.10.12 kimgun

	if( i / 2 == IF_UNIT_LD && m_pDicsData->m_GenInfo.bEqpInitComp )//2008.09.02 kimgun
	{
		OnTactTime( CMainSeq::ttCOUNT_END, 0L );
		OnTactTime( CMainSeq::ttCOUNT_START, 0L );
	}
	
	

	//SetLampState( SWN_TOWER_LAMP_R, lampOFF );
	//SetLampState( SWN_TOWER_LAMP_Y, lampOFF );
	//SetLampState( SWN_BUZZER_OFF, lampOFF );
	//SetLampState( SWN_ALARM_RESET, lampOFF );

	// All Alarm Reset (ϴ  Alarm )
//	OnAlarm( ALARM_RESET_ALL, (LPARAM)(LPCTSTR) "" );

	return dmOK;
}
//---------------------------------------------------------------------------
// Move the glass information
//---------------------------------------------------------------------------
int CDicsView::GlassInfoMove(int i, int nTarget)
{
	// Target Position : There is glass data
	BOOL bIsValid = m_pDicsData->m_GlsInfo[nTarget].bIsValid;
	if( bIsValid ) return dmDUP_DATA;	// ̵ ġ Data 

#ifndef _MY_DEBUG
	if( !m_pEqpAssy->m_GlassExistUnit.GetOr( nTarget ) ) return dmNOT_SENSED_GLASS;
/*
	if( nTarget < MAX_UNIT_NO * 2 - 1 ) 
	{
		if( m_pEqpAssy->m_GlassExistUnit.GetOr(( nTarget + 1 ) ) return dmDENIED_LOGICALLY;
	}
*/
#endif
	if( GlassInfoDelete( i , TRUE ) != dmOK ) return dmSENSED_GLASS;
	//if( GlassInfoDelete( i ) != dmOK ) return dmSENSED_GLASS;

	// Add a glass no
	m_pDicsData->m_GenInfo.nGlassNo += 1;
	OnGlassNo( m_pDicsData->m_GenInfo.nGlassNo, 0L );

	// Set the glass no again
	int nGlassNo = m_pDicsData->FindGlassNo();
	m_pDicsData->m_GlsInfo[i].nGlassNo = nGlassNo;

	// Set the glass existence
	m_pDicsData->MoveGlassData( i, nTarget );
	m_pDicsData->DeleteGlassData( nTarget, FALSE );	// Target Data Validϰ Ѵ.

	int nPortNo = atoi( m_pDicsData->m_GlsInfo[nTarget].sPortNo );
	int nSlotNo = atoi( m_pDicsData->m_GlsInfo[nTarget].sSlotNo );
	CString sMessage;
	sMessage.Format( "1%02d%d", nSlotNo, nPortNo );
	OnCvStatusChanged( i, (LPARAM)(LPCTSTR) sMessage );

	// glass move region
	m_pGlassAni->StartGlassMove( nGlassNo );

	if( nTarget >= 10 ) m_pGlassAni->GlassMoveRegion( nGlassNo, nTarget+2 );
	else 
	{
		if( nTarget == 8 )
		{
			if( m_pDicsData->m_IfFlag[IF_UNIT_LD].bRecvPosComp ) 
			{
				m_pGlassAni->GlassMoveRegion( nGlassNo, nTarget+1 );
			}
			else m_pGlassAni->GlassMoveRegion( nGlassNo, nTarget+2 );
		}
		else if( nTarget == 9 )
		{
			if( m_pDicsData->m_IfFlag[IF_UNIT_LD].bRecvPosComp ) m_pGlassAni->GlassMoveRegion( nGlassNo, nTarget-1 );
			else m_pGlassAni->GlassMoveRegion( nGlassNo, nTarget+2 );
		}
		else 
		{
			m_pGlassAni->GlassMoveRegion( nGlassNo, nTarget );
		}
	}

	// Set the sequence number again
	m_pTrSeq->InitParameter();
	m_pCvSeq->InitParameter();
	m_pCvSeq1->InitParameter();
	m_pTrSeq->SetSeqNo();
	m_pCvSeq->SetSeqNo();
	m_pCvSeq1->SetSeqNo(nTarget);

	sMessage.Format( "Glass Data Move from %d to %d", i, nTarget ); 
	SetLog("DATAMOVE", 0, 0, sMessage );

	return dmOK;
}

void CDicsView::GlassDataAdd( WPARAM wParam, LPARAM lParam )
{
/*	int nUnitNo = m_pDicsData->m_IfCim.nSubUnitID;
	
	int nGlassNo = m_pDicsData->FindGlassNo();
	m_pDicsData->m_GlsInfoRecv.nGlassNo = nGlassNo;
	m_pDicsData->m_GlsInfoRecv.bIsValid = TRUE;
	m_pDicsData->m_GlsInfo[nUnitNo] = m_pDicsData->m_GlsInfoRecv;

	m_pDicsData->WriteProfileGlassData( nUnitNo );

	m_pDicsData->m_GenInfo.nGlassNo += 1;			
	m_pTabJobsMainView->SetGlassNo( m_pDicsData->m_GenInfo.nGlassNo, 1 );

	if( nUnitNo == IF_UNIT_LD*2 + 0 )
	{
		m_pDicsData->m_GenInfo.bCycleStop = TRUE;

#ifdef _MY_DEBUG
		m_pDicsData->m_bDebugInSensor[nUnitNo/2+nUnitNo%2] = TRUE;
#endif
		m_pMainSeq->m_pGlassAni->StartGlassMove( nGlassNo );
		m_pMainSeq->m_pGlassAni->GlassMoveRegion( nGlassNo, nUnitNo, TRUE );
		m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateSTOP] = 1;

		m_pCvSeq->m_nSeqInSensorNo[IF_UNIT_LD] = 0;
		m_pCvSeq->m_nSeqUnitLdNo = 0;
	}

	int nSlotNo = atoi( m_pDicsData->m_GlsInfo[nUnitNo].sSlotNo );
	CString sMessage;
	sMessage.Format( "1%02d%d", nSlotNo, 1 );
	OnCvStatusChanged( nUnitNo, (LPARAM)(LPCTSTR) sMessage );

	// glass move region
	if( m_pDicsData->m_IfCim.bUlGlsExist )
	{
		m_pDicsData->m_IfCim.bManualUnloadGlsDataReq = TRUE;
	}
	else
	{
		m_pGlassAni->StartGlassMove( nGlassNo );
		m_pGlassAni->GlassMoveRegion( nGlassNo, nUnitNo );
		
		// Set the sequence number again
		m_pTrSeq->InitParameter();
		//	m_pCvSeq->InitParameter();
		m_pTrSeq->SetSeqNo();
		//	m_pCvSeq->SetSeqNo();
	}
	sMessage.Format( "Glass Data Add from %d ", nUnitNo); 
	SetLog("DATA_ADD", 0, 0, sMessage );
*/
}

//---------------------------------------------------------------------------
// Copy the glass information
//---------------------------------------------------------------------------
int CDicsView::GlassInfoCopy(int i, int nTarget)
{
	// Target Position : There is glass data
/*	BOOL bIsValid = m_pDicsData->m_GlsInfo[nTarget].bIsValid;
	if( bIsValid ) return dmDUP_DATA;	// ̵ ġ Data 
#ifndef _MY_DEBUG
	if( !GLASS_EXIST_SENSOR( nTarget ) ) return dmNOT_SENSED_GLASS;
#endif

	// Add a glass no
	m_nGlassNo += 1;
	if( m_nGlassNo > MAX_EQP_GLASS_NO ) { m_nGlassNo = MAX_EQP_GLASS_NO; return dmEXCEED_GLASS_NO; }
	Msg( WM_GLASS_NO, m_nGlassNo, 0L, FALSE );

	// Set the glass no again
	int nGlassNo;
	int nBackupGlassNo = m_pDicsData->m_GlsInfo[i].nGlassNo;
	
	// Target Glass No ٲ۴.
	nGlassNo = m_pDicsData->FindGlassNo();
	m_pDicsData->m_GlsInfo[i].nGlassNo = nGlassNo;

	// Copy glass data
	m_pDicsData->MoveGlassData( i, nTarget );
	m_pDicsData->DeleteGlassData( i, FALSE );	// Source Data Validϰ Ѵ.

	if( m_pDicsData->m_GlsInfo[nTarget].bOfflineGlass )
	{
		m_nOfflineGlassNo += 1;
		if( m_nOfflineGlassNo > MAX_EQP_GLASS_NO ) m_nOfflineGlassNo = MAX_EQP_GLASS_NO; 
	}
	else
	{	
		m_nOnlineGlassNo += 1;
		if( m_nOnlineGlassNo > MAX_EQP_GLASS_NO ) m_nOnlineGlassNo = MAX_EQP_GLASS_NO; 
	}

	// Set the glass no again : Source Glass No  Ѵ.
	m_pDicsData->m_GlsInfo[i].nGlassNo = nBackupGlassNo;

	int nPortNo = m_pDicsData->m_GlsInfo[nTarget].nPortNo;
	int nSlotNo = m_pDicsData->m_GlsInfo[nTarget].nSlotNo;
	m_sMessage.Format( "1%02d%d", nSlotNo, nPortNo );
	Msg( WM_CV_STATUS_CHANGED, nTarget, (LPARAM)(LPCTSTR) m_sMessage );

	// glass move region
	m_pGlassAni->StartGlassMove( nGlassNo );
	m_pGlassAni->GlassMoveRegion( nGlassNo, nTarget );

	// Clear Parameter : TR  BUF Unit SeqNo ״  д.
	InitParameter();
	SetSeqNo();
	m_pTimer->InitFlagTimerOff();
	
	// All Alarm Reset (ϴ  Alarm )
	SetLampState( SWN_TOWER_LAMP_R, lampOFF );
	SetLampState( SWN_TOWER_LAMP_Y, lampOFF );
	SetLampState( SWN_BUZZER_OFF, lampOFF );
	SetLampState( SWN_ALARM_RESET, lampOFF );

	MELODY_O( 2, OFF );
	Msg( WM_ALARM, ALARM_RESET_ALL, 0L );

	// Flag Set
//	m_SeqFlag.bInit = TRUE;*/
	return dmOK;
}


void CDicsView::OnCheckCommLog() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	m_IniConfiguration.Open( "DicsInfo", "GenInfo" );

	m_pDicsData->m_GenInfo.bEnableCommLog = !m_pDicsData->m_GenInfo.bEnableCommLog;
	m_IniConfiguration.SetIntValue( "VIEW LOG", "COMM LOG", m_pDicsData->m_GenInfo.bEnableCommLog );
	
	m_macEnableCommLog.SetCheck( m_pDicsData->m_GenInfo.bEnableCommLog );
}

void CDicsView::OnCheckEqpLog() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	m_IniConfiguration.Open( "DicsInfo", "GenInfo" );

	m_pDicsData->m_GenInfo.bEnableEqpLog = !m_pDicsData->m_GenInfo.bEnableEqpLog;
	m_IniConfiguration.SetIntValue( "VIEW LOG", "EQP LOG", m_pDicsData->m_GenInfo.bEnableEqpLog );
	
	m_macEnableEqpLog.SetCheck( m_pDicsData->m_GenInfo.bEnableEqpLog );
}

void CDicsView::OnLostGlassAdd( WPARAM wParam, LPARAM lParam )
{
	CDaoLostGlassListSet LostGlassList; 
	LostGlassList.Open();
	LostGlassList.AddGlassData( m_pDicsData->m_GlsInfoLost );
	LostGlassList.Close();

	GlassInfoDelete( m_pDicsData->m_IfCim.nLostUnitNo );

	int nUnitNo = m_pDicsData->m_IfCim.nLostUnitNo;
#ifdef _MY_DEBUG
	if( nUnitNo % 2 )
	{
		m_pDicsData->m_bDebugOutSensor[nUnitNo/2] = FALSE;
	}
	else
	{
		m_pDicsData->m_bDebugInSensor[nUnitNo/2] = FALSE;
	}
#endif
}

void CDicsView::OnLostGlassRecovery( WPARAM wParam, LPARAM lParam )
{	
	int nVal=0;

	int nUnitNo = m_pDicsData->m_IfCim.nRecoveryUnitNo;

	m_pDicsData->ParseGlassData( m_pDicsData->m_GlsInfo[nUnitNo], m_pDicsData->m_GlsInfoRecovery.nGlassData );

	int nGlassNo = m_pDicsData->FindGlassNo();
	m_pDicsData->m_GlsInfo[nUnitNo].nGlassNo = nGlassNo;
	m_pDicsData->m_GlsInfo[nUnitNo].bIsValid = TRUE;

	m_pDicsData->WriteProfileGlassData( nUnitNo );
//		m_pTabJobsTab1View->SetCvState( nUnitNo, TRUE, m_pDicsData->m_GlsInfo[nUnitNo].nSlotNo );

	m_pDicsData->m_GenInfo.nGlassNo += 1;
	m_pTabJobsMainView->SetGlassNo( m_pDicsData->m_GenInfo.nGlassNo, 1 );

//		m_pTabJobsTab1View->m_bCreateGlassData[nUnitNo] = FALSE;

	m_pDicsData->m_GlsInfoRecv = m_pDicsData->m_GlsInfo[nUnitNo];

	if( nUnitNo == IF_UNIT_LD*2 + 0 )
	{
		m_pDicsData->m_GenInfo.bCycleStop = TRUE;

#ifdef _MY_DEBUG
		m_pDicsData->m_bDebugInSensor[nUnitNo/2+nUnitNo%2] = TRUE;
#endif
		m_pMainSeq->m_pGlassAni->StartGlassMove( nGlassNo );
		m_pMainSeq->m_pGlassAni->GlassMoveRegion( nGlassNo, nUnitNo, TRUE );
		m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateSTOP] = 1;

		m_pCvSeq->m_nSeqInSensorNo[IF_UNIT_LD] = 0;
		m_pCvSeq->m_nSeqUnitLdNo = 0;
	}

	CDaoLostGlassListSet LostGlassList;
	LostGlassList.Open();
	LostGlassList.DelGlassData( m_pDicsData->m_IfCim.nRecoveryListNo );
	LostGlassList.Close();

//		m_pDicsData->m_IfCim.nGlassDataReportRequestCase[nUnitNo/2] = CDicsData::caseCREATE;
//		m_pDicsData->m_IfCim.bGlassDataReportRequestUnitNo[nUnitNo/2] = TRUE;	
}


//--------------------------------------------------------------------------------
// SetLog
//--------------------------------------------------------------------------------
void CDicsView::SetLog(CString sSeqName, int nPortNo, int nSlotNo, CString sMessage)
{
	// Log
	CString sLog;
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	sLog.Format( "VIEW\t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( sLog );
}

/*BOOL CDicsView::SocketOpen(BOOL bShowMsgBox)
{

	if( m_pHost->m_bConnected ) return TRUE;
	m_bConnecting = FALSE;

	m_pHost->HSMST3 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsT3] );
	m_pHost->HSMST5 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsT5] );
	m_pHost->HSMST6 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsT6] );
	m_pHost->HSMST7 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsT7] );
	m_pHost->HSMST8 = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsT8] );
	m_pHost->LinkTestTimer = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsLINK_TEST_TIMER] );
//	m_pHost->m_nPositionReportTime = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsGLSPOSION_TIME] );

	m_pHost->SetDeviceID( atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsDEVICE_ID] ) );
	// 2002.12.21 Hong Jaehee
	// ܵ Mode  ܺο  ʵ 
	m_sIpAddress = GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsIP_ADDRESS];

	m_nPortNumber = atoi( GetDocument()->m_pSetupItems->m_sValueHsmsPara[CSetupItems::hsmsPORT_NUMBER] );
	if( !m_pHost->Connect(m_sIpAddress, m_nPortNumber, bShowMsgBox) ) return FALSE;

	m_bConnecting = TRUE;
	return TRUE;
}

void CDicsView::OnSocketOpen( WPARAM wParam, LPARAM lParam )
{
	switch(lParam)
	{
	case 1:
		SocketOpen( FALSE );
		break;

	case 0:
		m_pHost->m_bConnected = FALSE;
		m_pHost->m_bSelected = FALSE;
		delete m_pHost->m_pClientSocket;
		m_pHost->m_pClientSocket = NULL;

		CDicsApp* pApp = (CDicsApp*) AfxGetApp();
		CMainFrame* pMainFrame = (CMainFrame*) pApp->m_pMainWnd;
		//pMainFrame->SetTitlePanelMsg( CTitlePanel::nHOSTCOMM,  "Not Connected" );
		break;
	}
}
*/
//---------------------------------------------------------------------------
// Set the SECS message between eqp. and host.
//---------------------------------------------------------------------------
#include "SECS\XSecsSFCode.h"

//void CDicsView::OnSecsMsg(WPARAM wParam, LPARAM lParam)
//{
//	CTimeoutDlg dlg;
//	CString szBuf;
//	char buf[256];
//	char cWait;
//	if( lTranx == NULL ) return;
//	XSecsTranxThread* pTranx = (XSecsTranxThread*)lParam;
//	int nEvent = (int)wParam & 0x0F;
//	int nPortNo = (int)wParam >> 4;
//	switch( nEvent )
//	{
//		case XSecsHSMS::smPrimaryOut :
//			if( pTranx->Primary.GetWaitFlag() == XSecsMessage::waitFlagOn ) cWait = 'W';
//			else cWait = ' ';
//			szBuf.Format( "1 ޼ ۽ (HM) S%dF%d %c \"%s\"", pTranx->Primary.GetStreamCode(), pTranx->Primary.GetFunctionCode(), 
//				cWait, pTranx->GetDescription() );
//			AddHostMsg((LPCTSTR)szBuf);
//			break;
//		case XSecsHSMS::smSecondaryOut :
//			if( pTranx->Secondary.GetWaitFlag() == XSecsMessage::waitFlagOn ) cWait = 'W';
//			else cWait = ' ';
//			szBuf.Format( "2 ޼ ۽ (HM) S%dF%d", pTranx->Secondary.GetStreamCode(), pTranx->Secondary.GetFunctionCode() );
//			AddHostMsg((LPCTSTR)szBuf);
//			break;
//		case XSecsHSMS::smPrimaryIn :
//			if( pTranx->Primary.GetWaitFlag() == XSecsMessage::waitFlagOn ) cWait = 'W';
//			else cWait = ' ';
//			szBuf.Format( "1 ޼  (HM) S%dF%d %c \"%s\"", pTranx->Primary.GetStreamCode(), pTranx->Primary.GetFunctionCode(),
//				cWait, pTranx->GetDescription() );
//			AddHostMsg((LPCTSTR)szBuf);
//			break;
//		case XSecsHSMS::smSecondaryIn :
//			szBuf.Format( "2 ޼  (HM) S%dF%d", pTranx->Secondary.GetStreamCode(), pTranx->Secondary.GetFunctionCode() );
//			AddHostMsg((LPCTSTR)szBuf);
//			break;
//		case XSecsHSMS::smConnected :
//			{
//				CDicsApp* pApp = (CDicsApp*) AfxGetApp();
//				CMainFrame* pMainFrame = (CMainFrame*)pApp->m_pMainWnd;
//				pMainFrame->SetTitlePanelMsg( CTitlePanel::nHOSTCOMM,  "Connected" );
//			}
//			break;
//		case XSecsHSMS::smDisconnected :
//			{
//				CDicsApp* pApp = (CDicsApp*) AfxGetApp();
//				CMainFrame* pMainFrame = (CMainFrame*)pApp->m_pMainWnd;
//				pMainFrame->SetTitlePanelMsg( CTitlePanel::nHOSTCOMM,  "Not Connected" );
//			}
//			break;
//		case XSecsHSMS::smError :
//			{
//				CString sMessage;
//				sMessage.Format( "%s", (LPCTSTR) lParam );
//				m_pMainSeq->SetLog( "DICS VIEW", 0, 0, sMessage );
//			}
//			break;
//		case XSecsHSMS::smPrimaryOutError :
//		case XSecsHSMS::smSecondaryOutError :	
//			{
//				//call operator(buzzer, tower)
//				int nOldEqpMode = m_pMainSeq->m_pDicsData->m_nEqpMode;
//				m_pAlarmSeq->SetLampState(CMcStatus::lampMELODY1, CMcStatus::lampON);
//				m_pAlarmSeq->SetLampState(CMcStatus::lampTOWER_LAMP_R, CMcStatus::lampON);
//				CString sMessage;
//				if( nEvent == XSecsHSMS::smPrimaryOutError )
//					sMessage.Format( "S%dF%d Primary message send error : Retry ?", pTranx->Primary.GetStreamCode(), pTranx->Primary.GetFunctionCode() );
//				else if( nEvent == XSecsHSMS::smSecondaryOutError )
//					sMessage.Format( "S%dF%d Secondary message send error : Retry ?", pTranx->Secondary.GetStreamCode(), pTranx->Secondary.GetFunctionCode() );
//				m_pMainSeq->SetLog( "DICS VIEW", 0, 0, sMessage );
//				if ( AfxMessageBox( sMessage,MB_YESNO|MB_ICONQUESTION ) == IDYES) // Retry
//				{
//					if( !m_pHost->m_bConnected )
//						AfxMessageBox ( "Host  ܼ ۽ Ұմϴ!" );					
//					else if( m_pMainSeq->m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::ctlOFFLINE )
//						AfxMessageBox ( "Offline mode  ۽ Ұմϴ!" );					
//					else
//					{
//						if( nEvent == XSecsHSMS::smSecondaryOutError )
//							pTranx->SecondaryOut();
//						else
//							pTranx->PrimaryOut();
//					}
//				}
//				else
//				{
//					m_pMainSeq->SetLog( "DICS VIEW", 0, 0, "Message send error ߻[Offline ȯ]" );
//					// Offline ȯ
//					m_pMainSeq->m_pDicsData->m_IfCim.bCtlModeChangeReq = TRUE;
//					m_pMainSeq->m_pDicsData->m_IfCim.cCtlMode = CDicsData::ctlOFFLINE;
//				}
//				m_pAlarmSeq->SetLampState(CMcStatus::lampMELODY1, CMcStatus::lampOFF);
//				m_pAlarmSeq->SetMcStatus( nOldEqpMode );
//			}
//			break;
//		case XSecsHSMS::smT3Error:
//			{
//				int nSFCode = pTranx->Primary.GetSFCode();
//				switch( nSFCode )
//				{
//				case _S1F1:
//				case _S1F61:
//				case _S1F67:
//				case _S2F17:
//				case _S2F25:
//				case _S2F51:
//				case _S2F61:
//				case _S2F63:
//				case _S2F67:
//				case _S2F79: // Get Glass Data Request
//				case _S2F81:
//				case _S5F1:
//				//case _S6F61:
//				//case _S6F63:
//				//case _S6F67:
//				case _S6F73: // Glass APD Report
//				case _S6F75:
//				case _S6F83: // Lot APD Report
//				case _S6F91: //
//				case _S6F93:
//				case _S6F101:
//					{
//						//call operator(buzzer, tower)
//						int nOldEqpMode = m_pMainSeq->m_pDicsData->m_nEqpMode;
//						m_pAlarmSeq->SetLampState(CMcStatus::lampMELODY1, CMcStatus::lampON);
//						m_pAlarmSeq->SetLampState(CMcStatus::lampTOWER_LAMP_R, CMcStatus::lampON);
//						//T3 timeout dialog
//						CString sMessage;
//						sMessage.Format( "S%dF%d T3 Timeout ߻.", pTranx->Primary.GetStreamCode(), pTranx->Primary.GetFunctionCode() );
//						m_pMainSeq->SetLog( "DICS VIEW", 0, 0, sMessage );
//						//AfxMessageBox( sMessage );
//						m_pTabJobsTab1View->SendMessage( WM_T3_MESSAGE, (WPARAM) TRUE, (LPARAM)(LPCTSTR) sMessage );
//						
//						//if ( AfxMessageBox( sMessage,MB_OK|MB_ICONQUESTION ) == IDOK) // Retry
//						{
//							m_pAlarmSeq->SetLampState(CMcStatus::lampMELODY1, CMcStatus::lampOFF);
//							m_pAlarmSeq->SetMcStatus( nOldEqpMode );
//						}
//						if( nSFCode == _S1F1 ) m_pHost->m_FlagSecondary.S1F2 = TRUE;
//						if( nSFCode == _S1F61 ) m_pHost->m_FlagSecondary.S1F62 = TRUE;
//						if( nSFCode == _S1F67 ) m_pHost->m_FlagSecondary.S1F68 = TRUE;
//						if( nSFCode == _S2F17 ) m_pHost->m_FlagSecondary.S2F18 = TRUE;
//						if( nSFCode == _S2F25 ) m_pHost->m_FlagSecondary.S2F26 = TRUE;
//						if( nSFCode == _S2F51 ) m_pHost->m_FlagSecondary.S2F52 = TRUE;
//						if( nSFCode == _S2F61 ) m_pHost->m_FlagSecondary.S2F62 = TRUE;
//						if( nSFCode == _S2F63 ) m_pHost->m_FlagSecondary.S2F64 = TRUE;
//						if( nSFCode == _S2F67 ) m_pHost->m_FlagSecondary.S2F68 = TRUE;
//						if( nSFCode == _S2F79 ) m_pHost->m_FlagSecondary.S2F80 = TRUE;
//						if( nSFCode == _S2F81 ) m_pHost->m_FlagSecondary.S2F82 = TRUE;
//						if( nSFCode == _S5F1 ) m_pHost->m_FlagSecondary.S5F2 = TRUE;
//						//if( nSFCode == _S6F61 ) m_pHost->m_FlagSecondary.S6F62 = TRUE;
//						//if( nSFCode == _S6F63 ) m_pHost->m_FlagSecondary.S6F64 = TRUE;
//						//if( nSFCode == _S6F67 ) m_pHost->m_FlagSecondary.S6F68 = TRUE;
//						if( nSFCode == _S6F73 ) m_pHost->m_FlagSecondary.S6F74 = TRUE;
//						if( nSFCode == _S6F75 ) m_pHost->m_FlagSecondary.S6F76 = TRUE;
//						if( nSFCode == _S6F83 ) m_pHost->m_FlagSecondary.S6F84 = TRUE;
//						if( nSFCode == _S6F91 ) m_pHost->m_FlagSecondary.S6F92 = TRUE;
//						if( nSFCode == _S6F93 ) m_pHost->m_FlagSecondary.S6F94 = TRUE;
//						if( nSFCode == _S6F101 ) m_pHost->m_FlagSecondary.S6F102 = TRUE;
//						if( nSFCode == _S15F79 ) m_pHost->m_FlagSecondary.S15F80 = TRUE;
//					}
//					break;
//				case _S6F61: // Load Glass Data Request
//				case _S6F63: // Unload Glass Data Report
//				case _S6F67: // Glass Move Report
//					{
//						//call operator(buzzer, tower)
//						int nOldEqpMode = m_pMainSeq->m_pDicsData->m_nEqpMode;
//						m_pAlarmSeq->SetLampState(CMcStatus::lampMELODY1, CMcStatus::lampON);
//						m_pAlarmSeq->SetLampState(CMcStatus::lampTOWER_LAMP_R, CMcStatus::lampON);
//						//T3 timeout dialog
//						CString sMessage;
//						if( m_pHost->m_nT3RetryCount > 1 ) sMessage.Format( "S%dF%d T3 timeout occur : Offline ȯմϴ.", pTranx->Primary.GetStreamCode(), pTranx->Primary.GetFunctionCode() );
//						else sMessage.Format( "T3 timeout occur : %d-th Retry ?", m_pHost->m_nT3RetryCount + 1 );
////						m_pMainSeq->SetLog( "DICS VIEW", 0, 0, sMessage );
//
//						if ( AfxMessageBox( sMessage,MB_OK|MB_ICONQUESTION ) == IDOK) // Retry
//						{
////							m_pAlarmSeq->SetLampState(CMcStatus::lampMELODY1, CMcStatus::lampOFF);
////							m_pAlarmSeq->SetMcStatus( nOldEqpMode );
//							if( m_pHost->m_nT3RetryCount < 2 ) 
//							{
//								if( !m_pHost->m_bConnected )
//									AfxMessageBox ( "Host  ܼ ۽ Ұմϴ!" );					
//								else if( m_pMainSeq->m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::ctlOFFLINE )
//									AfxMessageBox ( "Offline mode  ۽ Ұմϴ!" );					
//								else
//								{
//									pTranx->PrimaryOut();	
//									m_pHost->m_nT3RetryCount++;
//								}
//							}
//							else
//							{
//								if( nSFCode == _S6F61 ) m_pHost->m_FlagSecondary.S6F62 = TRUE;
//								if( nSFCode == _S6F63 )
//								{
//									sMessage = "Unload Data  Ϸ ϰ Unloading մϴ.";
//									AfxMessageBox(sMessage, MB_OK);
////									m_pMainSeq->SetLog( "DICS VIEW", 0, 0, sMessage );
//									m_pHost->m_FlagSecondary.S6F64 = TRUE;
//								}
//								else if( nSFCode == _S6F67 ) m_pHost->m_FlagSecondary.S6F68 = TRUE;
//								else
//								{
//									// Offline ȯ
////									m_pMainSeq->m_pDicsData->m_IfCim.bCtlModeChangeReq = TRUE;
////									m_pMainSeq->m_pDicsData->m_IfCim.cCtlMode = CDicsData::ctlOFFLINE;
//									m_pHost->m_nT3RetryCount = 0;
//								}
//							}
//						}
//					}
//					break;
//				default:
//					break;
//				}
//			}
//			break;
//		case XSecsHSMS::smWarning :
//			break;
//		//2006.01.27 Youngsik ===>
//		// Abort Transaction °Ϳ ... 
//		case XSecsHSMS::smAbortTransaction :
//			{
//				CString sMessage;
//				sMessage.Format( "Abort Transaction (S%dF0)", pTranx->Secondary.GetStreamCode() );
//				m_pMainSeq->SetLog( "DICS VIEW", 0, 0, sMessage );
//				szBuf.Format( "2 ޼  (HM) S%dF0 Abort Transaction", pTranx->Secondary.GetStreamCode() );
//				AddHostMsg((LPCTSTR)szBuf);
//			}
//			break;
//		//2006.01.27 Youngsik <===
//	}
//}

void CDicsView::AddHostMsg(LPCTSTR szMsg)
{
	m_listHostLog.AddString(szMsg);
	//100 ̻ ޼ .(  )
	while(m_listHostLog.GetCount() > 100){
		m_listHostLog.DeleteString(0);
	}
	int no = m_listHostLog.GetCount();
	if (no > 0) m_listHostLog.SetCurSel(no-1);
}

void CDicsView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

//#ifdef _MY_DEBUG
//	CDlgLoaderTest dlg;
//	dlg.SetDicsData( m_pDicsData );
//	dlg.DoModal();
//#endif
	CFormView::OnLButtonDown(nFlags, point);
}

void CDicsView::OnTestModeSet( WPARAM wParam, LPARAM lParam )
{/*
	int	nCount = (int) wParam;
	CString	sMsg;

	sMsg.Format( "%d / %d / %d", m_pCimSeq->m_TestModeFlag.nInputGlassCount,
								m_pCimSeq->m_TestModeFlag.nOutputGlassCount,
								m_pCimSeq->m_TestModeFlag.nTestSettingCount );

	if( m_pCimSeq->m_TestModeFlag.nOutputGlassCount >= m_pCimSeq->m_TestModeFlag.nTestSettingCount )
	{
		m_pTabJobsCimView->EnableTestModeButton( TRUE );
	}

	m_pTabJobsCimView->m_msgGlassCount.SetOpMsg( sMsg ); */
}
