// CvSeq.cpp: implementation of the CCvSeq class.
// Ver 1.1
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "CvSeq.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCvSeq::CCvSeq()
{

}

CCvSeq::~CCvSeq()
{

}

void CCvSeq::InitParameter()
{
	m_nSeqUnitLdNo	= 0;
	m_nSeqUnitUl1No	= 0;
	m_nSeqUnitUl2No = 0;
	m_nSeqUnitUlTiltNo = 0;
	m_nSeqAkManualCheckNo = 0;
	m_bUnloadWaitRequest = FALSE;
	m_bAkManualAlarm = FALSE;

	m_pDicsData->m_GenInfo.bUlTimeOut = FALSE;
	m_pDicsData->m_GenInfo.bUlNotReady = FALSE;
///////////////////////////////////////////////////////////////////////////////
// Init : Member
///////////////////////////////////////////////////////////////////////////////
	for( int i = IF_UNIT_LD; i < MAX_UNIT_NO ; i ++ )
	{
		m_nSeqInSensorNo[i]				= 0;
		m_nSeqOutSensorNo[i]			= 0;
		m_nSeqInSensorSickAlarmNo[i]	= 0;
		m_nSeqOutSensorSickAlarmNo[i]	= 0;
	}

	m_nStopCountAll		= 0;
	m_nStopCount		= 0;	
///////////////////////////////////////////////////////////////////////////////
// Init : IfFlag
///////////////////////////////////////////////////////////////////////////////
	for( i = 0 ; i < MAX_IF_NO ; i ++ )
	{
		m_pDicsData->m_IfFlag[i].bInReady				= FALSE;
		m_pDicsData->m_IfFlag[i].bOutReady				= FALSE;
		m_pDicsData->m_IfFlag[i].bInComp				= FALSE;
//		m_pDicsData->m_IfFlag[i].bOutComp				= FALSE;
		m_pDicsData->m_IfFlag[i].bWaitPos				= FALSE;
		m_pDicsData->m_IfFlag[i].bInError				= FALSE;
		m_pDicsData->m_IfFlag[i].bOutError				= FALSE;
		m_pDicsData->m_IfFlag[i].bSeqStop				= FALSE;
		m_pDicsData->m_IfFlag[i].bInSick				= FALSE; 
		m_pDicsData->m_IfFlag[i].bOutSick				= FALSE; 
		m_pDicsData->m_IfFlag[i].bInLogicCheckIgnore	= TRUE;
		m_pDicsData->m_IfFlag[i].bOutLogicCheckIgnore	= TRUE;
		m_pDicsData->m_IfFlag[i].bRecoveryReq			= FALSE;
		m_pDicsData->m_IfFlag[i].bCvBwReq				= FALSE;
		m_pDicsData->m_IfFlag[i].bRecvComp				= FALSE;


		// In & Out Complete flag is TRUE for CV Unit
		// LD Unit InSensor 
		m_pDicsData->m_IfFlag[i].bOutComp = TRUE;
		if( (i+IF_UNIT_UP_LD)  != IF_UNIT_UP_LD )
		{
			m_pDicsData->m_IfFlag[i + IF_UNIT_UP_LD].bInComp = TRUE;
		}
	}
	
///////////////////////////////////////////////////////////////////////////////		
// Init : SeqFlag
///////////////////////////////////////////////////////////////////////////////
	for( i = 0 ; i < MAX_UNIT_NO ; i ++ )
	{
		for( int j=0; j<MAX_STOP_COUNT_NO; j++ )
		{
			m_pDicsData->m_SeqFlag.nRollerState[j][i]		= cvSTOP;
			m_pDicsData->m_SeqFlag.nRollerStateAll[j][i]	= cvSTOP;
			m_pDicsData->m_SeqFlag.bSeqStopState[j][i]		= FALSE;
		}			
	}

	m_pDicsData->m_SeqFlag.bStopCount1		= FALSE;
	m_pDicsData->m_SeqFlag.bStopCount2		= FALSE;
	m_pDicsData->m_SeqFlag.bGlassOutComp1	= TRUE;
	m_pDicsData->m_SeqFlag.bGlassOutComp2	= TRUE;
	m_pDicsData->m_SeqFlag.bGlassGetComp	= FALSE;
///////////////////////////////////////////////////////////////////////////////		
// Init : Debug Mode
///////////////////////////////////////////////////////////////////////////////		
#ifdef _MY_DEBUG
	for( i = 0 ; i < MAX_UNIT_NO ; i ++ )
	{
		m_pDicsData->m_bDebugInSensor[i] = FALSE;
		m_pDicsData->m_bDebugOutSensor[i] = FALSE;
	}
#endif

	for( i = 0 ; i < MAX_CV_NO ; i ++ )
	{
		m_CvMotor.nCvAuto[i]	= cvSTOP;
		m_CvMotor.nSpeedAuto[i] = 0;
	}
	for( i = 0 ; i < MAX_CV_MOTOR_NO ; i ++ )
	{
		m_CvMotor.nCvManual[i]		= cvSTOP;
		m_CvMotor.nSpeedManual[i]	= 0 ;
	}	
}

BOOL CCvSeq::Initialize()
{
	m_nSeqInitNo	= 0;

	InitParameter();
	
	return TRUE;
}

BOOL CCvSeq::Sequence()
{
	Sleep( 10 );

	SeqInit();

	SeqUnitLd();

	SeqInSensor( IF_UNIT_EUV );
	SeqInSensor( IF_UNIT_RB );	
	SeqInSensor( IF_UNIT_FR );	
	SeqInSensor( IF_UNIT_AK );

	SeqOutSensor( IF_UNIT_LD );
	SeqOutSensor( IF_UNIT_EUV );
	SeqOutSensor( IF_UNIT_RB );
	SeqOutSensor( IF_UNIT_FR );
	SeqOutSensor( IF_UNIT_AK );

	SeqUnitUl1();
	SeqUnitUl2();		

	SeqCvMotorSpeedControl();

	for(int i = CV_NO_LD; i<m_pEqpAssy->m_CvMotor.GetMaxSectionNo(); i++) 
	{
		SeqCv(i);	
		SeqCvMotorControl(i);
	}

	CheckStopCountCond();

	for( i = CV_NO_LD+1; i<m_pEqpAssy->m_CvMotorAll.GetMaxSectionNo(); i++ )
	{
		SeqCvMotorManualControl(i);
	}
	
//	for( i = IF_UNIT_UP_LD ; i < MAX_UNIT_NO ; i ++ )..//2009.03.20 kimgun // 2009.03.18 minhan 
//	{
//		SeqInSensorSickAlarm( i );
//		SeqOutSensorSickAlarm( i );
//	}

	SeqCvManualControlInterlock();
	SeqAkManualInterlockCheck();
	if( m_pDicsData->m_GenInfo.bAuto && !m_pDicsData->m_GenInfo.bPause )
	{
		SeqUnitUlTilt();
	}

	m_pDicsView->m_pCommonIntrSeq->SetTimerPart( 1, TRUE );	// halesu
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////
// Initialize The Sequence
//////////////////////////////////////////////////////////////////////////
void CCvSeq::SeqInit()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	static int nReturnSeqNo = 0;
	static DWORD dwTickStart = 0;

	// Use for alarm reset
	static int nAlarmId[MAX_CV_MOTOR_NO] = { 0, };
	CString sSeqName( "INIT    " );
	int tm = TM_SEQ_INIT_CV;

	static CString sCvName[] = 
	{
		"LD Unit C/V Motor",
		"EUV Unit C/V Motor",
		"RB1 Unit C/V Motor",
		"RB2 Unit C/V Motor",
		"F/R & A/K Unit C/V Motor",
		"UL Unit C/V Motor"
	};

	int nSeqNo = m_nSeqInitNo;
	
	switch( nSeqNo )
	{
	case 0 :
		if( m_SeqFlag.bInitReq )
		{
			Msg( WM_INIT_STATUS, MSG_STATUS_RESET_MAIN, NULL, TRUE );

			nSeqNo = 10;
		}
		break;
	case 5 :
		if( m_SeqFlag.bInitReq )
		{
			nSeqNo = 10;
		}
		break;
	case 10 :
		{
			m_SeqFlag.bInitReq	= FALSE;
			m_SeqFlag.bInitComp	= FALSE;
			m_SeqFlag.bInitFail	= FALSE;

			m_pDicsView->m_pIfSeq->ResetInterfaceSignalAll();
			m_pDicsView->m_pMainSeq->SetRecipe2JobCond( m_pDicsData->m_GenInfo.sRecipeId );
//			m_pDicsData->m_EqpInfo.nEqpState[CDicsData::statePREPARE] = 1;

			Msg( WM_EQP_MESSAGE, MSG_EQP_MESSAGE, (LPARAM)(LPCTSTR)"Initialize : Start", FALSE );

			m_sMessage.Format( "%2d%d", CDicsData::initCHECK_CV_GLASS, MSG_STATUS_START );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
			
			BOOL bOk = TRUE;
			for( int i = IF_UNIT_LD ; i < m_pEqpAssy->m_CvMotor.GetMaxSectionNo(); i++ )
			{
				int nSensorNo = i;
#ifndef _MY_DEBUG
				if( !m_pDicsData->m_GenInfo.nGlassNo && 
				   ( m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) || m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) ) )
#else
				if( 0 )
#endif
				{
					bOk = FALSE;
					nAlarmId[i] = ALM_GLASS_SENSING1 + nSensorNo;
					m_pEqpStateSeq->SetAlarm( nAlarmId[i] );

					m_sMessage.Format( "%s Glass sensing error", m_pDicsData->m_sUnitName[nSensorNo] );
					SetLog( sSeqName, 0, 0, m_sMessage );
				}
			}

			if( bOk )
			{
				nSeqNo = 20;
			}
			else
			{
				m_sMessage.Format("%2d%d", CDicsData::initCHECK_CV_GLASS, MSG_STATUS_NG );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				m_SeqFlag.bInitFail	= TRUE;
				nSeqNo = 1000;
			}
		}
		break;
	case 20 :
		{
			BOOL bOk = TRUE;
			for( int i = IF_UNIT_LD ; i < m_pEqpAssy->m_CvMotor.GetMaxSectionNo(); i++ )
			{
				int nSensorNo = i;
#ifndef _MY_DEBUG
//				if( ( m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].bIsValid && !m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) ) || 
//					( m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].bIsValid && !m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) ) ) 
				// 100412 halesu
				if( ( m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].bIsValid && !m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) ) || 
					( m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].bIsValid && !m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) ) ||
					( m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].bIsValid && m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) && !m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].bIsValid && nSensorNo <= IF_UNIT_AK ) ||
					( m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].bIsValid && m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo + 1 ) && !m_pDicsData->m_GlsInfo[nSensorNo*2 + 2].bIsValid && nSensorNo <= IF_UNIT_AK )) 
#else
				if( 0 )
#endif
				{
					bOk = FALSE;
					nAlarmId[i] = ALM_GLASS_DATA_ERROR1 + nSensorNo;
					m_pEqpStateSeq->SetAlarm( nAlarmId[i] );

					m_sMessage.Format( "%s Glass Data error", m_pDicsData->m_sUnitName[nSensorNo] );
					SetLog( sSeqName, 0, 0, m_sMessage );
				}
			}

			if( bOk )
			{
				m_sMessage.Format("%2d%d", CDicsData::initCHECK_CV_GLASS, MSG_STATUS_OK );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				m_sMessage.Format( "%2d%d", CDicsData::initCHECK_CV_CP, MSG_STATUS_START );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				nSeqNo = 30;
			}
			else
			{
				m_sMessage.Format("%2d%d", CDicsData::initCHECK_CV_GLASS, MSG_STATUS_NG );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				m_SeqFlag.bInitFail	= TRUE;
				nSeqNo = 1000;
			}
		}
		break;
	case 30 :
		{
			BOOL bOk = TRUE;
			for( int i = 0 ; i < m_pEqpAssy->m_CvMotorAll.GetMaxSectionNo(); i++ )
			{
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_CvMotorAll.GetMotorCpAlarm( i ) )
#else
				if( FALSE )
#endif
				{
					bOk = FALSE;
					m_sMessage.Format( "%s CP Down Error", sCvName[i] );
					SetLog( sSeqName, 0, 0, m_sMessage );
				}
			}

			if( bOk )
			{
				m_sMessage.Format("%2d%d", CDicsData::initCHECK_CV_CP, MSG_STATUS_OK );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				m_sMessage.Format( "%2d%d", CDicsData::initCHECK_CV_ALARM, MSG_STATUS_START );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				nSeqNo = 40;
			}
			else
			{
				m_sMessage.Format( "%2d%d", CDicsData::initCHECK_CV_CP, MSG_STATUS_NG );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				m_SeqFlag.bInitFail	= TRUE;
				nSeqNo = 1000;
			}
		}
		break;
	case 40 :
		{
			BOOL bOk = TRUE;
			for( int i = 0 ; i < m_pEqpAssy->m_CvMotorAll.GetMaxSectionNo(); i++ )
			{
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_CvMotorAll.GetMotorAlarm( i ) )
#else
				if( FALSE )
#endif
				{
					bOk = FALSE;
					m_sMessage.Format( "%s Driver Alarm", sCvName[i] );
					SetLog( sSeqName, 0, 0, m_sMessage );
				}
			}

			if( bOk )
			{
				m_sMessage.Format("%2d%d", CDicsData::initCHECK_CV_ALARM, MSG_STATUS_OK );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

//				nSeqNo = 50;
				nSeqNo = 70;
			}
			else
			{
				m_sMessage.Format( "%2d%d", CDicsData::initCHECK_CV_ALARM, MSG_STATUS_NG );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
					
				m_SeqFlag.bInitFail	= TRUE;
				nSeqNo = 1000;
			}
		}
		break;
	/*case 50:
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_CylinderUlHand.GetFw() )
#else
		if( 1 )
#endif
		{
			m_pEqpAssy->m_CylinderUlTilt.SetFw();

			TIMER_ON( tm, 50 );

			SetLog( sSeqName, 0, 0, "UL Tilt Cylinder UP" );
			nSeqNo = 60;
		}
		break;
	case 60:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_CylinderUlTilt.GetFw() )
#else
		if( m_pEqpAssy->m_CylinderUlTilt.GetFwState() )
#endif
		{
			SetLog( sSeqName, 0, 0, "UL Tilt Cylinder UP Confirm" );
			nSeqNo = 70;
		}
		else if( TIMER( tm ))
		{
			nAlarmId[IF_UNIT_UL] = ALM_UL_UNIT_TILT_UP;
			m_pEqpStateSeq->SetAlarm( nAlarmId[IF_UNIT_UL] );

			SetLog( sSeqName, 0, 0, "UL Tilt Cylinder UP Error" );
			nSeqNo = 1000;
		}
		break;*/
	case 70 :
		{
			for( int i = IF_UNIT_LD * 2 ; i < m_pEqpAssy->m_GlassExistUnit.GetMaxSectionNo(); i++ )//2008.08.26 kimgun
			{
				int nSensorNo = i/2;//2008.08.26 kimgun
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) || m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) )
#else
				if( m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].bIsValid || m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].bIsValid )
#endif
				{
					m_pDicsData->m_GenInfo.bCleanOut	= TRUE;
					m_pDicsData->m_GenInfo.bCycleStop	= TRUE;

					m_pDicsData->m_SeqFlag.bTimeOver = FALSE;
					Msg( WM_TACT_TIME, ttCOUNT_START, 0L );
				}
			}
			nSeqNo = 100;
		}
		break;

	case 100 :
		{
			m_SeqFlag.bInitReq	= FALSE;
			m_SeqFlag.bInitComp	= TRUE;

			InitParameter();
			SetSeqNo();
			// Log
			SetLog( sSeqName, 0, 0, "Init Complete" );

			nSeqNo = 0;
		}
		break;
	case 1000 :
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			m_SeqFlag.bInitReq  = FALSE;

			for( int i=0; i<MAX_CV_MOTOR_NO; i++ )
			{
				if( nAlarmId[i] > 0 )
				{
					m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
					nAlarmId[i] = 0;
				}
			}

			SetLog( sSeqName, 0, 0, "Error Recovery" );
			nSeqNo = 5;
		}
		break;
	}
	m_nSeqInitNo = nSeqNo;
}

void CCvSeq::SeqUnitLd()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	int nSensorNo = IF_UNIT_LD;
	int tm1 = TM_IN_SENSOR_ON( IF_UNIT_LD );
	int tm2 = TM_IN_SENSOR_OFF( IF_UNIT_LD );
	static int nTime1 = 0;
	static int nTime2 = 0;

	static DWORD dwTickStart = 0;
	static CString sOldRecipeId = m_pDicsData->m_GenInfo.sRecipeId;
	static int nAlarmId = 0;

	int nSeqNo = m_nSeqUnitLdNo;
	static int nReturnSeqNo = 0;
	static int nSlotNo		= 0;
	static int nPortNo		= 0;
	static int nGlassNo		= 0;

	TimerControl( ssIN, nSensorNo );

	if( !GetSeqRunCond( nSensorNo ) )	return;

	switch( nSeqNo )
	{
	case 0:
		{
			if( nAlarmId > 0 )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId );
				nAlarmId = 0;
				if( m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_LD] )	// 121002 halesu
				{
					m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_LD] = FALSE;
				}
			}

			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].bIsValid;
			if( bIsValid && m_pDicsData->m_IfFlag[IF_UNIT_LD].bSendPosComp )
			{  // When there is glass data.
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugInSensor[nSensorNo]		= TRUE;
#endif
				nSeqNo = 1;
			}
			else if( m_pDicsData->m_IfFlag[IF_UNIT_LD].bSendPosComp )
			{	// NO Glass Data, but Glass Sensing
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) ) 
#else
				if( m_pDicsData->m_bDebugInSensor[nSensorNo] ) 
#endif
				{ 
//					m_pDicsData->m_IfFlag[nSensorNo].bInComp = FALSE; 
					m_pDicsData->m_IfFlag[CV_NO_LD].bSeqStop = FALSE; 
					nSeqNo = 200; 
				}
				else
				{
					nSeqNo = 1;
				}
			}
		}
		break;
	case 1:
		if( m_pDicsData->m_IfFlag[IF_UNIT_LD].bSendPosComp )
		{
			m_pDicsData->m_IfFlag[CV_NO_LD].bSeqStop = FALSE;
			nSeqNo = 3;
		}
		break;
	case 3:
		// LD UNIT  ִ ̴.
		m_pDicsData->m_IfFlag[IF_UNIT_LD].bWaitPos = TRUE;
		nSlotNo = 0;
		nPortNo = 0;
		nSeqNo = 10;
		break;

	case 10:
		if( 1 )
		{
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "LD C/V unit : glass sending complete" );
			nSeqNo = 20;
		}
		break;
// 	case 20:    // Scan Check!!
// 		if( !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupLD_UNIT_SCAN_SENSOR] || 
// 			!m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_LD] ) 
// 		{
// 			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nPortNo;
// 			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nSlotNo;
// 
// 			SetLog( "LD IN1 ", nPortNo, nSlotNo, "Scan Check Finished" );
// 
// 			nSeqNo = 30;
// 		}
// 		else if( m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_LD] )
// 		{
// 			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nPortNo;
// 			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nSlotNo;
// 
// 			m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError = TRUE;
// 			SetLog( "LD IN1 ", nPortNo, nSlotNo, "BUF Scan Broken Sensor Error" );
// 
// 			nAlarmId = ALM_LD_UNIT_SCAN_SENSOR;
// 			m_pEqpStateSeq->SetAlarm( nAlarmId );
// 
// 			nReturnSeqNo = nSeqNo;		// ljy_050128
// 			nSeqNo = 7000;
// 		}
//		else
//		{
//			if( m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_LD] ) nAlarmId = ALM_LD_UNIT_SCAN_SENSOR;
//			else nAlarmId = 0;
//
//			if( nAlarmId == 0 ) nSeqNo = 30;
//			else
//			{
//				m_pDicsData->m_IfFlag[IF_UNIT_LD].bOutError = TRUE;
//
//				m_pEqpStateSeq->SetAlarm( nAlarmId );
//
//				// Log
//				int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nPortNo;
//				int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nSlotNo;
//				SetLog( "LD IN1 ", nPortNo, nSlotNo, "BUF Scan Broken Sensor Error" );
//				nReturnSeqNo = 20;		// ljy_050128
//				nSeqNo = 7000;
//			}
//		}		
		break;
	case 20:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) )
#else
		if( m_pDicsData->m_bDebugInSensor[IF_UNIT_LD] )
#endif
		{
			// Flag Set
//			GlassDataMove( IF_UNIT_LD_FISH*2 + 0, IF_UNIT_LD*2 + 0, &nSlotNo, &nPortNo );
			m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].bProcessed = TRUE;

			nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nSlotNo;
			nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nPortNo;

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "In Sensor is ON" );

			// Set Recipe ID
			CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();

			if ( 1 ) 
			{ 
				CString sRecipeId = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].sRecipeId;
				
				if( pDoc->GetRowfromID( sRecipeId ) < 0 )
				{
					sRecipeId = pDoc->m_pRecipeInfo[0].sValue[0] ;
					SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "RecipeId is Wrong" );
				}
				m_pDicsData->m_GenInfo.sRecipeId = sRecipeId ;
			}
			else
			{	// ljy_041220 : To display Recipe info Using Currently
				CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();
				m_pDicsData->m_GenInfo.sRecipeId = pDoc->m_pRecipeInfo[0].sValue[0];
				//pDoc->m_nRecipeId = m_pDicsData->m_GenInfo.sRecipeId = 1;
			}
			nSeqNo = 30;
		}
		break;
	case 30:    // Scan Check!!
		if( !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupLD_UNIT_SCAN_SENSOR] || 
			!m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_LD] )	// 121002 halesu
		{
			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nSlotNo;

			SetLog( "LD IN1 ", nPortNo, nSlotNo, "Scan Check Finished" );

			nSeqNo = 100;
		}
		else if( m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_LD] )	// 121002 halesu
		{
			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nSlotNo;

			m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError = TRUE;
			SetLog( "LD IN1 ", nPortNo, nSlotNo, "BUF Scan Broken Sensor Error" );

			nAlarmId = ALM_LD_UNIT_SCAN_SENSOR;	// 121002 halesu
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			nReturnSeqNo = nSeqNo;		// ljy_050128
			nSeqNo = 7000;
		}
		break;
	// Check Recipe
	case 100 :
		if( m_pDicsData->m_GenInfo.sRecipeId == sOldRecipeId &&
			!m_pDicsData->m_GenInfo.bRecipeBodyChanged ) nSeqNo = 120;
		else nSeqNo = 110; // Recipe ID ޶
		break;

	case 110 :
		if( !m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 1].bIsValid && 
			!m_pDicsData->m_GlsInfo[IF_UNIT_EUV*2 + 0].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_EUV*2 + 1].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_RB*2 + 0].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_RB*2 + 1].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_FR*2 + 0].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_FR*2 + 1].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_AK*2 + 0].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_AK*2 + 1].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].bIsValid )
		{
			sOldRecipeId = m_pDicsData->m_GenInfo.sRecipeId;
			if( m_pDicsData->m_GenInfo.bRecipeBodyChanged ) //2008.12.03 kimgun
			{
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], 0, nSlotNo, "Recipe Item Changed" );
				m_pDicsData->m_GenInfo.bRecipeBodyChanged = FALSE;
			}
			else 
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], 0, nSlotNo, "Recipe Id Changed" );
			nSeqNo = 120;
		}
		break;

	case 120:
		//   ִ´.
		{
			m_pDicsView->m_pMainSeq->SetRecipe2JobCond( m_pDicsData->m_GenInfo.sRecipeId );

			// Change Normal Speed ( LD ) // JUN_SPEED
//			int nCvSpeed = m_pDicsData->m_JobCond.nCvSpeedSet[CV_NO_LD][CJobCond::speedNORMAL];
//			int nSpeed = (int) ( CV_SPEED_2_AO( CV_NO_LD, nCvSpeed ) );
//			if( nSpeed > 0x4000 ) nSpeed = 0x4000;
//			aogCV_MOTOR_SPEED( CV_NO_LD, nSpeed );	// dspcrassus - SeqCvMotorSpeedControl  Motor Speed Set

			// JobView Recipe Items Update
			CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();
			pDoc->SetRecipeId( m_pDicsData->m_GenInfo.sRecipeId );
			nSeqNo = 140;
		}
		break;
	case 140 :
		{
			BOOL bOk = TRUE;
			for( int i = IF_UNIT_LD; i<=IF_UNIT_UL; i++ )
			{
				bOk &= CheckUnitCondition( ssIN, i );
			}
			
			if( bOk )
			{
				// Log
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "Unit Condition Check : OK" );
				nSeqNo = 150;
			}
			else
			{	// Log
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "Unit Condition Check : NG" );
				
				nReturnSeqNo = nSeqNo;
				nSeqNo = 4000;
			}
		}
		break;

		//   Unload Up Hand, Unload Lo Hand, Tr Glass Ȳ ȮϿ 
		// A/K   ִ  ߻  ִ Checkϰ  ϵ 
	case 150 :
		{
			int nGlassEA = 0;
//			if( m_pDicsData->m_GlsInfo[IF_UNIT_TR*2 + 0].bIsValid && 
//				m_pDicsData->m_GlsInfo[IF_UNIT_TR*2 + 0].bProcessed )
//				nGlassEA ++;
			for( int i = IF_UNIT_EUV ; i < MAX_IF_NO ; i ++ )
			{
				if( m_pDicsData->m_GlsInfo[i*2 + 0].bIsValid )
					nGlassEA ++;
				if( m_pDicsData->m_GlsInfo[i*2 + 1].bIsValid )
					nGlassEA ++;
			}

			if( nGlassEA < 2 ) 
			{
				int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nPortNo;
				int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nSlotNo;
				m_sMessage.Format( "Advanced Glass = %d", nGlassEA );
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, m_sMessage );
				nSeqNo = 160;
			}
			else if ( nGlassEA == 2 && m_pDicsData->m_GenInfo.bLdUnitGlassStart ) // 091228 halesu
			{
				m_pDicsData->m_GenInfo.bLdUnitGlassStart = FALSE; 
				int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nPortNo;
				int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nSlotNo;
				m_sMessage.Format( "Advanced Glass = %d but UL Glass Out Completed", nGlassEA );
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, m_sMessage );
				nSeqNo = 160;
			}

			
		}
		break;

	case 160 :
		if(  m_pDicsData->m_SeqFlag.bTimeOver && 
			!m_pDicsData->m_SeqFlag.bStopCount1 && 
			!m_pDicsData->m_SeqFlag.bStopCount2 )
		{
			m_pDicsData->m_SeqFlag.bTimeOver = FALSE;

			// Set Recipe log
			m_sMessage.Format( "Recipe Id = %s", m_pDicsData->m_GenInfo.sRecipeId );
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, m_sMessage );
			
			// Set Tact time Log
			m_sMessage.Format( "Tact Time = %d", ( (CDicsView *) m_pOwnerWnd )->m_nTactTime );
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, m_sMessage );

#ifndef _NO_EUV
			nSeqNo = 180;
#else
			nSeqNo = 200;
#endif			
			//m_pDicsData->m_IfFlag[IF_UNIT_LD].bOutComp = TRUE;
		}
		break;

	case 180:
		if( !m_pDicsView->m_pEuvSeq->IsEuvUse() )
		{
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "EUV OK (EUV No Use)" );		
			nSeqNo = 200;
		}
		else if( !m_pDicsView->m_pEuvSeq->GetEuvAlarm() && 
				  m_pDicsView->m_pEuvSeq->IsEuvReady() &&
				  !m_pDicsData->m_IfEuv.bEuvUtilAlarm )//2008.12.08 kimgun)
		{
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "EUV OK (EUV Use)" );
			nSeqNo = 200;
		}
		else
		{
			nAlarmId = ALM_EUV_NOT_READY;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "EUV Lamp Not Ready" );
			nReturnSeqNo = nSeqNo;		
			nSeqNo = 2000;
		}
		break;
	// Glass starts
	case 200:
		if( m_pDicsData->m_IfFlag[IF_UNIT_LD].bOutComp )
		{
			// Flag Reset
//			m_pDicsData->m_IfFlag[IF_UNIT_LD].bOutComp = FALSE;
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bInReady = TRUE;
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bInComp = TRUE;
//#ifdef _MY_DEBUG
//			m_pDicsData->m_bDebugInSensor[IF_UNIT_LD_LO_HAND] = FALSE;
//#endif 
			// Tact Time Counting Start : 
			m_pDicsData->m_SeqFlag.bTimeOver = FALSE;
			Msg( WM_TACT_TIME, ttCOUNT_START, 0L );

			for( int i=0; i<MAX_PARTS_NO; i++ )
			{
				m_pDicsView->m_pCommonIntrSeq->PartsGlsCountIncrease( i );
			}

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "Out Complete OK" );

			// Set the glass move speed
			int nGlassNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nGlassNo;
			m_pGlassAni->SetGlassMoveSpeed( nGlassNo, m_pDicsData->m_JobCond.nCvSpeed / 60 );

			// glass move
			m_pGlassAni->GlassMove( nGlassNo, (IF_UNIT_LD+1)*2 + 1 );

			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "LD Unit move-time Count start" );

			GetTimeOut( IF_UNIT_LD, 0, &nTime1, &nTime2 );

#ifndef _MY_DEBUG
			TIMER_ON( tm1, nTime1 );
#else
			TIMER_ON( tm1, 20 );
			m_pDicsData->m_bDebugInSensor[IF_UNIT_LD] = FALSE;
#endif

			nSeqNo = 210;
		}
		break;

	case 210:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) )
#else
		if( TIMER( tm1 ) )
#endif
		{
#ifdef _MY_DEBUG
			m_pDicsData->m_bDebugOutSensor[IF_UNIT_LD] = TRUE;
#endif
			// Flag Reset
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bOutComp = FALSE;	//LYS20070330

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "Out Sensor is ON (Next Sensor)" );
			// C/V Restart for previous alarm
			if( m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError ) 
			{
				m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError = FALSE;
				m_pDicsData->m_IfFlag[IF_UNIT_LD].bRecoveryReq = FALSE;
//				CvRestart( IF_UNIT_LD );
			}

			// Glass Move Region
			nGlassNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nGlassNo;
			m_pGlassAni->GlassMoveRegion( nGlassNo, (IF_UNIT_LD+1)*2 + 1 );	// Auto Stop

			TIMER_ON( tm2, nTime2 + 20 );

			nSeqNo = 220;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm1 ) )	// Sensor On Timeout Error
#else
		else if( 0 )
#endif
		{
			// C/V Stop
//			CvStop( IF_UNIT_LD, m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError );

			// Set Alarm
//			nAlarmId = ALM_SENSOR_OUT_ON_TIMEOUT1;
			nAlarmId = ALM_SENSOR_OUT_ON_TIMEOUT1 + IF_UNIT_LD;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "Out Sensor ON Timeout Error" );

			// Flag Set
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError = TRUE;
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bRecoveryReq = FALSE;//2008.08.28 kimgun
			nReturnSeqNo = nSeqNo;
			nSeqNo = 1000;
		}
		break;

	case 220:
		//-----------------------------------------------------------------------------------------
		// LD UNIT Length : 1500 > Glass Size : 1300
		//-----------------------------------------------------------------------------------------
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) && !m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_EUV )) // 060410 by molnic
#else
		if( !m_pDicsData->m_bDebugOutSensor[IF_UNIT_LD] )
#endif
		{
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "Interlock Sensor is OFF (1st)" );

			// C/V Restart for previous alarm
			if( m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError ) 
			{
				m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError = FALSE;
//				CvRestart( IF_UNIT_LD );
			}
			
			dwTickStart = GetTickCount();
			nSeqNo = 230;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm2 ) )	// Sensor Off Timeout Error
#else
		else if( FALSE )
#endif
		{
			// C/V Stop
//			CvStop( IF_UNIT_LD, m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError );

			// Set Alarm
//			nAlarmId = ALM_SENSOR_OUT_OFF_TIMEOUT1;
			nAlarmId = ALM_SENSOR_OUT_OFF_TIMEOUT1 + IF_UNIT_LD;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "Out Sensor OFF Timeout Error" );

			// Flag Set
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError = TRUE;
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bRecoveryReq = FALSE;//2008.08.28 kimgun CHECK ʿ.
			nReturnSeqNo = nSeqNo;
			nSeqNo = 1000;
		}
		break;
	case 230:
		if( ( GetTickCount() - dwTickStart ) > 500 )
		{
#ifndef _MY_DEBUG
			if( !m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) && !m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_EUV )) // 060410 by molnic
#else
			if( !m_pDicsData->m_bDebugOutSensor[IF_UNIT_LD] )
#endif
			{
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugInterlockSensor = FALSE;
#endif
				// Log
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "Interlock Sensor is OFF (2nd)" );
				nSeqNo = 240;
			}
			else nSeqNo = 220;
		}
		break;

	case 240 :
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) && !m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) &&
			!m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_EUV ) && !m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_LD ) ) // 2009.03.11 minhan
#else
		if( !m_pDicsData->m_bDebugInSensor[IF_UNIT_LD] && !m_pDicsData->m_bDebugOutSensor[IF_UNIT_LD] &&
			!m_pDicsData->m_bDebugInSensor[IF_UNIT_EUV] && !m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_LD ) ) 
#endif
		{
			// Log
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "Send Comp is TRUE" );
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bSendComp = TRUE;
			nSeqNo = 250;
		}
		break;
	case 250:
#ifndef _MY_DEBUG
		if( !m_pDicsData->m_IfFlag[IF_UNIT_LD].bSendComp )//2008.10.18 kimgun check
#else
		if( 1 )
#endif
		{
			nSeqNo = 1;
		}
		break;

	// Error ó (Timeout Error)
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId );

			// Set Timer
			TIMER_ON( tm1, nTime1 );
			TIMER_ON( tm2, nTime2 );

			// C/V Restart
//			CurCvRestart( IF_UNIT_LD );
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bRecoveryReq = TRUE;
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "Error Recovery" );
			nSeqNo = nReturnSeqNo;
		}
		break;
	case 2000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )//|| 
		//	( !m_pDicsView->m_pEuvSeq->GetEuvAlarm() &&
		//	  !m_pDicsData->m_IfEuv.bEuvUtilAlarm ) )//2008.12.08 kimgun
		{
			if ( m_pDicsView->m_pEuvSeq->GetEuvAlarm() ) return;
			if( m_pDicsData->m_IfEuv.bEuvUtilAlarm ) return;//2008.12.08 kimgun
			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId );

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "Error Recovery" );
			nSeqNo = nReturnSeqNo;
		}
		break;	
	case 3000 :	// Error ó (General Error)
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId );

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "Error Recovery" );
			nSeqNo = nReturnSeqNo;
		}
		break;
	case 4000 :
		{
			BOOL bOk = TRUE;
			for( int i = IF_UNIT_LD; i<=IF_UNIT_UL; i++ )
			{
				bOk &= CheckUnitCondition( ssIN, i );
			}
			
			if( bOk )
			{
				// Log
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "Re Check - Unit Condition Check : OK" );
				nSeqNo = nReturnSeqNo;
			}
		}
		break;
	// Scan Broken
	case 7000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nSlotNo;

			m_pEqpStateSeq->ResetAlarm( nAlarmId );
			nAlarmId = 0;

			SetLog( "LD IN1 ", nPortNo, nSlotNo, "Scan Reset OFF(Error)" );

			nSeqNo = 7010;
		}
		break;

	case 7010:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) && m_pDicsData->m_GlsInfo[IF_UNIT_LD * 2 + 0 ].bIsValid )
#else
		if( m_pDicsData->m_bDebugInSensor[IF_UNIT_LD] )
#endif
		{
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError = FALSE;  
		//	m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq   = TRUE; 2008.08.08.28 kimgun// ??

			m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_LD] = FALSE;	// 121002 halesu
			nSeqNo = nReturnSeqNo;
		}
		else if( !m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) && !m_pDicsData->m_GlsInfo[IF_UNIT_LD * 2 + 0 ].bIsValid )
		{
			nSeqNo = 0;
		}
		break;
//			// Log
//			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nPortNo;
//			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nSlotNo;
//			SetLog( "LD IN1 ", nPortNo, nSlotNo, "Scan Reset OFF(Error)" );
//
//			m_pEqpStateSeq->ResetAlarm( nAlarmId );
//
//			
//			nSeqNo = nReturnSeqNo;
//		} 
//		break; 
	}// Switch End
	
	m_nSeqUnitLdNo = nSeqNo;
}


void CCvSeq::SeqUnitUl1()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	int nSeqNo = m_nSeqUnitUl1No;
	static int nReturnSeqNo = 0;
	static DWORD dwTickStart = 0;

	// Use for alarm reset
	static int nAlarmId = 0;

	int nSensorNo = IF_UNIT_UL;
	int tm1 = TM_IN_SENSOR_ON( IF_UNIT_UL );
	int tm2 = TM_IN_SENSOR_OFF( IF_UNIT_UL );
	int tm3 = TM_IN_SENSOR_IN2OUT( IF_UNIT_UL );

	static int nTime1 = 0;
	static int nTime2 = 0;
	static int nTime3 = 0;
	static int nSlotNo, nPortNo, nGlassNo = 0;
	static BOOL bTm3Warning = FALSE;

	
	TimerControl( ssIN, nSensorNo );

	if( !GetSeqRunCond( nSensorNo) )	return;

	switch( nSeqNo )
	{
	case 0:
		{
			if( nAlarmId > 0 )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId );
				nAlarmId = 0;
			}

			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].bIsValid;
	
			if( bIsValid )
			{  // When there is glass data.
				m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady	= TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bInComp		= FALSE;
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugInSensor[nSensorNo]		= TRUE;
				m_pDicsData->m_bDebugOutSensor[nSensorNo - 1]	= TRUE;
				m_nSeqOutSensorNo[nSensorNo - 1] = 0;
#endif
				nSeqNo = 1;
			}
			else
			{	// NO Glass Data, but Glass Sensing
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_UL ) ) 
#else
				if( m_pDicsData->m_bDebugInSensor[nSensorNo] ) 
#endif
				{ 
					m_pDicsData->m_IfFlag[nSensorNo].bInComp = FALSE; 
					nSeqNo = 500;
				}
				else
				{
					nSeqNo = 1;
				}
			}
		}
		break;
	case 1:
#ifndef _MY_DEBUG
		if( m_pDicsData->m_IfFlag[IF_UNIT_UL - 1].bOutReady && !m_pDicsData->m_IfFlag[IF_UNIT_UL - 1].bOutError && 
			m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_UL )  )
#else
		if( m_pDicsData->m_IfFlag[IF_UNIT_UL - 1].bOutReady && !m_pDicsData->m_IfFlag[IF_UNIT_UL - 1].bOutError && 
			m_pDicsData->m_bDebugInSensor[IF_UNIT_UL] )
#endif
		{
			// Flag Reset
			m_pDicsData->m_IfFlag[IF_UNIT_UL - 1].bOutReady = FALSE;

			GlassDataMove( (IF_UNIT_UL - 1)*2 + 1, IF_UNIT_UL*2 + 0, &nSlotNo, &nPortNo );

			// Log
			nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].nPortNo;
			nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].nSlotNo;
//2008.11.07 kimgun CEID 
// 			if( m_pDicsView->m_pHost1->m_bCeidEnable[IF_UNIT_UL * 2 + 1] ) 
// 			{
// //				m_pDicsView->m_pHost1->S6F11( IF_UNIT_UL * 2 + 1 );
// 				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Glass_In Event Report" );
// 				m_pDicsView->m_pHost1->m_bEventReportReq[IF_UNIT_UL * 2 + 1] = TRUE;
// 			}

			//2008.11.07 kimgun APC DATA Glass HEAD ġ  
			//////////////////////////////////////////////////////////////////////////
			m_pDicsData->m_GlsInfo[IF_UNIT_UL * 2].sGlassHeadPos.Format("%d",195 + IF_UNIT_UL );
			//////////////////////////////////////////////////////////////////////////

			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "In Sensor is ON" );
			nSeqNo = 10;
		}
		break;

	case 10:
		if( m_pDicsData->m_SeqFlag.bGlassOutComp1 )
		{
			// Flag reset
 			m_pDicsData->m_SeqFlag.bGlassOutComp1 = FALSE;

			// glass move
			nGlassNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].nGlassNo;
			
			m_pGlassAni->SetGlassMoveSpeed( nGlassNo, m_pDicsData->m_JobCond.nCvSpeed / 60 );
			m_pGlassAni->GlassMove( nGlassNo, (IF_UNIT_UL+1)*2 + 1, TRUE, TRUE ); 

			GetTimeOut( IF_UNIT_UL, 0, &nTime1, &nTime2, &nTime3 );
#ifndef _MY_DEBUG
			TIMER_ON( tm1, nTime1 );
			TIMER_ON( tm2, nTime2 );
			TIMER_ON( tm3, nTime3 );
#else
//			TIMER_ON( tm1, nTime1 );
//			TIMER_ON( tm2, nTime2 );
//			TIMER_ON( tm3, nTime3 );
			TIMER_ON( tm1, 20 );
			TIMER_ON( tm2, 20 );
			TIMER_ON( tm3, 20 );
#endif

			bTm3Warning = FALSE; // 2009.03.18 minhan

			nSeqNo = 20;
		}
		else 
		{				
			// glass move
			nGlassNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].nGlassNo;
			m_pGlassAni->GlassMove( nGlassNo, (IF_UNIT_UL+1)*2 + 1, FALSE );

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Unloading Timeout Error(1)" );
			
			m_pDicsData->m_GenInfo.bUlTimeOut = TRUE;
			// C/V Stop
				CvStop( IF_UNIT_UL );
			nSeqNo = 100;
		}
		break;
		
	case 20:
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_UL ) )
#else
		if( TIMER( tm2 ) )
#endif
		{
#ifdef _MY_DEBUG
			m_pDicsData->m_bDebugInSensor[IF_UNIT_UL] = FALSE;
#endif
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "In Sensor is OFF(1st)" );
			dwTickStart = GetTickCount();
			nSeqNo = 30;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm2 ) )	// Sensor Off Timeout Error
#else
		else if( FALSE )
#endif
		{
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "In Sensor isn't OFF, but time is over" );
			nSeqNo = 30;
		}
		break;

	case 30:
		{
#ifndef _MY_DEBUG
		BOOL bOutSensorOn = m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_UL );//2009.03.20 kimgun 
		if( bOutSensorOn && //2009.03.20 kimgun
			( TIMER( tm3 ) ) ) // 2009.03.18 minhan
#else
		if( TIMER( tm1 ) || m_pDicsData->m_bDebugOutSensor[IF_UNIT_UL] )
#endif
		{
#ifdef _MY_DEBUG
			m_pDicsData->m_bDebugOutSensor[IF_UNIT_UL] = TRUE;
#endif
			// Flag Set
			m_pDicsData->m_IfFlag[IF_UNIT_UL].bInReady				= TRUE;
			m_pDicsData->m_IfFlag[IF_UNIT_UL].bInLogicCheckIgnore	= FALSE;
//			if( !bTm3Warning )//2009.03.20 kimgun sick  glass   .
//				m_pDicsData->m_IfFlag[IF_UNIT_UL].bOutSick = FALSE;
			
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL],  nPortNo, nSlotNo, "Out Sensor is ON(Glass Arrive in UL C/V)" );
			// Flag Set
			m_pDicsData->m_IfFlag[IF_UNIT_UL].bInComp = TRUE;

			// C/V Restart for previous alarm
			if( m_pDicsData->m_IfFlag[IF_UNIT_UL].bInError ) 
			{
				m_pDicsData->m_IfFlag[IF_UNIT_UL].bInError	= FALSE;
//				m_pDicsData->m_IfFlag[IF_UNIT_UL].bAlarm	= FALSE;
				m_pDicsData->m_IfFlag[IF_UNIT_UL].bRecoveryReq = FALSE;
//				CvRestart( IF_UNIT_UL );
			}
			nSeqNo = 1;
		}
#ifndef _MY_DEBUG // 2009.03.18 minhan
		else if( bOutSensorOn && !bTm3Warning )//2009.03.20 kimgun
#else
		else if( 0 )
#endif
		{
			dwTickStart = GetTickCount();
			nSeqNo = 35;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm1 ) )	// Sensor On Timeout Error
#else
		else if( FALSE )
#endif
		{
			// C/V Stop
//			CvStop( IF_UNIT_UL );

			// Set Alarm
//			nAlarmId = ALM_SENSOR_OUT_ON_TIMEOUT1 + IF_UNIT_UL;
			nAlarmId = ALM_SENSOR_OUT_ON_TIMEOUT1+IF_UNIT_UL;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Out Sensor ON Timeout Error" );

			// Flag Set
			m_pDicsData->m_IfFlag[nSensorNo].bInError = TRUE;
			m_pDicsData->m_IfFlag[IF_UNIT_UL].bRecoveryReq = FALSE;//2008.08.28 kimgun
//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm   = TRUE;	

			nReturnSeqNo = nSeqNo;
			nSeqNo = 1000;
		}
		}
		break;

	case 35 :
		if( GetTickCount() - dwTickStart > 500 )
		{
			if( m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_UL ) && !bTm3Warning ) // 2009.03.18 minhan
			{
				bTm3Warning = TRUE;
//				m_pDicsData->m_IfFlag[IF_UNIT_UL].bOutSick = TRUE; // 2009.03.22 minhan
				SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Next Sensor NG(2nd)" );
				nSeqNo = 30;
			}
			else
			{
				nSeqNo = 30;
			}
		}
		else if( !m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_UL ) )
		{
			nSeqNo=30;
		}
		break;

	// Unloading Timeout Case1 :
	// UL C/V Glass  UL Lo Hand ޾ư ʾ  ó
	case 100:
		if( m_pDicsData->m_SeqFlag.bGlassOutComp1 )
		{	
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Unloading Timeout Release" );
			// C/V Restart All
//			CvRestart( IF_UNIT_UL );
			m_pDicsData->m_GenInfo.bUlTimeOut = FALSE;
			nSeqNo = 10;
		}
		break;
	// SetSeqNo  case
	case 500 :
		{
			double dGlassSize	= GLASS_SIZE;
			double dCvSpeed		= m_pDicsData->m_JobCond.nCvSpeed / 60.0; // mm/sec
#ifndef _MY_DEBUG
			nTime2	= (int)( ( dGlassSize / dCvSpeed ) * 10 );
#else
			nTime2	= (int)( ( (dGlassSize/3.) / dCvSpeed ) * 10 );
#endif
			TIMER_ON( tm2, nTime2 );

			nSeqNo = 20;
		}
		break;
	// Error ó (Timeout Error)
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId );

			// Set Timer
			TIMER_ON( tm1, nTime1 );
			TIMER_ON( tm2, nTime2 );

			// C/V Restart
//			CurCvRestart( IF_UNIT_UL );
			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq   = TRUE;
			// Log
			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].nSlotNo;
			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Error Recovery" );
			nSeqNo = nReturnSeqNo;
		}
		break;
	}// Switch End
	
	m_nSeqUnitUl1No = nSeqNo;
}

void CCvSeq::SeqUnitUl2()
{ 
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	int nSensorNo = IF_UNIT_UL;
	int tm1 = TM_UL_CV_STOP;
	int tm2 = TM_OUT_SENSOR_OFF( nSensorNo );
	int tm3 = TM_OUT_SENSOR_OUT2IN( nSensorNo );

	int nSeqNo = m_nSeqUnitUl2No;
	static int nReturnSeqNo = 0;

	// Use for alarm reset
	static int nAlarmId = 0;
	static DWORD dwTickStart = 0;
 	static int nGlassNo, nSlotNo, nPortNo = 0;


	TimerControl( ssOUT, nSensorNo );

	if( !GetSeqRunCond( nSensorNo) )	return;

	switch( nSeqNo )
	{
	case 0:
		{
			if( nAlarmId > 0 )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId );
				nAlarmId = 0;
				if( m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_UL] )
				{
					m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_UL] = FALSE;
				}
			}

			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].bIsValid;
			if( bIsValid )
			{  // When there is glass data.
				m_pDicsData->m_IfFlag[nSensorNo].bInReady	= TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bOutComp	= FALSE;
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugOutSensor[nSensorNo]	= TRUE;
//				m_pDicsData->m_bDebugInSensor[nSensorNo]	= TRUE; // 2009.03.03 minhan
				m_nSeqUnitUl1No = 0;
#endif
				m_pDicsData->m_SeqFlag.bGlassOutComp1 = FALSE;
				nSeqNo = 1;
			}
			else
			{	// NO Glass Data, but Glass Sensing
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) ) 
#else
				if( m_pDicsData->m_bDebugOutSensor[nSensorNo] ) 
#endif
				{ 
					m_pDicsData->m_IfFlag[nSensorNo].bOutComp = FALSE; 
					m_pDicsData->m_SeqFlag.bGlassOutComp1 =  FALSE;
					nSeqNo = 500;
				}
				else
				{
					nSeqNo = 1;
				}
			}
		}
		break;
	case 1:
#ifndef _MY_DEBUG
		if( m_pDicsData->m_IfFlag[IF_UNIT_UL].bInReady && m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_UL ) && !m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_UL ) )
#else
		if( m_pDicsData->m_IfFlag[IF_UNIT_UL].bInReady && m_pDicsData->m_bDebugOutSensor[IF_UNIT_UL] )
#endif
		{
			// Flag Reset
			m_pDicsData->m_IfFlag[IF_UNIT_UL].bInReady = FALSE;
			m_pDicsData->m_IfFlag[IF_UNIT_UL].bOutComp = FALSE;
	

			// Glass Data Move
			GlassDataMove( IF_UNIT_UL*2 + 0, IF_UNIT_UL*2 + 1, &nSlotNo, &nPortNo );
			m_pDicsData->m_GlsInfoSend = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1];

			// Log
			nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nPortNo;
			nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nSlotNo;
			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Out Sensor is ON" );

/*			// EDC Data Set
			COleDateTime OleStartTm = COleDateTime::GetCurrentTime();
			CString szDateTime = OleStartTm.Format(_T("%Y%m%d%H%M%S"));
//			m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].sApdData[CCimSeq::apdGLS_UL_TIME] = szDateTime; //08HC06

			// Set Flag
			m_pDicsData->m_IfCim.bProcessDataReq[nPortNo-1] = TRUE; //S6F11 Glass Process Data
			m_pDicsData->m_IfCim.bApdReportReq = TRUE; //Process View Set
*/			
			// Set Timer... 
			//dwTickStart = GetTickCount(); 
			//nSeqNo = 10;
			nSeqNo = 5;
		}
		break;

	case 5 :
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_UL ) )
#else
		if( 1 )
#endif
		{
			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Glass enter UL Unit" );
			// Set Timer...
			double nTime;
			nTime = atof( m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_UNIT_GLASS_STOP_DISTANCE] );
			nTime = (( nTime  / ( m_pDicsData->m_JobCond.nCvSpeed / 60 )) * 10 );

#ifndef _MY_DEBUG
			TIMER_ON( tm1, (int)nTime );
#else
			TIMER_ON( tm1, (int)nTime );
//			TIMER_ON( tm1, 20 );
#endif
	
			nSeqNo = 10;
		}
		break;

	case 10:
		if( TIMER( tm1 ) )
		{

			// Glass Move Region : Auto Stop
			int nGlassNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nGlassNo;
			m_pGlassAni->GlassMoveRegion( nGlassNo, (IF_UNIT_UL+1) * 2 + 1, TRUE );

			// Flag Set
			m_pDicsData->m_IfFlag[IF_UNIT_UL].bOutReady = TRUE;
			m_pDicsData->m_IfFlag[IF_UNIT_UL].bOutComp	= TRUE;

			nSeqNo = 20;
		}
		break;
	case 20:
		if( !m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_UL )  )
		{
			if( m_pDicsView->m_pHost1->m_bCeidEnable[IF_UNIT_UL] )//2008.11.07 kimgun
			{
//				m_pDicsView->m_pHost1->S6F11( IF_UNIT_UL * 2 + 2 );
				m_pDicsView->m_pHost1->m_bEventReportReq[IF_UNIT_UL] = TRUE;//2008.11.07 kimgun
				SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Glass_In Event Report" );
			}
			nSeqNo = 25;
		}
		break;

	case 25:    // Scan Check!!
		if( !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUL_UNIT_SCAN_SENSOR] || 
			!m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_UL] ) 
		{
			// Log
			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nSlotNo;

			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Scan Check Finished" );

			nSeqNo = 30;
		}
		else if( m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_UL] )
		{
			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nSlotNo;

			m_pDicsData->m_IfFlag[IF_UNIT_UL].bOutError = TRUE;
			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "UL Scan Broken Sensor Error" );

			nAlarmId = ALM_UL_UNIT_SCAN_SENSOR;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			nReturnSeqNo = nSeqNo;
			nSeqNo = 2000;
		}
//		else
//		{
//			if( m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_UL] ) c
//			else nAlarmId = 0;
//
//			if( nAlarmId == 0 ) nSeqNo = 40;
//			else
//			{
//				m_pDicsData->m_IfFlag[IF_UNIT_UL].bOutError = TRUE;
//
//				m_pEqpStateSeq->SetAlarm( nAlarmId );
//
//				// Log
//				int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nPortNo;
//				int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nSlotNo;
//				SetLog( "LD IN1 ", nPortNo, nSlotNo, "UL Scan Broken Sensor Error" );
//				nReturnSeqNo = 30;		// ljy_050128
//				nSeqNo = 2000;
//			}
//		}		
		break;

	case 30:
		if( !m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_UL ) )
		{
//			doUL_UNIT_TILT_CYL_UP( OFF );
//			doUL_UNIT_TILT_CYL_DN( ON );
//
//			dwTickStart = GetTickCount(); 
//
//			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Tilt Down Start" );
			nSeqNo = 40;
		}
		break;
	case 40:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_CylinderUlTilt.GetBw() )
#else
		if( m_pEqpAssy->m_CylinderUlTilt.GetBwState() )
#endif
		{
			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Tilt Down Confirm" );

			m_pDicsData->m_IfFlag[IF_UNIT_UL].bRecvComp = TRUE;
#ifdef _NO_UL_HAND
			m_bUnloadWaitRequest = TRUE;//pos change 2008.10.18 kimgun
#endif
			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nPortNo;
//			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nSlotNo;
//			CString sGlassData;
//			sGlassData.Format( "%d", nPortNo );
//			mowPORT_NO(sGlassData,1);//2008.10.03 kimgun
//			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "UW Request" );
			nSeqNo = 50;
#ifdef _NO_UL_HAND
			nSeqNo = 43;
#endif
		}
//		else if( ( GetTickCount() - dwTickStart > 5000 ) )
//		{
//			nAlarmId = ALM_UL_UNIT_TILT_DN;
//			m_pEqpStateSeq->SetAlarm( nAlarmId );
//
//			// Log
//			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Tilt Dn Error" );
//			nReturnSeqNo = nSeqNo;		
//			nSeqNo = 1000;
//		}
		break;
	case 43:
		{
			m_pDicsData->m_IfSend.bBit[CDicsData::sndREQ] = TRUE;
			// EDC Data Set
			COleDateTime OleStartTm = COleDateTime::GetCurrentTime();
			CString szDateTime = OleStartTm.Format(_T("%Y%m%d%H%M%S"));
//			m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].sApdData[CCimSeq::apdGLS_UL_TIME] = szDateTime; //08HC06

			// Set Flag
//			m_pDicsData->m_IfCim.bProcessDataReq[nPortNo-1] = TRUE; //S6F11 Glass Process Data
//			m_pDicsData->m_IfCim.bApdReportReq = TRUE; //Process View Set

			nSeqNo = 45;
		}
		break;
	case 45:
		if( m_pDicsData->m_IfSend.bBit[CDicsData::sndCOMP] )
		{
			m_pDicsData->m_IfSend.bBit[CDicsData::sndCOMP] = FALSE;

// 			if( m_pDicsView->m_pHost1->m_bCeidEnable[ IF_UNIT_UL * 2 + 3 ] )
// 			{
// 				m_pDicsView->m_pHost1->S6F11( IF_UNIT_UL * 2 + 3 );
// 			}

			int nGlassNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nGlassNo;
			m_pGlassAni->EndGlassMove( nGlassNo );
			m_pDicsData->DeleteGlassData( IF_UNIT_UL*2 + 1 );
			
			m_pDicsData->m_GenInfo.nGlassNo -= 1;
			if( m_pDicsData->m_GenInfo.nGlassNo < 0 ) m_pDicsData->m_GenInfo.nGlassNo = 0;
			Msg( WM_GLASS_NO, m_pDicsData->m_GenInfo.nGlassNo, 0L, FALSE );
			
			m_pDicsData->m_SeqFlag.bGlassGetComp = TRUE;
			nSeqNo = 50;

#ifdef _MY_DEBUG
			m_pDicsData->m_bDebugOutSensor[IF_UNIT_UL] = FALSE;
#endif
		}
		break;
	case 50:
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_UL ) && m_pDicsData->m_SeqFlag.bGlassGetComp )
#else
		if( !m_pDicsData->m_bDebugOutSensor[IF_UNIT_UL] )
#endif
		{
			m_pDicsData->m_SeqFlag.bGlassGetComp = FALSE;
			m_pDicsData->m_IfFlag[IF_UNIT_UL].bOutReady = FALSE;

//			doUL_UNIT_TILT_CYL_UP( ON );
//			doUL_UNIT_TILT_CYL_DN( OFF );

//			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Tilt Up Start" );

			nSeqNo = 60;
		}
		break;
	case 60:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_CylinderUlTilt.GetFw() )
#else
		if( m_pEqpAssy->m_CylinderUlTilt.GetFwState() )
#endif
		{
			m_pDicsData->m_SeqFlag.bGlassOutComp1 = TRUE;
			nSeqNo = 1;
		}
//		else if( ( GetTickCount() - dwTickStart > 5000 ) )
//		{
//			nAlarmId = ALM_UL_UNIT_TILT_UP;
//			m_pEqpStateSeq->SetAlarm( nAlarmId );
//
//			// Log
//			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Tilt Up Error" );
//			nReturnSeqNo = nSeqNo;		
//			nSeqNo = 1000;
//		}
		break;
/*	case 30:
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_UL ) && m_pDicsData->m_IfLoader.bGlassGetComp )
#else
		if( !m_pDicsData->m_bDebugOutSensor[IF_UNIT_UL] )
#endif
		{
			m_pDicsData->m_IfLoader.bGlassGetComp = FALSE;
			// Log
			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nSlotNo;
			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Out Sensor is OFF(Finish)" );

			// Reset Flag
			m_pDicsData->m_SeqFlag.bGlassOutComp1		= TRUE;
			m_pDicsData->m_IfFlag[IF_UNIT_UL].bOutReady = FALSE;

			// glass move end
			int nGlassNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nGlassNo;
			m_pGlassAni->EndGlassMove( nGlassNo );

			// Delete the data
			m_pDicsData->DeleteGlassData( IF_UNIT_UL*2 + 1 );
	
			// Substrate a glass : LPARAM => "0L" means that don't set to "total glass no" value.
			m_pDicsData->m_GenInfo.nGlassNo -= 1;
			if( m_pDicsData->m_GenInfo.nGlassNo < 0 ) m_pDicsData->m_GenInfo.nGlassNo = 0;
			Msg( WM_GLASS_NO, m_pDicsData->m_GenInfo.nGlassNo, 0L, FALSE );

/*			if( ((CDicsView*) m_pOwnerWnd )->m_pCimSeq->m_TestModeFlag.bTestModeRunning )
			{
				((CDicsView*) m_pOwnerWnd )->m_pCimSeq->m_TestModeFlag.nOutputGlassCount++;
				Msg( WM_TEST_MODE_SET, (WPARAM) ((CDicsView*) m_pOwnerWnd )->m_pCimSeq->m_TestModeFlag.nInputGlassCount, 0 ); 

				if( ((CDicsView*) m_pOwnerWnd )->m_pCimSeq->m_TestModeFlag.nOutputGlassCount >= ((CDicsView*) m_pOwnerWnd )->m_pCimSeq->m_TestModeFlag.nTestSettingCount &&
						((CDicsView*) m_pOwnerWnd )->m_pCimSeq->m_TestModeFlag.bSlotSelectComplete )
				{
					((CDicsView*) m_pOwnerWnd )->m_pCimSeq->m_TestModeFlag.bTestModeRunning = FALSE;
				}
			} 
			nSeqNo = 1;
		}
		break;
*/
	// SetSeqNo  case
	case 500 :
		{
//			double dGlassSize	= GLASS_SIZE;
//			double dCvSpeed		= m_pDicsData->m_JobCond.nCvSpeed / 60.0; // mm/sec
//#ifndef _MY_DEBUG
//			nTime2	= (int)( ( dGlassSize / dCvSpeed ) * 10 );
//#else
//			nTime2	= (int)( ( (dGlassSize/3.) / dCvSpeed ) * 10 );
//#endif
//			TIMER_ON( tm2, nTime2 );

			nSeqNo = 30;
		}
		break;
	case 1000 :	// Error ó (General Error)
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId );

			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Error Recovery" );
			nSeqNo = nReturnSeqNo;
		}
		break;
	case 2000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nSlotNo;

			m_pEqpStateSeq->ResetAlarm( nAlarmId );
			nAlarmId = 0;

			m_pDicsData->m_IfFlag[IF_UNIT_UL].bOutError = FALSE;  
		//	m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = TRUE; //2008.08.28 kimgun // ??

			m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_UL] = FALSE;
			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "Scan Reset OFF(Error)" );

			nSeqNo = nReturnSeqNo;
		}
		break;
	} // Switch End 
	m_nSeqUnitUl2No = nSeqNo;
}

void CCvSeq::SetSeqNo()
{

	for( int i = ssIN ; i < 2 ; i ++ )
	{
		for( int nSensorNo = IF_UNIT_LD; nSensorNo< IF_UNIT_UL; nSensorNo++ )
		{
			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + i].bIsValid;
			
			if( bIsValid ) // When there is glass data.
			{
				// glass move ON
				// int nGlassNo = m_pDicsData->m_GlsInfo[j*2 + i].nGlassNo;
				// m_pGlassAni->GlassMove( nGlassNo, TRUE );
				
				if( i == ssIN && nSensorNo == IF_UNIT_LD ) 
				{
					// Set Sequence No
					m_nSeqUnitLdNo = 30;
				}
				else if( nSensorNo == IF_UNIT_UL ) 
				{
					if( i == ssIN )  // SeqUnitUl1()
					{
						// Set flag
						m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady = TRUE;
						m_pDicsData->m_IfFlag[nSensorNo].bInComp = FALSE;
						m_nSeqUnitUl1No = 10;
					}
					else if( i == ssOUT ) // SeqUnitUl2()
					{
						// Flag reset
						m_pDicsData->m_SeqFlag.bGlassOutComp1 = FALSE;
						m_nSeqUnitUl2No = 5; 
					}
				}
				else // In case of C/V
				{
					if( i == ssIN ) // SeqInSensor
					{
						// Set flag
						if( nSensorNo != IF_UNIT_LD ) m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady = TRUE;
						m_pDicsData->m_IfFlag[nSensorNo].bInComp = FALSE;
					}
//==>2009.02.26 minhan
					else if( i == ssOUT && nSensorNo == IF_UNIT_LD ) 
					{ 
					 	m_nSeqUnitLdNo = 200; 
					}
//<==2009.02.26 minhan
					else if( i == ssOUT ) // SeqOutSensor
					{
						// Set flag
						m_pDicsData->m_IfFlag[nSensorNo].bInReady = TRUE;
						m_pDicsData->m_IfFlag[nSensorNo].bOutComp = FALSE;
					}
				}
#ifdef _MY_DEBUG
				if( i == ssIN )
				{
					m_pDicsData->m_bDebugInSensor[nSensorNo] = TRUE;
					if( nSensorNo > IF_UNIT_LD )
						m_pDicsData->m_bDebugOutSensor[nSensorNo - 1] = TRUE;
				}
				else 
				{
					m_pDicsData->m_bDebugOutSensor[nSensorNo] = TRUE;
					if( nSensorNo > IF_UNIT_LD )
					m_pDicsData->m_bDebugInSensor[nSensorNo] = TRUE; // 2009.03.03 minhan
				}
#endif
			}
		}
	}
	
	// glass data doesn't exist, but glass is sensed.
	for( i = ssIN ; i < 2 ; i ++ )
	{
		for( int nSensorNo=IF_UNIT_LD; nSensorNo<IF_UNIT_UL; nSensorNo++ )
		{
			// 1. Sequence No 0̸ 
			// 2.  Sensor  Ǿ ִ Ȳ 
			// 3.  Glass ͼ ٷ  Glass Ǹ
			// 4. bInReady or bOutReady True ǰ Sensor ǹǷ ٷ Data Ѿ .
			// 5. Data  ߻ ==>  Ǵ Sensor Off Ǵ  Ȯؾ 
			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + i].bIsValid;
			if( !bIsValid )
			{
				if( nSensorNo >= IF_UNIT_LD && nSensorNo <= IF_UNIT_UL )
				{
#ifndef _MY_DEBUG
					if( i == ssIN && m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) && nSensorNo == IF_UNIT_LD ) 
#else
					if( i == ssIN && m_pDicsData->m_bDebugInSensor[nSensorNo] && nSensorNo == IF_UNIT_LD ) 
#endif
					{ 
//						m_pDicsData->m_IfFlag[nSensorNo].bInComp = FALSE; // 2009.03.03 minhan 
						m_nSeqUnitLdNo = 200; 
					}
#ifndef _MY_DEBUG
					if( i == ssIN && m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) && nSensorNo != IF_UNIT_LD ) 
#else
					if( i == ssIN && m_pDicsData->m_bDebugInSensor[nSensorNo] && nSensorNo != IF_UNIT_LD ) 
#endif
					{ 
					 	if( nSensorNo == IF_UNIT_EUV ) m_nSeqUnitLdNo = 240; //2009.02.26 kimgun
						m_pDicsData->m_IfFlag[nSensorNo].bInComp = FALSE; 
						m_nSeqInSensorNo[nSensorNo] = 500; 
					}
//==>2009.02.26 kimgun
#ifndef _MY_DEBUG
					if( i == ssOUT && m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) && nSensorNo == IF_UNIT_LD ) 
#else
					if( i == ssOUT && m_pDicsData->m_bDebugOutSensor[nSensorNo] && nSensorNo == IF_UNIT_LD ) 
#endif
					{ 
					 	m_nSeqUnitLdNo = 240;
					}
//<==2009.02.26 kimgun
#ifndef _MY_DEBUG
					else if( i == ssOUT && m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) ) 
#else
					else if( i == ssOUT && m_pDicsData->m_bDebugOutSensor[nSensorNo] ) 
#endif
					{ 
						m_pDicsData->m_IfFlag[nSensorNo].bOutComp = FALSE; 
						m_nSeqOutSensorNo[nSensorNo] = 500; 
					}
				}
			}
		} // MAX_IF_NO
	}
}

BOOL CCvSeq::CheckUnitCondition( int nSensorType, int nUnitNo )
{ 
	BOOL bOk = TRUE;
	int nIndex = nUnitNo-IF_UNIT_LD+nSensorType;

	for( int i=ssIN; i<=nSensorType; i++ )
		bOk &= m_pDicsView->m_pCommonIntrSeq->GetCvCond( nUnitNo + i );	
	bOk &= m_pDicsView->m_pGaugeIntrSeq->GetGaugeCond( nIndex );

	switch( nUnitNo )
	{
	case IF_UNIT_LD:
		if( nSensorType == ssIN )
		{
//			if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupJOB_MODE] == 1 )
			if( m_pDicsData->m_JobCond.bJobProcessUse == 1 )
			{
#ifndef _NO_RB	
				bOk &= m_pDicsView->m_pRbSeq->GetRbCond();
#endif
#ifndef _NO_EUV
				if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUSE_EUV] )
					bOk &= m_pDicsView->m_pEuvSeq->GetEuvCond();
#endif
			}
		}
		break;
	case IF_UNIT_EUV:
		if( m_pDicsData->m_JobCond.bJobProcessUse == 1 )
		{
#ifndef _NO_RB	
				bOk &= m_pDicsView->m_pRbSeq->GetRbCond();
#endif
#ifndef _NO_EUV
			if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUSE_EUV] )
				bOk &= m_pDicsView->m_pEuvSeq->GetEuvCond();
#endif
		}
		break;
	case IF_UNIT_RB:
	case IF_UNIT_FR:
		if( m_pDicsData->m_JobCond.bJobProcessUse == 1 )
		{
#ifndef _NO_RB
			bOk &= m_pDicsView->m_pRbSeq->GetRbCond();
#endif
			if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] &&
				m_pDicsData->m_JobCond.bJobProcessUse )
			{
				bOk &= m_pDicsView->m_pPumpSeq->m_SeqFlag.bDiTankReady[0];
				bOk &= !m_pEqpAssy->m_DiTank[0].GetPumpAlarm();
				bOk &= !m_pDicsView->m_pPumpSeq->m_SeqFlag.bInsufficientDiFlowrate[0];//2009.02.18 kimgun
		//		bOk &= m_pEqpAssy->m_DiTank[0].GetPumpOnState();
			}
#ifndef _NO_EUV
				if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUSE_EUV] )
					bOk &= m_pDicsView->m_pEuvSeq->GetEuvCond();
#endif
//			if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupSBJ_USE] )
//			{
//				bOk &= m_pEqpAssy->m_AutoValveSbjCda.GetState( 0 ) & m_pEqpAssy->m_AutoValveSbjCda.GetState( 1 ) & m_pEqpAssy->m_AutoValveSbjCda.GetState( 2 );
//			}
		}
		break;
	case IF_UNIT_AK:
#ifndef _NO_RB
			if( nSensorType == 0 )//A/K in RB ġǷ.2008.12.08 kimgun
			bOk &= m_pDicsView->m_pRbSeq->GetRbCond();
#endif		
#ifndef _NO_EUV//A/K in euv ĥ Ƿ.2008.12.08 kimgun
				if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUSE_EUV] && nSensorType == 0 )
					bOk &= m_pDicsView->m_pEuvSeq->GetEuvCond();
#endif
//==>2009.02.18 kimgun
			if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] && 
				m_pDicsData->m_JobCond.bJobProcessUse &&
				nSensorType == 0 )
			{
				bOk &= m_pDicsView->m_pPumpSeq->m_SeqFlag.bDiTankReady[0];
				bOk &= !m_pEqpAssy->m_DiTank[0].GetPumpAlarm();
				bOk &= !m_pDicsView->m_pPumpSeq->m_SeqFlag.bInsufficientDiFlowrate[0];//2009.02.18 kimgun
		//		bOk &= m_pEqpAssy->m_DiTank[0].GetPumpOnState();
			}
//<==2009.02.18 kimgun
		break;
	case IF_UNIT_UL:
		break;
	}
	
	return bOk;

/*
	BOOL bOk = TRUE;
	int nIndex = nUnitNo-IF_UNIT_LD+nSensorType;
	if( nIndex == 4 ) nIndex = 3;

	int nIndex2 = nUnitNo-IF_UNIT_LD+nSensorType;

	if( nIndex == MAX_CV_NO ) return bOk;

	bOk &= m_pDicsView->m_pCommonIntrSeq->GetCvCond( nIndex );
	bOk &= m_pDicsView->m_pGaugeIntrSeq->GetGaugeCond( nIndex2 );

	switch ( nUnitNo )
	{

	case ( IF_UNIT_LD ):
		if( nSensorType == ssIN )
		{
//			if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupJOB_MODE] == 1 )
			if( m_pDicsData->m_JobCond.bJobProcessUse == 1 )
			{
				bOk &= m_pDicsView->m_pRbSeq->GetRbCond();
			}
		}
		break;

	case (IF_UNIT_RB-1) :
		bOk &= m_pDicsView->m_pRbSeq->GetRbCond();
#ifndef _NO_EUV
		bOk &= m_pDicsView->m_pEuvSeq->GetEuvCond();
#endif
		break;
	default :
		break;
	}
	
	return bOk;
*/

}

void CCvSeq::SeqAkManualInterlockCheck()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	int nSeqNo = m_nSeqAkManualCheckNo;
	
	static DWORD dwTickStart; 

	BOOL bUse[4]    = { FALSE,};

	static BOOL bAlarm[4][2]    = { { FALSE, FALSE,}, };
	static BOOL bWarning[4][2]  = { { FALSE, FALSE,}, };	
	static int nCheckAiNo[4] = {0,0,0,0};
	BOOL bCheckCond = TRUE; 
		
	double dCurVal[4] = { 0,};	

	int nLowLimit[4]   = { 0,};
	int	nLoWarning[4] = { 0,};	
	int	nUpWarning[4] = { 0,};
	int nUpLimit[4]	  = { 0,};

	bCheckCond &= !m_pDicsData->m_GenInfo.bAuto;
	bCheckCond &= ( m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_AK1 ) || 
					m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_AK1 ) || 
					m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_AK2 ) ||
					m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_AK2 ) );
	bCheckCond &= ( m_pEqpAssy->m_AutoValveAkUp.GetState() || m_pEqpAssy->m_AutoValveAkLo.GetState() );

	switch( nSeqNo )
	{
	case 0:
		if( bCheckCond )
		{
			dwTickStart = GetTickCount();
			nSeqNo = 10;
		}
		break;

	case 10:
		if( !bCheckCond )
		{
			nSeqNo = 0;
		}
		else if( GetTickCount() - dwTickStart > 3000 )
		{
			for( int nAiNo = 0; nAiNo < m_pEqpAssy->m_AnalogInput.GetAiSize(); nAiNo++ )
			{
				for(int i=0; i<m_pEqpAssy->m_AnalogInputAk.GetAiSize(); i++)
				{
					if( m_pEqpAssy->m_AnalogInput.GetAddress( nAiNo ) == m_pEqpAssy->m_AnalogInputAk.GetAddress( i ) )
					{
						nCheckAiNo[i] = nAiNo;
						int nIntrNo = m_pEqpAssy->m_AnalogInput.m_aiSet[nAiNo].nAiIntrNo;
						if( nIntrNo < 0 ) continue;
						dCurVal[i] = (double) m_pEqpAssy->m_AnalogInputAk.GetRealVal( i );

						bUse[i]	   = m_pSetupItems->m_nValueGaugeLimit_Option[nIntrNo];
						nLowLimit[i]	= m_pSetupItems->m_nValueGaugeLimit[0][nIntrNo];
						nLoWarning[i]	= m_pSetupItems->m_nValueGaugeLimit[1][nIntrNo];
						nUpWarning[i]	= m_pSetupItems->m_nValueGaugeLimit[2][nIntrNo];
						nUpLimit[i]		= m_pSetupItems->m_nValueGaugeLimit[3][nIntrNo];
					}
				}
			}
			
			for(int i=0; i<4; i++)
			{
				if( bCheckCond && bUse[i] )
				{
					if(	nLowLimit[i] >= dCurVal[i]  ) bAlarm[i][0] = TRUE;
					else if( nLowLimit[i] < dCurVal[i] && nLoWarning[i] >= dCurVal[i] ) bWarning[i][0] = TRUE;
					else if( nUpLimit[i] <= dCurVal[i] ) bAlarm[i][1] = TRUE;
					else if( nUpLimit[i] > dCurVal[i] && nUpWarning[i] <= dCurVal[i] ) bWarning[i][1] = TRUE;
				}
			}
			
			if ( bAlarm[0][0] || bAlarm[0][1] || bWarning[0][0] || bWarning[0][1] ||
				 bAlarm[1][0] || bAlarm[1][1] || bWarning[1][0] || bWarning[1][1] || 
				 bAlarm[2][0] || bAlarm[2][1] || bWarning[2][0] || bWarning[2][1] ||
				 bAlarm[3][0] || bAlarm[3][1] || bWarning[3][0] || bWarning[3][1] )
			{
				for( i=0; i<4; i++ )
				{
					bAlarm[i][0] = FALSE;
					bAlarm[i][1] = FALSE;
					bWarning[i][0] = FALSE;
					bWarning[i][1] = FALSE;
				}
				dwTickStart = GetTickCount();
				nSeqNo = 15;
			}
			else nSeqNo = 0;
		}
		break;

	case 15:
		if( !bCheckCond )
		{
			nSeqNo = 0;
		}
		else if( GetTickCount() - dwTickStart > 1000 )
		{
			for( int nAiNo = 0; nAiNo < m_pEqpAssy->m_AnalogInput.GetAiSize(); nAiNo++ )
			{
				for(int i=0; i<m_pEqpAssy->m_AnalogInputAk.GetAiSize(); i++)
				{
					if( m_pEqpAssy->m_AnalogInput.GetAddress( nAiNo ) == m_pEqpAssy->m_AnalogInputAk.GetAddress( i ) )
					{
						int nIntrNo = m_pEqpAssy->m_AnalogInput.m_aiSet[nAiNo].nAiIntrNo;
						if( nIntrNo < 0 ) continue;
						dCurVal[i] = (double) m_pEqpAssy->m_AnalogInputAk.GetRealVal( i );

						bUse[i]	   = m_pSetupItems->m_nValueGaugeLimit_Option[nIntrNo];
						nLowLimit[i]	= m_pSetupItems->m_nValueGaugeLimit[0][nIntrNo];
						nLoWarning[i]	= m_pSetupItems->m_nValueGaugeLimit[1][nIntrNo];
						nUpWarning[i]	= m_pSetupItems->m_nValueGaugeLimit[2][nIntrNo];
						nUpLimit[i]		= m_pSetupItems->m_nValueGaugeLimit[3][nIntrNo];
					}
				}
			}
			
			for(int i=0; i<4; i++)
			{
				if( bCheckCond && bUse[i] )
				{
					if(	nLowLimit[i] >= dCurVal[i]  ) bAlarm[i][0] = TRUE;
					else if( nLowLimit[i] < dCurVal[i] && nLoWarning[i] >= dCurVal[i] ) bWarning[i][0] = TRUE;
					else if( nUpLimit[i] <= dCurVal[i] ) bAlarm[i][1] = TRUE;
					else if( nUpLimit[i] > dCurVal[i] && nUpWarning[i] <= dCurVal[i] ) bWarning[i][1] = TRUE;
				}
			}
			
			if ( bAlarm[0][0] || bAlarm[0][1] || bWarning[0][0] || bWarning[0][1] ||
				 bAlarm[1][0] || bAlarm[1][1] || bWarning[1][0] || bWarning[1][1] || 
				 bAlarm[2][0] || bAlarm[2][1] || bWarning[2][0] || bWarning[2][1] ||
				 bAlarm[3][0] || bAlarm[3][1] || bWarning[3][0] || bWarning[3][1] )
			{
				for( int j=0; j<MAX_CV_MOTOR_NO; j++ )
				{
					m_CvMotor.nCvManual[j] = CCvSeq::cvSTOP;
				}

				m_bAkManualAlarm = TRUE;
				nSeqNo = 20;
			}
			else nSeqNo = 0;
		}
		break;

	case 20:
		{
			for( int i=0; i<4; i++)
			{
				if ( bAlarm[i][0] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_LOWER_ALARM1 + nCheckAiNo[i] );
			    if ( bAlarm[i][1] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_UPPER_ALARM1 + nCheckAiNo[i] );
				if ( bWarning[i][0] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_LOWER_WARNING1 + nCheckAiNo[i] );
				if ( bWarning[i][1] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_UPPER_WARNING1 + nCheckAiNo[i] );
			}
			nSeqNo = 30;
		}
		break;

	case 30:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			for ( int i=0; i<4; i++ )
			{ 
				if ( bAlarm[i][0] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_LOWER_ALARM1 + nCheckAiNo[i] );
					 bAlarm[i][0] = FALSE;
				}
				if ( bAlarm[i][1] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_UPPER_ALARM1 + nCheckAiNo[i] );
					bAlarm[i][1] = FALSE;
				}
				if ( bWarning[i][0] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_LOWER_WARNING1 + nCheckAiNo[i] );
					bWarning[i][0] =FALSE;
				}
				if ( bWarning[i][1] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_UPPER_WARNING1 + nCheckAiNo[i] );
					bWarning[i][1] = FALSE;
				}
			}
			m_bAkManualAlarm = FALSE;

			nSeqNo = 0;
		}
		break;
	}
	m_nSeqAkManualCheckNo = nSeqNo;
}


void CCvSeq::SeqCvManualControlInterlock()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

////////////////////////////////////////////////////////////////////
	static int nSeqNo = 0;
	static DWORD dwStartTick = 0;
////////////////////////////////////////////////////////////////////

	switch( nSeqNo )
	{
	case 0 :
		if( !m_pDicsData->m_GenInfo.bAuto )
		{
			dwStartTick = GetTickCount();
			nSeqNo = 10;
		}
		break;
	case 10 :
		if( m_pDicsData->m_GenInfo.bAuto ) 
		{
			nSeqNo = 0;
		}
		else if( GetTickCount() - dwStartTick > 500 )
		{
			BOOL bLdCvFw = m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_LD );
			BOOL bLdCvBw = m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_LD );
			BOOL bUlCvFw = m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_UL );
			BOOL bUlCvBw = m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_UL );
			BOOL bEuvCvFw = m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_EUV );
			BOOL bEuvCvBw = m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_EUV );
			BOOL bRb1CvFw = m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_RB1 );
			BOOL bRb1CvBw = m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_RB1 );
			BOOL bRb2CvFw = m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_RB2 );
			BOOL bRb2CvBw = m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_RB2 );
			BOOL bFrCvFw = m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_FR );
			BOOL bFrCvBw = m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_FR );
			BOOL bAk1CvFw = m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_AK1 );
			BOOL bAk1CvBw = m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_AK1 );
			BOOL bAk2CvFw = m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_AK2 );
			BOOL bAk2CvBw = m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_AK2 );
			
			BOOL bCvStop = FALSE;
			bCvStop |= ( bLdCvBw && m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) );
			bCvStop |= ( bLdCvFw && 
						 !m_pDicsData->m_IfFlag[IF_UNIT_LD].bRecvPosComp &&
						 !m_pDicsData->m_IfFlag[IF_UNIT_LD].bSendPosComp &&
						 m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) );
			bCvStop |= ( bEuvCvBw && 
						 !m_pDicsData->m_IfFlag[IF_UNIT_LD].bSendPosComp &&
						 m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_EUV ) );


			bCvStop |= ( bUlCvFw && m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_UL ) );
			bCvStop |= ( bUlCvBw && 
						 !m_pEqpAssy->m_CylinderUlTilt.GetFw() &&
						 m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_UL ) );
			bCvStop |= ( ( bAk1CvFw || bAk2CvFw ) && 
						 !m_pEqpAssy->m_CylinderUlTilt.GetFw() &&
						 m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_AK ) );

			
			if( bCvStop )
			{
				for( int i = CV_NO_LD ; i < m_pEqpAssy->m_CvMotorAll.GetMaxSectionNo(); i++ )
				{
					m_CvMotor.nCvManual[i] = cvSTOP;
				}
			}
			nSeqNo = 0;
		}
		break;
	}
}


void CCvSeq::SeqInSensor(int nSensorNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	// return if not initialized
	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	int nSeqNo = m_nSeqInSensorNo[nSensorNo];
	static int nReturnSeqNo[MAX_UNIT_NO]		  = { 0, };
	static DWORD dwTickStart[MAX_UNIT_NO]		  = { 0, };
	
	int tm1 = TM_IN_SENSOR_ON( nSensorNo );
	int tm2 = TM_IN_SENSOR_OFF( nSensorNo );
	int tm3 = TM_IN_SENSOR_IN2OUT( nSensorNo );
		
	static int nTime1[MAX_UNIT_NO] = { 0, };
	static int nTime2[MAX_UNIT_NO] = { 0, };
	static int nTime3[MAX_UNIT_NO] = { 0, };
	static BOOL bTm3Warning[MAX_UNIT_NO] = { FALSE, };
	
	static int nPortNo[MAX_UNIT_NO] = { 0, };
	static int nSlotNo[MAX_UNIT_NO] = { 0, };
	static int nGlassNo[MAX_UNIT_NO] = { 0, };
	static int nAlarmId[MAX_UNIT_NO] = { 0, };


	TimerControl( ssIN, nSensorNo );

	if( !GetSeqRunCond( nSensorNo ) )	return;

	switch( nSeqNo )
	{
	case 0 :
		{
			if( nAlarmId[nSensorNo] > 0 )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId[nSensorNo] );
				nAlarmId[nSensorNo] = 0;
			}

			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].bIsValid;
	
			if( bIsValid )
			{  // When there is glass data.
				m_pDicsData->m_IfFlag[nSensorNo].bInComp		= FALSE;
				m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady	= TRUE;
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugInSensor[nSensorNo]		= TRUE;
				m_pDicsData->m_bDebugOutSensor[nSensorNo - 1]	= TRUE;
				m_nSeqOutSensorNo[nSensorNo - 1] = 0;
#endif
				nSeqNo = 1;
			}
			else
			{	// NO Glass Data, but Glass Sensing
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) ) 
#else
				if( m_pDicsData->m_bDebugInSensor[nSensorNo] ) 
#endif
				{ 
					m_pDicsData->m_IfFlag[nSensorNo].bInComp = FALSE; 
					nSeqNo = 500;
				}
				else
				{
					nSeqNo = 1; 
				}
			}
		}
		break;
	case 1 :
		//-----------------------------------------------------------------------------------------
		// 1. bOutReady : Program ׾   Sensor Ǿ  ̰ TRUE Ǵµ
		//    => ׷ ʵ? => ׷  History   True Ѵ.
		// 2. bOutError : Error   Glass  Դ  ϰ Ҽ ִµ ̶
		//    Sensor Ǵ ͵ ϰ Ѵ.
		//    =>  : Error ߻ϸ   C/V  Sequence θ ʴµ,  Error
		//       ߻ C/V   C/V  Ѵ.
		//-----------------------------------------------------------------------------------------
#ifndef _MY_DEBUG
		if( m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady && 
			!m_pDicsData->m_IfFlag[nSensorNo - 1].bOutError &&
			m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) )
#else
		if( m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady && 
			!m_pDicsData->m_IfFlag[nSensorNo - 1].bOutError &&
			m_pDicsData->m_bDebugInSensor[nSensorNo] )
#endif
		{
			// Flag Reset
			m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady = FALSE;

			// Glass Data Move
			GlassDataMove( ( nSensorNo - 1 )*2 + 1, nSensorNo*2 + 0, &nSlotNo[nSensorNo], &nPortNo[nSensorNo] );

			// Log
			nSlotNo[nSensorNo] = m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].nSlotNo;
			nPortNo[nSensorNo] = m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].nPortNo;

			if( m_pDicsView->m_pHost1->m_bCeidEnable[ nSensorNo] &&
				nSensorNo == IF_UNIT_EUV )//2008.11.07 kimgun
			{
//				m_pDicsView->m_pHost1->S6F11( nSensorNo * 2 + 1 );
				m_pDicsView->m_pHost1->m_bEventReportReq[nSensorNo] = TRUE;//2008.11.07 kimgun
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Glass_In Event Report" );
			}
			//2008.11.07 kimgun APC DATA Glass Head ġ  
			//////////////////////////////////////////////////////////////////////////
			m_pDicsData->m_GlsInfo[nSensorNo * 2].sGlassHeadPos.Format("%d",195 + nSensorNo );
			//////////////////////////////////////////////////////////////////////////

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "In Sensor is ON" );

			// glass move
			nGlassNo[nSensorNo] = m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].nGlassNo;
			m_pGlassAni->SetGlassMoveSpeed( nGlassNo[nSensorNo], m_pDicsData->m_JobCond.nCvSpeed / 60 );
			m_pGlassAni->GlassMove( nGlassNo[nSensorNo], nSensorNo*2 + 3 ); 

			GetTimeOut( nSensorNo, 0, &nTime1[nSensorNo], &nTime2[nSensorNo], &nTime3[nSensorNo] );
#ifndef _MY_DEBUG
			TIMER_ON( tm1, nTime1[nSensorNo] );
			TIMER_ON( tm2, nTime2[nSensorNo] );
			TIMER_ON( tm3, nTime3[nSensorNo] );
#else
//			TIMER_ON( tm1, nTime1[nSensorNo] );
//			TIMER_ON( tm2, nTime2[nSensorNo] );
//			TIMER_ON( tm3, nTime3[nSensorNo] );
			TIMER_ON( tm1, 30 );
			TIMER_ON( tm2, 30 );
			TIMER_ON( tm3, 30 );
#endif

			bTm3Warning[nSensorNo] = FALSE;
			
			//if( nSensorNo == IF_UNIT_AK )
			//{
			//	nSeqNo = 5;
			//}
			//else nSeqNo = 10;
			nSeqNo = 10; //leechelki_091124
		}
		break;
	case 5:
		if( m_pDicsData->m_SeqFlag.bUlUnitRecvReady || m_pDicsData->m_SeqFlag.bPreRecvReady )
		{
			nSeqNo = 10;
		}
		else 
		{				
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Unload Unit is Not Ready" );
			
			m_pDicsData->m_GenInfo.bUlNotReady = TRUE;
			nSeqNo = 100;
		}
		break;
	
	case 10:
		//-----------------------------------------------------------------------------------------
		// Check the out complete (Whether Out Sensor is Off or not)
		//-----------------------------------------------------------------------------------------
		if( m_pDicsData->m_IfFlag[nSensorNo].bOutComp )
		{
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Out Complete OK" );
			nSeqNo = 20;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm3 ) )
#else 
		else if( FALSE )
#endif
		{
			m_pDicsData->m_IfFlag[nSensorNo].bInLogicCheckIgnore = TRUE;
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Out Complete NG" );
			nSeqNo = 20;
		}
		break;

	case 20:
		{
		//-----------------------------------------------------------------------------------------
		// ׸ Out Sensor Ǹ شϴ Glass  ¥ Ǵ ̴.
		//-----------------------------------------------------------------------------------------
#ifndef _MY_DEBUG
		BOOL bOutSensorOn = m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo );//2009.03.20 kimgun warning.
		if( bOutSensorOn &&															   //2009.03.20 kimgun	
			( TIMER( tm3 ) || m_pDicsData->m_IfFlag[nSensorNo].bInLogicCheckIgnore ) ) // 2009.03.18 minhan
#else
		if( TIMER( tm1 ) )
#endif
		{
#ifdef _MY_DEBUG
			m_pDicsData->m_bDebugOutSensor[nSensorNo] = TRUE;
#endif
			// Flag Reset
			m_pDicsData->m_IfFlag[nSensorNo].bOutComp			= FALSE;
//			if( !bTm3Warning[nSensorNo] )//2009.03.20 kimgun sick  glass   .
//				m_pDicsData->m_IfFlag[nSensorNo].bOutSick	= FALSE;
			// Flag Set
			m_pDicsData->m_IfFlag[nSensorNo].bInReady			= TRUE;
			m_pDicsData->m_IfFlag[nSensorNo].bInLogicCheckIgnore = FALSE;
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Out Sensor is ON (Next Sensor)" );
			// glass move
			m_pGlassAni->GlassMoveRegion( nGlassNo[nSensorNo], (nSensorNo+1)*2 + 1 ); 

			// C/V Restart for previous alarm
			if( m_pDicsData->m_IfFlag[nSensorNo].bInError ) 
			{
				m_pDicsData->m_IfFlag[nSensorNo].bInError     = FALSE;
//				m_pDicsData->m_IfFlag[nSensorNo].bAlarm       = FALSE;
		//		m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;2008.08.28 kimgun
//				CvRestart( nSensorNo );
			}
			//2008.08.28 kimgun InError case 3000 
            // ϹǷ 쿡  bRecoveryReq     ִ.
			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
			nSeqNo = 30;
		}
#ifndef _MY_DEBUG // 2009.03.18 minhan
		else if( bOutSensorOn && !bTm3Warning[nSensorNo] ) //2009.03.20 kimgun// tm3 Glass Ǵ 
#else
		else if( 0 ) // tm3 Glass Ǵ 
#endif
		{
			// Flag Reset
			m_pDicsData->m_IfFlag[nSensorNo].bOutComp = FALSE;
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Next Sensor NG(1st)" );
		
			dwTickStart[nSensorNo] = GetTickCount();
			nSeqNo = 25;
		}	
#ifndef _MY_DEBUG
		else if( TIMER( tm1 ) )	// Sensor On Timeout Error
#else
		else if( 0)//nSensorNo == IF_UNIT_FR )
#endif
		{
			// C/V Stop

			// Set Alarm
//			nAlarmId[nSensorNo] = ALM_SENSOR_OUT_ON_TIMEOUT1 + nSensorNo - IF_UNIT_LD;
			nAlarmId[nSensorNo] = ALM_SENSOR_OUT_ON_TIMEOUT1 + nSensorNo;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nSensorNo] );

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Out Sensor ON Timeout Error" );

			// Flag Set
			m_pDicsData->m_IfFlag[nSensorNo].bInError	  = TRUE;
			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;//2008.08.28 kimgun
//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm       = TRUE;

			nReturnSeqNo[nSensorNo] = nSeqNo;
			nSeqNo = 1000;
		}
		else if( !CheckUnitCondition( ssIN, nSensorNo ) ) 
		{
			// C/V Stop
			m_pDicsData->m_IfFlag[nSensorNo].bInError	  = TRUE;

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Unit Condition : NG" );
//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm        = TRUE;
			
			nReturnSeqNo[nSensorNo] = nSeqNo;
			nSeqNo = 3000;
		}
		}
		break;

	case 25:
		if( GetTickCount() - dwTickStart[nSensorNo] > 500 )
		{
			if( m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) && !bTm3Warning[nSensorNo] ) // 2009.03.18 minhan
			{
				bTm3Warning[nSensorNo]			= TRUE;
//				m_pDicsData->m_IfFlag[nSensorNo].bOutSick	= TRUE; // 2009.03.22 minhan
	
				// Log
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Next Sensor NG(2nd)" );
				nSeqNo=20;
			}
			else
			{
				nSeqNo=20;
			}

		}
		else if( !m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) )
		{
			nSeqNo=20;
		}
		break;

	case 30:
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) )
#else
		if( TIMER( tm2 ) )
#endif
		{
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "In Sensor is OFF(1st)" );

			// C/V Restart for previous alarm
			if( m_pDicsData->m_IfFlag[nSensorNo].bInError ) 
			{
				 m_pDicsData->m_IfFlag[nSensorNo].bInError     = FALSE;
//				 m_pDicsData->m_IfFlag[nSensorNo].bAlarm       = FALSE;
//				 m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;2008.08.28 kimgun
			}
			//2008.08.28 kimgun InError case 3000 
            // ϹǷ 쿡  bRecoveryReq     ִ.
			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
			dwTickStart[nSensorNo] = GetTickCount();
			nSeqNo = 40;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm2 ) )	// Sensor Off Timeout Error
#else
		else if( FALSE )
#endif
		{
//			if( m_pSetupItems->m_nValueOutSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 1 )
            if( m_pSetupItems->m_nValueInSensorOffTimeOut[nSensorNo - IF_UNIT_UP_LD] == 1 ) // 2009.03.18 minhan
			{
				// C/V Stop
//				CvStop( nSensorNo, m_pDicsData->m_IfFlag[nSensorNo].bInError );

				// Set Alarm
//				nAlarmId[nSensorNo] = ALM_SENSOR_IN_OFF_TIMEOUT1 + nSensorNo - IF_UNIT_LD;
				nAlarmId[nSensorNo] = ALM_SENSOR_IN_OFF_TIMEOUT1 + nSensorNo;
				m_pEqpStateSeq->SetAlarm( nAlarmId[nSensorNo] );

				// Log
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "In Sensor OFF Timeout Error" );

				// Flag Set
//				m_pDicsData->m_IfFlag[nSensorNo].bAlarm   = TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bInError = TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;//2008.08.28 kimgun
				nReturnSeqNo[nSensorNo] = nSeqNo;
				nSeqNo = 1000;
			}
			else
			{
				// Log
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "In Sensor OFF Timeout Skip" );
				dwTickStart[nSensorNo] = GetTickCount();
				nSeqNo = 40;
			}
		}
		break;

	case 40:
		if( GetTickCount() - dwTickStart[nSensorNo] > 1000 )	// 0.1 sec 
		{
#ifndef _MY_DEBUG
//			if( !m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) || m_pSetupItems->m_nValueOutSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 0 )
            if( !m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) || m_pSetupItems->m_nValueInSensorOffTimeOut[nSensorNo - IF_UNIT_UP_LD] == 0 ) // 2009.03.18 minhan
#else
			if( 1 )
#endif
			{
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugInSensor[nSensorNo] = FALSE;
#endif
			
#ifndef _MY_DEBUG
				if( !m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) )
#else
				if( 1 )
#endif
				{
					SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "In Sensor is OFF(2nd)->End" );
				}
//				else if( m_pSetupItems->m_nValueOutSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 0 )
				else if( m_pSetupItems->m_nValueInSensorOffTimeOut[nSensorNo - IF_UNIT_UP_LD] == 0 ) // 2009.03.18 minhan
				{
					SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "In Sensor OFF Timeout Skip(2nd->End" );
				}
				
				// Flag Set
				m_pDicsData->m_IfFlag[nSensorNo].bInComp = TRUE;

				// C/V Restart for previous alarm
				if( m_pDicsData->m_IfFlag[nSensorNo].bInError ) 
				{
					m_pDicsData->m_IfFlag[nSensorNo].bInError     = FALSE;
//					m_pDicsData->m_IfFlag[nSensorNo].bAlarm       = FALSE;
//					m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;2008.08.28 kimgun
//					CvRestart( nSensorNo );
				}
				//2008.08.28 kimgun InError case 3000 
				// ϹǷ 쿡  bRecoveryReq     ִ.
			    m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
				nSeqNo = 1;
			}
			else nSeqNo = 30;
		}
		break;
	case 100:
		if( m_pDicsData->m_SeqFlag.bUlUnitRecvReady || m_pDicsData->m_SeqFlag.bPreRecvReady )
		{	
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Unload Unit is Ready Comfirm" );
			m_pDicsData->m_GenInfo.bUlNotReady = FALSE;
			nSeqNo = 5;
		}
		break;
	// SetSeqNo  case
	case 500 :
		{
			double dGlassSize	= GLASS_SIZE;
			double dCvSpeed		= m_pDicsData->m_JobCond.nCvSpeed / 60.0; // mm/sec
#ifndef _MY_DEBUG
			nTime2[nSensorNo]	= (int)( ( dGlassSize / dCvSpeed ) * 10 );
#else
			nTime2[nSensorNo]	= (int)( ( (dGlassSize/3.) / dCvSpeed ) * 10 );
#endif
			TIMER_ON( tm2, nTime2[nSensorNo] );

			nSeqNo = 30;
		}
		break;

	// Error ó (Timeout Error)
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId[nSensorNo] );
			nAlarmId[nSensorNo] = 0;

			// Set Timer
			TIMER_ON( tm1, nTime1[nSensorNo] );
			TIMER_ON( tm2, nTime2[nSensorNo] );

			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = TRUE;
			// C/V Restart
//			CvRestart( nSensorNo );

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Error Recovery" );
			nSeqNo = nReturnSeqNo[nSensorNo];
		}
		break;

	case 3000 :
#ifndef _MY_DEBUG
		if( CheckUnitCondition( ssIN, nSensorNo ) )
#else
		if( CheckUnitCondition( ssIN, nSensorNo ) )
#endif
		{
			// C/V Restart
			m_pDicsData->m_IfFlag[nSensorNo].bInError = FALSE;

			//CvRestart( nSensorNo );
//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm = FALSE;

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Re-check Unit Condition : OK" );
			nSeqNo = nReturnSeqNo[nSensorNo];
		}
		break;
	} // Switch End

	m_nSeqInSensorNo[nSensorNo] = nSeqNo;
}


void CCvSeq::SeqOutSensor(int nSensorNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return; 

	int nSeqNo = m_nSeqOutSensorNo[nSensorNo];
	static int nReturnSeqNo[MAX_UNIT_NO]		  = { 0, };
	static DWORD dwTickStart[MAX_UNIT_NO]		  = { 0, };
		
	int tm1 = TM_OUT_SENSOR_ON( nSensorNo );
	int tm2 = TM_OUT_SENSOR_OFF( nSensorNo );
	int tm3 = TM_OUT_SENSOR_OUT2IN( nSensorNo );
	static int nTime1[MAX_UNIT_NO] = { 0, };
	static int nTime2[MAX_UNIT_NO] = { 0, };
	static int nTime3[MAX_UNIT_NO] = { 0, };
	static BOOL bTm3Warning[MAX_UNIT_NO] = { FALSE, };
	
	static int nPortNo[MAX_UNIT_NO] = { 0, };
	static int nSlotNo[MAX_UNIT_NO] = { 0, };
	static int nGlassNo[MAX_UNIT_NO] = { 0, };
	static int nAlarmId[MAX_UNIT_NO] = { 0, };

	TimerControl( ssOUT, nSensorNo );

	if( !GetSeqRunCond( nSensorNo) )	return;

	switch( nSeqNo )
	{
	case 0 :
		{
			if( nAlarmId[nSensorNo] > 0 )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId[nSensorNo] );
				nAlarmId[nSensorNo] = 0;
			}

			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].bIsValid;
			if( bIsValid )
			{  // When there is glass data.
				m_pDicsData->m_IfFlag[nSensorNo].bInReady	= TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bOutComp	= FALSE;
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugOutSensor[nSensorNo]	= TRUE;
				if ( ( nSensorNo != IF_UNIT_LD ) && ( nSensorNo != IF_UNIT_UL ) ) // 2009.03.03 minhaan
				m_pDicsData->m_bDebugInSensor[nSensorNo]	= TRUE; 
				m_nSeqInSensorNo[nSensorNo] = 0;
#endif
				nSeqNo = 1;
			}
			else
			{	// NO Glass Data, but Glass Sensing
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) ) 
#else
				if( m_pDicsData->m_bDebugOutSensor[nSensorNo] ) 
#endif
				{ 
					m_pDicsData->m_IfFlag[nSensorNo].bOutComp = FALSE; 
					nSeqNo = 500;
				}
				else
				{
					nSeqNo = 1;
				}
			}
		}
		break;
	case 1 :
		//-----------------------------------------------------------------------------------------
		// 1. bInReady : Program ׾   Sensor Ǿ  ̰ TRUE Ǵµ
		//    => ׷ ʵ? => ׷  History   True Ѵ.
		// 2. bOutError : Error   Glass  Դ  ϰ Ҽ ִµ ̶
		//    Sensor Ǵ ͵ ϰ Ѵ.
		//    =>  : Error ߻ϸ   C/V  Sequence θ ʴµ,  Error
		//       ߻ C/V   C/V  Ѵ.
		//-----------------------------------------------------------------------------------------
#ifndef _MY_DEBUG
		if(  m_pDicsData->m_IfFlag[nSensorNo].bInReady && 
			!m_pDicsData->m_IfFlag[nSensorNo].bInError &&
			m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) )
#else
		if( m_pDicsData->m_IfFlag[nSensorNo].bInReady && 
			!m_pDicsData->m_IfFlag[nSensorNo].bInError &&
			m_pDicsData->m_bDebugOutSensor[nSensorNo] )
#endif
		{
//			SetApdData( nSensorNo );
			
			// Flag Reset
			m_pDicsData->m_IfFlag[nSensorNo].bInReady = FALSE;
			// Glass Data Move
			GlassDataMove( nSensorNo*2 + 0, nSensorNo*2 + 1, &nSlotNo[nSensorNo], &nPortNo[nSensorNo] );

			nSlotNo[nSensorNo] = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].nSlotNo;
			nPortNo[nSensorNo] = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].nPortNo;
//2008.11.07 kimgun CEID 
// 			if( m_pDicsView->m_pHost1->m_bCeidEnable[ nSensorNo * 2 + 2 ] )
// 			{
// //				m_pDicsView->m_pHost1->S6F11( nSensorNo * 2 + 2 );
// //				m_pDicsView->m_pHost1->m_bEventReportReq[nSensorNo * 2 + 2] = TRUE;2008.10.08 kimgun
// 				// Log
// 				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Glass_Out Event Report" );
// 			} 
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Out Sensor is ON(2nd)" );

			// Glass Move
			nGlassNo[nSensorNo] = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].nGlassNo;
			m_pGlassAni->SetGlassMoveSpeed( nGlassNo[nSensorNo], m_pDicsData->m_JobCond.nCvSpeed / 60 );
			m_pGlassAni->GlassMove( nGlassNo[nSensorNo], ( nSensorNo + 2 ) * 2 + 0 ); 

			GetTimeOut( nSensorNo, 1, &nTime1[nSensorNo], &nTime2[nSensorNo], &nTime3[nSensorNo] );
#ifndef _MY_DEBUG
			TIMER_ON( tm1, nTime1[nSensorNo] );
			TIMER_ON( tm2, nTime2[nSensorNo] );
			TIMER_ON( tm3, nTime3[nSensorNo] );
#else
//			TIMER_ON( tm1, nTime1[nSensorNo] );
//			TIMER_ON( tm2, nTime2[nSensorNo] );
//			TIMER_ON( tm3, nTime3[nSensorNo] );
			TIMER_ON( tm1, 20 );
			TIMER_ON( tm2, 20 );
			TIMER_ON( tm3, 20 );
#endif

			bTm3Warning[nSensorNo] = FALSE;

			//if( nSensorNo == IF_UNIT_FR ) nSeqNo = 5;
			//else if( nSensorNo == IF_UNIT_AK ) nSeqNo = 7;
			if( nSensorNo == IF_UNIT_AK ) nSeqNo = 7;		//leechelki_091124
			else
				nSeqNo = 10;
		}
		break;

	case 5:
		if( m_pDicsData->m_SeqFlag.bUlUnitRecvReady || m_pDicsData->m_SeqFlag.bPreRecvReady )
		{
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Unload Unit is Ready State" );
			nSeqNo = 10;
		}
		else 
		{				
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Unload Unit is Not Ready" );
			
			m_pDicsData->m_GenInfo.bUlNotReady = TRUE;
			nSeqNo = 100;
		}
		break;
	case 7:
		if( m_pDicsData->m_SeqFlag.bUlUnitRecvReady )
		{
			// Flag Set
			m_pDicsData->m_SeqFlag.bPreRecvReady = FALSE;

			nSeqNo = 10;
		}
		else 
		{			
			dwTickStart[nSensorNo] = GetTickCount();	// 141229 halesu
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Unload Unit is Not Ready!" );
			
			m_pDicsData->m_GenInfo.bUlNotReady = TRUE;
			nSeqNo = 200;
		}
		break;
	case 10:
		// A sensor is simultaneously working as LD OUT sensor and EUV IN sensor.
//		if( nSensorNo == IF_UNIT_LD || m_pDicsData->m_IfFlag[nSensorNo + 1].bInComp )
		if( !CheckUnitCondition( ssOUT, nSensorNo ) ) 
		{
			// C/V Stop
//			CvStop( nSensorNo );
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Unit Condition : NG" );
			
//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm = TRUE;
			nReturnSeqNo[nSensorNo] = nSeqNo;
			nSeqNo = 3000;
		}
		else if( m_pDicsData->m_IfFlag[nSensorNo + 1].bInComp )
		{
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "In Complete OK" );
			nSeqNo = 15;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm3 ) )
#else 
		else if( FALSE )
#endif
		{
			m_pDicsData->m_IfFlag[nSensorNo].bOutLogicCheckIgnore	= TRUE;

			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "In Complete NG" );
			nSeqNo = 15;
		}
		break;
	case 15 :
		if( CheckUnitCondition( ssOUT, nSensorNo ) )
		{	
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Cv Condition : OK" );

			// Save APD
			// 240730 halesu
			if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupAK_ECO_USE] == 1 )
			{
				if( nSensorNo == IF_UNIT_AK )
				{
					ApdSave( nSensorNo * 2 + 1, nPortNo[nSensorNo], nSlotNo[nSensorNo] );
					SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "APD Save" );
				}
			}
			else if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_ECO_USE] == 1 )
			{
				if( nSensorNo == IF_UNIT_RB )
				{
					ApdSave( nSensorNo * 2 + 1, nPortNo[nSensorNo], nSlotNo[nSensorNo] );
					SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "APD Save" );
				}
			}
			else if( nSensorNo == IF_UNIT_EUV )
			{
				ApdSave( nSensorNo * 2 + 1, nPortNo[nSensorNo], nSlotNo[nSensorNo] );
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "APD Save" );
			}
			nSeqNo = 20;
		}
		else
		{
//			CvStop( nSensorNo );
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;
			
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Cv Condition : NG" );

//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm = TRUE;
			nReturnSeqNo[nSensorNo] = nSeqNo;
			nSeqNo = 3000;			
		}
		break;
	case 20:
		{
#ifndef _MY_DEBUG
		BOOL bInSensorOn =  m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo + 1 );//2009.03.20 kimgun
		if( bInSensorOn && // 2009.03.20 kimgun
					( TIMER( tm3 ) || m_pDicsData->m_IfFlag[nSensorNo].bOutLogicCheckIgnore ) ) // 2009.03.18 minhan
#else
		if( TIMER( tm1 ) )
#endif
		{
#ifdef _MY_DEBUG
			m_pDicsData->m_bDebugInSensor[nSensorNo + 1] = TRUE;
#endif
			// Flag Reset
			m_pDicsData->m_IfFlag[nSensorNo + 1].bInComp = FALSE;
			//2009.03.20 kimgun sick  glass   .
//			if( !bTm3Warning[nSensorNo] )
//				m_pDicsData->m_IfFlag[nSensorNo + 1].bInSick = FALSE;
			// Flag Set
			m_pDicsData->m_IfFlag[nSensorNo].bOutReady				= TRUE;
			m_pDicsData->m_IfFlag[nSensorNo].bOutLogicCheckIgnore	= FALSE;
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "In Sensor is ON (Next Sensor)" );
			// Glass Move
			m_pGlassAni->GlassMoveRegion( nGlassNo[nSensorNo], ( nSensorNo + 2 )*2 + 0 ); 

			// C/V Restart
			if( m_pDicsData->m_IfFlag[nSensorNo].bOutError ) 
			{
				m_pDicsData->m_IfFlag[nSensorNo].bOutError    = FALSE;
//				m_pDicsData->m_IfFlag[nSensorNo].bAlarm       = FALSE;
//				m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;2008.08.28 kimgun
//				CvRestart( nSensorNo );
			}
			//2008.08.28 kimgun OutError case 3000 
			// ϹǷ 쿡  bRecoveryReq     ִ.
			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
			nSeqNo = 30;
		}
#ifndef _MY_DEBUG // 2009.03.18 minhan
		else if( bInSensorOn &&  !bTm3Warning[nSensorNo] )// 2009.03.20 kimgun 
#else
		else if( 0 )
#endif
		{
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Next Sensor NG(1st)" );
			dwTickStart[nSensorNo] = GetTickCount();
		
			nSeqNo = 25;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm1 ) )	// Sensor On Timeout Error
#else
		else if( 0 )//nSensorNo == IF_UNIT_RB )// )
#endif
		{
			// C/V Stop
//			CvStop( nSensorNo, m_pDicsData->m_IfFlag[nSensorNo].bOutError );
			// Set Alarm
//			nAlarmId[nSensorNo] = ALM_SENSOR_IN_ON_TIMEOUT1 + nSensorNo + 1 - IF_UNIT_LD;
			nAlarmId[nSensorNo] = ALM_SENSOR_IN_ON_TIMEOUT1 + nSensorNo + 1;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nSensorNo] );
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "In Sensor ON Timeout Error" );

			// Flag Set
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;
			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;//2008.08.28 kimgun
//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm    = TRUE;

			nReturnSeqNo[nSensorNo] = nSeqNo;
			nSeqNo = 1000;
		}
		if( !CheckUnitCondition( ssOUT, nSensorNo ) ) 
		{
			// C/V Stop
//			CvStop( nSensorNo );
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;

			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Unit Condition : NG" );
			nReturnSeqNo[nSensorNo] = nSeqNo;
//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm = TRUE;
			nSeqNo = 3000;
		}
		}
		break;

	case 25 :
		if( GetTickCount() - dwTickStart[nSensorNo] > 500 )
		{
			if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo + 1 ) && !bTm3Warning[nSensorNo] ) // 2009.03.18 minhan
			{
				bTm3Warning[nSensorNo] = TRUE;
//				m_pDicsData->m_IfFlag[nSensorNo + 1].bInSick = TRUE; // 2009.03.22 minhan
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Next Sensor NG(2nd)" );
				nSeqNo=20;
			}
			else
			{
				nSeqNo=20;
			}

		}
		else if( !m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo + 1 ) )
		{
			nSeqNo=20;
		}
		break;

	case 30:
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) )
#else
		if( TIMER( tm2 ) )
#endif
		{
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Out Sensor is OFF (1st)" );
			// C/V Restart for previous alarm
			if( m_pDicsData->m_IfFlag[nSensorNo].bOutError ) 
			{
				 m_pDicsData->m_IfFlag[nSensorNo].bOutError	   = FALSE;
//				 m_pDicsData->m_IfFlag[nSensorNo].bAlarm	   = FALSE;
//				 m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;//2008.08.28 kimgun
//				 CvRestart( nSensorNo );
			}
			//2008.08.28 kimgun OutError case 3000 
			// ϹǷ 쿡  bRecoveryReq     ִ.
			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
			dwTickStart[nSensorNo] = GetTickCount();
			nSeqNo = 40;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm2 ) )	// Sensor Off Timeout Error
#else
		else if( nSensorNo == IF_UNIT_FR)
#endif
		{
			// C/V Stop
//			if( m_pSetupItems->m_nValueInSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 1 )
            if( m_pSetupItems->m_nValueOutSensorOffTimeOut[nSensorNo - IF_UNIT_UP_LD] == 1 ) // 2009.03.18 minhan 
			{
//				CvStop( nSensorNo, m_pDicsData->m_IfFlag[nSensorNo].bOutError );

				// Set Alarm
//				nAlarmId[nSensorNo] = ALM_SENSOR_OUT_OFF_TIMEOUT1 + nSensorNo - IF_UNIT_LD;
				nAlarmId[nSensorNo] = ALM_SENSOR_OUT_OFF_TIMEOUT1 + nSensorNo;
				m_pEqpStateSeq->SetAlarm( nAlarmId[nSensorNo] );

				// Log
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Out Sensor OFF Timeout Error" );

				// Flag Set
				m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;//2008.08.28 kimgun
//				m_pDicsData->m_IfFlag[nSensorNo].bAlarm    = TRUE;
				nReturnSeqNo[nSensorNo] = nSeqNo;
				nSeqNo = 1000;
			}
			else
			{
				// Log
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Out Sensor OFF Timeout Skip" );
				dwTickStart[nSensorNo] = GetTickCount();
				nSeqNo = 40;
			}
		}
		break;

	case 40:
		if( GetTickCount() - dwTickStart[nSensorNo] > 1000 )	// 1 sec 
		{
#ifndef _MY_DEBUG
//			if( !m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) || m_pSetupItems->m_nValueInSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 0 )
            if( !m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) || m_pSetupItems->m_nValueOutSensorOffTimeOut[nSensorNo - IF_UNIT_UP_LD] == 0 ) // 2009.03.18 minhan
#else
			if( 1 )
#endif
			{
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugOutSensor[nSensorNo] = FALSE;
#endif

#ifndef _MY_DEBUG
				if( !m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) )
#else
				if( 1 )
#endif
				{
					SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Out Sensor is OFF (2nd)" );
				}
//				else if( m_pSetupItems->m_nValueInSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 0 )
                else if( m_pSetupItems->m_nValueOutSensorOffTimeOut[nSensorNo - IF_UNIT_UP_LD] == 0 ) // 2009.03.18 minhan
				{
					SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Out Sensor OFF Timeout Skip(2nd)" );
				}

				// Flag Set
				m_pDicsData->m_IfFlag[nSensorNo].bOutComp = TRUE;

				//2008.11.07 kimgun APC DATA Glass Tail ġ  
				//////////////////////////////////////////////////////////////////////////
				for( int i = nSensorNo * 2; i < IF_UNIT_UL * 2 + 1; i++ )
				{
					if( m_pDicsData->m_GlsInfo[i].bIsValid )
					{
						m_pDicsData->m_GlsInfo[i].sGlassTailPos.Format("%d",195 + nSensorNo + 1 );
						break;
					}

				}
				//////////////////////////////////////////////////////////////////////////

				// C/V Restart
				if( m_pDicsData->m_IfFlag[nSensorNo].bOutError ) 
				{
					m_pDicsData->m_IfFlag[nSensorNo].bOutError	  = FALSE;
//					m_pDicsData->m_IfFlag[nSensorNo].bAlarm		  = FALSE;
//					m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;2008.08.28 kimgun
//					CvRestart( nSensorNo );
				}
				//2008.08.28 kimgun OutError case 3000 
				// ϹǷ 쿡  bRecoveryReq     ִ.
				m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
				nSeqNo = 1;
			}
			else nSeqNo = 30;
		}
		break;

	case 100:
		if(  m_pDicsData->m_SeqFlag.bUlUnitRecvReady || m_pDicsData->m_SeqFlag.bPreRecvReady )
		{	
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Unload Unit is Ready Comfirm" );
			m_pDicsData->m_GenInfo.bUlNotReady = FALSE;
			nSeqNo = 5;
		}
		break;
	case 200:
		if( m_pDicsData->m_SeqFlag.bUlUnitRecvReady )
		{
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Unload Unit is Ready Comfirm!" );
			m_pDicsData->m_GenInfo.bUlNotReady = FALSE;
			nSeqNo = 7;
		}
		else if( GetTickCount() - dwTickStart[nSensorNo] > (double)( 1000 * atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupAK_OUT_WAITING_TIMEOUT] )))	// 141229 halesu
		{
			// Set Alarm
			nAlarmId[nSensorNo] = ALM_AK_OUT_WAITING_TIMEOUT;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nSensorNo] );

			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "AK Out Waiting Timeout Alarm" );

			// Flag Set
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;
			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;

			nReturnSeqNo[nSensorNo] = nSeqNo;
			nSeqNo = 2000;			
		}
		break;
	case 500 :
		{
			double dGlassSize	= GLASS_SIZE;
			double dCvSpeed		= m_pDicsData->m_JobCond.nCvSpeed / 60.0; // mm/sec
#ifndef _MY_DEBUG
			nTime2[nSensorNo]	= (int)( ( dGlassSize / dCvSpeed ) * 10 );
#else
			nTime2[nSensorNo]	= (int)( ( (dGlassSize/3.) / dCvSpeed ) * 10 );
#endif
			TIMER_ON( tm2, nTime2[nSensorNo] );

			nSeqNo = 30;
		}
		break;

	// Error ó (Timeout Error)
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId[nSensorNo] );

			// Set Timer
			TIMER_ON( tm1, nTime1[nSensorNo] );
			TIMER_ON( tm2, nTime2[nSensorNo] );

			// C/V Restart
//			CurCvRestart( nSensorNo );
			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = TRUE;
			// Log
			nPortNo[nSensorNo] = atoi( m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].sPortNo );
			nSlotNo[nSensorNo] = atoi( m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].sSlotNo );

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Error Recovery" );
			nSeqNo = nReturnSeqNo[nSensorNo];
		}
		break;
	case 2000:	// 141229 halesu
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId[nSensorNo] );

			// Set Timer
			dwTickStart[nSensorNo] = GetTickCount();

			// C/V Restart
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = FALSE;
			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = TRUE;

			// Log
			nPortNo[nSensorNo] = atoi( m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].sPortNo );
			nSlotNo[nSensorNo] = atoi( m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].sSlotNo );

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Error Recovery" );
			nSeqNo = nReturnSeqNo[nSensorNo];
		}
		break;
	case 3000 :
		if( CheckUnitCondition( ssOUT, nSensorNo ) )
		{
			// C/V Restart
//			CvRestart( nSensorNo );			
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = FALSE;

			// Log
//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm = FALSE;
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Re-check Unit Condition : OK" );
			nSeqNo = nReturnSeqNo[nSensorNo];
		}
		break;

	} // Switch End 

	m_nSeqOutSensorNo[nSensorNo] = nSeqNo;
}


//******************************************************************************
//
//
//	-o-----o--o----o--o----o--o----o--o----o--o----o--o----o-
//	|		||		||		||		||		||		||		||
//	|	0	||	1	||	2	||	3	||	4	||	5	||	6	||		MAX_UNIT_NO = 7
//	----------------------------------------------------------
//	(M0)---->|(M1)---------->|(M2)------------------>|(M3)-->|		MAX_CV_NO = 4
//	
//	n=	1			2					3				1			nInfoSet[MAX_CV_NO][1] = n
//
//	static int nInfoSet[MAX_CV_NO][2]
//	{
//		{ IF_UNIT_O, 1},
//		{ IF_UNIT_1, 2},
//		{ IF_UNIT_3, 3},
//		{ IF_UNIT_6, 1},
//	};
//******************************************************************************
void CCvSeq::SeqCv(int nCvNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	static int nInfoSet[MAX_UNIT_NO][2] = {
		{0,0},
		{0,0},
		{0,0},
		{0,0},
		{ IF_UNIT_LD, 1 },
		{ IF_UNIT_EUV,1 },
		{ IF_UNIT_RB, 1 },
		{ IF_UNIT_FR, 1 },
		{ IF_UNIT_AK, 1 },
		{ IF_UNIT_UL, 1 }
	};

	// 140403 halesu
	static CString sUnitName[MAX_UNIT_NO] = {
		"",
		"",
		"",
		"",
		"LD",
		"EUV",
#ifdef _NO_RB
		"SBJ",
#else
		"RB",
#endif
		"FR",
		"AK",
		"UL",
	};

	int nUnit = nInfoSet[nCvNo][cvinfoSTART_UNIT];
	int nUnitEA = nInfoSet[nCvNo][cvinfoUNIT_NO];
	//******************************************************************************
	// Get Run Condition
	//******************************************************************************
	BOOL bRunCond = FALSE;
	for( int i = 0 ; i < nUnitEA ; i ++ )
	{
		nUnit = nUnit + i;
		bRunCond |= ( m_pDicsData->m_IfFlag[nUnit-1].bOutReady & ( nUnit != IF_UNIT_LD ) );
 		bRunCond |= ( !m_pDicsData->m_IfFlag[nUnit-1].bOutComp & ( nUnit != IF_UNIT_LD ) );
		bRunCond |= m_pDicsData->m_IfFlag[nUnit].bInReady;
		bRunCond |= m_pDicsData->m_IfFlag[nUnit].bOutReady;
		bRunCond |= ( m_pDicsData->m_GlsInfo[nUnit*2+0].bIsValid & ( nUnit != IF_UNIT_LD ) );
		bRunCond |= !m_pDicsData->m_IfFlag[nUnit].bOutComp;
//		bRunCond |= !m_pDicsData->m_IfFlag[nUnit+i].bInComp;
		bRunCond |= ( !m_pDicsData->m_IfFlag[nUnit+1].bInComp & 
					  ( ( nUnit != IF_UNIT_UL ) && ( nUnit != IF_UNIT_LD ) ) );
	}
	nUnit = nInfoSet[nCvNo][cvinfoSTART_UNIT];
	//==>2008.10.12 kimgun Sbj stop Ȯϰ ϱ.. 
	if( nUnit == IF_UNIT_FR && m_CvMotor.nCvAuto[IF_UNIT_RB] != cvFW && 
	     m_pDicsData->m_IfFlag[IF_UNIT_FR].bOutComp )
	{
		bRunCond = FALSE;	
	}
	//<==2008.10.12
	if( nUnit == IF_UNIT_UL && m_pDicsData->m_IfFlag[IF_UNIT_UL].bInComp && 
	     m_pDicsData->m_IfFlag[IF_UNIT_UL].bOutComp )
	{
		bRunCond = FALSE;	
	}
	//******************************************************************************
	// Get Alarm Condition
	//******************************************************************************
	BOOL bAlarm = FALSE;
	for( i = nCvNo; i < MAX_UNIT_NO ; i ++ )
	{
		nUnit = nInfoSet[i][cvinfoSTART_UNIT];
		nUnitEA = nInfoSet[i][cvinfoUNIT_NO];
		for( int j = 0 ; j < nUnitEA ; j ++ )
		{
			nUnit = nUnit + j;
			bAlarm |= m_pDicsData->m_IfFlag[nUnit].bInError | m_pDicsData->m_IfFlag[nUnit].bOutError;
		}
		if( i <= IF_UNIT_AK )
		{
			bAlarm |= m_pDicsData->m_GenInfo.bAkInterlock;
		}
	}
	//******************************************************************************
	// Get Recovery Condition
	//******************************************************************************
	BOOL bRecoveryReq = FALSE;
	for( i = nCvNo ; i < nCvNo + 3 ; i ++ )//2008.08.28 KIMGUN Glass ִ 3~4 Unit ⶧..
	{                                      //߻ ˶ġ ڷ 2 ڱ C/V ȸ Ű.. 
		if( (nCvNo == MAX_CV_NO) || (i >= MAX_CV_NO) ) continue;

		nUnit = nInfoSet[i][cvinfoSTART_UNIT];
		nUnitEA = nInfoSet[i][cvinfoUNIT_NO];
		for( int j = 0 ; j < nUnitEA ; j ++ )
		{
			nUnit = nUnit + j;
			bRecoveryReq |= m_pDicsData->m_IfFlag[nUnit].bRecoveryReq;
		}
	}
	//******************************************************************************
	// Get Interlock Condition
	//******************************************************************************
	BOOL bInterlock = FALSE;
	bInterlock|= !m_pDicsData->m_GenInfo.bAuto;
	bInterlock|= m_pDicsData->m_GenInfo.bPause;
	bInterlock|= ( m_pDicsData->m_GenInfo.bUlTimeOut && nInfoSet[nCvNo][cvinfoSTART_UNIT] < IF_UNIT_UL );
	bInterlock|= ( m_pDicsData->m_GenInfo.bUlNotReady && 
				   m_pDicsData->m_GlsInfo[IF_UNIT_FR*2+1].bIsValid &&
				   nInfoSet[nCvNo][cvinfoSTART_UNIT] < IF_UNIT_AK );
	bInterlock|= ( m_pDicsData->m_GenInfo.bUlNotReady && 
				   nInfoSet[nCvNo][cvinfoSTART_UNIT] == IF_UNIT_AK && 
				   m_pDicsData->m_GlsInfo[IF_UNIT_FR*2+1].bIsValid &&
				   m_pDicsData->m_IfFlag[IF_UNIT_AK].bOutComp );

	bInterlock|= ( m_pDicsData->m_GenInfo.bUlNotReady && 
				   nInfoSet[nCvNo][cvinfoSTART_UNIT] < IF_UNIT_UL && 
				   ( m_pDicsData->m_GlsInfo[IF_UNIT_AK*2+0].bIsValid || m_pDicsData->m_GlsInfo[IF_UNIT_AK*2+1].bIsValid ));
	bInterlock|= m_pDicsData->m_GenInfo.bLeakSensor;
	bInterlock|= m_pDicsData->m_GenInfo.bEmo;
	bInterlock|= m_pDicsData->m_GenInfo.bAreaSensor;
	bInterlock|= m_pDicsData->m_GenInfo.bCoverOpen;
	bInterlock|= m_pDicsData->m_GenInfo.bDoorOpen;
	bInterlock|= m_pDicsData->m_GenInfo.bIonizerAlarm;
	bInterlock|= m_pDicsData->m_SeqFlag.bUlHandAlarm;

	//******************************************************************************
	// Set C/V Motor Command
	//******************************************************************************
	if( !bInterlock && bRunCond && ( bRecoveryReq || !bAlarm ) )
	{
		if( m_CvMotor.nCvAuto[nCvNo] == cvSTOP )	// 140403 halesu
		{
			SetLog( sUnitName[nCvNo], 0, 0, "C/V Run" );	
		}
		m_CvMotor.nCvAuto[nCvNo] = cvFW;

		//2008.08.28 kimgun    Ǿ   ʰԲ..
		if( m_pDicsData->m_GenInfo.bSbjStop &&
			(m_CvMotor.nCvAuto[IF_UNIT_RB] != cvSTOP  ||
 			m_CvMotor.nCvAuto[IF_UNIT_FR] != cvSTOP) )
			m_pDicsData->m_GenInfo.bSbjStop = FALSE;
	}
	else
	{
		if( m_CvMotor.nCvAuto[nCvNo] != cvSTOP )	// 140403 halesu
		{
			SetLog( sUnitName[nCvNo], 0, 0, "C/V Stop" );	
		}
		m_CvMotor.nCvAuto[nCvNo] = cvSTOP;

		if( !m_pDicsData->m_GenInfo.bSbjStop &&
			( bInterlock || ( bAlarm && nInfoSet[nCvNo][cvinfoSTART_UNIT] > IF_UNIT_EUV ) ) )
		{
			BOOL bSbjStop = FALSE;
			for( i = nInfoSet[nCvNo][cvinfoSTART_UNIT] + 1; i <= IF_UNIT_FR; i++ )
			{// glass  FR    ߸  . 2008.12.08 kimgun
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( i ) || m_pEqpAssy->m_GlassExistUnitOut.GetOr( i ) )
#else
				if( m_pDicsData->m_bDebugInSensor[i] ||  m_pDicsData->m_bDebugOutSensor[i] )
#endif
					bSbjStop = TRUE;
			}
				if( !bSbjStop )
				m_pDicsData->m_GenInfo.bSbjStop = TRUE;

		}
	}
}

void CCvSeq::SeqCvMotorControl(int nCvNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if( nCvNo == CV_NO_LD && !m_pDicsData->m_IfFlag[IF_UNIT_LD].bSendPosComp ) return;

	if( m_pDicsData->m_GenInfo.bAuto )
	{
		if( m_CvMotor.nCvAuto[nCvNo] == cvFW )
		{
			m_pEqpAssy->m_CvMotor.SetMotorFw( nCvNo, ON );
			m_pEqpAssy->m_CvMotor.SetMotorBw( nCvNo, OFF );
		}
		else if( m_CvMotor.nCvAuto[nCvNo] == cvBW )
		{
			m_pEqpAssy->m_CvMotor.SetMotorFw( nCvNo, OFF );
			m_pEqpAssy->m_CvMotor.SetMotorBw( nCvNo, ON );
		}
		else if( m_CvMotor.nCvAuto[nCvNo] == cvSTOP )
		{
			m_pEqpAssy->m_CvMotor.SetMotorFw( nCvNo, OFF );
			m_pEqpAssy->m_CvMotor.SetMotorBw( nCvNo, OFF );
		}
	} 
}

void CCvSeq::SeqCvMotorSpeedControl()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	static int nSeqCvMotorSpeedControlNo = 0;
	static int nCurSpeedAuto[MAX_CV_NO] = { 0, };
	static int nCurSpeedManual[MAX_CV_MOTOR_NO] = { 0, };

	// 140403 halesu
	static CString sUnitName[MAX_UNIT_NO] = {
		"",
		"",
		"",
		"",
		"LD",
		"EUV",
#ifdef _NO_RB
		"SBJ",
#else
		"RB",
#endif
		"FR",
		"AK",
		"UL",
	};

	int nSeqNo = nSeqCvMotorSpeedControlNo;

	switch( nSeqNo ) 
	{
	case 0 :
		if( !m_pDicsData->m_GenInfo.bAuto )
		{
			nSeqNo = 10;			
		}
		else
		{
			for( int i=CV_NO_LD; i<m_pEqpAssy->m_CvMotor.GetMaxSectionNo(); i++ )
			{
				if( i == CV_NO_LD && 
					( m_pDicsData->m_IfFlag[i].bRecvPosComp || 
					  !m_pDicsData->m_IfFlag[i].bSendPosComp ) )
				{
					nCurSpeedAuto[i] = 0;	// 140425 halesu
					continue;
				}

				int nCvSpeed = m_pDicsData->m_JobCond.nCvSpeedSet[i][CJobCond::speedNORMAL];

				// halesu 091216
#ifndef _MY_DEBUG
				if ( !m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_EUV ) &&
					 !m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_RB ) )
#else
				if( !m_pDicsData->m_bDebugOutSensor[IF_UNIT_EUV] && !m_pDicsData->m_bDebugInSensor[IF_UNIT_RB] )
#endif
				{
					nCvSpeed = m_pDicsData->m_JobCond.nCvSpeedSet[i][CJobCond::speedDEC];
				}

				if( nCvSpeed != nCurSpeedAuto[i] )
				{
					// 140403 halesu
					CString sMessage;
					sMessage.Format("%s : %d --> %d", sUnitName[i], nCurSpeedAuto[i], nCvSpeed );
					SetLog( "LO SPEED", 0, 0, sMessage );

					nCurSpeedAuto[i] = nCvSpeed;
					m_pEqpAssy->m_CvMotor.SetMotorSpeed( i, nCvSpeed );
				}
			}	
		}
		break;
	case 10 :
		if( m_pDicsData->m_GenInfo.bAuto )
		{
			for( int i=CV_NO_LD ; i<m_pEqpAssy->m_CvMotor.GetMaxSectionNo(); i++ )
			{
				nCurSpeedAuto[i] = 0;
			}
			nSeqNo = 0;
		}
		else
		{
			for( int i=CV_NO_LD; i<m_pEqpAssy->m_CvMotorAll.GetMaxSectionNo(); i++ )
			{
				if( i == CV_NO_LD && 
					( m_pDicsData->m_IfFlag[i].bRecvPosComp || 
					  !m_pDicsData->m_IfFlag[i].bSendPosComp ) )
					continue;

				int nCvSpeed = m_CvMotor.nSpeedManual[i];
				if( nCvSpeed != nCurSpeedManual[i] )
				{
					nCurSpeedManual[i] = nCvSpeed; 
					m_pEqpAssy->m_CvMotorAll.SetMotorSpeed( i, nCvSpeed );
				}
			}
		}
		break;
	}

	nSeqCvMotorSpeedControlNo = nSeqNo;
}

void CCvSeq::SeqCvMotorManualControl(int nCvMotorNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	if( !m_pDicsData->m_GenInfo.bAuto )
	{
		if( nCvMotorNo == IF_UNIT_LD && !m_pDicsData->m_IfFlag[IF_UNIT_LD].bSendPosComp ) return;

		if ( m_CvMotor.nCvManual[nCvMotorNo] == cvFW )
		{
			m_pEqpAssy->m_CvMotorAll.SetMotorFw( nCvMotorNo, ON );
			m_pEqpAssy->m_CvMotorAll.SetMotorBw( nCvMotorNo, OFF );
		}
		else if( m_CvMotor.nCvManual[nCvMotorNo] == cvBW )
		{
			m_pEqpAssy->m_CvMotorAll.SetMotorFw( nCvMotorNo, OFF );
			m_pEqpAssy->m_CvMotorAll.SetMotorBw( nCvMotorNo, ON );
		}
		else if( m_CvMotor.nCvManual[nCvMotorNo] == cvSTOP )
		{
			m_pEqpAssy->m_CvMotorAll.SetMotorFw( nCvMotorNo, OFF );
			m_pEqpAssy->m_CvMotorAll.SetMotorBw( nCvMotorNo, OFF );
		}		
	}
	else 
	{
		m_CvMotor.nCvManual[nCvMotorNo] = cvSTOP;
	} 
}
void CCvSeq::TimerControl( int nSensorType, int nSensorNo )
{
	static BOOL bTimerPause[MAX_CV_NO*2] = { FALSE, };
	int nIndex = nSensorNo*2 + nSensorType;

//	static int nCvInfo[MAX_CV_NO] = {
//		0,
//		0,
//		0,
//		0,
//		CV_NO_LD,
//		CV_NO_EUV,
//		CV_NO_RB,
//		CV_NO_FR,
//		CV_NO_AK,
//		CV_NO_UL,
//	};

	if( nSensorNo == IF_UNIT_LD && !m_pDicsData->m_IfFlag[IF_UNIT_LD].bSendPosComp ) return;

	if( ( m_CvMotor.nCvAuto[nSensorNo] == cvFW ) && bTimerPause[nIndex] )//2008.08.26 kimgun
//	if( ( m_CvMotor.nCvAuto[nSensorNo-IF_UNIT_LD] == cvFW ) )//&& bTimerPause[nIndex] )
	{
		
		TimerRestart( nIndex );
		bTimerPause[nIndex] = FALSE;

		// Glass Start
		BOOL bIsValid = m_pDicsData->m_GlsInfo[nIndex].bIsValid;
		if( bIsValid ) 
		{
			int nGlassNo = m_pDicsData->m_GlsInfo[nIndex].nGlassNo;
			m_pGlassAni->GlassMove( nGlassNo, nIndex + 3, TRUE );
		}
	}
	else if( ( m_CvMotor.nCvAuto[nSensorNo] == cvSTOP ) && !bTimerPause[nIndex] )//2008.08.26 kimgun
//	else if( ( m_CvMotor.nCvAuto[nSensorNo-IF_UNIT_LD] == cvSTOP ) )//&& !bTimerPause[nIndex] )
	{
		TimerStop( nIndex );
		bTimerPause[nIndex] = TRUE;

		// Glass Stop
		BOOL bIsValid = m_pDicsData->m_GlsInfo[nIndex].bIsValid;
		if( bIsValid ) 
		{
			int nGlassNo = m_pDicsData->m_GlsInfo[nIndex].nGlassNo;
			m_pGlassAni->GlassMove( nGlassNo, nIndex + 3, FALSE );
		}
	}
}

void CCvSeq::GetTimeOut(int nSensorNo, int nIsOutSensor, int* nTm1, int* nTm2, int* nTm3)
{
	double dCvSpeed = 0.0;
	double dCvLength = m_pSetupItems->m_fValueCvLength[( nSensorNo )*2 + nIsOutSensor + 1];

	dCvSpeed = m_pDicsData->m_JobCond.nCvSpeed / 60.0; // mm/sec

	double dCvMarginOn		= TIMEOUT_MARGIN_LENGTH_ON;
	double dCvMarginOff		= TIMEOUT_MARGIN_LENGTH_OFF;
	double dMarginOnTime	= dCvMarginOn / dCvSpeed;
	double dMarginOffTime	= dCvMarginOff / dCvSpeed;
	double dGlassSize		= GLASS_SIZE;

	// In Sensor Time out Setting
	*nTm1 = (int)( ( dCvLength / dCvSpeed + dMarginOnTime ) * 10 );
	*nTm2 = (int)( ( ( dGlassSize / dCvSpeed ) + dMarginOffTime ) * 10 );
	if( nTm3 != NULL )
		*nTm3 = (int)( ( dCvLength / dCvSpeed - dMarginOnTime ) * 10 );
#ifdef _MY_DEBUG
	*nTm1 = (int)( ( dCvLength / dCvSpeed ) * 10 );
	*nTm2 = (int)( ( dGlassSize / dCvSpeed ) * 10 );
	if( nTm3 != NULL )
		*nTm3 = (int)( ( dCvLength / dCvSpeed + dMarginOnTime ) * 10 );
#endif
}

BOOL CCvSeq::GetSeqRunCond( int nSensorNo )
{
	BOOL bRunCond   = TRUE;
	BOOL bAlarm		= FALSE;
	BOOL bUlTimeout = FALSE;

	// Check CvStop Condition
	for( int i = nSensorNo + 1; i<= IF_UNIT_UL; i++ )
	{
		bAlarm |= m_pDicsData->m_IfFlag[i].bInError;
		bAlarm |= m_pDicsData->m_IfFlag[i].bOutError;

//		bAlarm |= m_pDicsData->m_IfFlag[i].bAlarm;
	}
	 bUlTimeout = ( m_pDicsData->m_GenInfo.bUlTimeOut && nSensorNo != IF_UNIT_UL );
	if( nSensorNo == IF_UNIT_LD )
	{
		bAlarm |= !m_pDicsData->m_IfFlag[IF_UNIT_LD].bSendPosComp;
	}

	if( nSensorNo != IF_UNIT_UL )
	{
		bAlarm |= m_pDicsData->m_GenInfo.bUlTimeOut;
	}

	if( m_pDicsData->m_GlsInfo[IF_UNIT_AK * 2 + 0].bIsValid ||
		m_pDicsData->m_GlsInfo[IF_UNIT_AK * 2 + 1].bIsValid )
	{
		if( nSensorNo < IF_UNIT_AK )
		{
			bAlarm |= m_pDicsData->m_GenInfo.bUlNotReady;
		}
	}
	else if( m_pDicsData->m_GlsInfo[IF_UNIT_FR * 2 + 1].bIsValid )
	{
		if( nSensorNo < IF_UNIT_FR )
		{
			bAlarm |= m_pDicsData->m_GenInfo.bUlNotReady;
		}
	}

	bRunCond &=	m_pDicsData->m_GenInfo.bAuto &  
				!m_pDicsData->m_GenInfo.bEmo &
				!m_pDicsData->m_GenInfo.bCoverOpen &
				!m_pDicsData->m_GenInfo.bDoorOpen &
				!m_pDicsData->m_GenInfo.bLeakSensor &
				!m_pDicsData->m_GenInfo.bPause &
				!bUlTimeout &
				!bAlarm;

	return bRunCond;
}

void CCvSeq::ApdSave(UINT nID, int nPortNo, int nSlotNo)
{
	int nSlot = m_pDicsData->m_GlsInfo[nID].nGlass_slot;
	m_sMessage.Format( "Unit No : %d, GLS Slot : %d", nID, nSlot );
	SetLog( "APD SAVE", nPortNo, nSlotNo, m_sMessage );	
//#ifndef _MY_DEBUG
#ifndef _NO_EUV
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[2] = m_pDicsData->m_IfEuv.fLampIntensity[0];
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[3] = m_pDicsData->m_IfEuv.fLampIntensity[1];
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[4] = m_pDicsData->m_IfEuv.fLampIntensity[2]; 
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[5] = m_pDicsData->m_IfEuv.fLampIntensity[3]; 
#else
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[2] = 0.0;
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[3] = 0.0;
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[4] = 0.0; 
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[5] = 0.0; 
#endif
	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		int nApdNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nApdReportNo;
		if( nApdNo < 0 ) continue;
		m_pDicsData->m_CimApd[nSlot].dbGLSApd[CCimSeq::apdAI_START+nApdNo] = (double) m_pEqpAssy->m_AnalogInput.GetRealVal( i );
	}


	CString sString;
	for( int j = 2; j < MAX_APD_DATA_NO ; j++ )
	{
		CString sBuf;
		sString.Format( "%.3f", m_pDicsData->m_CimApd[nSlot].dbGLSApd[j] );
//		m_pDicsData->m_GlsInfo[nID].sApdData[j].Format("%10.3f", m_pDicsData->m_CimApd[nSlot].dbGLSApd[j] );
		m_pDicsData->m_GlsInfo[nID].sApdData[j] = sString;
	}

	m_pDicsData->WriteProfileGlassData( nID );
	
}
void CCvSeq::CvStop(int nCvNo, BOOL bError)
{
// NOOP 
}

void CCvSeq::CvStopAll()
{
// NOOP 
}

void CCvSeq::CurCvRestart(int i)
{
// NOOP 
}

void CCvSeq::CvRestart(int nCvNo)
{
// NOOP 
}

void CCvSeq::CvRestartAll()
{
// NOOP 
}
void CCvSeq::SeqUnitUlTilt()
{
	if( !m_SeqFlag.bInitReq && !m_SeqFlag.bInitComp )	return;

	static DWORD dwTickStart = 0;
	static int nAlarmId = 0;

	int nSeqNo = m_nSeqUnitUlTiltNo;

	BOOL bUlHandCylFw		= m_pEqpAssy->m_CylinderUlHand.GetFw();
	BOOL bUlHandCylBw		= m_pEqpAssy->m_CylinderUlHand.GetBw();

	BOOL bUlHandHomePos		= m_pMmc->GetHomeSwitch( RBT_UL_HAND_UNIT_S_AXIS );
	BOOL bUlHandBeforeRecv	= m_pMmc->GetHomeSwitch( RBT_UL_HAND_UNIT_S_AXIS );
	BOOL bUlHandAfterRecv	= m_pEqpAssy->m_PosSensorUlHand.GetAnd( UL_HAND_UNIT_AFTER_RECV_POS );
	BOOL bUlHandSendPos		= m_pEqpAssy->m_PosSensorUlHand.GetAnd( UL_HAND_UNIT_SEND_POS );

	int nCurUlHandPosition	= 0;
#ifndef _NO_UL_HAND
	nCurUlHandPosition = m_pMmc->GetCurPoint( RBT_UL_HAND_UNIT );
#ifdef _MY_DEBUG
	bUlHandCylFw = m_pEqpAssy->m_CylinderUlHand.GetFwState();
	bUlHandCylBw = m_pEqpAssy->m_CylinderUlHand.GetBwState();
#endif
#else
	bUlHandCylFw = FALSE;
	bUlHandCylBw = TRUE;
	bUlHandHomePos = TRUE;
	bUlHandBeforeRecv = bUlHandAfterRecv = bUlHandSendPos = FALSE;
#endif
//*************************** UL Unit State Monitor ********************// 
	if( !m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+0].bIsValid &&
		!m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].bIsValid &&
	//	!m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_UL ) &&2008.12.18 kimgun A/K out ul in ʰ    ȵ.
		!m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_UL ) && 
		!m_pEqpAssy->m_CvMotor.GetMotorFwState( IF_UNIT_UL ) && 
		!m_pEqpAssy->m_CvMotor.GetMotorBwState( IF_UNIT_UL ) &&
#ifndef _MY_DEBUG
		m_pEqpAssy->m_CylinderUlTilt.GetFw() )
#else
		m_pEqpAssy->m_CylinderUlTilt.GetFwState() )
#endif
	{
		m_pDicsData->m_SeqFlag.bUlUnitRecvReady	= TRUE;		
	}
	else
	{
		m_pDicsData->m_SeqFlag.bUlUnitRecvReady	= FALSE;	
	}
//**********************************************************************// 

	switch( nSeqNo )
	{
	case 0:		// dspcrassus - Decide whether Tilt Up or Down
		// Tilt Dn Condition
#ifndef _MY_DEBUG
		if( m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].bIsValid && 
			m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_UL ) && 
			!m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_UL ) && 
			!m_pEqpAssy->m_CylinderUlTilt.GetBw() && 
			!m_pEqpAssy->m_CvMotor.GetMotorFwState( IF_UNIT_UL ) && 
			!m_pEqpAssy->m_CvMotor.GetMotorBwState( IF_UNIT_UL ) )
#else
		if( m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].bIsValid &&
//			m_pDicsData->m_bDebugOutSensor[IF_UNIT_UL] && !m_pDicsData->m_bDebugInSensor[IF_UNIT_UL] &&
			!m_pEqpAssy->m_CylinderUlTilt.GetBwState() && 
			!m_pEqpAssy->m_CvMotor.GetMotorFwState( IF_UNIT_UL ) && 
			!m_pEqpAssy->m_CvMotor.GetMotorBwState( IF_UNIT_UL ) )
#endif
		{
		
			m_pEqpAssy->m_CylinderUlTilt.SetBw();
			
			dwTickStart = GetTickCount();
			nSeqNo = 100;
		}
#ifndef _MY_DEBUG
//		else if( ( bUlHandCylBw || ( bUlHandSendPos && nCurUlHandPosition == UL_HAND_UNIT_SEND_POS ) ) &&
//				 !m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].bIsValid && 
//				 !m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_UL ) && 
//				 !m_pEqpAssy->m_CylinderUlTilt.GetFw() )
		// 091221 halesu
		else if( ( bUlHandCylBw || 
				 ( bUlHandSendPos && nCurUlHandPosition == UL_HAND_UNIT_SEND_POS ) ||
				 ( m_pDicsData->m_SeqFlag.bUlTiltUpReady && bUlHandAfterRecv &&
				   nCurUlHandPosition != UL_HAND_UNIT_AFTER_RECV_POS && nCurUlHandPosition != UL_HAND_UNIT_BEFORE_RECV_POS)) &&
				 !m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].bIsValid && 
				 !m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_UL ) && 
				 !m_pEqpAssy->m_CylinderUlTilt.GetFw() )
#else
		else if( ( bUlHandCylBw || ( /*bUlHandSendPos &&*/ nCurUlHandPosition == UL_HAND_UNIT_SEND_POS ) ) &&
				 !m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].bIsValid && 
				 !m_pEqpAssy->m_CylinderUlTilt.GetFwState() )
#endif
		{
			m_pEqpAssy->m_CylinderUlTilt.SetFw();
			m_pDicsData->m_SeqFlag.bUlTiltUpReady = FALSE; // 091221 halesu
			dwTickStart = GetTickCount();
			nSeqNo = 200;
		}
		break;

	case 100:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_CylinderUlTilt.GetBw() )
#else
		if( m_pEqpAssy->m_CylinderUlTilt.GetBwState() )
#endif
		{
			nSeqNo = 0;
		}
		else if( ( GetTickCount() - dwTickStart ) > 10000 )
		{
			nAlarmId = ALM_UL_UNIT_TILT_DN;
			m_pEqpStateSeq->SetAlarm( nAlarmId ); // 2009.03.09 minhan
			SetLog( "UL TILT", 0, 0, "Ul Tilt Down Error" );
			nSeqNo = 1000;
		}
		break;

	case 200:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_CylinderUlTilt.GetFw() )
#else
		if( m_pEqpAssy->m_CylinderUlTilt.GetFwState() )
#endif
		{
			nSeqNo = 0;
		}
		else if( ( GetTickCount() - dwTickStart ) > 10000 )
		{
			nAlarmId = ALM_UL_UNIT_TILT_UP;
			m_pEqpStateSeq->SetAlarm( nAlarmId ); // 2009.03.09 minhan
			SetLog( "UL TILT", 0, 0, "Ul Tilt Up Error" );
			nSeqNo = 1000;
		}
		break;

	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId );
			nAlarmId = 0;
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqUnitUlTiltNo = nSeqNo;
}

void CCvSeq::CheckStopCountCond()
{
	BOOL bAlarm = FALSE;
	for( int i = IF_UNIT_LD; i<= IF_UNIT_UL; i++ )
	{
		bAlarm |= m_pDicsData->m_IfFlag[i].bInError;
		bAlarm |= m_pDicsData->m_IfFlag[i].bOutError;
//		bAlarm |= m_pDicsData->m_IfFlag[i].bAlarm;
	}
	bAlarm |= m_pDicsData->m_GenInfo.bUlTimeOut;
	bAlarm |= m_pDicsData->m_GenInfo.bUlNotReady;
	
	if ( bAlarm )
		m_pDicsData->m_SeqFlag.bStopCount1 = TRUE;
	else 
		m_pDicsData->m_SeqFlag.bStopCount1 = FALSE;
}
