// PumpSeq.cpp: implementation of the CPumpSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"	// halesu
#include "PumpSeq.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPumpSeq::CPumpSeq()
{

}

CPumpSeq::~CPumpSeq()
{

}

void CPumpSeq::InitParameter()
{
	CDicsPumpSeq::InitParameter();
	m_fDebugTankLevel = 0.;

	m_nSeqGearSupplyNo = 0;
	m_nSeqMistShowerNo = 0;
}

BOOL CPumpSeq::Initialize()
{
	InitParameter();

////////////////////////////////////////////////////////////////////
// Must be Init Address : for pump Interlock flow 
// 	m_nInterlockFlowMeterID[0] = noRB_UNIT_UP_SWR_FLOW;
////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////
// Must be Init Address : for Tank Level Simulation
#ifdef _MY_DEBUG
//	m_nTankLevelStartAddress[0] = DI_NODE2+35;
#endif
////////////////////////////////////////////////////////////////////
	return TRUE;
}

BOOL CPumpSeq::Sequence()
{
	Sleep( 100 );
	SeqInit();
	SeqModeChange();
	SeqGlassExist();
	SeqAirKnife();
//	SeqGearSupply();
	
	for( int i=0; i<MAX_DI_TANK_NO; i++ )
	{
		SeqDiPumpInterlock( i );
		SeqDiTank( i );
		SeqDiPump( i );
		for( int j=0; j<lvHL; j++ )//2009.04.20 kimgun
		{
			SeqLevelSensor( i, j);
		}
	}
	for ( i=0; i<MAX_SBJ_NO; i++ )
	{
		SeqSbj( i );
	}
	SeqMistShower();//2008.08.28 kimgun
	SeqDiwIdleRunning();

	m_pDicsView->m_pCommonIntrSeq->SetTimerPart( 2, TRUE );	// halesu

	return TRUE;
}

/*
void CPumpSeq::SeqGearSupply()
{
	int nSeqNo = m_nSeqGearSupplyNo;
	
	BOOL bUse = ( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupGEAR_SUPPLY_USE] == 1 );

	switch( nSeqNo )
	{
	case 0 :
		if( m_pDicsData->m_GenInfo.bAuto )
		{
			if( bUse && !dosFR_UNIT_GEAR_SUPPLY_IN_VALVE )		doFR_UNIT_GEAR_SUPPLY_IN_VALVE( ON );
			else if( !bUse && dosFR_UNIT_GEAR_SUPPLY_IN_VALVE ) doFR_UNIT_GEAR_SUPPLY_IN_VALVE( OFF );
		}
	}
	m_nSeqGearSupplyNo = nSeqNo;
}*/


void CPumpSeq::SeqAirKnife()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	static DWORD dwTickStart = 0;
	int nSeqNo = m_nSeqAirKnifeNo;

	m_sSeqName.Format( "A/K	" );

	switch( nSeqNo )
	{
	case 0 :
		{
			dwTickStart = GetTickCount();
			nSeqNo = 10;
		}
		break;

	case 10 :
		if( GetTickCount() - dwTickStart > 1000 )
		{
			nSeqNo = 20;
		}
		break;

	case 20 :
		if( m_pDicsData->m_GenInfo.bAuto )
		{
			
			// 240730 halesu AK ECO Mode
			BOOL bECO = TRUE;

			bECO &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupAK_ECO_USE] == 1;
			//bECO &= m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].bIsValid | m_pDicsData->m_GlsInfo[IF_UNIT_UL_HAND*2 + 0].bIsValid;
//			bECO &= /*!m_pDicsData->m_GlsInfo[IF_UNIT_RB*2 + 0].bIsValid &&
//					!m_pDicsData->m_GlsInfo[IF_UNIT_RB*2 + 1].bIsValid &&
//					!m_pDicsData->m_GlsInfo[IF_UNIT_FR*2 + 0].bIsValid &&*/
//					!m_pDicsData->m_GlsInfo[IF_UNIT_FR*2 + 1].bIsValid &&
//					!m_pDicsData->m_GlsInfo[IF_UNIT_AK*2 + 0].bIsValid &&
//					!m_pDicsData->m_GlsInfo[IF_UNIT_AK*2 + 1].bIsValid &&
//					!m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].bIsValid;
			bECO &= !m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_FR ) &&	// 250108 halesu
					!m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_AK ) &&
					!m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_AK );
			//bECO &= !m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_AK ) ;
		
			m_pDicsData->m_GenInfo.bAkECO = bECO;

			if( !m_pDicsData->m_GenInfo.bIdleRunning && !bECO )//2008.11.26 kimgun
			{
				if( !m_pEqpAssy->m_AutoValveAk.GetState() )
				{
					m_pEqpAssy->m_AutoValveAk.Set( 0, ON );
					SetLog( m_sSeqName, -1, -1, "AK CDA ON" );
				}
			}
			else if( m_pEqpAssy->m_AutoValveAk.GetState() )
			{
				m_pEqpAssy->m_AutoValveAk.Set( 0, OFF );//2008.11.26 kimgun
				SetLog( m_sSeqName, -1, -1, "AK CDA OFF" );
			}
		}
		else
		{
			if( ( m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_AK1 ) || m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_AK2 ) ) && 
				( !m_pEqpAssy->m_AutoValveAk.GetState() ) )
			{
				if( !m_pEqpAssy->m_AutoValveAk.GetState() ) 
				{
					m_pEqpAssy->m_AutoValveAk.Set( 0, ON );
					SetLog( m_sSeqName, -1, -1, "AK CDA ON" );
				}
			}
		}
		break;
	}
	m_nSeqAirKnifeNo = nSeqNo;
}

//----------------------------------------------------------------------------------------------
// Description :
//----------------------------------------------------------------------------------------------
void CPumpSeq::SeqDiPump( int i )
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	static BOOL bInit = FALSE;
	static DWORD dwStartTick = GetTickCount();

	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 1000 )	bInit = TRUE;
		if( !bInit ) return;
	}

	m_sSeqName.Format( "DI PUMP%d", i + 1 );

	int nSeqNo = m_nSeqDiPumpNo[i];
	static int nReturnSeqNo[MAX_DI_TANK_NO];
	static int nAlarmId[MAX_DI_TANK_NO] = { 0, };

#ifdef _MY_DEBUG
	static float fCount = 0.0;
#endif

////////////////////////////////////////////////////////////////////////////////
// manual ¿ Pump, Valve Control ϱ ؼ Ʒ Flag ʿϴ.
	static BOOL bDiStop[MAX_DI_TANK_NO] = { TRUE, };
	static BOOL bAqkStop = TRUE;
////////////////////////////////////////////////////////////////////////////////

	BOOL bPumpUse = ( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1 );

	BOOL bRunCond = TRUE;
	bRunCond &= !m_pDicsData->m_GenInfo.bEmo;
	bRunCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bRunCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
	bRunCond &= !m_pDicsData->m_GenInfo.bDoorOpen;
	bRunCond &= !( m_pDicsData->m_GenInfo.bSbjStop && m_pDicsData->m_GenInfo.bAuto );//2008.08.28 KIMGUN alarm ߻  pump Բ..
	bRunCond &= !( m_pDicsData->m_GenInfo.bPause && m_pDicsData->m_GenInfo.bAuto );//2008.08.28 kimgun
	bRunCond &= ( m_pDicsData->m_JobCond.bJobProcessUse == 1 );
	bRunCond &= !m_pDicsData->m_GenInfo.bUlTimeOut;
	bRunCond &= !m_pDicsData->m_GenInfo.bUlNotReady;

	BOOL bPumpRun = bRunCond; 
	bPumpRun &=	m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+i] == 1;
	bPumpRun &=	!m_pEqpAssy->m_DiTank[i].GetPumpAlarm(); 
	bPumpRun &=	m_SeqFlag.bDiTankReady[i];
	bPumpRun &=	m_pDicsData->m_IfPump.bDiStart;
	bPumpRun &= !m_SeqFlag.bInsufficientDiFlowrate[i];
	bPumpRun &= m_SeqFlag.bDiTankLevel[i][lvL];
	bPumpRun &= m_SeqFlag.bDiTankLevel[i][lvLL];

	BOOL bSkipCond = !m_pDicsData->m_GenInfo.bAuto;
	switch( nSeqNo )
	{ 
	case 0:
		//2008.08.28 kimgun
		if( bPumpRun )
		{
			bDiStop[i] = FALSE;
			
			if( !m_pEqpAssy->m_DiTank[i].GetPumpOnState() )
			{ // Turn on DI Pump Motor
				m_pEqpAssy->m_DiTank[i].SetPumpOn(0, ON);
				SetLog( m_sSeqName, -1, -1, "DI Pump Motor On" );
			}

			nSeqNo = 10;
		}
		//2008.09.14 kimgun
		else if( m_pEqpAssy->m_DiTank[i].GetPumpOnState() )
		{
			BOOL bPumpManualRunCond = TRUE;
			bPumpManualRunCond &= !m_pEqpAssy->m_DiTank[i].GetPumpAlarm(); 
			bPumpManualRunCond &= bPumpUse;
			bPumpManualRunCond &= !m_SeqFlag.bInsufficientDiFlowrate[i];
			bPumpManualRunCond &= m_SeqFlag.bDiTankLevel[i][lvL];
			bPumpManualRunCond &= m_SeqFlag.bDiTankLevel[i][lvLL];
			if( !bPumpManualRunCond )
			{
				m_pEqpAssy->m_DiTank[i].SetPumpOn(0, OFF);
				SetLog( m_sSeqName, -1, -1, "DI Pump Manual motor Off" );
			}
		}
		break;

	case 10:
		if( !bPumpRun )
		{
			if( !bRunCond || m_pDicsData->m_GenInfo.bAuto || !bDiStop[i] )
			{
				bDiStop[i] = TRUE;
			
				if( m_pEqpAssy->m_DiTank[i].GetPumpOnState() )
				{ // DI Pump Stop
					m_pEqpAssy->m_DiTank[i].SetPumpOn(0, OFF);
					SetLog( m_sSeqName, -1, -1, "DI Pump motor Off" );
				}
			}
			nSeqNo = 0;//2008.08.28 kimgun
		}
		// Pump Motor Alarm
		if( bPumpUse && m_pEqpAssy->m_DiTank[i].GetPumpAlarm() )
		{
			if( m_pEqpAssy->m_DiTank[i].GetPumpOnState() ) 
			{
				m_pEqpAssy->m_DiTank[i].SetPumpOn(0, OFF);
				SetLog( m_sSeqName, -1, -1, "DI Pump Motor Stop" );
			}
			
			nAlarmId[i] = ALM_DI_PUMP_ALARM1 + i;
			m_pEqpStateSeq->SetAlarm( nAlarmId[i] );
			SetLog( m_sSeqName, -1, -1, "DI Pump Motor Alarm" );
			
			nReturnSeqNo[i] = nSeqNo;
			nSeqNo = 1000;
			break;
		}
		break;
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			SetLog( m_sSeqName, -1, -1, "Alarm reset" );

			m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
			nAlarmId[i] = 0;
			nSeqNo = nReturnSeqNo[i];
		}
		break;
	}
	m_nSeqDiPumpNo[i] = nSeqNo;
}

//---------------------------------------------------------------------------
// SeqInit
//---------------------------------------------------------------------------
void CPumpSeq::SeqInit()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	int nSeqNo = m_nSeqInitNo;

	m_sSeqName.Format( "INIT    " );

	static BOOL bAlarm = FALSE;
	static DWORD dwStartTick = 0;
	static int nAlarmId[MAX_DI_PUMP_NO] = { 0, };

	switch( nSeqNo )
	{
	case 0:
		if( m_SeqFlag.bInitReq )
		{
			m_SeqFlag.bInitReq	= FALSE;
			m_SeqFlag.bInitComp	= FALSE;
			m_SeqFlag.bInitFail = FALSE;

			int nPumpNo = MAX_DI_PUMP_NO;
			for( int i=0; i<nPumpNo; i++ )
			{
				m_sMessage.Format( "%2d%d", CDicsData::initPUMP_CHECK + i, MSG_STATUS_START );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_PUMP, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
			}

			SetLog( m_sSeqName, -1, -1, "Initialize : Start" );

			dwStartTick = GetTickCount();
			nSeqNo = 10;
		}
		break;
	case 10:
		if( GetTickCount() - dwStartTick >= 1000 )
		{
//			if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupJOB_MODE] == 1  &&
//				m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1)
			if( m_pDicsData->m_JobCond.bJobProcessUse == 1  &&
				m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1)
			{
				for( int i=0; i<MAX_DI_PUMP_NO; i++ )
				{
					bAlarm |= m_pEqpAssy->m_DiTank[i].GetPumpAlarm();
				}
			}
			nSeqNo = 20;
		}
		break;
	case 20:
		if( !bAlarm )
		{
			for( int i=0; i<MAX_DI_PUMP_NO; i++ )
			{//2008.08.28 kimgun
// 				m_sMessage.Format( "%2d%d", CDicsData::initPUMP_CHECK + i, MSG_STATUS_OK );
// 				Msg( WM_INIT_STATUS, MSG_STATUS_SET_PUMP, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				m_sMessage.Format( "DI Pump %d Check OK", i+1 );
				SetLog( m_sSeqName, -1, -1, m_sMessage );
			}

			dwStartTick = GetTickCount();

			nSeqNo = 30;//2008.08.28 kimgun
		}
		else
		{
			for( int i=0; i<MAX_DI_PUMP_NO; i++ )
			{
				if( m_pEqpAssy->m_DiTank[i].GetPumpAlarm() )
				{
					m_sMessage.Format( "%2d%d", CDicsData::initPUMP_CHECK + i, MSG_STATUS_NG );
					Msg( WM_INIT_STATUS, MSG_STATUS_SET_PUMP, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
				
					m_sMessage.Format( "DI PUMP %d Alarm", i+1 );
					SetLog( m_sSeqName, -1, -1, m_sMessage );

					nAlarmId[i] = ALM_DI_PUMP_ALARM1 + i;
					m_pEqpStateSeq->SetAlarm( nAlarmId[i] );
				}
			}

			m_SeqFlag.bInitFail = TRUE;
			
			nSeqNo = 1000;
		}
		break;
//==>2008.08.28 kimgun
	case 30:
		if( m_pDicsData->m_JobCond.bJobProcessUse == 1  &&
				m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1)
		{
			BOOL bTankSupplyReq = FALSE;
				for( int i = 0; i < MAX_DI_TANK_NO; i++)
				{
					if( !m_SeqFlag.bDiTankLevel[i][lvMH] && !m_SeqFlag.bDiTankLevel[i][lvML] ) bAlarm = TRUE;
					else bAlarm = FALSE;
					if( bAlarm)
					{	
						m_sMessage.Format( "Tank%d DI Supply", i+1 );
						SetLog( m_sSeqName, -1, -1, m_sMessage );
						m_pEqpAssy->m_DiTank[i].SetTankSupplyInValve( 0, ON );
						bTankSupplyReq = TRUE;
					}
				}
				if( bTankSupplyReq ) nSeqNo = 35;
				else  nSeqNo = 40;			
		}
		else
		{
			for( int i=0; i<MAX_DI_PUMP_NO; i++ )
			{
				m_sMessage.Format( "%2d%d", CDicsData::initPUMP_CHECK + i, MSG_STATUS_OK );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_PUMP, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
			}
			nSeqNo = 100;	
		}
		break;
	case 35:
		if( m_pDicsData->m_JobCond.bJobProcessUse == 1  &&
			m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1)
		{
			BOOL bTankSupplyStop = TRUE;
			for( int i = 0; i < MAX_DI_TANK_NO; i++)
			{
				if( m_SeqFlag.bDiTankLevel[i][lvMH] || m_SeqFlag.bDiTankLevel[i][lvML] )
				{
					if( m_pEqpAssy->m_DiTank[i].GetTankSupplyInValveState() )
					{
						m_sMessage.Format( "Tank%d DI Supply", i+1 );
						SetLog( m_sSeqName, -1, -1, m_sMessage );
						m_pEqpAssy->m_DiTank[i].SetTankSupplyInValve( 0, OFF );
					}
					bTankSupplyStop &= TRUE;
				}
				else  bTankSupplyStop &= FALSE;
			}
			if( bTankSupplyStop ) nSeqNo = 40;
		}
		else nSeqNo = 100;
		break;
		
	case 40:
		if( m_pDicsData->m_JobCond.bJobProcessUse == 1  &&
			m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1)
		{
			for( int i = 0; i < MAX_DI_TANK_NO; i++)
			{
				bAlarm = FALSE;
				if( GetLevelSensorFault( i ) ) bAlarm |= TRUE;	
			}
			if( bAlarm )
			{
				m_sMessage.Format( "%2d%d", CDicsData::initPUMP_CHECK + i, MSG_STATUS_NG );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_PUMP, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
				
				m_sMessage.Format( "DI Tank %d Sensor Fault Alarm", i+1 );
				SetLog( m_sSeqName, -1, -1, m_sMessage );
				m_SeqFlag.bInitFail = TRUE;
				nSeqNo = 1000;
			}
			else 
			{
				for( int i=0; i<MAX_DI_PUMP_NO; i++ )
				{
					m_sMessage.Format( "%2d%d", CDicsData::initPUMP_CHECK + i, MSG_STATUS_OK );
					Msg( WM_INIT_STATUS, MSG_STATUS_SET_PUMP, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
				}
				nSeqNo = 100;
			}
		}
		else nSeqNo = 100;	
		break;
		//<==2008.08.28 kimgun

	case 100:
		{ // Initialize Complete
			m_SeqFlag.bInitComp = TRUE;
			m_SeqFlag.bInitReq	= FALSE;

			SetLog( m_sSeqName, -1, -1, "Initialize : End" );

			Msg( WM_EQP_MESSAGE, MSG_EQP_MESSAGE, (LPARAM)(LPCTSTR) "Initialize End" );
			nSeqNo = 0;
		}
		break;
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			for( int i=0; i<MAX_DI_PUMP_NO; i++ )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
			}
			SetLog( m_sSeqName, 0, 0, "Alarm reset" );

			nSeqNo = 0;
		}
		break;
	
	}

	m_nSeqInitNo = nSeqNo;
}

//----------------------------------------------------------------------------------------------
// Description :
//----------------------------------------------------------------------------------------------
void CPumpSeq::SeqSbj( int i )
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	m_sSeqName.Format( "SBJ %d   ", i + 1 );

	int nSeqNo = m_nSeqSbjNo[i];
	static int nReturnSeqNo = 0;

////////////////////////////////////////////////////////////////////////////////
// manual ¿ Pump, Valve Control ϱ ؼ Ʒ Flag ʿϴ.
	static BOOL bStop[MAX_SBJ_NO] = { TRUE, };
////////////////////////////////////////////////////////////////////////////////

	BOOL bRunCond = TRUE;
	bRunCond &= !m_pDicsData->m_GenInfo.bEmo &&
				!m_pDicsData->m_GenInfo.bLeakSensor &&
				!m_pDicsData->m_GenInfo.bCoverOpen &&
				!m_pDicsData->m_GenInfo.bDoorOpen &&
				//( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupSBJ_USE]) &&//2008.11.28 kimgun//2008.08.28 kimgun
				( (i == 2) | m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE])&&//2008.08.28 kimgun sbj1,2 pump ⶧
				( (i == 2) | m_pEqpAssy->m_DiTank[0].GetPumpOnState())&&//2008.08.28 kimgun sbj1,2 pump ⶧
//				( !m_pDicsData->m_GenInfo.bPause || !m_pDicsData->m_GenInfo.bAuto ) &&
//				( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupJOB_MODE] == 1 );
				( m_pDicsData->m_JobCond.bJobProcessUse == 1 );
				
	BOOL bSbjRun = bRunCond; 
	bSbjRun &=	m_pDicsData->m_IfPump.bDiStart;
	if( m_pDicsData->m_GenInfo.bAuto )//2008.08.28 kimgun
	bSbjRun &=	!m_pDicsData->m_GenInfo.bSbjStop;

	BOOL bSbjCdaCond = bSbjRun;
	bSbjCdaCond &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupSBJ_USE];
	switch( nSeqNo )
	{ 
	case 0:
		if( bSbjRun )
		{//di parts
			bStop[i] = FALSE;		
			
			if( !m_pEqpAssy->m_AutoValveSbjDi.GetState( 0 ) && (i == 2) )//2008.08.28 kimgun
			{ // Open SBJ DI Valve
				m_pEqpAssy->m_AutoValveSbjDi.Set( 0, ON );
				SetLog( m_sSeqName, -1, -1, "SBJ DI ON" );
			}
			nSeqNo = 10;
		}
		if( m_pDicsData->m_GenInfo.bAuto || m_pDicsData->m_IfPump.bDiStart )
		{
			if( !m_pEqpAssy->m_AutoValveSbjCda.GetState( i ) && bSbjCdaCond )//2008.12.01 kimgun
			{ //CDA Parts
				m_pEqpAssy->m_AutoValveSbjCda.Set( i, ON );
				SetLog( m_sSeqName, -1, -1, "SBJ CDA ON" );
			}
			else if( m_pEqpAssy->m_AutoValveSbjCda.GetState( i ) && !bSbjCdaCond )//2008.12.01 kimgun
			{ //CDA Parts
				m_pEqpAssy->m_AutoValveSbjCda.Set( i, OFF );
				SetLog( m_sSeqName, -1, -1, "SBJ CDA OFF" );
			}
		}
		break;
		
	case 10:
		if( !bSbjRun )
		{//di parts
			if( !bRunCond || m_pDicsData->m_GenInfo.bAuto || !bStop[i] )
			{
				bStop[i] = TRUE;
				if( m_pEqpAssy->m_AutoValveSbjDi.GetState( 0 ) && (i == 2) )
				{ // Close SBJ DI Valve
					m_pEqpAssy->m_AutoValveSbjDi.Set( 0, OFF );
//					SetLog( m_sSeqName, -1, -1, "SBJ DI Stop" );
				}
			}
			nSeqNo = 0;//2008.08.28 kimgun
		}
		if( m_pDicsData->m_GenInfo.bAuto || !m_pDicsData->m_IfPump.bDiStart)
		{
			if( !m_pEqpAssy->m_AutoValveSbjCda.GetState( i ) && bSbjCdaCond )//2008.12.01 kimgun
			{ //CDA Parts
				m_pEqpAssy->m_AutoValveSbjCda.Set( i, ON );
				SetLog( m_sSeqName, -1, -1, "SBJ CDA ON" );
			}
			else if( m_pEqpAssy->m_AutoValveSbjCda.GetState( i ) && !bSbjCdaCond )//2008.12.01 kimgun
			{ //CDA Parts
				m_pEqpAssy->m_AutoValveSbjCda.Set( i, OFF );
				SetLog( m_sSeqName, -1, -1, "SBJ CDA OFF" );
			}
		}
		break;
	}
	m_nSeqSbjNo[i] = nSeqNo;
}

void CPumpSeq::SeqLevelSensor( int nTankNo, int nSensorNo )
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	static BOOL bInit = FALSE;
	static DWORD dwInitTick = GetTickCount();

	if( !bInit )
	{
		if( GetTickCount() - dwInitTick > 1000 )	bInit = TRUE;
		if( !bInit ) return;
	}

	m_sSeqName.Format( "LEVEL%d-%d", nTankNo + 1 , nSensorNo + 1);

	int nSeqNo	= m_nSeqLevelSensorNo[nTankNo][nSensorNo];
	DWORD nConfirmTime = atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupLEVEL_SENSOR_CONFIRM_TIME] );
	static int nAlarmId[MAX_DI_TANK_NO][lvHL]		= { 0, };
	static DWORD dwStartTick[MAX_DI_TANK_NO][lvHL] = { 0, };

	//// dspcrassus - Level Sensor -> PT ////////////////////////////
#ifdef _MY_DEBUG
//	m_pEqpAssy->m_DiTank[0].SetLoadCelState( 0, m_fDebugTankLevel );
#endif

	BOOL bTankLevel[lvHL] = { FALSE, };
#ifndef _MY_DEBUG
	float fTankLevel = m_pEqpAssy->m_DiTank[0].GetLoadCell( 0 );
#else
	float fTankLevel = m_pEqpAssy->m_DiTank[0].GetLoadCell( 0 );// 150;
#endif

	bTankLevel[lvMH] = ( fTankLevel >= DI_TANK_LEVEL_H ) ? TRUE : FALSE;
	bTankLevel[lvML] = ( fTankLevel >= DI_TANK_LEVEL_M ) ? TRUE : FALSE;
	bTankLevel[lvL] = ( fTankLevel >= DI_TANK_LEVEL_L ) ? TRUE : FALSE;
	bTankLevel[lvLL] = ( fTankLevel >= DI_TANK_LEVEL_LL ) ? TRUE : FALSE;
#ifndef _MY_DEBUG
	bTankLevel[lvLL] &= m_pEqpAssy->m_DiTank[0].GetTankLevel( 0 );
#endif

#ifdef _MY_DEBUG
	if( bTankLevel[lvLL] )
		m_pEqpAssy->m_DiTank[0].SetTankLevelState(lvLL, ON);
	else
		m_pEqpAssy->m_DiTank[0].SetTankLevelState(lvLL, OFF);
#endif
	//////////////////////////////////////////////////////////////////
	
	switch( nSeqNo )
	{
	case 0 :
		{
			if( bTankLevel[nSensorNo] && //digDI_TANK_LEVEL( nTankNo, nSensorNo ) &&
				!m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo] )
			{
				dwStartTick[nTankNo][nSensorNo] = GetTickCount();
			}
	
			nSeqNo = 10;
		}
		break;
	case 10 :
		if( ( GetTickCount()-dwStartTick[nTankNo][nSensorNo] > nConfirmTime*1000 ) &&
			 bTankLevel[nSensorNo] ) //digDI_TANK_LEVEL( nTankNo, nSensorNo ) )
		{
			if( ( nSensorNo == lvLL ) || m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo-1] )
			{
				if( !m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo] )	
				{
					m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo] = TRUE;
					SetLog( m_sSeqName, -1, -1, "Level ON : Confirm" );
				}
				nSeqNo = 0;
			}
			else if( !bTankLevel[nSensorNo-1] && //!digDI_TANK_LEVEL( nTankNo, nSensorNo-1 ) &&
					 !m_SeqFlag.bDiTankLevelSensorFault[nTankNo][nSensorNo-1] )
			{	// alarm
				m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo] = FALSE;
				m_SeqFlag.bDiTankLevelSensorFault[nTankNo][nSensorNo] = TRUE;
				SetLog( m_sSeqName, -1, -1, "Level Sensor Fault" );

				nAlarmId[nTankNo][nSensorNo] = ALM_DI_TANK1_LV_SENSOR_ALARM1 + ( nTankNo*lvMAX + nSensorNo );
				m_pEqpStateSeq->SetAlarm( nAlarmId[nTankNo][nSensorNo] );
				nSeqNo = 1000;			
			}
		}
		else if( !bTankLevel[nSensorNo] ) //!digDI_TANK_LEVEL( nTankNo, nSensorNo ) )
		{
			if( m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo] )
			{
				m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo] = FALSE;
				SetLog( m_sSeqName, -1, -1, "Level OFF : Confirm" );
			}

			if( ( nSensorNo == lvHL-1 ) || !m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo+1] )
			{
				nSeqNo = 0;
			}
			else 
			{	// alarm
				m_SeqFlag.bDiTankLevelSensorFault[nTankNo][nSensorNo] = TRUE;
				SetLog( m_sSeqName, -1, -1, "Level Sensor Fault" );
				
				nAlarmId[nTankNo][nSensorNo] = ALM_DI_TANK1_LV_SENSOR_ALARM1 + ( nTankNo*lvHL + nSensorNo );
				m_pEqpStateSeq->SetAlarm( nAlarmId[nTankNo][nSensorNo] );
				nSeqNo = 1000;			
			}
		}
		break;
		
	case 1000 :
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			m_SeqFlag.bDiTankLevelSensorFault[nTankNo][nSensorNo] = FALSE;
			SetLog( m_sSeqName, -1, -1, "Alarm reset" );

			m_pEqpStateSeq->ResetAlarm( nAlarmId[nTankNo][nSensorNo] );
			nAlarmId[nTankNo][nSensorNo] = 0;
			dwStartTick[nTankNo][nSensorNo] = 0;
			nSeqNo = 1100;
		}
		break;		
	case 1100 :
		if( GetTickCount()-dwStartTick[nTankNo][nSensorNo] > 2000 )
		{
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqLevelSensorNo[nTankNo][nSensorNo] = nSeqNo;
}

//---------------------------------------------------------------------------
// - SeqGlassExist
//---------------------------------------------------------------------------
void CPumpSeq::SeqGlassExist()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if( !m_SeqFlag.bInitComp ) return;
	if( !m_pDicsData->m_GenInfo.bAuto ) return; 
//	if( !m_pDicsData->m_GenInfo.bAuto || 
//		 m_pDicsData->m_GenInfo.bPause ||
//		 m_pDicsData->m_GenInfo.bEmo ||
//		 m_pDicsData->m_GenInfo.bLeakSensor ||
//		 m_pDicsData->m_GenInfo.bCoverOpen )
//	{	
////		m_nSeqGlassExistNo = 0;
////		m_pDicsData->m_GenInfo.bIdleRunning = FALSE;
//		return;
//	}

	static DWORD dwStartTick = 0;
	DWORD nIdleWaitTime = 60 * 1000 * atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupIDLE_WAIT_TIME] );

	int nSeqNo = m_nSeqGlassExistNo;

	switch( nSeqNo )
	{
	case 0:
		// case 0  m_pDicsData->m_GenInfo.nGlassNo = 0  
	  	// case 10  m_pDicsData->m_GenInfo.nGlassNo > 0  Ǵ 
		if( !m_pDicsData->m_GenInfo.nGlassNo ) 
		{
//			m_pDicsData->m_GenInfo.bIdleRunning = TRUE;
//			m_nSeqDiwIdleRunningNo = 0;

			nSeqNo = 20;
		}
		else nSeqNo = 20;
		break;

	case 10:
		if( !m_pDicsData->m_GenInfo.nGlassNo )
		{
			m_pDicsData->m_IfPump.bDiStart = FALSE;

			dwStartTick = GetTickCount();
			
			nSeqNo = 20;
		}
		else if( m_pDicsData->m_GenInfo.nGlassNo &&
				 m_pDicsData->m_JobCond.bJobProcessUse == 1 )
		{
			BOOL bProcessRequired = FALSE;
			for( int i=IF_UNIT_LD*2; i<=IF_UNIT_UL*2; i++ )
			{
				bProcessRequired |= m_pDicsData->m_GlsInfo[i].bIsValid;
			}

			// 240730 halesu DI ECO Mode
			BOOL bECO = TRUE;

			bECO &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_ECO_USE] == 1;
			bECO &= m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].bIsValid | m_pDicsData->m_GlsInfo[IF_UNIT_UL_HAND*2 + 0].bIsValid;
			bECO &= !m_pDicsData->m_GlsInfo[IF_UNIT_RB*2 + 0].bIsValid &&
					!m_pDicsData->m_GlsInfo[IF_UNIT_RB*2 + 1].bIsValid &&
					!m_pDicsData->m_GlsInfo[IF_UNIT_FR*2 + 0].bIsValid &&
					!m_pDicsData->m_GlsInfo[IF_UNIT_FR*2 + 1].bIsValid &&
					!m_pDicsData->m_GlsInfo[IF_UNIT_AK*2 + 0].bIsValid &&
					!m_pDicsData->m_GlsInfo[IF_UNIT_AK*2 + 1].bIsValid &&
					!m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].bIsValid;
			bECO &= !m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_RB ) ;
			
			if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_ECO_CEHCK_POS] == EUV_OUT )
				bECO &= !m_pDicsData->m_GlsInfo[IF_UNIT_EUV*2 + 1].bIsValid;
			
		
			m_pDicsData->m_GenInfo.bDiECO = bECO;
			
			if(( !bProcessRequired | bECO ) && m_pDicsData->m_IfPump.bDiStart )
			{
				m_pDicsData->m_IfPump.bDiStart = FALSE;
			}
			else if( bProcessRequired && !bECO && !m_pDicsData->m_IfPump.bDiStart )
			{
				m_pDicsData->m_IfPump.bDiStart = TRUE;
//#ifdef _SPT_TYPE
				if( !m_pDicsData->m_GenInfo.bMistShowerStart )//Jung Hae Yong
				{
					m_pEqpAssy->m_AutoValveMistNozzle.Set( 0, ON );
					m_pDicsData->m_GenInfo.bMistShowerStart = TRUE;
				}
//#endif
			}
		}
		break;

	case 20:
		if( m_pDicsData->m_GenInfo.nGlassNo ) 
		{
			m_pDicsData->m_GenInfo.bIdleRunning = FALSE;
//			if( m_pDicsData->m_GenInfo.bIdleRunning )
//			{
//				m_pDicsData->m_GenInfo.bIdleRunning = FALSE;
//				m_pDicsData->m_IfPump.bDiStart = FALSE;
//				Msg( WM_DIW_IDLE_RUNNING_PROGRESS, PROGRESS_END, 0L, FALSE );
//				m_nSeqDiwIdleRunningNo = 0;				
//			}
			nSeqNo = 10;
		}
		else if( !m_pDicsData->m_GenInfo.bEqpInitComp )
		{
			dwStartTick = GetTickCount();
		}
		else if( !m_pDicsData->m_GenInfo.bIdleRunning &&
				 ( GetTickCount()-dwStartTick ) > nIdleWaitTime )
		{
			m_pDicsData->m_GenInfo.bIdleRunning = TRUE;
//			m_nSeqDiwIdleRunningNo = 0;
		}
		break;
	}

	m_nSeqGlassExistNo = nSeqNo;
}


//----------------------------------------------------------------------------------------------
// Description :
//----------------------------------------------------------------------------------------------
void CPumpSeq::SeqDiTank(int i)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	m_sSeqName.Format( "DI TANK%d", i + 1 );

	BOOL bRunCond = TRUE;
	bRunCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bRunCond &= !m_pDicsData->m_GenInfo.bEmo;
	bRunCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
	bRunCond &= !m_pDicsData->m_GenInfo.bDoorOpen;
	bRunCond &= ( m_pDicsData->m_JobCond.bJobProcessUse == 1 );
	bRunCond &= ( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+i] == 1 );	
	bRunCond &= !GetLevelSensorFault( i );


	if( !bRunCond || m_SeqFlag.bDiTankLevel[i][lvMH] )
	{
		if( m_pEqpAssy->m_DiTank[i].GetTankSupplyInValveState() )
		{
			m_pEqpAssy->m_DiTank[i].SetTankSupplyInValve( 0, OFF );

			if( !bRunCond )						SetLog( m_sSeqName, -1, -1, "DI in Valve Close : RunCond(FALSE)" );
			if( m_SeqFlag.bDiTankLevel[i][lvMH] )SetLog( m_sSeqName, -1, -1, "DI in Valve Close : H Level Exist" );
			
			SetLog( m_sSeqName, -1, -1, "In Valve Close" );
		}
	}

	BOOL bNotReady = FALSE;
	bNotReady |= !m_SeqFlag.bDiTankLevel[i][lvL];
	bNotReady |= !m_SeqFlag.bDiTankLevel[i][lvLL];
	bNotReady |= GetLevelSensorFault( i );

	if( bNotReady && m_SeqFlag.bDiTankReady[i] )
	{
		m_SeqFlag.bDiTankReady[i] = FALSE;
		SetLog( m_sSeqName, -1, -1, "Not Ready Condition" );
	}
#ifdef _MY_DEBUG
	if( m_pEqpAssy->m_DiTank[i].GetTankSupplyInValveState() )
		m_fDebugTankLevel += (float)0.4;
	if( m_pEqpAssy->m_DiTank[i].GetPumpOnState() )
		m_fDebugTankLevel -= (float)0.3;
	if( m_pEqpAssy->m_AutoValveFrShower.GetState() )
		m_fDebugTankLevel += (float)0.2;

	m_pEqpAssy->m_DiTank[i].SetLoadCelState( 0, m_fDebugTankLevel );
#endif
//	if( !m_SeqFlag.bInitComp ) return;

	//--------------------------------------------------------------------
	if( !bRunCond ||
	  ( m_pDicsData->m_GenInfo.bAuto && !m_SeqFlag.bInitComp ) ||
	  ( !m_pDicsData->m_GenInfo.bAuto && ( !m_pDicsData->m_IfPump.bDiStart && !m_pEqpAssy->m_DiTank[i].GetPumpOnState() ) ) ) return; 
	//--------------------------------------------------------------------
	//--------------------------------------------------------------------
//	if( !m_pDicsData->m_GenInfo.bAuto && !bRunCond && !m_pDicsData->m_IfPump.bDiStart ) return; 
	//--------------------------------------------------------------------

#ifdef _MY_DEBUG
	static int nTime[MAX_DI_TANK_NO] = { 0, };
#endif

	int nSeqNo	= m_nSeqDiTankNo[i];
	int tm		= TM_SEQ_DI_TANK( i );
	static int nReturnSeqNo[MAX_DI_TANK_NO];
	static DWORD dwStartTick[MAX_DI_TANK_NO] = { 0, };

// #ifdef _MY_DEBUG
// 	if( m_pEqpAssy->m_DiTank[i].GetTankSupplyInValveState() )
// 		m_fDebugTankLevel += (float)0.4;
// 	if( m_pEqpAssy->m_DiTank[i].GetPumpOnState() )
// 		m_fDebugTankLevel -= (float)0.3;
// 	if( m_pEqpAssy->m_AutoValveFrShower.GetState() )
// 		m_fDebugTankLevel += (float)0.2;
// 
// 	m_pEqpAssy->m_DiTank[i].SetLoadCelState( 0, m_fDebugTankLevel );
// #endif

	switch( nSeqNo )
	{
	case 0 :
		if( bRunCond && 
			!m_SeqFlag.bDiTankLevel[i][lvMH] &&
		  ( !m_SeqFlag.bDiTankLevel[i][lvML] ||
		    !m_SeqFlag.bDiTankLevel[i][lvL] ||
			!m_SeqFlag.bDiTankLevel[i][lvLL] ) )
		{
			if( !m_pEqpAssy->m_DiTank[i].GetTankSupplyInValveState() )
			{
				SetLog( m_sSeqName, -1, -1, "DI Supply" );
				m_pEqpAssy->m_DiTank[i].SetTankSupplyInValve( 0, ON );

#ifdef _MY_DEBUG
				TIMER_ON( tm, 40 );
				nTime[i] = 0;
#endif
			}
		}
		else if( !bRunCond || m_SeqFlag.bDiTankLevel[i][lvMH] )
		{
			if( m_pEqpAssy->m_DiTank[i].GetTankSupplyInValveState() )
			{
				SetLog( m_sSeqName, -1, -1, "DI Supply Stop" );
				m_pEqpAssy->m_DiTank[i].SetTankSupplyInValve( 0, OFF );
			}
		}		
		nSeqNo = 10;
		break;

	case 10 :
		if( ( !m_SeqFlag.bDiTankLevel[i][lvL] ||
			  !m_SeqFlag.bDiTankLevel[i][lvLL] ) &&
			  m_SeqFlag.bDiTankReady[i] )
		{
			m_SeqFlag.bDiTankReady[i] = FALSE;
		}
		nSeqNo = 20;
		break;
		
	case 20:
//#ifdef _MY_DEBUG
//		if( TIMER( tm ) && 
//			m_pEqpAssy->m_DiTank[i].GetTankSupplyInValveState() &&
//			!digDI_TANK_LEVEL_H( i ) )
//		{
//			TIMER_ON( tm, 40 );
//			m_pDevice->SetDiState( m_nTankLevelStartAddress[i] - nTime[i], ON );
//			nTime[i] ++;
//		}
//#endif
		if( m_SeqFlag.bDiTankLevel[i][lvML] &&
			m_SeqFlag.bDiTankLevel[i][lvL] &&
			m_SeqFlag.bDiTankLevel[i][lvLL] &&
			!m_SeqFlag.bDiTankReady[i] )
		{
			m_SeqFlag.bDiTankReady[i] = TRUE;
		}
		nSeqNo = 0;
		break;
	}
	m_nSeqDiTankNo[i] = nSeqNo;
}

//----------------------------------------------------------------------------------------------
// - SeqIdleRunning
//----------------------------------------------------------------------------------------------
void CPumpSeq::SeqDiwIdleRunning()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	if( !m_SeqFlag.bInitComp ) return;

	int nRunTime  = m_pSetupItems->m_nValueIdleRun[CSetupItems::idleDIW_IDLE_RUN_TIME];
	int nStopTime = m_pSetupItems->m_nValueIdleRun[CSetupItems::idleDIW_IDLE_STOP_TIME] * 60;

	BOOL bIdleCond = TRUE;
	bIdleCond &= m_SeqFlag.bInitComp;
//	bIdleCond &= !m_pDicsData->m_GenInfo.bPause;
	bIdleCond &= m_pDicsData->m_GenInfo.bAuto;
	bIdleCond &= !m_pDicsData->m_GenInfo.bEmo;
	bIdleCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bIdleCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
	bIdleCond &= !m_pDicsData->m_GenInfo.bDoorOpen;
 	bIdleCond &= !m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateDOWN];
 	
//	bIdleCond &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupJOB_MODE];
	bIdleCond &= m_pDicsData->m_JobCond.bJobProcessUse;
	bIdleCond &= m_pSetupItems->m_nValueIdleRun[CSetupItems::idleDIW_ZONE_USE];
	bIdleCond &= m_pDicsData->m_GenInfo.bIdleRunning;
	bIdleCond &= ( nRunTime > 0 );

#ifndef _MY_DEBUG
	bIdleCond &= !m_pDicsData->m_GenInfo.bCycleStop;
#endif

	static int nReturnSeqNo = 0;
	static int nOldTime = 0;

	int nTime = 0;
	int tm = TM_SEQ_DIW_IDLE;

	int nSeqNo = m_nSeqDiwIdleRunningNo;
					
	switch( nSeqNo )
	{
	case 0 :
		if( bIdleCond )
		{
			m_pDicsData->m_IfPump.bDiStart = !nStopTime;
			nSeqNo = 10;
		}
		break;
	case 10 :
		if( !bIdleCond )
		{			
			m_pDicsData->m_IfPump.bDiStart = FALSE;
			nSeqNo = 0;
		}
		else
		{
			nOldTime = 0;
			TIMER_ON( tm, nStopTime*10 );
			Msg( WM_DIW_IDLE_RUNNING_PROGRESS, PROGRESS_START, nStopTime, FALSE );
			nSeqNo = 20;
		}
		break;
	case 20 : // Stop Time
		nTime = (int)( m_pTimer->m_pTimer[tm].dwNow / 100 );
		if( nTime - nOldTime > 2 )
		{
			nOldTime = nTime;
			
			Msg( WM_DIW_IDLE_RUNNING_PROGRESS, PROGRESS_SET, nTime, FALSE );
		}
		if( !bIdleCond )
		{
			m_pDicsData->m_IfPump.bDiStart = FALSE;
			Msg( WM_DIW_IDLE_RUNNING_PROGRESS, PROGRESS_END, 0, FALSE );
			nSeqNo = 0;
		}
		else if( TIMER( tm ) ) 
		{
			m_pDicsData->m_IfPump.bDiStart = TRUE;
			m_pDicsData->m_GenInfo.bSbjStop = FALSE;//2008.09.16 kimgun
			
			TIMER_ON( tm, nRunTime*10 );
			Msg( WM_DIW_IDLE_RUNNING_PROGRESS, PROGRESS_START, nRunTime, FALSE );
			nOldTime = 0;

			nSeqNo = 30;
		}
		break;
	case 30 : // Run Time
		nTime = (int)( m_pTimer->m_pTimer[tm].dwNow / 100 );
		if( nTime - nOldTime > 2 ) 
		{
			nOldTime = nTime;
			Msg( WM_DIW_IDLE_RUNNING_PROGRESS, PROGRESS_SET, nTime, FALSE );
		}
		if( !bIdleCond )
		{
			m_pDicsData->m_IfPump.bDiStart = FALSE;
			Msg( WM_DIW_IDLE_RUNNING_PROGRESS, PROGRESS_END, 0, FALSE );
			nSeqNo = 0;
		}
		else if( TIMER( tm ) )
		{
			m_pDicsData->m_IfPump.bDiStart = !nStopTime;
			Msg( WM_DIW_IDLE_RUNNING_PROGRESS, PROGRESS_END, 0, FALSE );
			nSeqNo = 10;
		}
		break;
	}

	m_nSeqDiwIdleRunningNo = nSeqNo;
}

void CPumpSeq::SeqMistShower()
{
	if( !m_SeqFlag.bInitComp )	return;

	BOOL bRunCond = TRUE;
	bRunCond &= !m_pDicsData->m_GenInfo.bLeakSensor &&
				!m_pDicsData->m_GenInfo.bCoverOpen &&
				!m_pDicsData->m_GenInfo.bEmo &&
				m_pDicsData->m_GenInfo.bAuto &&//2008.12.17 kimgun
				m_pDicsData->m_JobCond.bJobProcessUse;

	BOOL bShowerCond = FALSE;
#ifndef _MY_DEBUG
	bShowerCond |= ( m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_FR ) || m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_FR ) ) && 
				   ( !m_pEqpAssy->m_CvMotor.GetMotorFwState( IF_UNIT_FR ) && !m_pEqpAssy->m_CvMotor.GetMotorBwState( IF_UNIT_FR ) );
	bShowerCond |= ( m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_RB ) || m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_RB ) ) &&
				   ( !m_pEqpAssy->m_CvMotor.GetMotorFwState( IF_UNIT_RB ) && !m_pEqpAssy->m_CvMotor.GetMotorBwState( IF_UNIT_RB ) );
#else
	bShowerCond |= ( m_pDicsData->m_bDebugInSensor[IF_UNIT_FR] || m_pDicsData->m_bDebugOutSensor[IF_UNIT_FR] ) && 
				   ( !m_pEqpAssy->m_CvMotor.GetMotorFwState( IF_UNIT_FR ) && !m_pEqpAssy->m_CvMotor.GetMotorBwState( IF_UNIT_FR ) );
	bShowerCond |= ( m_pDicsData->m_bDebugInSensor[IF_UNIT_RB] || m_pDicsData->m_bDebugOutSensor[IF_UNIT_RB] ) &&
				   ( !m_pEqpAssy->m_CvMotor.GetMotorFwState( IF_UNIT_RB ) && !m_pEqpAssy->m_CvMotor.GetMotorBwState( IF_UNIT_RB ) );
#endif
	bShowerCond &= !m_pEqpAssy->m_DiTank[0].GetPumpOnState() && !m_pEqpAssy->m_AutoValveFrShower.GetState();
	bShowerCond &= bRunCond;

	int nSeqNo = m_nSeqMistShowerNo;
	m_sSeqName.Format( "MIST_SHW" );

	switch( nSeqNo )
	{ 
	case 0:
		if( bShowerCond )
		{		
			if( !m_pEqpAssy->m_AutoValveMistNozzle.GetState() )
			{ 
				m_pEqpAssy->m_AutoValveMistNozzle.Set( 0, ON );
				SetLog( m_sSeqName, -1, -1, "FR Unit Mist Nozzle Valve Open" );
			}
		}
		nSeqNo = 10;
		break;

	case 10:
		if( !bShowerCond )
		{
			if( m_pEqpAssy->m_AutoValveMistNozzle.GetState() )
			{
				m_pEqpAssy->m_AutoValveMistNozzle.Set( 0, OFF );
				SetLog( m_sSeqName, -1, -1, "FR Unit Mist Nozzle Valve Close" );
			}
		}
		nSeqNo = 0;
		break;
	}
	m_nSeqMistShowerNo = nSeqNo;
}
