// JobsTabMainView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "..\MainFrm.h"
#include "JobsTabMainView.h"
#include "..\View\SetupView.h"
#include "..\Dlg\DlgCvMotor.h"
#include "..\Dlg\DlgGridCvMotor.h"
#include "..\Dlg\DlgListCvMotor.h"
//#include "..\Dlg\DlgEuv.h"
#include "..\Dlg\DlgEuvTime.h"
#include "..\Dlg\DlgGridRollBrush.h"
#include "..\Dlg\DialogGlassInfo.h"
#include "..\Dlg\DlgGlassInfo.h"
#include "..\Dlg\DlgAlign.h"
#include "..\Dlg\DlgSetCurPos.h"
#include "..\Dlg\DlgLostGlassList.h"
#include "..\Dlg\DlgKeyPad.h"
#include "..\Dlg\DlgFishRib.h"
#include "..\Dlg\DlgTilt.h"
#include "..\Dlg\DlgUlHandCylinder.h"
//////////////////////////////////////////////////////////////////////////
//  INT				nRows;
//	INT				nCols;
//	LPTSTR			sText[MAX_GRID_COLS];
//	INT				nColWidth[MAX_GRID_COLS];
//	unsigned int	uCellBackColor;
//	BOOL			bTitle;
//////////////////////////////////////////////////////////////////////////

GRID_INFO CJobsTabMainView::m_GridInfo[MAX_GRID_CTRL] = 
{
#ifndef _NO_RB
	{ 
		MAX_TOTAL_RECIPE_BODY_NO + 1 - SKIP_3_ITEMS, 
		2, 
		{ " Items ", " Value ", }, 
		{ 2000, 1000, }, 
		LIGHT_BLUE_COLOR,
		TRUE
	},
#else
	{ 
		MAX_TOTAL_RECIPE_BODY_NO + 1 - SKIP_3_ITEMS-16, 
		2, 
		{ " Items ", " Value ", }, 
		{ 2000, 1000, }, 
		LIGHT_BLUE_COLOR,
		TRUE
	},
#endif
	{
		1,	//default value. It will be change correct value in OnInitialUpdate()
		2,
		{ " Items ", " Value ", }, 
		{ 2000, 1000, }, 
		LIGHT_BLUE_COLOR,
		TRUE
	},
	{	// UL HAND
		3,
		1,
		{ "Z3", "Z2", "Z1" },
		{ 400, 400, 400 },
		WHITE_COLOR,
		FALSE
	},
	{   // LD UPDN
		2,
		1,
		{ "Z2", "Z1" },
		{ 400, 400 },
		WHITE_COLOR,
		FALSE
	},
	{
		3,
		1,
		{ "Z3", "Z2", "Z1", },
		{ 400, 400, 400, },
		WHITE_COLOR,
		FALSE
	},
	{
		1,
		3,
		{ "RT", "A1", "A2",},
		{ 400, 400, 400 },
		WHITE_COLOR,
		FALSE
	},
	{
		1,
		MAX_TR_POS_SENSOR,
#ifdef _LTYPE
		{ "LD", "MID", "UL", },
#else
		{ "UL", "MID", "LD", },
#endif
		{ 400, 400, 400, },
		WHITE_COLOR,
		FALSE
	},
#ifndef _NO_EUV
	{
		1,
		MAX_LAMP_CONTROL_NO,
#ifdef _LTYPE
		{ "1", "2", "3", "4", },
#else
		{ "4", "3", "2", "1", },
#endif
		{ 237, 237, 237, 237, },
		WHITE_COLOR,
		FALSE
	},
#endif
};

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// JobsTabMainView

IMPLEMENT_DYNCREATE(CJobsTabMainView, CFormView)

CJobsTabMainView::CJobsTabMainView()
	: CFormView(CJobsTabMainView::IDD)
{
	//{{AFX_DATA_INIT(CJobsTabMainView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CJobsTabMainView::CJobsTabMainView(CView* pView, int nTabNo)
	: CFormView(CJobsTabMainView::IDD)
{
	m_nTabNo	= nTabNo; 
	m_pView		= pView;
	m_pDicsData = ( (CDicsView*)m_pView )->m_pDicsData;
	m_pEqpAssy	= ( (CDicsView*) m_pView )->m_pEqpAssy;
	m_bInitialUpdateComp = FALSE;
	SetMmc( ( (CDicsView*)m_pView )->m_pMmc );

	for( int i = 0; i < 2*MAX_IF_NO; i++ )
	{
		m_bCreateGlassData[i] = FALSE;
	}
}

CJobsTabMainView::~CJobsTabMainView()
{
}

void CJobsTabMainView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJobsTabMainView)
	DDX_Control(pDX, IDC_GRID_RECIPE_INFO, m_gridRecipeInfo);
	DDX_Control(pDX, IDC_GRID_SETUP_INFO, m_gridSetupInfo);
	DDX_Control(pDX, IDC_GRID_EUV_LAMP, m_gridLampStatus);
//	DDX_Control(pDX, IDC_GRID_TR_POS, m_gridTrPos);
//	DDX_Control(pDX, IDC_GRID_TR_AREA, m_gridTrArea);
	DDX_Control(pDX, IDC_LD_UPPER_HAND_UNIT_IN, m_bitmapLdUpperHand);
	DDX_Control(pDX, IDC_LD_UPPER_HAND_UNIT_OUT, m_bitmapUlUpperHand);
	DDX_Control(pDX, IDC_UL_HAND_UNIT, m_bitmapUlHand);
	DDX_Control(pDX, IDC_PROGRESS_IDLE_RUN, m_progIdleRun);
	DDX_Control(pDX, IDC_PROGRESS_EUV_ON, m_progEuvOn);
	DDX_Control(pDX, IDC_EUV, m_ocxEuv);
	DDX_Control(pDX, IDC_GRID_UL_HAND_POS, m_gridUlHandZ);
	DDX_Control(pDX, IDC_GRID_LD_UP_Z_POS, m_gridLdUpZ);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_CV_MOTOR1, m_ocxCvMotor[0]);
	DDX_Control(pDX, IDC_CV_MOTOR2, m_ocxCvMotor[1]);
	DDX_Control(pDX, IDC_CV_MOTOR3, m_ocxCvMotor[2]);
	DDX_Control(pDX, IDC_CV_MOTOR4, m_ocxCvMotor[3]);
	DDX_Control(pDX, IDC_CV_MOTOR5, m_ocxCvMotor[4]);
	DDX_Control(pDX, IDC_CV_MOTOR6, m_ocxCvMotor[5]);
	DDX_Control(pDX, IDC_CV_MOTOR7, m_ocxCvMotor[6]);
	DDX_Control(pDX, IDC_CV_MOTOR8, m_ocxCvMotor[7]);
	DDX_Control(pDX, IDC_CV_MOTOR9, m_ocxCvMotor[8]);
	DDX_Control(pDX, IDC_CV_MOTOR10, m_ocxCvMotor[9]);
	DDX_Control(pDX, IDC_CV_MOTOR11, m_ocxCvMotor[10]);
	DDX_Control(pDX, IDC_CV_MOTOR12, m_ocxCvMotor[11]);

	DDX_Control(pDX, IDC_RB_UNIT_RB1_UP, m_ocxRollBrush[0]);
	DDX_Control(pDX, IDC_RB_UNIT_RB1_LO, m_ocxRollBrush[1]);
	DDX_Control(pDX, IDC_RB_UNIT_RB2_UP, m_ocxRollBrush[2]);
	DDX_Control(pDX, IDC_RB_UNIT_RB2_LO, m_ocxRollBrush[3]);

	DDX_Control(pDX, IDC_ALIGN1, m_ocxAlign[0]);
	DDX_Control(pDX, IDC_ALIGN2, m_ocxAlign[1]);
	DDX_Control(pDX, IDC_ALIGN3, m_ocxAlign[2]);
	DDX_Control(pDX, IDC_ALIGN4, m_ocxAlign[3]);

	DDX_Control(pDX, IDC_LD_TILT, m_ocxCyl[0]);
	DDX_Control(pDX, IDC_UL_TILT, m_ocxCyl[1]);

	DDX_Control(pDX, IDC_UL_HAND_CYL1, m_ocxUlCyl[0]);
	DDX_Control(pDX, IDC_UL_HAND_CYL2, m_ocxUlCyl[1]);
}


BEGIN_MESSAGE_MAP(CJobsTabMainView, CFormView)
	//{{AFX_MSG_MAP(CJobsTabMainView)
	ON_WM_RBUTTONDOWN()
	ON_WM_CLOSE()
	ON_WM_CTLCOLOR()
//	ON_BN_CLICKED(IDC_UNIT4, OnUnit4)
//	ON_BN_CLICKED(IDC_LD_UPPER_HAND_UNIT, OnClickFishRib)
	//}}AFX_MSG_MAP
	ON_MESSAGE( WM_EQP_STATUS_CHANGED, OnEqpStatusChanged )
	ON_MESSAGE( WM_LD_STATUS_CHANGED, OnLdStatusChanged )
	ON_MESSAGE( WM_BROKEN_SENSOR_STATUS_CHANGED, OnBrokenSensorStatusChanged )// kjd
	ON_MESSAGE( WM_BROKEN_SCAN_STATUS_CHANGED, OnBrokenScanStatusChanged) // by molnic
	ON_MESSAGE( WM_MSG_BOX_CLICKED, OnMsgBoxClicked )
	ON_MESSAGE( WM_LD_DOOR_OPEN, OnLdDoorOpenChanged )	// ljy_050406 : add
	ON_MESSAGE( WM_UL_DOOR_OPEN, OnUlDoorOpenChanged )	// ljy_050406 : add
	ON_MESSAGE( WM_POSITION_SENSOR_STATUS_CHANGED, OnPosSensorStatusChanged )	// ljy_050502 : add
	ON_MESSAGE( WM_TR_POS_SENSOR_STATUS_CHANGED, OnTrPosSensorStatusChanged )
	ON_MESSAGE( WM_TR_AREA_SENSOR_STATUS_CHANGED, OnTrAreaSensorStatusChanged )
	ON_MESSAGE( WM_AGING_MODE_STATUS_CHANGED, OnAgingModeStatusChanged )
	ON_COMMAND_RANGE( IDC_SUB_UNIT1_1, IDC_SUB_UNIT11_1, OnCvInfo )

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJobsTabMainView diagnostics

#ifdef _DEBUG
void CJobsTabMainView::AssertValid() const
{
	CFormView::AssertValid();
}

void CJobsTabMainView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CJobsTabMainView message handlers

BOOL CJobsTabMainView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CJobsTabMainView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	// Get brush
	m_hbrBgColor =	CreateSolidBrush( BG_COLOR );
	m_hbrTextColor = CreateSolidBrush( BLUE_COLOR );

	// Set the bitmap
	m_bitmapUlHand.LoadBitmaps( IDB_UL_LO_HAND, IDB_UL_LO_HAND1, 0, IDB_UL_LO_HAND1 );

#ifndef _LTYPE
	m_bitmapLdUpperHand.LoadBitmaps( IDB_UL_UP_HAND, IDB_UL_UP_HAND1, 0, IDB_UL_UP_HAND1 );
	m_bitmapUlUpperHand.LoadBitmaps( IDB_UL_UP_HAND, IDB_UL_UP_HAND1, 0, IDB_UL_UP_HAND1 );
#else
	m_bitmapLdUpperHand.LoadBitmaps( IDB_LD_UP_HAND, IDB_LD_UP_HAND1, 0, IDB_LD_UP_HAND1 );
	m_bitmapUlUpperHand.LoadBitmaps( IDB_LD_UP_HAND, IDB_LD_UP_HAND1, 0, IDB_LD_UP_HAND1 );
#endif
	m_bitmapLdUpperHand.ShowWindow( FALSE );
	m_bitmapUlUpperHand.ShowWindow( FALSE );
//#ifndef _LTYPE
//	m_bitmapLdUpperHand.LoadBitmaps( IDB_LD_UP_HAND, IDB_LD_UP_HAND1, 0, IDB_LD_UP_HAND1 );
//	m_bitmapUlUpperHand.LoadBitmaps( IDB_UL_UP_HAND, IDB_UL_UP_HAND1, 0, IDB_UL_UP_HAND1 );
//#else
//	m_bitmapUlUpperHand.LoadBitmaps( IDB_LD_UP_HAND, IDB_LD_UP_HAND1, 0, IDB_LD_UP_HAND1 );
//	m_bitmapLdUpperHand.LoadBitmaps( IDB_UL_UP_HAND, IDB_UL_UP_HAND1, 0, IDB_UL_UP_HAND1 );
//	m_bitmapLdLowerHand.LoadBitmaps( IDB_LD_LO_HAND, IDB_LD_LO_HAND1, 0, IDB_LD_LO_HAND1 );
//	m_bitmapUlLowerHand.LoadBitmaps( IDB_UL_LO_HAND, IDB_UL_LO_HAND1, 0, IDB_UL_LO_HAND1 );
//endif
	
	// Tact Time
	CRect r;
	CString sMessage;
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	GetDlgItem( IDC_TACT_TIME )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgTactTime.Create( 100, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_TACT_TIME,
			WHITE_COLOR, BLACK_COLOR, 18, TRUE );
	sMessage.Format( "%d sec", 0 );
	m_msgTactTime.SetOpMsg( sMessage );
	//2008.08.26 kimgun
	GetDlgItem( IDC_TACT_TIME_OLD )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgOldTactTime.Create( 101, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_TACT_TIME_OLD,
			WHITE_COLOR, RED_COLOR, 18, TRUE );
	sMessage.Format( "%.1f sec", 0. );
	m_msgOldTactTime.SetOpMsg( sMessage );
	// Recipe ID
	GetDlgItem( IDC_RECIPE_ID )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgRecipeId.Create( 101, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_RECIPE_ID,
			WHITE_COLOR, RED_COLOR, 20 );
	sMessage.Format( "%s", ( (CDicsDoc*) ( (CDicsView*)m_pView->GetDocument() ) )->m_sRecipeId );
	m_msgRecipeId.SetOpMsg( sMessage );

	// Total Glass number
	m_IniConfiguration.Open( "ProcessData", "Config" );
	GetDlgItem( IDC_TOTAL_GLASS_NO )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgTotalGlassNo.Create( 102, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_TOTAL_GLASS_NO,
			WHITE_COLOR, BLACK_COLOR, 16, TRUE );
	UINT nTotalGlassNo = m_IniConfiguration.GetIntValue( "EQP GLASS COUNT", "Total Glass Count", 0 );
	m_pDicsData->m_GenInfo.nTotalGlassNo = nTotalGlassNo;
	sMessage.Format( "%d EA", nTotalGlassNo );
	m_msgTotalGlassNo.SetOpMsg( sMessage );

	// Current Glass number
	GetDlgItem( IDC_CUR_GLASS_NO )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgCurGlassNo.Create( 103, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_CUR_GLASS_NO,
			YELLOW_COLOR, BLUE_COLOR, 16 );
	m_nCurGlassNo = m_IniConfiguration.GetIntValue( "EQP GLASS COUNT", "Current Glass Count", 0 );
	sMessage.Format( "%d EA", m_nCurGlassNo );
	m_msgCurGlassNo.SetOpMsg( sMessage );

	// Equipment Glass Number
	GetDlgItem( IDC_EQP_GLASS_NO )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgGlassNo.Create( 104, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_EQP_GLASS_NO,
			WHITE_COLOR, BLUE_COLOR, 16, TRUE );
	m_msgGlassNo.SetOpMsg( "0 EA" );


	GetDlgItem( IDC_MSG_AGING )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgAging.Create( 105, "", WS_CHILD|WS_VISIBLE, r, this, IDC_MSG_AGING,
			LIGHT_GRAY, BLACK_COLOR, 16, TRUE );
	m_msgAging.SetOpMsg( " " );

	//////////////////////////////////////
	// Add other functions
	//////////////////////////////////////

	UINT uSubUnitId[MAX_UNIT_NO*2] = {
		IDC_SUB_UNIT1_1,  IDC_SUB_UNIT1_2, 
		IDC_SUB_UNIT2_1,  IDC_SUB_UNIT2_2, 
		IDC_SUB_UNIT3_1,  IDC_SUB_UNIT3_2, 
		IDC_SUB_UNIT4_1,  IDC_SUB_UNIT4_2, 
		IDC_SUB_UNIT5_1,  IDC_SUB_UNIT5_2, 
		IDC_SUB_UNIT6_1,  IDC_SUB_UNIT6_2, 
		IDC_SUB_UNIT7_1,  IDC_SUB_UNIT7_2, 
		IDC_SUB_UNIT8_1,  IDC_SUB_UNIT8_2, 
		IDC_SUB_UNIT9_1,  IDC_SUB_UNIT9_2, 
		IDC_SUB_UNIT10_1,  IDC_SUB_UNIT10_2, 
#ifndef _NO_UL_HAND
		IDC_SUB_UNIT11_1,  IDC_SUB_UNIT11_2, 
#endif
	};
	// Set the static control : Sub Unit
	for( int i=0; i<2 * MAX_UNIT_NO; i++ )
	{
		m_stcSubUnit[i].SubclassDlgItem( uSubUnitId[i], this );
		m_stcSubUnit[i].SetTextColor( BLACK_COLOR );
		m_stcSubUnit[i].SetBkColor( BG_COLOR );
	}

	// Set the static control : Exist Sensor
	for( i=0; i<MAX_GLS_EXIST_SENSOR_NO; i++ )
	{
		m_stcGlsExistSensor[i].SubclassDlgItem( IDC_GLS_EXIST_SENSOR1_1 + i, this );
		m_stcGlsExistSensor[i].SetTextColor( BLACK_COLOR );
		m_stcGlsExistSensor[i].SetBkColor( WHITE_COLOR );
	}

	{
		m_stcGlsExistInterlock.SubclassDlgItem( IDC_GLS_EXIST_SENSOR_INTERLOCK, this );
		m_stcGlsExistInterlock.SetTextColor( BLACK_COLOR );
		m_stcGlsExistInterlock.SetBkColor( WHITE_COLOR );
	}

	// Set the static control : Unit
	for( i=0; i<MAX_UNIT_NO; i++ )
	{
		m_stcUnit[i].SubclassDlgItem( IDC_UNIT1 + i, this );
		m_stcUnit[i].SetTextColor( BLACK_COLOR );
		m_stcUnit[i].SetBkColor( GRAY_COLOR );
	} 

	UINT nLeakSensorResId[MAX_LEAK_SENSOR_NO] = {
		IDC_LEAK1, IDC_LEAK2, IDC_LEAK3, IDC_LEAK4,
	};
	for( i = 0 ; i < MAX_LEAK_SENSOR_NO ; i ++ )
	{
		m_stcLeak[i].SubclassDlgItem( nLeakSensorResId[i], this );
		m_stcLeak[i].SetTextColor( RED_COLOR );
		m_stcLeak[i].SetBkColor( WHITE_COLOR );
	}

	// Set the static control : Cover Sensor
	for( i = 0 ; i < MAX_COVER_OPEN_NO ; i ++ )
	{
		m_stcCoverOpen[i].SubclassDlgItem( IDC_COVER_OPEN1 + i, this );
		m_stcCoverOpen[i].SetTextColor( BLACK_COLOR );
		m_stcCoverOpen[i].SetBkColor( WHITE_COLOR );
	}

	// Set the static control : Door Sensor
	for( i=0; i<MAX_DOOR_OPEN_NO; i++ )
	{
		m_stcDoorOpen[i].SubclassDlgItem( IDC_LD_UNIT_DOOR_OPEN1 + i, this );
		m_stcDoorOpen[i].SetTextColor( BLACK_COLOR );
		m_stcDoorOpen[i].SetBkColor( WHITE_COLOR );
	}

	// Set the static control : Broken Sensor
	for( i=0; i<MAX_GLS_BROKEN_SENSOR_NO; i++ )
	{
		m_stcBrokenSensor[i].SubclassDlgItem( IDC_GLS_BROKEN_SENSOR1 + i, this );
		SetDlgItemText( IDC_GLS_BROKEN_SENSOR1 +i, (LPCTSTR) "");
		m_stcBrokenSensor[i].SetTextColor( BLACK_COLOR );
		m_stcBrokenSensor[i].SetBkColor( WHITE_COLOR );
	}

	for( i=0; i<MAX_SCAN_NO; i++ )	// 121002 halesu
	{
		GetDlgItem( IDC_MSG_LD_SCAN + i )->GetWindowRect( &r );
		ScreenToClient( &r );
		r -= CRect( 1, 1, 1, 1 );
		m_msgBrokenSensor[i].Create( 106 + i, " ", WS_CHILD|WS_VISIBLE, r, this, IDC_MSG_LD_SCAN + i, 
			LIGHT_GREEN_COLOR, BLUE_COLOR, 14 );
		m_msgBrokenSensor[i].SetOpMsg( "SCAN READY" );
	}
#ifndef _NO_RB
	for( i=0; i<MAX_RB_GAP_SERVO_NO; i++ )
	{
		GetDlgItem( IDC_RB1_UP + i )->GetWindowRect( &r );
		ScreenToClient( &r );
		r -= CRect( 1, 1, 1, 1 );
		m_msgRbGap[i].Create( 109/*108 121002 halesu*/ + i, "", WS_CHILD|WS_VISIBLE, r, this, IDC_RB1_UP+i,	
				LIGHT_GRAY, BLACK_COLOR, 14, TRUE );
#ifndef _MY_DEBUG
		m_msgRbGap[i].SetOpMsg( "0.00 mm" );
#else
		m_msgRbGap[i].SetOpMsg( "Unknown" );
#endif
	}
#endif
	// LD / UL Port Information
/*	for( i=0; i<MAX_PORT_NO; i++ )
	{
//		m_stcPort[i].SubclassDlgItem( IDC_PORT1 + i, this );
//		m_stcPort[i].SetTextColor( BLACK_COLOR );
//		m_stcPort[i].SetBkColor( YELLOW_COLOR );

		m_stcTrsMode[i].SubclassDlgItem( IDC_TR_MODE_PORT1 + i, this );
		m_stcTrsMode[i].SetTextColor( RED_COLOR );
		m_stcTrsMode[i].SetBkColor( WHITE_COLOR );
		m_stcTrsMode[i].SetWindowText( "AUTO" );

		m_stcInOutNum[i].SubclassDlgItem( IDC_IN_OUT_NUM_PORT1 + i, this );
		m_stcInOutNum[i].SetTextColor( RED_COLOR );
		m_stcInOutNum[i].SetBkColor( WHITE_COLOR );
		m_stcInOutNum[i].SetWindowText( "00/00/00" );

		m_stcPortState[i].SubclassDlgItem( IDC_STATE_PORT1 + i, this );
		m_stcPortState[i].SetTextColor( BLUE_COLOR );
		m_stcPortState[i].SetBkColor( WHITE_COLOR );
		m_stcPortState[i].SetWindowText( "NONE" );
	}*/

	//////////////////////////////////////////////////////////////////////////
	// GridInit( CMSFlexGrid &gridCtrl, GRID_INFO gridInfo )
	// GRID_INFO	0 : RecipeInfo 
	//				1 : SetupInfo
	//				2 : HandPosSensor_Y
	//				3 : UpHandPosSensor_Z
	//				4 : LoHandPosSensor_Z
	//				5 : TrAreaSensor
	//				6 : TrPosSensor
	//				7 : EuvLampStatus
	//////////////////////////////////////////////////////////////////////////
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	GridInit( m_gridRecipeInfo, m_GridInfo[gRecipeInfo] );
	SetDataToGridCtrl_RecipeInfo();
	pDoc->SetRecipeId( ( (CDicsView*)m_pView )->m_pDicsData->m_GenInfo.sRecipeId );

	CSetupItems* pItems = ( (CDicsDoc*) m_pView->GetDocument() )->m_pSetupItems;
	int nCount = pItems->m_nItemNoSetup;
	m_GridInfo[gSetupInfo].nRows = nCount + 1;
	
	GridInit( m_gridSetupInfo, m_GridInfo[gSetupInfo] );
	SetDataToGridCtrl_SetupInfo();
	
	GridInit( m_gridUlHandZ, m_GridInfo[gUlHandZ] );
	GridInit( m_gridLdUpZ, m_GridInfo[gUpHandPosZ] );
//	GridInit( m_gridTrArea, m_GridInfo[gTrArea] );
//	GridInit( m_gridTrPos, m_GridInfo[gTrPos] );
#ifndef _NO_EUV
	GridInit( m_gridLampStatus, m_GridInfo[gLampStatus] );
	SetDataToGridCtrl_LampStatus();
#endif

	// Set the mode
	//for( i=0; i<MAX_PORT_NO; i++ ) SetLdState( i, CDicsData::stateNONE );
	//SetEqpState( CDicsData::stateNONE );

	// Show Glass Data
	( (CDicsView*) m_pView )->m_pMainSeq->GetProfileGlassData();

#ifndef _NO_EUV
	m_ocxEuv.SetHouseType( MAX_LAMP_CONTROL_NO ); //by molnic 060106

	m_ocxEuv.SetLampOff();		// ljy_050513

	m_ocxEuv.SetLampNoUse();	// ljy_050513 by molnic 060106

#else 
	m_ocxEuv.ShowWindow( SW_HIDE );
#endif 


#ifdef _NO_RB
	m_ocxRollBrush[0].ShowWindow( SW_HIDE );
	m_ocxRollBrush[1].ShowWindow( SW_HIDE );
	m_ocxRollBrush[2].ShowWindow( SW_HIDE );
	m_ocxRollBrush[3].ShowWindow( SW_HIDE );
	m_ocxCvMotor[7].ShowWindow( SW_HIDE );
	GetDlgItem( IDC_RB1_UP )->ShowWindow( FALSE );
	GetDlgItem( IDC_RB1_LO )->ShowWindow( FALSE );
	GetDlgItem( IDC_RB2_UP )->ShowWindow( FALSE );
	GetDlgItem( IDC_RB2_LO )->ShowWindow( FALSE );
	GetDlgItem( IDC_STATIC_RB )->ShowWindow( FALSE );
#endif

#ifdef _NO_UL_HAND
	m_gridUlHandZ.ShowWindow( SW_HIDE );
	m_ocxUlCyl[0].ShowWindow( SW_HIDE );
	m_ocxUlCyl[1].ShowWindow( SW_HIDE );
	GetDlgItem( IDC_GLS_EXIST_SENSOR11_1 )->ShowWindow( FALSE );
	GetDlgItem( IDC_GLS_EXIST_SENSOR11_2 )->ShowWindow( FALSE );
	GetDlgItem( IDC_SUB_UNIT11_1 )->ShowWindow( FALSE );
	GetDlgItem( IDC_UNIT11 )->ShowWindow( FALSE );
	GetDlgItem( IDC_UL_HAND_UNIT )->ShowWindow( FALSE );
#endif
 
	GetDlgItem( IDC_GRID_TR_AREA )->ShowWindow( FALSE );
	GetDlgItem( IDC_GRID_TR_POS )->ShowWindow( FALSE );
	GetDlgItem( IDC_SUB_UNIT11_2 )->ShowWindow( FALSE );
//	GetDlgItem( IDC_RB1_UP )->ShowWindow( FALSE );
//	GetDlgItem( IDC_RB1_LO )->ShowWindow( FALSE );
//	GetDlgItem( IDC_RB2_UP )->ShowWindow( FALSE );
//	GetDlgItem( IDC_RB2_LO )->ShowWindow( FALSE );
//	( (CDicsView*) m_pView )->SetSeqStart();

	// Initial Update Complete
	m_bInitialUpdateComp = TRUE;
}

void CJobsTabMainView::OnRButtonDown(UINT nFlags, CPoint point) 
{
/*	m_pIniGlsData->SetIntValue( "GLS01", "RCP_ID", 191 , TRUE );

	int nValue = m_pIniGlsData->GetIntValue( "GLS01", "RCP_ID", 100 );

	m_pIniGlsData->SetStringValue( "GLS01", "PNL_INFO", "123456789012345678901234", TRUE );

	CString sTemp;
	sTemp = m_pIniGlsData->GetStringValue( "GLS01", "PNL_INFO", "1234" );

	m_pIniGlsData->SetIntValue( "GLS02", "RCP_ID", 212, TRUE );
	m_pIniGlsData->SetIntValue( "GLS03", "RCP_ID", 213, TRUE );
	m_pIniGlsData->SetIntValue( "GLS04", "RCP_ID", 214, TRUE );
	m_pIniGlsData->SetIntValue( "GLS05", "RCP_ID", 215, TRUE );

	CStringList* pSectionList;
	pSectionList = m_pIniGlsData->GetSectionList();
*/	
#ifdef _MY_DEBUG
	if( ( (CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto || 
		( ( (CDicsView*) m_pView )->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER ) ) return;
	
	CDlgSetCurPos dlg;
	dlg.SetMmc( ((CDicsView*)m_pView)->m_pMmc );
	dlg.SetGlassAni( ( (CDicsView*)m_pView)->m_pGlassAni );
	dlg.SetMainSeq( ( (CDicsView*)m_pView)->m_pMainSeq );
	dlg.DoModal();


//	m_pDevice->SetDiState( DI_NODE1+9,  OFF);  // Align FW
//	m_pDevice->SetDiState( DI_NODE1+11, OFF);
//	m_pDevice->SetDiState( DI_NODE1+13, OFF);
//	m_pDevice->SetDiState( DI_NODE1+15, OFF);
//
//	m_pDevice->SetDiState( DI_NODE1+10, ON );  // Align BW
//	m_pDevice->SetDiState( DI_NODE1+12, ON );
//	m_pDevice->SetDiState( DI_NODE1+14, ON );
//	m_pDevice->SetDiState( DI_NODE1+16, ON );
//
//	m_pDevice->SetDiState( DI_NODE1+0, ON );
//	m_pDevice->SetDiState( DI_NODE1+1, ON );
#endif
	
	CFormView::OnRButtonDown(nFlags, point);
}

void CJobsTabMainView::OnClose() 
{
	// Delete the context
	DeleteObject( m_hbrBgColor );
	DeleteObject( m_hbrTextColor );

	
	CFormView::OnClose();
}

//--------------------------------------------------------------------
// Initialize the GridCtrl
//--------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////////
// GRID_INFO	0 : RecipeInfo 
//				1 : SetupInfo
//				2 : HandPosSensor_Y
//				3 : UpHandPosSensor_Z
//				4 : LoHandPosSensor_Z
//				5 : TrAreaSensor
//				6 : TrPosSensor
//				7 : EuvLampStatus
//////////////////////////////////////////////////////////////////////////
void CJobsTabMainView::GridInit( CMSFlexGrid &gridCtrl, GRID_INFO gridInfo )
{
	CString sText;
	
	gridCtrl.SetRows( gridInfo.nRows );
	gridCtrl.SetCols( gridInfo.nCols );

	
	if( gridInfo.bTitle )
	{
		for( int i = 0; i < gridInfo.nCols; i++ )
		{
			gridCtrl.SetRow( 0 );
			gridCtrl.SetCol( i );
			gridCtrl.SetCellAlignment( 4 );
			gridCtrl.SetCellBackColor( gridInfo.uCellBackColor );
			gridCtrl.SetColWidth( i, gridInfo.nColWidth[i] );
			gridCtrl.SetText( gridInfo.sText[i] );
		}
	}
	else
	{
		for( int i = 0; i < gridInfo.nRows; i++ )
		{
			for( int j = 0; j < gridInfo.nCols; j++ )
			{
				gridCtrl.SetRow( i );
				gridCtrl.SetCol( j );
				gridCtrl.SetCellAlignment( 4 );
				gridCtrl.SetCellBackColor( gridInfo.uCellBackColor );
				if( gridInfo.nRows < gridInfo.nCols ) 
				{
					gridCtrl.SetColWidth( j, gridInfo.nColWidth[j] );
					gridCtrl.SetText( gridInfo.sText[j] );
				}
				else
				{
					gridCtrl.SetColWidth( j, gridInfo.nColWidth[i] );
					gridCtrl.SetText( gridInfo.sText[i] );
				}
			}
		}
	}
}
//--------------------------------------------------------------------
// Skip Items
// 1. Recipe ID
// 2. Change Time
// 3. Comment
//--------------------------------------------------------------------
void CJobsTabMainView::SetDataToGridCtrl_RecipeInfo()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	CDaoFieldInfo FieldInfo;
#ifndef _NO_RB
	for( int i=SKIP_3_ITEMS; i<MAX_TOTAL_RECIPE_BODY_NO ; i++ )
	{
		// 1st column
		pDoc->m_pRecipeSet->GetFieldInfo( i, FieldInfo );
		m_gridRecipeInfo.SetCol( 0 );
		m_gridRecipeInfo.SetRow( i + 1 - SKIP_3_ITEMS );
		m_gridRecipeInfo.SetCellAlignment( 4 );
		m_gridRecipeInfo.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridRecipeInfo.SetText( (LPCTSTR) FieldInfo.m_strName );

		// 2nd column
		m_gridRecipeInfo.SetCol( 1 );
		m_gridRecipeInfo.SetRow( i + 1 - SKIP_3_ITEMS );
		
		// Set the background color
		RECIPE_INFO *pRecipeInfo = pDoc->m_pRecipeInfoTemp;

		if( FieldInfo.m_strName == "ID" || 
			FieldInfo.m_strName == "CHANGE TIME" ) m_gridRecipeInfo.SetCellBackColor( BG_COLOR_DISABLE );
		else m_gridRecipeInfo.SetCellBackColor( BG_COLOR_INT );

		CString sRecipeId;
		sRecipeId = ( (CDicsView*)m_pView )->m_pDicsData->m_GenInfo.sRecipeId;
		int nRow = pDoc->GetRowfromID( sRecipeId );
		if( FieldInfo.m_nType == dbBoolean ) 
		{
			if( pRecipeInfo[nRow].sValue[i] == "ON" ||
				pRecipeInfo[nRow].sValue[i] == "CW" ||
				pRecipeInfo[nRow].sValue[i] == "YES" ||
				pRecipeInfo[nRow].sValue[i] == "U-MODE") 
			{
				m_gridRecipeInfo.SetCellBackColor( BG_COLOR_BOOL_ON );
				m_gridRecipeInfo.SetCellForeColor( BLACK_COLOR );
			}
			else 
			{
				m_gridRecipeInfo.SetCellBackColor( BG_COLOR_BOOL_OFF );
				m_gridRecipeInfo.SetCellForeColor( DARK_GRAY_COLOR );
			}
		}
		m_gridRecipeInfo.SetText( (LPCTSTR) pRecipeInfo[nRow].sValue[i] );
		m_gridRecipeInfo.SetCellAlignment( 4 );
	}
#else
	for( int i=SKIP_3_ITEMS; i<MAX_TOTAL_RECIPE_BODY_NO-16 ; i++ )
	{
		// 1st column
		pDoc->m_pRecipeSet->GetFieldInfo( i, FieldInfo );
		m_gridRecipeInfo.SetCol( 0 );
		m_gridRecipeInfo.SetRow( i + 1 - SKIP_3_ITEMS );
		m_gridRecipeInfo.SetCellAlignment( 4 );
		m_gridRecipeInfo.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridRecipeInfo.SetText( (LPCTSTR) FieldInfo.m_strName );

		// 2nd column
		m_gridRecipeInfo.SetCol( 1 );
		m_gridRecipeInfo.SetRow( i + 1 - SKIP_3_ITEMS );
		
		// Set the background color
		RECIPE_INFO *pRecipeInfo = pDoc->m_pRecipeInfoTemp;

		if( FieldInfo.m_strName == "ID" || 
			FieldInfo.m_strName == "CHANGE TIME" ) m_gridRecipeInfo.SetCellBackColor( BG_COLOR_DISABLE );
		else m_gridRecipeInfo.SetCellBackColor( BG_COLOR_INT );

		CString sRecipeId;
		sRecipeId = ( (CDicsView*)m_pView )->m_pDicsData->m_GenInfo.sRecipeId;
		int nRow = pDoc->GetRowfromID( sRecipeId );
		if( FieldInfo.m_nType == dbBoolean ) 
		{
			if( pRecipeInfo[nRow].sValue[i] == "ON" ||
				pRecipeInfo[nRow].sValue[i] == "CW" ||
				pRecipeInfo[nRow].sValue[i] == "YES" ||
				pRecipeInfo[nRow].sValue[i] == "U-MODE") 
			{
				m_gridRecipeInfo.SetCellBackColor( BG_COLOR_BOOL_ON );
				m_gridRecipeInfo.SetCellForeColor( BLACK_COLOR );
			}
			else 
			{
				m_gridRecipeInfo.SetCellBackColor( BG_COLOR_BOOL_OFF );
				m_gridRecipeInfo.SetCellForeColor( DARK_GRAY_COLOR );
			}
		}
		m_gridRecipeInfo.SetText( (LPCTSTR) pRecipeInfo[nRow].sValue[i] );
		m_gridRecipeInfo.SetCellAlignment( 4 );
	}
#endif

}

//--------------------------------------------------------------------
// SetRecipeId2View
//--------------------------------------------------------------------
void CJobsTabMainView::SetRecipeId2View( CString sRecipeId ) 
{ 
	CString sMsg; 
	sMsg.Format( "%s", sRecipeId ); 
	m_msgRecipeId.SetOpMsg( sMsg ); 
}

//--------------------------------------------------------------------
// Set data
//--------------------------------------------------------------------
void CJobsTabMainView::SetDataToGridCtrl_SetupInfo()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	CSetupItems* pItems = ( (CDicsDoc*) m_pView->GetDocument() )->m_pSetupItems;

	int nCount = 0;
	for( int i=0; i<pItems->m_nItemNoSetup; i++ )
	{
		// 1st column
		m_gridSetupInfo.SetCol( 0 );
		m_gridSetupInfo.SetRow( nCount + 1 );
		m_gridSetupInfo.SetCellAlignment( 4 );
		m_gridSetupInfo.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridSetupInfo.SetText( pItems->m_infoSetup[i].sName );

		// Set the background color
		if( pItems->m_infoSetup[i].nOption != CSetupItems::optionNONE )
		{
			// 2nd column
			m_gridSetupInfo.SetCol( 1 );
			m_gridSetupInfo.SetRow( nCount + 1 );
			SetBoolTypeValue( pItems->m_nValueSetup_Option[i], pItems->m_infoSetup[i].nOption, m_gridSetupInfo );
			nCount++;
		}
		else
		{
			// 2nd column
			m_gridSetupInfo.SetCol( 1 );
			m_gridSetupInfo.SetRow( nCount + 1 );
			m_gridSetupInfo.SetCellAlignment( 4 );
			m_gridSetupInfo.SetText( (LPCTSTR) pItems->m_sValueSetup[i] );
			m_gridSetupInfo.SetCellBackColor( WHITE_COLOR );
			nCount++;
		}
	}
}

void CJobsTabMainView::SetDataToGridCtrl_LampStatus()
{
#ifdef _NO_EUV
	return;
#endif

	CDicsView* pView = (CDicsView*) m_pView;
	
	static int nStatus[MAX_LAMP_CONTROL_NO] = { 0, };

	for( int i = 0 ; i < MAX_LAMP_CONTROL_NO ; i++ )
	{
		BOOL bOn = TRUE;
		bOn &= pView->m_pEuvSeq->GetLampOnState();
		bOn &= pView->m_pEuvSeq->GetLampOnSelected( i );

		if( nStatus[i] != 1 && bOn )
		{
			m_gridLampStatus.SetCol( i );
			m_gridLampStatus.SetCellBackColor( LIGHT_RED_COLOR );
			nStatus[i] = 1;
   		}
		else if( nStatus[i] != 2 && !bOn )
		{
			m_gridLampStatus.SetCol( i );
			m_gridLampStatus.SetCellBackColor( WHITE_COLOR );
			nStatus[i] = 2;
		}
	}
}


//--------------------------------------------------------------------
// SetBoolTypeValue
//--------------------------------------------------------------------
void CJobsTabMainView::SetBoolTypeValue(int nValue, int nOption, CMSFlexGrid& gridCtrl)
{
	CString sBuf;
	if( nOption == CSetupItems::optionBOOL1 ) 
	{
		if( nValue == 1 )
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "PROCESS" );
		}
		else 
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "PASS MODE" );
		}
	}
	else if( nOption == CSetupItems::optionBOOL2 ) 
	{
		if( nValue == 1 )
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "USE" );
		}
		else 
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO USE" );
		}
	}
	else if( nOption == CSetupItems::optionBOOL3 ) 
	{
		if( nValue == 1 )
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "CHECK" );
		}
		else 
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO CHECK" );
		}
	}
	else if( nOption == CSetupItems::optionBOOL4 ) 
	{
		if( nValue == 1 )
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "FW" );
		}
		else 
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "BW" );
		}
	}
	else if( nOption == CSetupItems::optionBOOL7 )	// 250108 halesu 
	{
		if( nValue == 1 )
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "RB_IN" );
		}
		else 
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "EUV OUT" );
		}
	}
	else
	{
		gridCtrl.SetCellBackColor( BG_COLOR );
		gridCtrl.SetCellForeColor( BG_COLOR );
		sBuf.Format( "" );
	}

	gridCtrl.SetCellAlignment( 4 );
	gridCtrl.SetText( (LPCTSTR) sBuf );
}

//--------------------------------------------------------------------
// OnCtlColor
//--------------------------------------------------------------------
HBRUSH CJobsTabMainView::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CFormView::OnCtlColor(pDC, pWnd, nCtlColor);
	
	UINT id = pWnd->GetDlgCtrlID();
	switch( nCtlColor )
	{
//		case CTLCOLOR_DLG:
//			hbr = m_hbrBgColor;
//			break;
		case CTLCOLOR_STATIC:
			if( id == IDC_TITLE_RECIPE || 
				id == IDC_TITLE_TACT_TIME ||
				id == IDC_TITLE_TACT_TIME_OLD||
				id == IDC_TITLE_TOTAL_GLASS_NO || 
				id == IDC_TITLE_EQP_GLASS_NO || 
				id == IDC_TITLE_CUR_GLASS_NO ||
				id == IDC_TITLE_IDLE_RUNNING_PROGRESS ||
				id == IDC_TITLE_EUV_PROGRESS ||
				id == IDC_TITLE_EUV_PROGRESS2 )	
			{
				hbr = m_hbrBgColor;
				pDC->SetBkMode( TRANSPARENT );
				pDC->SetTextColor( BLACK_COLOR );
			}
			else if( id == IDC_STATIC_GLASS1 ||
				id == IDC_STATIC_GLASS2 || 
				id == IDC_STATIC_GLASS3 ||
				id == IDC_STATIC_GLASS4 ||
				id == IDC_STATIC_GLASS5 || 
				id == IDC_STATIC_GLASS6 ||
				id == IDC_STATIC_GLASS7 ||
				id == IDC_STATIC_GLASS8 )
			{
				hbr = m_hbrTextColor;
				pDC->SetBkMode( TRANSPARENT );
			}
	}
	
	return hbr;
}

// -----------------------------------------------------------
// Existence Sensor display
// -----------------------------------------------------------
void CJobsTabMainView::SetColorStatic( CColorStatic& stcObject, BOOL bState, COLORREF OnColor, COLORREF OffColor )
{	
	if( bState ) 
	{
		stcObject.StartBkBlink( FALSE );
		stcObject.StartTextBlink( FALSE );
		stcObject.SetTextColor( BLACK_COLOR );
		stcObject.SetBkColor( OnColor );
	}
	else
	{
		stcObject.StartBkBlink( FALSE );
		stcObject.StartTextBlink( FALSE );
		stcObject.SetTextColor( BLACK_COLOR );
		stcObject.SetBkColor( OffColor );
	}
}

//---------------------------------------------------------------------------
// set the glass no
//---------------------------------------------------------------------------
void CJobsTabMainView::SetGlassNo(int nGlassNo, int nAll)
{
	m_IniConfiguration.Open( "ProcessData", "Config" );

	CString sMessage;
	sMessage.Format( "%d EA", nGlassNo );
	m_msgGlassNo.SetOpMsg( sMessage );

	// lParam = 1 => Glass In
	if( nAll )
	{
		CDicsApp* pApp = ( CDicsApp* ) AfxGetApp();

		m_nCurGlassNo += 1;
		sMessage.Format( "%d EA", m_nCurGlassNo );
		m_msgCurGlassNo.SetOpMsg( sMessage );
		// Write to registry
		m_IniConfiguration.SetIntValue( "EQP GLASS COUNT", "Current Glass Count", m_nCurGlassNo, TRUE );
		
		( (CDicsView*)m_pView )->m_pDicsData->m_GenInfo.nTotalGlassNo += 1;
		UINT nTotalGlassNo = ( (CDicsView*)m_pView )->m_pDicsData->m_GenInfo.nTotalGlassNo;
		sMessage.Format( "%d EA", nTotalGlassNo );
		m_msgTotalGlassNo.SetOpMsg( sMessage );
		// Write to registry
		m_IniConfiguration.SetIntValue( "EQP GLASS COUNT", "Total Glass Count", nTotalGlassNo, TRUE );
	}
}

//---------------------------------------------------------------------------
// set the color static control
//---------------------------------------------------------------------------
void CJobsTabMainView::SetCvState( int i, BOOL bState, int nSlotNo, int nPortNo )
{
	if( bState ) 
	{
		CString sText;
		sText.Format( "%d-%02d", nPortNo, nSlotNo );
		m_stcSubUnit[i].SetWindowText( sText );

		m_stcSubUnit[i].StartBkBlink( FALSE );
		m_stcSubUnit[i].StartTextBlink( FALSE );
		m_stcSubUnit[i].SetTextColor( BLUE_COLOR );
		m_stcSubUnit[i].SetBkColor( YELLOW_COLOR );
//		m_stcSubUnit[i].SetBkColor( MAGENTA_COLOR );
	}
	else
	{
		CString sText = "";
		m_stcSubUnit[i].SetWindowText( sText );

		m_stcSubUnit[i].StartBkBlink( FALSE );
		m_stcSubUnit[i].StartTextBlink( FALSE );
		m_stcSubUnit[i].SetTextColor( BLACK_COLOR );
		m_stcSubUnit[i].SetBkColor( BG_COLOR );
	}
//	else if( nState == CCstSequence::lampTOGGLE ) 
//	{
//		m_stcSubUnit[i].SetBlinkBkColors( RED_COLOR, YELLOW_COLOR );
//		m_stcSubUnit[i].SetBlinkTextColors( YELLOW_COLOR, RED_COLOR );
//		m_stcSubUnit[i].StartBkBlink( TRUE, CColorStatic::ST_FLS_NORMAL );
//		m_stcSubUnit[i].StartTextBlink( TRUE, CColorStatic::ST_FLS_NORMAL );
//	}
}

//--------------------------------------------------------------------
// Set the equipment mode
//--------------------------------------------------------------------
void CJobsTabMainView::SetEqpState( int nState )
{
	if( nState == CDicsData::stateMANUAL )	// 1st priority
	{
		for( int i=0; i<MAX_UNIT_NO; i++ )
		{
			m_stcUnit[i].SetTextColor( BLACK_COLOR );
			m_stcUnit[i].SetBkColor( DARK_GRAY_COLOR );
			m_stcUnit[i].StartBkBlink( FALSE );
			m_stcUnit[i].Invalidate();
		}
	}
	else if( nState == CDicsData::stateNONE )
	{
		for( int i=0; i<MAX_UNIT_NO; i++ )
		{
			m_stcUnit[i].SetTextColor( BLACK_COLOR );
			m_stcUnit[i].SetBkColor( GRAY_COLOR );
			m_stcUnit[i].StartBkBlink( FALSE );
			m_stcUnit[i].Invalidate();
		}
	}
	else if( nState == CDicsData::stateIDLE )
	{
		for( int i=0; i<MAX_UNIT_NO; i++ )
		{
			m_stcUnit[i].SetTextColor( BLACK_COLOR );
			m_stcUnit[i].SetBkColor( YELLOW_COLOR );
			m_stcUnit[i].StartBkBlink( FALSE );
			m_stcUnit[i].Invalidate();
		}
	}
	else if( nState == CDicsData::stateRUN )
	{
		for( int i=0; i<MAX_UNIT_NO; i++ )
		{
			m_stcUnit[i].SetTextColor( BLACK_COLOR );
			m_stcUnit[i].SetBkColor( GREEN_COLOR );
			m_stcUnit[i].StartBkBlink( FALSE );
			m_stcUnit[i].Invalidate();
		}
	}
	else if( nState == CDicsData::stateALARM || nState == CDicsData::stateDOWN )
	{
		for( int i=0; i<MAX_UNIT_NO; i++ )
		{
			m_stcUnit[i].SetTextColor( BLACK_COLOR );
			m_stcUnit[i].SetBkColor( RED_COLOR );
			m_stcUnit[i].StartBkBlink( FALSE );
			m_stcUnit[i].Invalidate();
		}
	}
	else if( nState == CDicsData::stateSTOP )
	{
		for( int i=0; i<MAX_UNIT_NO; i++ )
		{
			m_stcUnit[i].SetTextColor( BLACK_COLOR );
			//m_stcUnit[i].SetBkColor( ORANGE_COLOR );
			m_stcUnit[i].SetBlinkBkColors( ORANGE_COLOR, GREEN_COLOR );
			m_stcUnit[i].StartBkBlink( TRUE, CColorStatic::ST_FLS_FAST );
			m_stcUnit[i].Invalidate();
		}
	}
	else if( nState == CDicsData::statePAUSE )
	{
		for( int i=0; i<MAX_UNIT_NO; i++ )
		{
			m_stcUnit[i].SetTextColor( BLACK_COLOR );
			m_stcUnit[i].SetBkColor( ORANGE_COLOR );
			m_stcUnit[i].StartBkBlink( FALSE );
			m_stcUnit[i].Invalidate();
		}
	}
	else if( nState == CDicsData::stateCLEAN )
	{
		for( int i=0; i<MAX_UNIT_NO; i++ )
		{
			m_stcUnit[i].SetTextColor( BLACK_COLOR );
//			m_stcUnit[i].SetBkColor( ORANGE_COLOR );
			m_stcUnit[i].SetBlinkBkColors( ORANGE_COLOR, CYAN_COLOR );
			m_stcUnit[i].StartBkBlink( TRUE, CColorStatic::ST_FLS_FAST );
			m_stcUnit[i].Invalidate();
		}
	}
}

//--------------------------------------------------------------------
// Set the Loader State
//--------------------------------------------------------------------
void CJobsTabMainView::SetLdState( int i, int nState )
{
/*	if( nState == CDicsData::stateMANUAL )	// 1st priority
	{
		m_stcPort[i].SetTextColor( BLACK_COLOR );
		m_stcPort[i].SetBkColor( DARK_GRAY_COLOR );
		m_stcPort[i].Invalidate();

		CRect rect;
		m_stcPort[i].GetWindowRect( &rect );
		ScreenToClient( &rect );
		InvalidateRect( &rect );
	}
	else if( nState == CDicsData::stateNONE )
	{
		m_stcPort[i].SetTextColor( BLACK_COLOR );
		m_stcPort[i].SetBkColor( GRAY_COLOR );
		m_stcPort[i].Invalidate();

		CRect rect;
		m_stcPort[i].GetWindowRect( &rect );
		ScreenToClient( &rect );
		InvalidateRect( &rect );
	}
	else if( nState == CDicsData::stateIDLE )
	{
		m_stcPort[i].SetTextColor( BLACK_COLOR );
		m_stcPort[i].SetBkColor( YELLOW_COLOR );
		m_stcPort[i].Invalidate();

		CRect rect;
		m_stcPort[i].GetWindowRect( &rect );
		ScreenToClient( &rect );
		InvalidateRect( &rect );
	}
	else if( nState == CDicsData::stateRUN )
	{
		m_stcPort[i].SetTextColor( BLACK_COLOR );
		m_stcPort[i].SetBkColor( GREEN_COLOR );
		m_stcPort[i].Invalidate();

		CRect rect;
		m_stcPort[i].GetWindowRect( &rect );
		ScreenToClient( &rect );
		InvalidateRect( &rect );
	}
	else if( nState == CDicsData::stateDOWN )
	{
		m_stcPort[i].SetTextColor( BLACK_COLOR );
		m_stcPort[i].SetBkColor( RED_COLOR );
		m_stcPort[i].Invalidate();

		CRect rect;
		m_stcPort[i].GetWindowRect( &rect );
		ScreenToClient( &rect );
		InvalidateRect( &rect );
	}
	else if( nState == CDicsData::statePAUSE )
	{
		for( int i=0; i<MAX_UNIT_NO; i++ )
		{
			m_stcPort[i].SetTextColor( BLACK_COLOR );
			m_stcPort[i].SetBkColor( ORANGE_COLOR );
			m_stcPort[i].StartBkBlink( FALSE );
			m_stcPort[i].Invalidate();
		}
	} */
}

//---------------------------------------------------------------------------------
// OnEqpStatusChanged
//---------------------------------------------------------------------------------
void CJobsTabMainView::OnEqpStatusChanged( WPARAM wParam, LPARAM lParam )
{
	if( !m_bInitialUpdateComp ) return;

	SetEqpState( ( int ) wParam );
}

//---------------------------------------------------------------------------------
// OnLdStatusChanged
//---------------------------------------------------------------------------------
void CJobsTabMainView::OnLdStatusChanged( WPARAM wParam, LPARAM lParam )
{
	if( !m_bInitialUpdateComp) return;

	if( lParam == 0 ) 
	{
		for( int i=0; i<MAX_PORT_NO; i++ ) SetLdState( i, ( int ) wParam );
	}
	else SetLdState( lParam - 1, ( int ) wParam );
}
// 2005.04.04 Yougnsik
//---------------------------------------------------------------------------------
// OnTrPosSensorStatusChanged => TR Hand Position Sensor Status
//---------------------------------------------------------------------------------
void CJobsTabMainView::OnTrPosSensorStatusChanged( WPARAM wParam, LPARAM lParam )
{
	if( !m_bInitialUpdateComp ) return;

#ifdef _LTYPE
	int nIndex = (int)lParam;
#else
	int nIndex = 2 - (int)lParam;
#endif

	if( wParam )
	{
		m_gridTrPos.SetRow( 0 );
		m_gridTrPos.SetCol( nIndex );
		m_gridTrPos.SetCellBackColor( ORANGE_COLOR );
	}
	else
	{
		m_gridTrPos.SetRow( 0 );
		m_gridTrPos.SetCol( nIndex );
		m_gridTrPos.SetCellBackColor( WHITE_COLOR );
	}
}

// 2005.04.04 Yougnsik
//---------------------------------------------------------------------------------
// OnTrAreaSensorStatusChanged => TR Hand Area Sensor Status
//---------------------------------------------------------------------------------
void CJobsTabMainView::OnTrAreaSensorStatusChanged( WPARAM wParam, LPARAM lParam )
{
//	if( !m_bInitialUpdateComp ) return;
//
//	if( wParam )
//	{
//		m_gridTrArea.SetRow( 0 );
//		m_gridTrArea.SetCol( lParam );
//		m_gridTrArea.SetCellBackColor( ORANGE_COLOR );
//	}
//	else
//	{
//		m_gridTrArea.SetRow( 0 );
//		m_gridTrArea.SetCol( lParam );
//		m_gridTrArea.SetCellBackColor( WHITE_COLOR );
//	}
}



// kjd
//---------------------------------------------------------------------------------
// OnBrokenSensorStatusChanged
//---------------------------------------------------------------------------------
void CJobsTabMainView::OnBrokenSensorStatusChanged( WPARAM wParam, LPARAM lParam )
{
	if( !m_bInitialUpdateComp ) return;
	if ( lParam < MAX_GLS_BROKEN_SENSOR_NO ) SetColorStatic( m_stcBrokenSensor[lParam], (BOOL)wParam );
	else
	{
		SetColorStatic( m_stcGlassInterlockSensor[lParam - MAX_GLS_BROKEN_SENSOR_NO], (BOOL)wParam );
	}
}

void CJobsTabMainView::OnBrokenScanStatusChanged( WPARAM wParam, LPARAM lParam )
{
	if( lParam == 0 )
		m_msgBrokenSensor[0].SetOpMsg( (( CDicsView*)  m_pView)->m_pDicsData->m_IfScan.sStatus[lParam] );
	else if( lParam == 1 )
		m_msgBrokenSensor[1].SetOpMsg( (( CDicsView*)  m_pView)->m_pDicsData->m_IfScan.sStatus[lParam] );
	else	// 121002 halesu
		m_msgBrokenSensor[2].SetOpMsg( (( CDicsView*)  m_pView)->m_pDicsData->m_IfScan.sStatus[lParam] );
}



void CJobsTabMainView::OnAgingModeStatusChanged( WPARAM wParam, LPARAM lParam )
{
	static UINT nMode = -1;
	if ( nMode == wParam ) return;

	if ( wParam == MODE_NONE ) 
	{
		m_msgAging.SetBgColor( LIGHT_GRAY );
		m_msgAging.SetOpMsg(" ");
		GetDlgItem( IDC_MSG_AGING )->ShowWindow( SW_HIDE );
	}
	else if  ( wParam == MODE_AGING ) 
	{
		m_msgAging.SetBgColor( LIGHT_BLUE_COLOR );
		m_msgAging.SetTextColor( BLUE_COLOR );
		m_msgAging.SetOpMsg("AGING MODE");
	}
	else if  ( wParam == MODE_CLEAN_OUT ) 
	{
		m_msgAging.SetBgColor( CYAN_COLOR );
		m_msgAging.SetTextColor( RED_COLOR );
		m_msgAging.SetOpMsg("CLEAN OUT MODE");
	}
	else if( wParam == MODE_UL_TIME_OUT )
	{
		m_msgAging.SetBgColor( CYAN_COLOR );
		m_msgAging.SetTextColor( RED_COLOR );
		m_msgAging.SetOpMsg( "Unloading Timeout" );
	}
	else if( wParam == MODE_DI_AK_ECO )	// 240730 halesu
	{
		m_msgAging.SetBgColor( CYAN_COLOR );
		m_msgAging.SetTextColor( RED_COLOR );
		m_msgAging.SetOpMsg( "DI+AK ECO Mode" );
	}
	else if( wParam == MODE_DI_ECO )	// 240730 halesu
	{
		m_msgAging.SetBgColor( CYAN_COLOR );
		m_msgAging.SetTextColor( RED_COLOR );
		m_msgAging.SetOpMsg( "DI ECO Mode" );
	}
	else if( wParam == MODE_AK_ECO )	// 240730 halesu
	{
		m_msgAging.SetBgColor( CYAN_COLOR );
		m_msgAging.SetTextColor( RED_COLOR );
		m_msgAging.SetOpMsg( "AK ECO Mode" );
	}

	nMode = wParam;
}

//---------------------------------------------------------------------------------
// ljy_050406 : OnDoorOpenChanged
//---------------------------------------------------------------------------------
void CJobsTabMainView::OnLdDoorOpenChanged( WPARAM wParam, LPARAM lParam )
{
//	if( !m_bInitialUpdateComp ) return;

//	SetColorStatic( m_stcLdDoor[lParam], (BOOL)wParam, RED_COLOR );
}

void CJobsTabMainView::OnUlDoorOpenChanged( WPARAM wParam, LPARAM lParam )
{
//	if( !m_bInitialUpdateComp ) return;

//	SetColorStatic( m_stcUlDoor[lParam], (BOOL)wParam, RED_COLOR );
}

void CJobsTabMainView::OnPosSensorStatusChanged( WPARAM wParam, LPARAM lParam )
{
	if( !m_bInitialUpdateComp) return;

	if( lParam == 0 || lParam == 1 )
	{

		if( wParam )
		{
			m_gridLdUpZ.SetRow( lParam );
			m_gridLdUpZ.SetCol( 0 );
			m_gridLdUpZ.SetCellBackColor( ORANGE_COLOR );			
		}
		else
		{
			m_gridLdUpZ.SetRow( lParam );
			m_gridLdUpZ.SetCol( 0 );
			m_gridLdUpZ.SetCellBackColor( WHITE_COLOR );
		}
	}
#ifndef _NO_UL_HAND
	else if( lParam == 2 || lParam == 3 || lParam == 4 )	// UL Hand Unit
	{
		if( wParam )
		{
			m_gridUlHandZ.SetRow( lParam - 2);
			m_gridUlHandZ.SetCol( 0 );
			m_gridUlHandZ.SetCellBackColor( ORANGE_COLOR );			
		}
		else
		{
			m_gridUlHandZ.SetRow( lParam - 2);
			m_gridUlHandZ.SetCol( 0 );
			m_gridUlHandZ.SetCellBackColor( WHITE_COLOR );
		}
	}
#endif
}

UINT CJobsTabMainView::GetEuvTime( int i )
{
	return (UINT) m_nEuvHour[i] * 3600 + (UINT) m_nEuvMin[i] * 60 + (UINT) m_nEuvSec[i];
}

//---------------------------------------------------------------------------
// OnMsgBoxClicked
//---------------------------------------------------------------------------
void CJobsTabMainView::OnMsgBoxClicked( WPARAM wParam, LPARAM lParam )
{	
	if( wParam == 103 )			// Current Glass No
	{
		if( AfxMessageBox( "Do you want to reset the counter of glass number?", MB_YESNO ) == IDYES )
		{
			m_IniConfiguration.Open( "ProcessData", "Config" );
			m_nCurGlassNo = 0;
			CString sMessage;
			sMessage.Format( "%d EA", m_nCurGlassNo );
			m_msgCurGlassNo.SetOpMsg( sMessage );
			m_IniConfiguration.SetIntValue( "EQP GLASS COUNT", "Current Glass Count", m_nCurGlassNo );
		}
		return;
	}

/*
		if( wParam == 105 || wParam == 106 / *|| wParam == 107 || wParam == 108 || wParam == 109* / )
		{
			CDlgEuvTime dlg;
			dlg.m_nHour1 = m_nEuvHour[0];
			dlg.m_nMin1 = m_nEuvMin[0];
			dlg.m_nSec1 = m_nEuvSec[0];
			dlg.m_nHour2 = m_nEuvHour[1];
			dlg.m_nMin2 = m_nEuvMin[1];
			dlg.m_nSec2 = m_nEuvSec[1];
	//		dlg.m_nHour3 = m_nEuvHour[2];
	//		dlg.m_nMin3 = m_nEuvMin[2];
	//		dlg.m_nSec3 = m_nEuvSec[2];
	//		dlg.m_nHour4 = m_nEuvHour[3];
	//		dlg.m_nMin4 = m_nEuvMin[3];
	//		dlg.m_nSec4 = m_nEuvSec[3];
	//		dlg.m_nHour5 = m_nEuvHour[4];
	//		dlg.m_nMin5 = m_nEuvMin[4];
	//		dlg.m_nSec5 = m_nEuvSec[4];
	
			CDicsView* pView = (CDicsView*) m_pView;
			dlg.m_bPermitAccess = ( m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) ? FALSE : TRUE;
			if( dlg.DoModal() == IDOK )
			{
				m_nEuvHour[0] = dlg.m_nHour1;
				m_nEuvMin[0] = dlg.m_nMin1;
				m_nEuvSec[0] = dlg.m_nSec1;
				m_nEuvHour[1] = dlg.m_nHour2;
				m_nEuvMin[1] = dlg.m_nMin2;
				m_nEuvSec[1] = dlg.m_nSec2;
	//			m_nEuvHour[2] = dlg.m_nHour3;
	//			m_nEuvMin[2] = dlg.m_nMin3;
	//			m_nEuvSec[2] = dlg.m_nSec3;
	//			m_nEuvHour[3] = dlg.m_nHour4;
	//			m_nEuvMin[3] = dlg.m_nMin4;
	//			m_nEuvSec[3] = dlg.m_nSec4;
	//			m_nEuvHour[4] = dlg.m_nHour5;
	//			m_nEuvMin[4] = dlg.m_nMin5;
	//			m_nEuvSec[4] = dlg.m_nSec5;
	
				for( int i=0; i<MAX_LAMP_NO; i++ )
				{
					m_pDicsData->m_IfEuv.nLampOnTime[i] = GetEuvTime( i );
					
					// Write to profile
					CString sName;
					sName.Format( "LAMP ON TIME%d", i + 1 );
					AfxGetApp()->WriteProfileInt( "DICS EUV", sName, m_pDicsData->m_IfEuv.nLampOnTime[i] );
	
					CString sMessage;
					sMessage.Format( "%02d:%02d:%02d", m_nEuvHour[i], m_nEuvMin[i], m_nEuvSec[i] );
					m_msgEuvTime[i].SetOpMsg( sMessage );
				}
			}
			return;
		}*/
	
}

//--------------------------------------------------------------------
// Description : Show the Glass information about each part
//--------------------------------------------------------------------
void CJobsTabMainView::OnCvInfo( UINT nID ) 
{
	CString sTitle[] = 
	{
		"UP LD UNIT Glass Information",
		"BUF1 UNIT Glass Information",
		"BUF2 UNIT Glass Information",
		"BUF3 UNIT Glass Information",
		"LD UNIT Glass Information",
		"EUV UNIT Glass Information",
		"R/B UNIT Glass Information",
		"F/R UNIT Glass Information",
		"A/K UNIT Glass Information",
		"UL UNIT Glass Information",
		"UL HAND UNIT Glass Information",
	};

	CString sMessage;
	int id = nID - IDC_SUB_UNIT1_1;
	CDicsView* pView = ( (CDicsView*) m_pView);
	CMainSeq* pMainSeq = pView->m_pMainSeq;	
	if( !m_pDicsData->m_GenInfo.bAuto && 
		!m_pDicsData->m_GlsInfo[id].bIsValid && 
		m_bCreateGlassData[id] &&
		( id == IF_UNIT_LD*2 + 0 ) )
	{
//		if( AfxMessageBox( "Do you want to recovery lost data?", 
//			MB_YESNO | MB_ICONQUESTION ) == IDYES ) 
//		{
//			CDlgLostGlassList dlg;
//			int nRv=0;
//			if( ( nRv = dlg.DoModal() ) == IDOK ) return;
//			else if( nRv == IDC_LOST_DATA_RECOVERY )
//			{
//				m_pDicsData->m_IfCim.nRecoveryUnitNo = id;
//				m_pDicsData->m_IfCim.nRecoveryListNo = dlg.m_nSelectNo;
//				m_pDicsData->m_GlsInfoRecovery = dlg.m_RecoverGlsInfo;
//				m_pDicsData->m_IfCim.bGlassDataRecoveryReq = TRUE;
//			}
//		}
		if( AfxMessageBox( "Do you want to Create Glass data?", 
			MB_YESNO | MB_ICONQUESTION ) == IDYES ) 
		{
			if( m_pDicsData->m_GenInfo.nGlassNo >= 
				atoi( ((CDicsView*)m_pView)->GetDocument()->m_pSetupItems->m_sValueSetup[CSetupItems::setupMAX_GLASS_NO] ) )
			{
				AfxMessageBox( "It's denied Trying put over than capacity of CLN.\nCannot Make any more Glass Data. " );
				return;
			}
			CDlgKeyPad dlg;
			
			dlg.m_nGlassData[0] = 0x0;
			dlg.m_nGlassData[1] = 0x0;
			dlg.m_nGlassData[2] = 0x01;
			dlg.m_nGlassData[3] = 0x0;
			dlg.m_nGlassData[4] = 0x0;
	
			if( dlg.DoModal() == IDOK )
			{
				m_pDicsData->m_GlsInfoRecovery.nGlassData[0] = dlg.m_nGlassData[0];
				m_pDicsData->m_GlsInfoRecovery.nGlassData[1] = dlg.m_nGlassData[1];
				m_pDicsData->m_GlsInfoRecovery.nGlassData[2] = dlg.m_nGlassData[2];
//				m_pDicsData->m_GlsInfoRecovery.sSptRecipeId  = dlg.m_sEdit[3];
				m_pDicsData->m_GlsInfoRecovery.nGlassData[4] = dlg.m_nGlassData[4];
			}

			sMessage.Format("%s Glass Data Created : %04X %04X %04X %s %04X",
				sTitle[id/2],
				m_pDicsData->m_GlsInfo[id].nGlassData[0],
				m_pDicsData->m_GlsInfo[id].nGlassData[1],
				m_pDicsData->m_GlsInfo[id].nGlassData[2],
//				m_pDicsData->m_GlsInfo[id].sSptRecipeId,
				m_pDicsData->m_GlsInfo[id].nGlassData[4]);
			pView->SetLog("CREATE  ", 0, 0, sMessage );

			m_pDicsData->ParseGlassData( m_pDicsData->m_GlsInfo[id], 
				m_pDicsData->m_GlsInfoRecovery.nGlassData );
			
			int nGlassNo = m_pDicsData->FindGlassNo();
			m_pDicsData->m_GlsInfo[id].nGlassNo = nGlassNo;
			m_pDicsData->m_GlsInfo[id].bIsValid = TRUE;

			m_pDicsData->WriteProfileGlassData( id );
			SetCvState( id, TRUE, m_pDicsData->m_GlsInfo[id].nSlotNo, m_pDicsData->m_GlsInfo[id].nPortNo );

			m_pDicsData->m_GenInfo.nGlassNo += 1;
			SetGlassNo( m_pDicsData->m_GenInfo.nGlassNo, 1 );

			m_bCreateGlassData[id] = FALSE;

			m_pDicsData->m_GlsInfoRecv = m_pDicsData->m_GlsInfo[id];
/*			m_pDicsData->m_GlsInfo[id].sSlotNo = "";
			m_pDicsData->m_GlsInfo[id].sPortNo = "";
			m_pDicsData->m_GlsInfo[id].sRecipeId = "";	
			m_pDicsData->m_GlsInfo[id].sLotId = "";	    
			m_pDicsData->m_GlsInfo[id].sCassetteId = "";
			m_pDicsData->m_GlsInfo[id].sProdId = "";	
			m_pDicsData->m_GlsInfo[id].sGlassId = "";	
			m_pDicsData->m_IfCim.sOperatorId = ""; */
			m_pDicsData->m_GlsInfo[id].nPortNo			= 0;
			m_pDicsData->m_GlsInfo[id].nSlotNo			= 0;
			m_pDicsData->m_GlsInfo[id].sRecipeId	    	= "";
			m_pDicsData->m_GlsInfo[id].sWaferId			= "";
			m_pDicsData->m_GlsInfo[id].sLotId			= "";
			m_pDicsData->m_GlsInfo[id].sCassetteId		= "";
			m_pDicsData->m_GlsInfo[id].sGlassId			= "";
			m_pDicsData->m_GlsInfo[id].sOperationId		= "";
			m_pDicsData->m_GlsInfo[id].sOperationNo		= "";

			if( id == IF_UNIT_LD*2 + 0 )
			{
				m_pDicsData->m_GenInfo.bCycleStop = TRUE;

#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugInSensor[id/2+id%2] = TRUE;
#endif
				pMainSeq->m_pGlassAni->StartGlassMove( nGlassNo );
				if( m_pDicsData->m_IfFlag[IF_UNIT_LD].bSendPosComp )
				pMainSeq->m_pGlassAni->GlassMoveRegion( nGlassNo, id + 2, TRUE );
				else pMainSeq->m_pGlassAni->GlassMoveRegion( nGlassNo, id, TRUE );
				m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateSTOP] = 1;

				pView->m_pCvSeq->m_nSeqInSensorNo[IF_UNIT_LD] = 0;
				pView->m_pCvSeq->m_nSeqUnitLdNo = 0;
			}
		}
	}
	
	BOOL bIsValid = m_pDicsData->m_GlsInfo[id].bIsValid;
	if( bIsValid )
	{
		//CDialogGlassInfo dlg;
		CDlgGlassInfo dlg;
		dlg.SetData( m_pDicsData );
		dlg.m_sTitle = sTitle[id / 2];
		dlg.m_nGlassInfoNo = id;
		dlg.m_GlsInfo = m_pDicsData->m_GlsInfo[id];
		m_pDicsData->m_IfCim.nSelectedOpIdNo = id;

		if( ( !m_pDicsData->m_GenInfo.bAuto || m_pDicsData->m_GenInfo.bPause ) &&
			m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP ) dlg.m_bPermitAccess = TRUE;
		else dlg.m_bPermitAccess = FALSE;
		// TODO: Glass Data Items Editing here
/*		dlg.m_sGlassData[0]	= m_pDicsData->m_GlsInfo[id].sSlotNo;			
		dlg.m_sGlassData[1]	= m_pDicsData->m_GlsInfo[id].sRecipeId;			
		dlg.m_sGlassData[2]	= m_pDicsData->m_GlsInfo[id].sLotId;	    	
		dlg.m_sGlassData[3]	= m_pDicsData->m_GlsInfo[id].sCassetteId;			
		dlg.m_sGlassData[4]	= m_pDicsData->m_GlsInfo[id].sProdId	;	
		dlg.m_sGlassData[5]	= m_pDicsData->m_GlsInfo[id].sGlassId;		
		dlg.m_sGlassData[6]	= m_pDicsData->m_GlsInfo[id].sPortNo;
		dlg.m_sGlassData[7] = m_pDicsData->m_IfCim.sOperatorId; */
#ifndef _SPT_TYPE //2008.11.17 kimgun
		dlg.m_sGlassData[0].Format( "%d", m_pDicsData->m_GlsInfo[id].nPortNo );
		dlg.m_sGlassData[1] = m_pDicsData->m_GlsInfo[id].sCassettePortNo;
		dlg.m_sGlassData[2].Format( "%d", m_pDicsData->m_GlsInfo[id].nSlotNo );
		dlg.m_sGlassData[3]	= m_pDicsData->m_GlsInfo[id].sRecipeId;			
		dlg.m_sGlassData[4]	= m_pDicsData->m_GlsInfo[id].sWaferId;	    	
		dlg.m_sGlassData[5]	= m_pDicsData->m_GlsInfo[id].sLotId;
		dlg.m_sGlassData[6]	= m_pDicsData->m_GlsInfo[id].sCassetteId	;	
		dlg.m_sGlassData[7]	= m_pDicsData->m_GlsInfo[id].sGlassId;
#ifndef _MY_DEBUG
		dlg.m_sGlassData[8] = m_pDicsData->m_GlsInfo[id].sOperationId;
		dlg.m_sGlassData[9] = m_pDicsData->m_GlsInfo[id].sOperationNo;
#else
// 		dlg.m_sGlassData[8] = m_pDicsData->m_GlsInfo[id].sGlassHeadPos;
// 		dlg.m_sGlassData[9] = m_pDicsData->m_GlsInfo[id].sGlassTailPos;
		dlg.m_sGlassData[8] = m_pDicsData->m_GlsInfo[id].sOperationId;
		dlg.m_sGlassData[9] = m_pDicsData->m_GlsInfo[id].sOperationNo;
#endif
#else
		dlg.m_sGlassData[0].Format( "%d", m_pDicsData->m_GlsInfo[id].nPortNo );
		dlg.m_sGlassData[1].Format( "%d", m_pDicsData->m_GlsInfo[id].nSlotNo );
		dlg.m_sGlassData[2]	= m_pDicsData->m_GlsInfo[id].sRecipeId;	
		dlg.m_sGlassData[3]	= m_pDicsData->m_GlsInfo[id].sWaferId;	  		
		dlg.m_sGlassData[4]	= m_pDicsData->m_GlsInfo[id].sLotId;  	
		dlg.m_sGlassData[5]	= m_pDicsData->m_GlsInfo[id].sCassetteId	;
		dlg.m_sGlassData[6]	= m_pDicsData->m_GlsInfo[id].sGlassId;	
#ifndef _MY_DEBUG
		dlg.m_sGlassData[7] = m_pDicsData->m_GlsInfo[id].sOperationId;
		dlg.m_sGlassData[8] = m_pDicsData->m_GlsInfo[id].sOperationNo;
#else
		dlg.m_sGlassData[7] = m_pDicsData->m_GlsInfo[id].sOperationId;
		dlg.m_sGlassData[8] = m_pDicsData->m_GlsInfo[id].sOperationNo;
// 		dlg.m_sGlassData[7] = m_pDicsData->m_GlsInfo[id].sGlassHeadPos;
// 		dlg.m_sGlassData[8] = m_pDicsData->m_GlsInfo[id].sGlassTailPos;
#endif
#endif
		// TODO: Glass Data Items Editing here
		
		int iRv;
		if( ( iRv = dlg.DoModal() ) == IDC_DELETE ) 
		{
			// Glass Data Delete
			int nRes = pView->GlassInfoDelete( id );
		
//			if( AfxMessageBox( "Do you want to report the glass scrap information?", MB_YESNO ) == IDYES ) 
//			{
//				m_pMainSeq->m_Scrap.nPart = id % 2;
//				m_pMainSeq->m_Scrap.nUnit = id / 2;
//				m_pMainSeq->m_Scrap.bOn = TRUE;
//			}

			// deletion => impossible
			if( nRes == CDicsView::dmSENSED_GLASS )
				AfxMessageBox( "Delete Failed : Glass is still sensing ", MB_OK );
			else
			{
				m_pDicsData->m_IfLoader.bScrapReq = TRUE;
				m_pDicsData->m_IfLoader.nScrapSlotNo = atoi(dlg.m_sGlassData[0]);
				m_pDicsData->m_IfLoader.nScrapPortNo = atoi(dlg.m_sGlassData[6]);
			}
		}
		else if( iRv == IDC_FORCE_DEL )
		{
			pView->GlassInfoDelete( id );
			//////////////////////////////////////////////////////////////////////////
			//Glass Data  s6f11 ġ UL Ͽ S6f1 ߴ
			{
				pView->m_pHost1->S6F11( IF_UNIT_UL );
				//m_pHost1->m_bEventReportReq[IF_UNIT_UL] = TRUE;//2008.11.07 kimgun
				pView->SetLog( "GLS_DELE", atoi(dlg.m_sGlassData[0]), atoi(dlg.m_sGlassData[1]), "Glass_In Event Report" );
			}
			//////////////////////////////////////////////////////////////////////////
			sMessage.Format("%s %d Data Forced Delete : %04X %04X", sTitle[id/2], id/2,
				m_pDicsData->m_GlsInfo[id].nGlassData[0], m_pDicsData->m_GlsInfo[id].nGlassData[1] );
			pView->SetLog("FORCEDEL", 0, 0, sMessage );
		}
		else if( iRv == IDC_EDIT )
		{
			// TODO: Glass Data Items Editing here
/*			m_pDicsData->m_GlsInfo[id].sSlotNo			= dlg.m_sGlassData[0];
			m_pDicsData->m_GlsInfo[id].sRecipeId		= dlg.m_sGlassData[1];	
			m_pDicsData->m_GlsInfo[id].sLotId	  		= dlg.m_sGlassData[2];	
			m_pDicsData->m_GlsInfo[id].sCassetteId		= dlg.m_sGlassData[3];	
			m_pDicsData->m_GlsInfo[id].sProdId			= dlg.m_sGlassData[4];	
			m_pDicsData->m_GlsInfo[id].sGlassId			= dlg.m_sGlassData[5];	
			m_pDicsData->m_GlsInfo[id].sPortNo			= dlg.m_sGlassData[6];
			m_pDicsData->m_IfCim.sOperatorId			= dlg.m_sGlassData[7]; */
#ifndef _SPT_TYPE //2008.11.17 kimgun
			m_pDicsData->m_GlsInfo[id].nPortNo			= atoi(dlg.m_sGlassData[0]);
			m_pDicsData->m_GlsInfo[id].sCassettePortNo	= dlg.m_sGlassData[1];
			m_pDicsData->m_GlsInfo[id].nSlotNo			= atoi(dlg.m_sGlassData[2]);
			m_pDicsData->m_GlsInfo[id].sCassetteSlotNo	= dlg.m_sGlassData[2];
			m_pDicsData->m_GlsInfo[id].sRecipeId	    = dlg.m_sGlassData[3];
			m_pDicsData->m_GlsInfo[id].sWaferId			= dlg.m_sGlassData[4];
			m_pDicsData->m_GlsInfo[id].sLotId			= dlg.m_sGlassData[5];
			m_pDicsData->m_GlsInfo[id].sCassetteId		= dlg.m_sGlassData[6];
			m_pDicsData->m_GlsInfo[id].sGlassId			= dlg.m_sGlassData[7];
			m_pDicsData->m_GlsInfo[id].sOperationId		= dlg.m_sGlassData[8];
			m_pDicsData->m_GlsInfo[id].sOperationNo		= dlg.m_sGlassData[9];
#else
			m_pDicsData->m_GlsInfo[id].nPortNo			= atoi(dlg.m_sGlassData[0]);
			m_pDicsData->m_GlsInfo[id].nSlotNo			= atoi(dlg.m_sGlassData[1]);
			m_pDicsData->m_GlsInfo[id].sRecipeId	    = dlg.m_sGlassData[2];
			m_pDicsData->m_GlsInfo[id].sWaferId			= dlg.m_sGlassData[3];
			m_pDicsData->m_GlsInfo[id].sLotId			= dlg.m_sGlassData[4];
			m_pDicsData->m_GlsInfo[id].sCassetteId		= dlg.m_sGlassData[5];
			m_pDicsData->m_GlsInfo[id].sGlassId			= dlg.m_sGlassData[6];
			m_pDicsData->m_GlsInfo[id].sOperationId		= dlg.m_sGlassData[7];
			m_pDicsData->m_GlsInfo[id].sOperationNo		= dlg.m_sGlassData[8];
#endif
			dlg.m_sGlassData[0];
			m_pDicsData->m_GlsInfo[id].sSlotNo = dlg.m_sGlassData[2];

			// TODO: Glass Data Items Editing here

			m_pDicsData->WriteProfileGlassData( id );
			int nSlotNo	= m_pDicsData->m_GlsInfo[id].nSlotNo;//2008.12.17 kimgun
			int nPortNo = m_pDicsData->m_GlsInfo[id].nPortNo;//2008.12.17 kimgun
			SetCvState( id, TRUE, nSlotNo, nPortNo );

			sMessage.Format("%s %d force Edit : %04X %04X", sTitle[id/2], id/2,
				m_pDicsData->m_GlsInfo[id].nGlassData[0], m_pDicsData->m_GlsInfo[id].nGlassData[1] );
			pView->SetLog("EDIT    ", 0, 0, sMessage );
		}
		else if( iRv == IDC_MOVE )
		{
			int nTargetCv = dlg.m_nTargetCv;
			int nRes = pView->GlassInfoMove( id, nTargetCv );

			if( nRes == CDicsView::dmDUP_DATA )
			{
				AfxMessageBox( "Move Failed : There is a glass data at target position", MB_OK );
			}
			else if( nRes == CDicsView::dmDENIED_LOGICALLY )
			{
				AfxMessageBox( "Move Failed : There is a glass at next target position", MB_OK );
			}
			else if( nRes == CDicsView::dmNOT_SENSED_GLASS )
			{
				AfxMessageBox( "Move Failed : There is no glass at target position", MB_OK );
			}
			else if( nRes == CDicsView::dmSENSED_GLASS )
			{
				AfxMessageBox( "Impossible Move : A glass is still sensed at original conveyor position.", MB_OK );
			}
			//2008.11.07 kimgun APC DATA Glass Head ġ  
			//////////////////////////////////////////////////////////////////////////
			if(nTargetCv/2 > IF_UNIT_LD)
				m_pDicsData->m_GlsInfo[nTargetCv].sGlassHeadPos.Format("%d",195 + nTargetCv/2 );
			//////////////////////////////////////////////////////////////////////////
			//2008.11.07 kimgun APC DATA Glass Tail ġ  
			//////////////////////////////////////////////////////////////////////////
			if(nTargetCv/2 > IF_UNIT_EUV)
			{
				for( int i = nTargetCv; i > IF_UNIT_LD * 2; i-- )
				{
					if( !m_pEqpAssy->m_GlassExistUnit.GetAnd(i) )
					{
						m_pDicsData->m_GlsInfo[nTargetCv].sGlassTailPos.Format("%d",195 + i/2 + 1 );
						break;
					}
				}
				if( i/2 < IF_UNIT_LD ) m_pDicsData->m_GlsInfo[nTargetCv].sGlassTailPos = "";
			}
			else m_pDicsData->m_GlsInfo[nTargetCv].sGlassTailPos = "";

	//////////////////////////////////////////////////////////////////////////
		}
	}
}

BEGIN_EVENTSINK_MAP(CJobsTabMainView, CFormView)
    //{{AFX_EVENTSINK_MAP(CJobsTabMainView)
	ON_EVENT(CJobsTabMainView, IDC_CV_MOTOR1, -600 /* Click */, OnClickCvMotor, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_EUV, -600 /* Click */, OnClickEuv, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_CV_MOTOR2, -600 /* Click */, OnClickCvMotor, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_CV_MOTOR3, -600 /* Click */, OnClickCvMotor, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_CV_MOTOR4, -600 /* Click */, OnClickCvMotor, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_CV_MOTOR5, -600 /* Click */, OnClickCvMotor, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_CV_MOTOR6, -600 /* Click */, OnClickCvMotor, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_CV_MOTOR7, -600 /* Click */, OnClickCvMotor, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_CV_MOTOR8, -600 /* Click */, OnClickCvMotor, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_CV_MOTOR9, -600 /* Click */, OnClickCvMotor, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_CV_MOTOR10, -600 /* Click */, OnClickCvMotor, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_CV_MOTOR11, -600 /* Click */, OnClickCvMotor, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_CV_MOTOR12, -600 /* Click */, OnClickCvMotor, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_RB_UNIT_RB1_LO, -600 /* Click */, OnClickRb, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_RB_UNIT_RB1_UP, -600 /* Click */, OnClickRb, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_RB_UNIT_RB2_LO, -600 /* Click */, OnClickRb, VTS_NONE)
	ON_EVENT(CJobsTabMainView, IDC_RB_UNIT_RB2_UP, -600 /* Click */, OnClickRb, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
	ON_EVENT_RANGE(CJobsTabMainView, IDC_ALIGN1, IDC_ALIGN4, -600 /* Click */, OnAlign, VTS_I2)
	ON_EVENT_RANGE(CJobsTabMainView, IDC_LD_TILT, IDC_UL_TILT, -600 /* Click */, OnTilt, VTS_I2)
	ON_EVENT_RANGE(CJobsTabMainView, IDC_UL_HAND_CYL1, IDC_UL_HAND_CYL2, -600 /* Click */, OnUlHand, VTS_I2)
END_EVENTSINK_MAP()

//---------------------------------------------------------------------------------
// OnClickCvMotor
//---------------------------------------------------------------------------------
void CJobsTabMainView::OnClickCvMotor() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CMainFrame* pMainFrame = (CMainFrame*)pApp->m_pMainWnd;
	if( pMainFrame->m_bAuto ) return;
	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	CDlgGridCvMotor dlg1;
	dlg1.SetDevice( ( (CDicsView*)m_pView )->m_pDevice );
	dlg1.SetSetupItems( pDoc->m_pSetupItems );
	dlg1.SetCvSeq( pDoc->m_pDicsView->m_pCvSeq );
	dlg1.SetCvSeq1( pDoc->m_pDicsView->m_pCvSeq1);
	dlg1.SetEqpAssy( m_pEqpAssy );
	dlg1.m_nMotorEA		= MAX_CV_MOTOR_NO;
#ifndef _NO_RB
	dlg1.m_sMotorName	= "UP LD;BUF1;BUF2;BUF3;LD;EUV;RB1;RB2;FR;AK1;AK2;UL; ";
#else
	dlg1.m_sMotorName	= "UP LD;BUF1;BUF2;BUF3;LD;EUV;SBJ;--;FR;AK1;AK2;UL; ";
#endif
	dlg1.SetSpeedRange( 600, 20000, 200 );
	dlg1.DoModal();

//	CDlgListCvMotor dlg2;
//	dlg2.m_nMotorEA		= MAX_CV_MOTOR_NO;
//	dlg2.m_sMotorName	= "LD;EUV;RB 1;RB 2;FR;AK 1;AK 2;UL;";
//	dlg2.SetDevice( m_pDevice );
//	dlg2.SetSetupItem( pDoc->m_pSetupItems );
//	dlg2.SetCvSeq( pDoc->m_pDicsView->m_pCvSeq );
//	dlg2.SetSpeedRange( 600, 6000, 300 );
//	dlg2.DoModal();
//
//
//	CDlgCvMotor dlg3;
//	dlg3.SetDevice( ( (CDicsView*)m_pView )->m_pDevice );
//	dlg3.SetSetupItems( pDoc->m_pSetupItems );
//	dlg3.SetCvSeq( pDoc->m_pDicsView->m_pCvSeq );
//	dlg3.DoModal();


//	for( int i = 0; i < MAX_CV_NO ; i++)
//	{
//		dlg.m_iRatio[i] = (int) pDoc->m_pSetupItems->m_fValueCvMotorRatio[i];
//	}
}

//---------------------------------------------------------------------------------
// OnClickEuv
//---------------------------------------------------------------------------------
void CJobsTabMainView::OnClickEuv() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CMainFrame* pMainFrame = (CMainFrame*)pApp->m_pMainWnd;
//	if( pMainFrame->m_bAuto ) return;
//	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;

#ifndef _NO_EUV
	( (CDicsView*)m_pView )->m_tabCtrl.SelectTab(CDicsView::viewJobEuv);
	( (CDicsView*)m_pView )->SendMessage(WM_SEL_CHANGE_TAB, CDicsView::viewJobEuv);
#endif
}

void CJobsTabMainView::OnClickRb() 
{
	if ( ((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto ) return;

	CDlgGridRollBrush dlg;
	dlg.SetDevice( ((CDicsView*)m_pView)->m_pDevice );
//	dlg.SetData( ((CDicsView*)m_pView)->m_pDicsData );
//	dlg.SetMmc( ((CDicsView*)m_pView)->m_pMmc );
	dlg.SetEqpAssy( m_pEqpAssy );
	dlg.SetRbSeq( ((CDicsView*)m_pView)->m_pRbSeq );
	dlg.m_nMotorEA		= MAX_RB_NO;
	dlg.m_sMotorName	= "RB1 UP;RB1 LO;RB2 UP;RB2 LO;";
	dlg.SetSpeedRange( 100, 400, 100 );
	dlg.DoModal();
}


void CJobsTabMainView::OnClickFishRib() 
{
/*	if( !( (CDicsView*)m_pView )->m_pDicsData->m_GenInfo.bAuto &&
		( (CDicsView*)m_pView )->m_pDicsData->m_LoginInfo.nCurUserLevel >= CDicsData::idMAINT )
	{	
		CDlgFishRib dlg;
		dlg.m_nDlgUnitNo = IF_UNIT_LD_FISH;
		dlg.SetDevice( ( (CDicsView*)m_pView )->m_pDevice );
		dlg.DoModal();
	} */
}


/*
//---------------------------------------------------------------------------------
// Loading C/V Aligner Operating Dialog
//---------------------------------------------------------------------------------
void CJobsTabMainView::OnUnit4() 
{
	// TODO: Add your control notification handler code here

	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;

	CDlgLdAlign dlg;
	dlg.SetDicsData( ( (CDicsView*)m_pView )->m_pDicsData );
	dlg.SetDevice( ( (CDicsView*)m_pView )->m_pDevice );
	dlg.DoModal();
	
}
*/
// ljy_050220 : CJobsTabMainView -> 04HC30   Ϸ(1).

void CJobsTabMainView::UpdateObjects()
{
	UpdateCvMotor();
	UpdateLeakSensor();
	UpdateCoverOpen();
	UpdateDoorOpen();
	UpdateGlassExistSensor();
#ifndef _NO_RB
	UpdateRollBrush();
#endif
	UpdateTrSensor();
	UpdatePositionSensor();
	UpdateBrokenSensor();
	UpdateGlassData();
	UpdateGlassDataCreate();
	UpdateLdUnitAlign();
	UpdateEuv();
	UpdateTiltSensor();
	UpdateUlUnitCylinder();
	UpdateLdUnitStatus();
	UpdateLoaderRobotHand();
}

//--------------------------------------------------------------------
// Monitoring the C/V Motor
//--------------------------------------------------------------------
void CJobsTabMainView::UpdateCvMotor()
{
	static int nOldStatus[MAX_CV_MOTOR_NO] = { 0, };
	static BOOL bOldOffStatus[MAX_CV_MOTOR_NO] = { FALSE, };
	static BOOL bOldAlarmStatus[MAX_CV_MOTOR_NO] = { FALSE, };

	BOOL bA, bB, bC, bD;
	bA = bB = bC = bD = FALSE;
	for( int i = 0 ; i < MAX_CV_MOTOR_NO ; i ++ )
	{
		bA = m_pEqpAssy->m_CvMotorAll.GetMotorFwState( i );
		bB = m_pEqpAssy->m_CvMotorAll.GetMotorBwState( i );
#ifndef _MY_DEBUG
		bC = m_pEqpAssy->m_CvMotorAll.GetMotorAlarm( i );
		bD = m_pEqpAssy->m_CvMotorAll.GetMotorCpAlarm( i );
#else
		bC = FALSE;
		bD = FALSE;
#endif
		if( !bOldOffStatus[i] && bD )
		{
			bOldOffStatus[i] = TRUE;
			m_ocxCvMotor[i].SetOff();
		}
		else if( bOldOffStatus[i] && !bD )
		{
			bOldOffStatus[i] = FALSE;
			m_ocxCvMotor[i].ResetOff();
		}
		if( bD ) continue;

		if( !bOldAlarmStatus[i] && bC )
		{
			bOldAlarmStatus[i] = TRUE;
			m_ocxCvMotor[i].SetAlarm();
		}
		else if( bOldAlarmStatus[i] && !bC )
		{
			bOldAlarmStatus[i] = FALSE;
			m_ocxCvMotor[i].ResetAlarm();
		}
		if( bC ) continue;

		if( ( nOldStatus[i] != -1 ) && bA && !bB ) 
		{
			nOldStatus[i] = -1;
#ifndef _LTYPE
			if( i < ( MAX_UP_CV_NO - 1 ) ) m_ocxCvMotor[i].SetStartCw();
			else m_ocxCvMotor[i].SetStartCcw();
#else
			if( i < ( MAX_UP_CV_NO - 1 ) ) m_ocxCvMotor[i].SetStartCcw();
			else m_ocxCvMotor[i].SetStartCw();
#endif
		}
		else if( ( nOldStatus[i] != 0 ) && !bA && !bB ) 
		{
			
			nOldStatus[i] = 0;
			m_ocxCvMotor[i].SetStop();
		}
		else if( ( nOldStatus[i] != 1 ) && !bA && bB ) 
		{
			nOldStatus[i] = 1;
#ifndef _LTYPE
			if( i < ( MAX_UP_CV_NO - 1 ) ) m_ocxCvMotor[i].SetStartCcw();
			else m_ocxCvMotor[i].SetStartCw();
#else
			if( i < ( MAX_UP_CV_NO - 1 ) ) m_ocxCvMotor[i].SetStartCw();
			else m_ocxCvMotor[i].SetStartCcw();
#endif
		}
	}
}

void CJobsTabMainView::UpdateLeakSensor()
{
	static BOOL bOldLeakSensorState[MAX_LEAK_SENSOR_NO] = { FALSE, };

	for( int i = 0 ; i < m_pEqpAssy->m_SensorLeak.GetDiSize(); i ++ )
	{
		if( !bOldLeakSensorState[i] && m_pEqpAssy->m_SensorLeak.Get( i ) )
		{
			bOldLeakSensorState[i] = TRUE; 
			SetColorStatic( m_stcLeak[i], TRUE, CYAN_COLOR );
		}
		if( bOldLeakSensorState[i] && !m_pEqpAssy->m_SensorLeak.Get( i ) )
		{
			bOldLeakSensorState[i] = FALSE; 
			SetColorStatic( m_stcLeak[i], FALSE, CYAN_COLOR );
		}
	}
}

void CJobsTabMainView::UpdateCoverOpen()
{
	static BOOL bOldCoverOpenState[MAX_COVER_OPEN_NO] = { FALSE, };

	for( int i = 0 ; i < m_pEqpAssy->m_SensorCover.GetDiSize(); i ++ )
	{
		BOOL bCoverOpenState = bOldCoverOpenState[i];
		BOOL bCover			 = m_pEqpAssy->m_SensorCover.Get( i );
		if( !bOldCoverOpenState[i] && bCover )
		{
			bOldCoverOpenState[i] = TRUE; 
			SetColorStatic( m_stcCoverOpen[i], TRUE, RED_COLOR );
		}
		if( bOldCoverOpenState[i] && !bCover )
		{
			bOldCoverOpenState[i] = FALSE; 
			SetColorStatic( m_stcCoverOpen[i], FALSE, RED_COLOR );
		}
	}
}

void CJobsTabMainView::UpdateGlassExistSensor()
{
	// Existence Sensor
	static BOOL bOldExistSensorState[MAX_GLS_EXIST_SENSOR_NO] = { FALSE, };
	static BOOL bOldInterlockSensorState = FALSE;
	
	COLORREF OnColor/*, OffColor*/;
	for( int i=0; i < MAX_GLS_EXIST_SENSOR_NO; i++ )
	{
#ifdef _MY_DEBUG
		BOOL bSensor;
		if(i%2 == 0) bSensor = m_pDicsData->m_bDebugInSensor[i/2];
		else bSensor = m_pDicsData->m_bDebugOutSensor[i/2];
		if( !bOldExistSensorState[i] && bSensor )
#else
		if( !bOldExistSensorState[i] && m_pEqpAssy->m_GlassExistUnit.GetAnd( i ) )
#endif
		{
			bOldExistSensorState[i] = TRUE; 
			if( i & 0x01 ) // Out Sensor
			{
				if( m_pDicsData->m_IfFlag[i/2].bOutSick ) OnColor = RED_COLOR;
				else OnColor = GREEN_COLOR;
			}
			else
			{
				if( m_pDicsData->m_IfFlag[i/2].bInSick ) OnColor = RED_COLOR;
				else OnColor = GREEN_COLOR;
			}
			SetColorStatic( m_stcGlsExistSensor[i], TRUE, OnColor );
		}
#ifdef _MY_DEBUG
		else if( bOldExistSensorState[i] && !bSensor )
#else
		else if( bOldExistSensorState[i] && !m_pEqpAssy->m_GlassExistUnit.GetAnd( i ) ) 
#endif
		{ 
			bOldExistSensorState[i] = FALSE; 
			if( i & 0x01 ) // Out Sensor
			{
				if( m_pDicsData->m_IfFlag[i/2].bOutSick ) OnColor = RED_COLOR;
				else OnColor = GREEN_COLOR;
			}
			else
			{
				if( m_pDicsData->m_IfFlag[i/2].bInSick ) OnColor = RED_COLOR;
				else OnColor = GREEN_COLOR;
			}
			SetColorStatic( m_stcGlsExistSensor[i], FALSE, OnColor );
		}
	}

	if( m_pEqpAssy->m_SensorBuf3Interlock.GetAnd() && !bOldInterlockSensorState )
	{
		OnColor = GREEN_COLOR;
		bOldInterlockSensorState = TRUE;
		SetColorStatic( m_stcGlsExistInterlock, TRUE, OnColor );
	}
	else if( !m_pEqpAssy->m_SensorBuf3Interlock.GetAnd() && bOldInterlockSensorState )
	{
		OnColor = GREEN_COLOR;
		bOldInterlockSensorState = FALSE;
		SetColorStatic( m_stcGlsExistInterlock, FALSE, OnColor );
	}
}

void CJobsTabMainView::UpdateRollBrush()
{

	static int nOldRBStatus[MAX_RB_NO] ={ 0, };
	BOOL bA, bB, bC, bD;
	bA = bB = bC = bD = FALSE;
	for( int i = 0; i < m_pEqpAssy->m_RbMotor.GetMaxSectionNo(); i ++ )
	{	

		bA = m_pEqpAssy->m_RbMotor.GetMotorFwState( i );
		bB = m_pEqpAssy->m_RbMotor.GetMotorBwState( i );
#ifndef _MY_DEBUG
//		bC = m_pEqpAssy->m_CvMotorAll.GetMotorAlarm( i );
//		bD = m_pEqpAssy->m_CvMotorAll.GetMotorCpAlarm( i );
		bC = m_pEqpAssy->m_RbMotor.GetMotorAlarm( i );
		bD = m_pEqpAssy->m_RbMotor.GetMotorCpAlarm( i );
#else
		bC = FALSE;
		bD = FALSE;
#endif
		if( ( bC || bD || (!bA && !bB) ) && ( nOldRBStatus[i] != 0 ) )
		{
			nOldRBStatus[i] = 0;
			m_ocxRollBrush[i].SetStop();
		}
		else if( !bC && !bD && bA && !bB && ( nOldRBStatus[i] != 1 ) )
		{
			nOldRBStatus[i] = 1;
			m_ocxRollBrush[i].SetCW();
			m_ocxRollBrush[i].SetRun();
		}
		else if( !bC && !bD && !bA && bB && ( nOldRBStatus[i] != 2 ))
		{
			nOldRBStatus[i] = 2;
			m_ocxRollBrush[i].SetCCW();
			m_ocxRollBrush[i].SetRun();
		}
	}

	RBT_POS rpPos[MAX_RB_GAP_SERVO_NO]	= { { 0, }, };
	UINT	nId[MAX_RB_GAP_SERVO_NO]	= { IDC_RB1_UP, IDC_RB1_LO, IDC_RB2_UP, IDC_RB2_LO, }; 
	for( i = 0 ; i < MAX_RB_GAP_SERVO_NO ; i++ )
	{
		CString sGap;
		double fGap = 0.0;
		
#ifndef _MY_DEBUG
		RBT_POS rpPos; 
		if( !m_pMmc->GetCurPosition( RBT_RB_UNIT_UP_RB1_UNIT+i, rpPos ) ) continue;
		fGap = rpPos.dPos[2] - m_pMmc->m_RbtInfo[RBT_RB_UNIT_UP_RB1_UNIT+i].pos[RBT_RB_ZERO_POS].dPos[2];
		sGap.Format( "%.2f mm", fGap );
		m_msgRbGap[i].SetOpMsg( sGap );
#else
		int nRefPos = ( (CDicsView*)m_pView )->m_pRbSeq->m_RbGap.nRefRbPosition[i];
		if( nRefPos == CDicsRbSeq::rbOFF )
		{
			fGap = -3.0;
		}
		else if( nRefPos == CDicsRbSeq::rbPROCESS )
		{
			fGap = m_pDicsData->m_JobCond.dRbGap[i];
			m_msgRbGap[i].SetOpMsg( "Gap POS" );
		}
		else if( nRefPos == CDicsRbSeq::rbWAIT )
		{
			fGap = -1.0;
			m_msgRbGap[i].SetOpMsg( "Wait POS" );
		}
#endif

//		sGap.Format( "%.1f mm", fGap );//JUN_MELSEC

//		SetDlgItemText( nId[i], sGap );//JUN_MELSEC
	}
}

void CJobsTabMainView::UpdateTrSensor()
{/*
	static BOOL	bOldTrAreaSensorState[MAX_TR_AREA_SENSOR + 1] = { FALSE, };
	static BOOL	bOldTrPosSensorState[MAX_TR_POS_SENSOR] = { FALSE, };
	static BOOL	bOldPositionSensorState[MAX_HAND_POS_SENSOR_NO] = { FALSE, };
	
	//TR Position Sensor
	for( int i = 0 ; i < MAX_TR_POS_SENSOR ; i++ )
	{
		if( !bOldTrPosSensorState[i] && digTR_UNIT_POS_SENSOR( i ) ) 
		{
			bOldTrPosSensorState[i] = TRUE;
			OnTrPosSensorStatusChanged( TRUE, i );
		}
		else if( bOldTrPosSensorState[i] && !digTR_UNIT_POS_SENSOR( i ) ) 
		{
			bOldTrPosSensorState[i] = FALSE;
			OnTrPosSensorStatusChanged( FALSE, i );
		}
	}

	//TR Area Sensor
/*	for( i = 0; i < MAX_TR_AREA_SENSOR + 1 ; i++ )
	{
		
		if( ( bOldTrAreaSensorState[i] != 1 ) && digTR_UNIT_AREA_SENSOR( i ) )
		{
			bOldTrAreaSensorState[i] = 1;
			OnTrAreaSensorStatusChanged( TRUE, i );
		}
		else if( ( bOldTrAreaSensorState[i] != 0 ) && !digTR_UNIT_AREA_SENSOR( i ) )
		{
			bOldTrAreaSensorState[i] = 0;
			OnTrAreaSensorStatusChanged( FALSE, i );
		}
	} */	
}

void CJobsTabMainView::UpdatePositionSensor()
{
	static BOOL	bSensorStatus[MAX_HAND_POS_SENSOR_NO] = { FALSE, };//2008.09.15 kimgun
	static BOOL bUlHandHomeStatus = FALSE;	
	//debug sensor ǥ
	BOOL bDebugSensorStatus[MAX_HAND_POS_SENSOR_NO] = {
	 ((CDicsView*)m_pView)->m_pMmc->GetCurPoint(0) == LD_UPDN_UNIT_RECV_POS,
	 ((CDicsView*)m_pView)->m_pMmc->GetCurPoint(0) == LD_UPDN_UNIT_SEND_POS,
	((CDicsView*)m_pView)->m_pMmc->GetCurPoint(1) == UL_HAND_UNIT_SEND_POS,
	((CDicsView*)m_pView)->m_pMmc->GetCurPoint(1) == UL_HAND_UNIT_AFTER_RECV_POS,
	((CDicsView*)m_pView)->m_pMmc->GetCurPoint(1) == UL_HAND_UNIT_BEFORE_RECV_POS,
	};
	for( int i = 0 ; i < m_pEqpAssy->m_PosSensorHandMainView.GetMaxSectionNo() ; i++ )
	{
#ifndef _MY_DEBUG
		BOOL bFlg = m_pEqpAssy->m_PosSensorHandMainView.GetAnd( i );
#else
		BOOL bFlg = bDebugSensorStatus[i];
#endif
		if( !bSensorStatus[i] && bFlg )
		{
			bSensorStatus[i] = TRUE;
			OnPosSensorStatusChanged( TRUE, i );
		}
		else if( bSensorStatus[i] && !bFlg )
		{
			bSensorStatus[i] = FALSE;
			OnPosSensorStatusChanged( FALSE, i );
		}
	} 
/*
#ifndef _NO_UL_HAND
	if( !bUlHandHomeStatus && ((CDicsView*)m_pView)->m_pMmc->GetHomeSwitch( RBT_UL_HAND_UNIT ) )
	{
		bUlHandHomeStatus = TRUE;
		m_gridUlHandZ.SetRow( 2 );
		m_gridUlHandZ.SetCol( 0 );
		m_gridUlHandZ.SetCellBackColor( ORANGE_COLOR );
	}
	else if( bUlHandHomeStatus && !((CDicsView*)m_pView)->m_pMmc->GetHomeSwitch( RBT_UL_HAND_UNIT ) )
	{
		bUlHandHomeStatus = FALSE;
		m_gridUlHandZ.SetRow( 2 );
		m_gridUlHandZ.SetCol( 0 );
		m_gridUlHandZ.SetCellBackColor( WHITE_COLOR );
	}
#endif*/
}

void CJobsTabMainView::UpdateBrokenSensor()
{
	// Broken Sensor
	static BOOL	bOldBrokenSensorState[MAX_GLS_BROKEN_SENSOR_NO] = { FALSE, };

	for( int i=0; i<m_pEqpAssy->m_FixedBrokenSensorLd.GetMaxSectionNo(); i++ )
	{
		BOOL bFlg = m_pEqpAssy->m_FixedBrokenSensorLd.GetAnd(i);
		if( !bOldBrokenSensorState[i] && bFlg ) 
		{
			bOldBrokenSensorState[i] = TRUE; 
			SetColorStatic( m_stcBrokenSensor[i], TRUE );
		}
		else if( bOldBrokenSensorState[i] && !bFlg ) 
		{ 
			bOldBrokenSensorState[i] = FALSE; 
			SetColorStatic( m_stcBrokenSensor[i], FALSE );
		}
	}
}

void CJobsTabMainView::UpdateGlassData()
{
	static BOOL bOldGlassData[MAX_IF_NO * 2] = { FALSE, };
	static int nOldSlot[MAX_IF_NO * 2] = {0,};//2009.03.12 kimgun ٸ tab ִٰ jobview ̵ glassdata update  ʴ 󶧹.
	CString sMessage;
	CDicsView* pView = ( (CDicsView*) m_pView);
	for( int i=0; i < ( MAX_IF_NO * 2 ) ; i++ )
	{
		int nSlotNo	= m_pDicsData->m_GlsInfo[i].nSlotNo;//2009.03.12 kimgun
		BOOL bIsValid	= m_pDicsData->m_GlsInfo[i].bIsValid;
		if( (!bOldGlassData[i] || nOldSlot[i] != nSlotNo) && bIsValid ) //2009.03.12 kimgun
		{
			bOldGlassData[i] = TRUE; 
			
			nOldSlot[i] = nSlotNo = m_pDicsData->m_GlsInfo[i].nSlotNo;//2009.03.12 kimgun
			int nPortNo = m_pDicsData->m_GlsInfo[i].nPortNo;

			SetCvState( i, TRUE, nSlotNo, nPortNo );
		}
		else if( bOldGlassData[i] && !bIsValid ) 
		{ 
			bOldGlassData[i] = FALSE; 
			SetCvState( i, FALSE, 0, 0 );
		}
	}
}

void CJobsTabMainView::UpdateGlassDataCreate()
{
	static BOOL bOldState = FALSE;
#ifndef _MY_DEBUG
	if( !m_pDicsData->m_GenInfo.bAuto &&
		!m_bCreateGlassData[IF_UNIT_LD*2 + 0] &&
		m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) &&
		!m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) &&
		!m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].bIsValid &&
		!m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 1].bIsValid )
#else
	if( !m_pDicsData->m_GenInfo.bAuto &&
		!m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].bIsValid &&
		!m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 1].bIsValid &&
		!bOldState )
#endif
	{
		CString sText = "";
		m_stcSubUnit[IF_UNIT_LD*2 + 0].SetWindowText( sText );

		m_stcSubUnit[IF_UNIT_LD*2 + 0].StartBkBlink( FALSE );
		m_stcSubUnit[IF_UNIT_LD*2 + 0].StartTextBlink( FALSE );
		m_stcSubUnit[IF_UNIT_LD*2 + 0].SetTextColor( BLACK_COLOR );
		m_stcSubUnit[IF_UNIT_LD*2 + 0].SetBkColor( YELLOW_COLOR );

		m_bCreateGlassData[IF_UNIT_LD*2 + 0] = TRUE;
		bOldState = TRUE;
	}
#ifndef _MY_DEBUG
	else if( ( m_pDicsData->m_GenInfo.bAuto ||
			 !m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) || 
 			 m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) || 
			 m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].bIsValid ||
			 m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 1].bIsValid ) &&
			 bOldState )
#else
	else if( ( m_pDicsData->m_GenInfo.bAuto ||
				m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].bIsValid ||
				m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 1].bIsValid ) &&
				bOldState )
#endif
	{
		BOOL bIsValid = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].bIsValid;
		BOOL nSlotNo  = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nSlotNo;
		BOOL nPortNo  = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nPortNo;
		SetCvState( IF_UNIT_LD*2 + 0, bIsValid, nSlotNo, nPortNo );
		m_bCreateGlassData[IF_UNIT_LD*2 + 0] = FALSE;
		bOldState = FALSE;
	}
}

void CJobsTabMainView::UpdateLdUnitAlign()
{
	static BOOL nOldAlignState[4] = { 0, };
	BOOL bA, bB;
	bA = bB = FALSE;
	CDicsApp* pApp = ( CDicsApp* )AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* )pApp->m_pMainWnd;
	CDicsView* pView = ( (CDicsView*) m_pView);
	for( int i=0; i<m_pEqpAssy->m_CylinderTrLdAlign.GetDiSize(); i++ )
	{
#ifndef _MY_DEBUG
		bA = m_pEqpAssy->m_CylinderTrLdAlign.GetFw( i );
		bB = m_pEqpAssy->m_CylinderTrLdAlign.GetBw( i );
#else
		bA = m_pEqpAssy->m_CylinderTrLdAlign.GetFwState();
		bB = m_pEqpAssy->m_CylinderTrLdAlign.GetBwState();
#endif
		
		
		if( nOldAlignState[i] != 1 && !bA && bB ) 
		{
			nOldAlignState[i] = 1;
			m_ocxAlign[i].SetBw();
		}
		if( nOldAlignState[i] != 2 && bA && !bB ) 
		{
			nOldAlignState[i] = 2;
			m_ocxAlign[i].SetFw();
		}
		else if(( pMainFrame->m_nMenu == CMainFrame::menuJOBS ) && pView->m_nSelectedTab == 0 &&//2009.03.12 kimgun
			    nOldAlignState[i] != 3 && !bA && !bB )  
		{
			nOldAlignState[i] = 3;
			m_ocxAlign[i].SetNone();
		}
		else if(( pMainFrame->m_nMenu == CMainFrame::menuJOBS ) && pView->m_nSelectedTab == 0 &&//2009.03.12 kimgun
			    nOldAlignState[i] != 4 && bA && bB )  
		{
			nOldAlignState[i] = 4;
			m_ocxAlign[i].SetNone();
		}
	}	
}

void CJobsTabMainView::UpdateUlUnitCylinder()
{
	static int nUlCylState[2] = { 0, };
	CDicsApp* pApp = ( CDicsApp* )AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* )pApp->m_pMainWnd;
	CDicsView* pView = ( (CDicsView*) m_pView); // 2009.03.13 minhan
	for( int i=0; i<2; i++ )
	{
		BOOL bFw=FALSE, bBw=FALSE;
#ifndef _MY_DEBUG
		bFw = m_pEqpAssy->m_CylinderUlHand.GetFw(i);
		bBw = m_pEqpAssy->m_CylinderUlHand.GetBw(i);
#else
		bFw = m_pEqpAssy->m_CylinderUlHand.GetFwState();
		bBw = m_pEqpAssy->m_CylinderUlHand.GetBwState();
#endif
		if( nUlCylState[i] != handBW && bBw ) 
		{
			nUlCylState[i] = handBW;
			m_ocxUlCyl[i].SetBw();
		}
#ifndef _MY_DEBUG
		if( nUlCylState[i] != handFW && 
			m_pEqpAssy->m_CylinderUlHand.GetFw( i ) && 
			!m_pEqpAssy->m_CylinderUlHand.GetBw( i ) ) 
#else
		if( nUlCylState[i] != handFW && 
			m_pEqpAssy->m_CylinderUlHand.GetFwState() && 
			!m_pEqpAssy->m_CylinderUlHand.GetBwState() ) 
#endif
		{
			nUlCylState[i] = handFW;
			m_ocxUlCyl[i].SetFw();
		}
#ifndef _MY_DEBUG
		else if( ( pMainFrame->m_nMenu == CMainFrame::menuJOBS ) && nUlCylState[i] != handERROR &&  pView->m_nSelectedTab == 0 &&//2009.03.12 kimgun
			( ( m_pEqpAssy->m_CylinderUlHand.GetFw( i ) && m_pEqpAssy->m_CylinderUlHand.GetBw( i ) ) ||
			  ( !m_pEqpAssy->m_CylinderUlHand.GetFw( i ) && !m_pEqpAssy->m_CylinderUlHand.GetBw( i ) ) ) )
		{
			nUlCylState[i] = handERROR;

			m_ocxUlCyl[i].SetNone();
		}
#endif
	}
}

void CJobsTabMainView::OnAlign(UINT uID) 
{
	if( !( (CDicsView*)m_pView )->m_pDicsData->m_GenInfo.bAuto &&
		( (CDicsView*)m_pView )->m_pDicsData->m_LoginInfo.nCurUserLevel >= CDicsData::idMAINT )
	{
		CDlgAlign dlg;
		dlg.SetEqpAssy(m_pEqpAssy);
		dlg.SetDevice( ( (CDicsView*)m_pView )->m_pDevice );
		dlg.DoModal();
	}
}

void CJobsTabMainView::OnTilt(UINT uID) 
{
	// TODO: Add your control notification handler code here
	CDicsApp* pApp = ( CDicsApp* )AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* )pApp->m_pMainWnd;
	if( pMainFrame->m_bAuto ) return;
	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;
	CDlgTilt dlg;
	dlg.m_nCurCylNo = uID - IDC_LD_TILT;
	dlg.SetDevice( ( (CDicsView*)m_pView )->m_pDevice );
	dlg.SetEqpAssy( m_pEqpAssy );
	dlg.DoModal();		
}

void CJobsTabMainView::OnUlHand(UINT uID) 
{
	// TODO: Add your control notification handler code here
	CDicsApp* pApp = ( CDicsApp* )AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* )pApp->m_pMainWnd;
	if( pMainFrame->m_bAuto ) return;
	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;
	CDlgUlHandCylinder dlg;
	dlg.SetEqpAssy(m_pEqpAssy); 
	dlg.SetDevice( ( (CDicsView*)m_pView )->m_pDevice );
	dlg.DoModal();		
}

void CJobsTabMainView::UpdateEuv()
{
#ifdef _NO_EUV
	return;
#endif

	// status : noUse, alarm, Lamp on, Lamp Off
	static int nStatus = 0;

	SetDataToGridCtrl_LampStatus();

//////////////////////////////////////////////////////////////////////////
// Euv Usage
	BOOL bUse = ( (CDicsView*)m_pView )->m_pEuvSeq->IsEuvUse();
	if( !bUse && nStatus != 1 )
	{
		m_ocxEuv.SetLampNoUse();
		nStatus = 1;
	}
	else if( bUse && nStatus == 1 )
	{
		nStatus = 0;
	}

	if( !bUse ) return;
	
//////////////////////////////////////////////////////////////////////////
// Euv Alarm
	BOOL bAlarm = ( (CDicsView*)m_pView )->m_pEuvSeq->GetEuvAlarm() ? TRUE : FALSE;
	if( bAlarm && nStatus != 2 ) 
	{
		m_ocxEuv.SetLampAlarm();
		nStatus = 2;
	}
	else if( !bAlarm && nStatus == 2 )
	{
		nStatus = 0;
	}

	if( bAlarm ) return;

	
//////////////////////////////////////////////////////////////////////////
// Lamp Selected
	static int nOldSelected[MAX_LAMP_CONTROL_NO] = { 0, };
	int nSelected[MAX_LAMP_CONTROL_NO] = { 0, };
#ifndef _LTYPE
	for( int i=0; i<MAX_LAMP_CONTROL_NO; i++ )
	{
		nSelected[i] = ( (CDicsView*)m_pView )->m_pEuvSeq->GetLampOnSelected( i ) ? 1 : 2;		
		if( nSelected[i] != nOldSelected[i] ) 
		{
			m_ocxEuv.LampSelect( MAX_LAMP_CONTROL_NO-i , nSelected[i] == 1 ? TRUE : FALSE );
			nOldSelected[i] = nSelected[i];
			nStatus = 0;
		}
	}
#else
	for( int i=0; i<MAX_LAMP_CONTROL_NO; i++ )
	{
		nSelected[i] = ( (CDicsView*)m_pView )->m_pEuvSeq->GetLampOnSelected( i ) ? 1 : 2;		
		if( nSelected[i] != nOldSelected[i] ) 
		{
			m_ocxEuv.LampSelect( i+1 , nSelected[i] == 1 ? TRUE : FALSE );
			nOldSelected[i] = nSelected[i];
			nStatus = 0;
		}
	}
#endif


//	nSelected[0] = ( (CDicsView*)m_pView )->m_pEuvSeq->GetLampOnSelected( 0 ) ? 1 : 2;	
//	if( nSelected[0] == 1 ) nSelected[3] = 1; nSelected[0] = 0;
//	if( nSelected[3] != nOldSelected[3] ) 
//	{
//		m_ocxEuv.LampSelect( 4 , nSelected[3] == 1 ? TRUE : FALSE );
//		nOldSelected[3] = nSelected[3];
//		nStatus = 0;
//	}
//
//	nSelected[1] = ( (CDicsView*)m_pView )->m_pEuvSeq->GetLampOnSelected( 1 ) ? 1 : 2;	
//	if( nSelected[1] == 1 ) nSelected[2] = 1; nSelected[1] = 0;
//	if( nSelected[2] != nOldSelected[2] ) 
//	{
//		m_ocxEuv.LampSelect( 3 , nSelected[2] == 1 ? TRUE : FALSE );
//		nOldSelected[2] = nSelected[2];
//		nStatus = 0;
//	}
//
//	nSelected[2] = ( (CDicsView*)m_pView )->m_pEuvSeq->GetLampOnSelected( 2 ) ? 1 : 2;	
//	if( nSelected[2] == 1 ) nSelected[1] = 1; nSelected[2] = 0;
//	if( nSelected[1] != nOldSelected[1] ) 
//	{
//		m_ocxEuv.LampSelect( 2 , nSelected[1] == 1 ? TRUE : FALSE );
//		nOldSelected[1] = nSelected[1];
//		nStatus = 0;
//	}
//
//	nSelected[3] = ( (CDicsView*)m_pView )->m_pEuvSeq->GetLampOnSelected( 3 ) ? 1 : 2;	
//	if( nSelected[3] == 1 ) nSelected[0] = 1; nSelected[3] = 0;
//	if( nSelected[0] != nOldSelected[0] ) 
//	{
//		m_ocxEuv.LampSelect( 1 , nSelected[0] == 1 ? TRUE : FALSE );
//		nOldSelected[0] = nSelected[0];
//		nStatus = 0;
//	}


//////////////////////////////////////////////////////////////////////////
// Lamp On
	BOOL bOn = ( (CDicsView*)m_pView )->m_pEuvSeq->GetLampOnState();
	if( bOn && nStatus != 3 ) 
	{
		m_ocxEuv.SetLampOn();
		nStatus = 3;
	}
	else if( !bOn && nStatus != 4 )
	{
		m_ocxEuv.SetLampOff();
		nStatus = 4;
	}
}

void CJobsTabMainView::UpdateTiltSensor()
{

	static int nCylState[2] = { 0, };
	BOOL bFw=FALSE, bBw=FALSE;
	CDicsApp* pApp = ( CDicsApp* )AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* )pApp->m_pMainWnd;
	CDicsView* pView = ( (CDicsView*) m_pView);
#ifndef _MY_DEBUG
	bFw = m_pEqpAssy->m_CylinderLdTilt.GetFw();
	bBw = m_pEqpAssy->m_CylinderLdTilt.GetBw();
#else
	bFw = m_pEqpAssy->m_CylinderLdTilt.GetFwState();
	bBw = m_pEqpAssy->m_CylinderLdTilt.GetBwState();
#endif
	if( nCylState[0] != tiltDOWN && bBw )
	{
		nCylState[0] = tiltDOWN;
		m_ocxCyl[0].SetBw();
	}
	else if( nCylState[0] != tiltUP && bFw )
	{
		nCylState[0] = tiltUP;
		m_ocxCyl[0].SetFw();
	}
	else if( ( pMainFrame->m_nMenu == CMainFrame::menuJOBS ) && pView->m_nSelectedTab == 0 &&//2009.03.12 kimgun
		    	nCylState[0] != tiltERROR && ( ( bFw&&bBw ) || ( !bFw&&!bBw ) )  )
	{
		nCylState[0] = tiltERROR;
		m_ocxCyl[0].SetNone();
	}

#ifndef _MY_DEBUG
	bFw = m_pEqpAssy->m_CylinderUlTilt.GetFw();
	bBw = m_pEqpAssy->m_CylinderUlTilt.GetBw();
#else
	bFw = m_pEqpAssy->m_CylinderUlTilt.GetFwState();
	bBw = m_pEqpAssy->m_CylinderUlTilt.GetBwState();
#endif
	if( nCylState[1] != tiltDOWN && bBw )
	{
		nCylState[1] = tiltDOWN;
		m_ocxCyl[1].SetBw();
	}
	else if( nCylState[1] != tiltUP && bFw )
	{
		nCylState[1] = tiltUP;
		m_ocxCyl[1].SetFw();
	}
	else if( ( pMainFrame->m_nMenu == CMainFrame::menuJOBS ) && pView->m_nSelectedTab == 0 &&//2009.03.12 kimgun
		      nCylState[1] != tiltERROR && ( (bFw&&bBw) || (!bFw&&!bBw) )  )
	{
		nCylState[1] = tiltERROR;
		 m_ocxCyl[1].SetNone();
	}
}


void CJobsTabMainView::UpdateLdUnitStatus()
{
	static nStatus = -1;
	int nRbtNo = 0;

	CDicsView* pView = (CDicsView*)m_pView;

//	if( nStatus != 0 && m_pEqpAssy->m_PosSensorLdUnit.GetAnd( LD_UPDN_UNIT_SEND_POS ) && !m_pEqpAssy->m_PosSensorLdUnit.GetAnd( LD_UPDN_UNIT_RECV_POS ) )
	if( nStatus != 0 && m_pDicsData->m_IfFlag[IF_UNIT_LD].bSendPosComp )
	{
		nStatus = 0;
		for( ; nRbtNo < MAX_RBT_ANI_NO-1; nRbtNo++ )
			pView->m_pGlassAni->RbtMoveRegion( nRbtNo, CGlassAni::aniLDUP_SEND );
	}
//	else if( nStatus != 1 && !m_pEqpAssy->m_PosSensorLdUnit.GetAnd( LD_UPDN_UNIT_SEND_POS ) && m_pEqpAssy->m_PosSensorLdUnit.GetAnd( LD_UPDN_UNIT_RECV_POS ) )
	else if( nStatus != 1 && m_pDicsData->m_IfFlag[IF_UNIT_LD].bRecvPosComp )
	{
		nStatus = 1;
		for( ; nRbtNo < MAX_RBT_ANI_NO-1; nRbtNo++ )
			pView->m_pGlassAni->RbtMoveRegion( nRbtNo, CGlassAni::aniLDUP_RECV );
	}
}

void CJobsTabMainView::UpdateDoorOpen()
{
#ifdef _MY_DEBUG
	static BOOL bDebugDoorOpenSensor[MAX_DOOR_OPEN_NO] = { FALSE, };
#endif

	static BOOL bOldDoorOpenState[MAX_DOOR_OPEN_NO] = { FALSE, };
	for( int i = 0 ; i < m_pEqpAssy->m_SensorDoor.GetDiSize() ; i ++ )
	{
#ifndef _MY_DEBUG
		if( !bOldDoorOpenState[i] && m_pEqpAssy->m_SensorDoor.Get(i) )
#else
		if( !bOldDoorOpenState[i] && bDebugDoorOpenSensor[i] )
#endif
		{
			bOldDoorOpenState[i] = TRUE; 
			SetColorStatic( m_stcDoorOpen[i], TRUE, RED_COLOR );
		}
#ifndef _MY_DEBUG
		if( bOldDoorOpenState[i] && !m_pEqpAssy->m_SensorDoor.Get( i ) )
#else
		if( bOldDoorOpenState[i] && !bDebugDoorOpenSensor[i] )
#endif
		{
			bOldDoorOpenState[i] = FALSE; 
			SetColorStatic( m_stcDoorOpen[i], FALSE, RED_COLOR );
		}
	}
}
void CJobsTabMainView::UpdateLoaderRobotHand()
{
#ifdef _MY_DEBUG
	static BOOL bInit = FALSE;
	if( !bInit )
	{
		bInit = TRUE;
// 		m_pDevice->SetDiState( DI_NODE3+53, ON );
// 		m_pDevice->SetDiState( DI_NODE3+54, ON );
	}
#endif
	
	BOOL bUpLDUnitHandInterLock = m_pEqpAssy->m_SensorRobotHandInterlock.Get( 0 );
	BOOL bUlUnitHandInterLock = m_pEqpAssy->m_SensorRobotHandInterlock.Get( 1 );
	static BOOL bOldRobotHandStatus[2] = { FALSE, FALSE };

	if( bUpLDUnitHandInterLock && !bOldRobotHandStatus[0] )
	{
		bOldRobotHandStatus[0] = TRUE;
		m_bitmapLdUpperHand.ShowWindow( TRUE );
	}
	else if( !bUpLDUnitHandInterLock && bOldRobotHandStatus[0] )
	{
		bOldRobotHandStatus[0] = FALSE;
		m_bitmapLdUpperHand.ShowWindow( FALSE );
	}

	if( bUlUnitHandInterLock && !bOldRobotHandStatus[1] )
	{
		bOldRobotHandStatus[1] = TRUE;
		m_bitmapUlUpperHand.ShowWindow( TRUE );
	}
	else if( !bUlUnitHandInterLock && bOldRobotHandStatus[1] )
	{
		bOldRobotHandStatus[1] = FALSE;
		m_bitmapUlUpperHand.ShowWindow( FALSE );
	}
}
