//{{AFX_INCLUDES()
#include "msflexgrid.h"
#include "cvsingle.h"
#include "rollbrush.h"
#include "euvhouse.h"
#include "dicscylinder.h"

//}}AFX_INCLUDES
#if !defined(AFX_JOBSTABMAINVIEW_H__50B77784_F961_4FCD_9C7D_712204CDBC46__INCLUDED_)
#define AFX_JOBSTABMAINVIEW_H__50B77784_F961_4FCD_9C7D_712204CDBC46__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// JobsTabMainView.h : header file
//

#include "..\X\MsgBox.h"
#include "..\X\ColorStatic.h"
#include "..\X\TextProgressCtrl.h"
#include "..\X\XCtlDevice.h"
#include "..\X\XMmc.h"
#include "..\X\MacButtons.h"
#include "DicsData.h"
#include "..\FactoryLib\IniData.h"	// Added by ClassView
#include "..\FactoryLib\EqpAssy.h"
/////////////////////////////////////////////////////////////////////////////
// CJobsTabMainView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#define SKIP_3_ITEMS	3
#define MAX_GRID_COLS	8	// 5
#define MAX_GRID_CTRL	8

typedef struct tagGRID_INFO
{
	INT				nRows;
	INT				nCols;
	LPTSTR			sText[MAX_GRID_COLS];
	INT				nColWidth[MAX_GRID_COLS];
	unsigned int	uCellBackColor;
	BOOL			bTitle;
} GRID_INFO;

class CJobsTabMainView : public CFormView
{
public:
	CJobsTabMainView();           // protected constructor used by dynamic creation
	CJobsTabMainView( CView* pView, int nTabNo );
	DECLARE_DYNCREATE(CJobsTabMainView)
// Form Data
public:
	//{{AFX_DATA(CJobsTabMainView)
#ifndef _LTYPE
	enum { IDD = IDD_JOBS_TAB_MAIN_VIEW_R };
#else
	enum { IDD = IDD_JOBS_TAB_MAIN_VIEW_L };
#endif
	CMSFlexGrid			m_gridRecipeInfo;
	CMSFlexGrid			m_gridSetupInfo;
	CMSFlexGrid			m_gridLampStatus;
	CMSFlexGrid			m_gridTrPos;
//	CMSFlexGrid			m_gridTrArea;

	CBitmapButton		m_bitmapUlHand;
	CBitmapButton		m_bitmapLdUpperHand;
	CBitmapButton		m_bitmapLdLowerHand;
	CBitmapButton		m_bitmapUlUpperHand;
	CBitmapButton		m_bitmapUlLowerHand;
	CTextProgressCtrl	m_progIdleRun;
	CTextProgressCtrl	m_progEuvOn;	
	CEUVHouse			m_ocxEuv;
	CMSFlexGrid			m_gridLdUpY;
	CMSFlexGrid			m_gridLdUpZ;
	CMSFlexGrid			m_gridLdLoZ;
	CMSFlexGrid			m_gridUlUpY;
	CMSFlexGrid			m_gridUlUpZ;
	CMSFlexGrid			m_gridUlLoZ;
	CMSFlexGrid			m_gridUlHandZ;

	//}}AFX_DATA

	CRollBrush		m_ocxRollBrush[MAX_RB_NO];
	CCVSingle		m_ocxCvMotor[MAX_CV_MOTOR_NO];
	CDicsCylinder	m_ocxAlign[4];
// Attributes
public:
	int				m_nTabNo;
	CView*			m_pView;
	CDicsData*		m_pDicsData;
	XMmc*			m_pMmc;	
	XCtlDevice*		m_pDevice;
	CEqpAssy*		m_pEqpAssy;

	CIniData		m_IniConfiguration;

	// color brush
	HBRUSH		m_hbrBgColor;
	HBRUSH		m_hbrTextColor;

	// Msg Box
	CMsgBox		m_msgTactTime;
	CMsgBox		m_msgOldTactTime;//2008.08.26 kimgun
	CMsgBox		m_msgRecipeId;
	
	
	CMsgBox		m_msgTotalGlassNo;
	CMsgBox		m_msgGlassNo;
	CMsgBox		m_msgCurGlassNo;
	CMsgBox		m_msgEuvTime[MAX_LAMP_NO];
	CMsgBox		m_msgBrokenSensor[MAX_SCAN_NO];	//EUN
	CMsgBox		m_msgAging;
	CMsgBox		m_msgRbGap[MAX_RB_GAP_SERVO_NO];


	int			m_nEuvHour[MAX_LAMP_NO];
	int			m_nEuvMin[MAX_LAMP_NO];
	int			m_nEuvSec[MAX_LAMP_NO];

	BOOL		m_bInitialUpdateComp;
	BOOL		m_bCreateGlassData[2*MAX_IF_NO];

	// Static Control
	CColorStatic	m_stcSubUnit[2 * MAX_UNIT_NO];
	CColorStatic	m_stcGlsExistSensor[MAX_GLS_EXIST_SENSOR_NO];
	CColorStatic	m_stcGlsExistInterlock;
	CColorStatic	m_stcUlStopInterlock;	// 141128 halesu
	CColorStatic	m_stcBrokenSensor[MAX_GLS_BROKEN_SENSOR_NO];
	CColorStatic	m_stcGlassInterlockSensor[MAX_GLS_INTERLOCK_SENSOR_NO];
	CColorStatic	m_stcUnit[MAX_UNIT_NO];

	CColorStatic	m_stcLeak[MAX_LEAK_SENSOR_NO];
	CColorStatic	m_stcCoverOpen[MAX_COVER_OPEN_NO];
	CColorStatic	m_stcDoorOpen[MAX_DOOR_OPEN_NO];

	CColorStatic	m_stcTrsMode[MAX_PORT_NO];
	CColorStatic	m_stcInOutNum[MAX_PORT_NO];
	CColorStatic	m_stcPortState[MAX_PORT_NO];
	CColorStatic	m_stcPort[MAX_PORT_NO];

	CDicsCylinder	m_ocxCyl[2];
	CDicsCylinder	m_ocxUlCyl[2];
	// Current Glass No
	int				m_nCurGlassNo;

	static GRID_INFO	m_GridInfo[MAX_GRID_CTRL];
	
	enum	nameGRID_CTRL { gRecipeInfo, gSetupInfo, gUlHandZ, gUpHandPosZ, gLoHandPosZ, gTrArea, gTrPos, gLampStatus };
	enum	TILT_STATE	  { tiltNONE, tiltUP, tiltDOWN, tiltERROR };
	enum	UL_HAND		  { handNONE, handFW, handBW, handERROR };
// Operations
public:
	void SetDataToGridCtrl_RecipeInfo();
	void SetRecipeId2View( CString sRecipeId );

	void SetDataToGridCtrl_SetupInfo();
	void SetBoolTypeValue(int nValue, int nOption, CMSFlexGrid& gridCtrl );

	void GridInit( CMSFlexGrid &gridCtrl, GRID_INFO gridInfo ); 

	void SetDataToGridCtrl_LampStatus();
	void SetColorStatic( CColorStatic& stcObject, BOOL bState, COLORREF OnColor = GREEN_COLOR, COLORREF OffColor = WHITE_COLOR );
	void SetGlassNo(int nGlassNo, int nAll);
	void SetCvState( int i, BOOL bState, int nSlotNo, int nPortNo );
	void SetEqpState( int nState );
	void SetLdState( int i, int nState );
	UINT GetEuvTime( int i );
	void SetDevice( XCtlDevice* pDevice ) { m_pDevice = pDevice; }
	void SetMmc(XMmc* pMmc) { m_pMmc = pMmc; }


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJobsTabMainView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	void UpdateDoorOpen();
	void UpdateLdUnitStatus();
	CIniData* m_pIniGlsData;
	virtual ~CJobsTabMainView();
	void UpdateObjects();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CJobsTabMainView)
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnClose();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnClickCvMotor();
	afx_msg void OnClickEuv();
	afx_msg void OnClickRb();
	afx_msg void OnClickFishRib();
//	afx_msg void OnUnit4();
	afx_msg void OnAlign(UINT uID);
	afx_msg void OnTilt(UINT uID);
	afx_msg void OnUlHand(UINT uID);
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	afx_msg void OnEqpStatusChanged( WPARAM wParam, LPARAM lParam );
	afx_msg void OnLdStatusChanged( WPARAM wParam, LPARAM lParam );
	afx_msg void OnBrokenSensorStatusChanged( WPARAM wParam, LPARAM lParam );
	afx_msg void OnBrokenScanStatusChanged( WPARAM wParam, LPARAM lParam );
	afx_msg void OnMsgBoxClicked( WPARAM wParam, LPARAM lParam );
	afx_msg void OnCvInfo(UINT nID);
	afx_msg void OnLdDoorOpenChanged( WPARAM wParam, LPARAM lParam );		// ljy_050406 : add
	afx_msg void OnUlDoorOpenChanged( WPARAM wParam, LPARAM lParam );		// ljy_050406 : add
	afx_msg void OnPosSensorStatusChanged( WPARAM wParam, LPARAM lParam );	// ljy_050502 : add
	afx_msg void OnTrPosSensorStatusChanged( WPARAM wParam, LPARAM lParam );
	afx_msg void OnTrAreaSensorStatusChanged( WPARAM wParam, LPARAM lParam );
	afx_msg void OnAgingModeStatusChanged( WPARAM WParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
protected:
	void UpdateGlassDataCreate();
	void UpdateGlassData();
	void UpdateGlassExistSensor();
	void UpdateCoverOpen();
	void UpdateLeakSensor();
	void UpdateCvMotor();
	void UpdateRollBrush();
	void UpdateTrSensor();
	void UpdateBrokenSensor();
	void UpdatePositionSensor();
	void UpdateLdUnitAlign();
	void UpdateEuv();
	void UpdateTiltSensor();
	void UpdateUlUnitCylinder();
	void UpdateLoaderRobotHand();
//	void UpdateDoorOpen();
//	void UpdateLdUnitStatus();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JOBSTABMAINVIEW_H__50B77784_F961_4FCD_9C7D_712204CDBC46__INCLUDED_)
