// SetupItems.cpp: implementation of the CSetupItems class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "SetupItems.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//--------------------------------------------------------------------
// Col 0 : Item Name
// Col 1 : Process / Pass Mode, Use, No Use
//			- optionBOOL1 : PROCESS MODE / PASS MODE
//			- optionBOOL2 : USE / NO USE
//			- optionBOOL3 : CHECK / NO CHECK
// Col 2 : Value
//--------------------------------------------------------------------
SETUP_INFO CSetupItems::m_infoSetup[] = 
{
	{ "PUMP USE",						optionBOOL2,	formatNONE,		"NONE"	},
	{ "SBJ USE",						optionBOOL2,	formatNONE,		"NONE"	},
	{ "UP LD BROKEN",					optionBOOL3,	formatNONE,		"NONE"  }, 
	{ "LD UNIT SCAN",					optionBOOL3,	formatNONE,		"NONE"  },
	{ "UL UNIT SCAN",					optionBOOL3,	formatNONE,		"NONE"  },	
	{ "BUF UNIT SCAN",					optionBOOL3,	formatNONE,		"NONE"  },	// 121002 halesu
	{ "EUV Use",						optionBOOL2,	formatNONE,		"NONE"	}, 
	{ "EUV1 Life Time",					optionNONE,		formatDIGIT,	"hour"	}, 
	{ "EUV2 Life Time",					optionNONE,		formatDIGIT,	"hour"	}, 
	{ "EUV3 Life Time",					optionNONE,		formatDIGIT,	"hour"	}, 
	{ "EUV4 Life Time",					optionNONE,		formatDIGIT,	"hour"	}, 
	{ "Upper C/V Normal Speed",			optionNONE,		formatDIGIT,	"mm/min"},
	{ "Upper C/V High Speed",			optionNONE,		formatDIGIT,	"mm/min"},
	{ "Upper C/V Decel Speed",			optionNONE,		formatDIGIT,	"mm/min"},
	{ "LD Unit C/V Decel Speed",		optionNONE,		formatDIGIT,	"mm/min"},
	{ "Glass Size",						optionNONE,		formatDIGIT,	"mm"	}, 
	{ "Max Glass No",					optionNONE,		formatDIGIT,	"EA"	}, 	
	{ "C/V Timeout Distance",			optionNONE,		formatDIGIT,	"mm"	},
	{ "LD Unit C/V Stop Distance",		optionNONE,		formatDIGIT,	"mm"	}, 
	{ "UL Unit C/V Stop Distance",		optionNONE,		formatDIGIT,	"mm"	}, 
	{ "Pump Interlock Check Time",		optionNONE,		formatDIGIT,	"Sec"	}, 	
	{ "Pump Interlock Flow Rate",		optionNONE,		formatDIGIT,	"lpm"	}, 	
	{ "R/B Up Servo1",					optionBOOL2,	formatNONE,		"NONE"	}, 
	{ "R/B Lo Servo1",					optionBOOL2,	formatNONE,		"NONE"	}, 
	{ "R/B Up Servo2",					optionBOOL2,	formatNONE,		"NONE"	}, 
	{ "R/B Lo Servo2",					optionBOOL2,	formatNONE,		"NONE"	}, 
	{ "Initialize TimeOut",				optionNONE,		formatDIGIT,	"sec"	},
	{ "Level Sensor Confirm Time",		optionNONE,		formatDIGIT,	"sec"	},
	{ "Idle Mode Wait Time",			optionNONE,		formatDIGIT,	"min"	},
	{ "AK Flow Deviation",				optionNONE,		formatDIGIT,	"lpm"	},
	{ "TIMER Reset Time(ms)",			optionNONE,		formatDIGIT,	"ms"	}, // halesu
	{ "AK Out Waiting Timeout",			optionNONE,		formatDIGIT,	"sec"	},	// 141229 halesu
	{ "DI ECO Mode",					optionBOOL2,	formatNONE,		"NONE"	},	// 240730 halesu
	{ "DI ECO Mode Check POS",			optionBOOL7,	formatNONE,		"NONE"	},	// 250108 halesu
	{ "AK ECO Mode",					optionBOOL2,	formatNONE,		"NONE"	},	// 240730 halesu
//	{ "Job Mode",						optionBOOL1,	formatNONE,		"NONE"	}, 
};

//--------------------------------------------------------------------
//--------------------------------------------------------------------
CString CSetupItems::m_sItemInSensorOffTimeOut[] = 
{
	"UP LD Unit In Sensor",
	"BUF1 Unit In Sensor",
	"BUF2 Unit In Sensor",
	"BUF3 Unit In Sensor",
	"LD Unit In Sensor",
	"EUV Unit In Sensor",
	"R/B(SBJ) Unit In Sensor",
	"F/R Unit In Sensor",
	"A/K Unit In Sensor",
	"UL Unit In Sensor",
};

CString CSetupItems::m_sItemOutSensorOffTimeOut[] = 
{
	"UP LD Unit Out Sensor",
	"BUF1 Unit Out Sensor",
	"BUF2 Unit Out Sensor",
	"BUF3 Unit Out Sensor",
	"LD Unit Out Sensor",
	"EUV Unit Out Sensor",
	"R/B(SBJ) Unit Out Sensor",
	"F/R Unit Out Sensor",
	"A/K Unit Out Sensor",
	"UL Unit Out Sensor",
};

//--------------------------------------------------------------------
//			- optionBOOL4 : CW / CCW
//--------------------------------------------------------------------
SETUP_INFO CSetupItems::m_infoIdleRun[] = 
{
	{ "Idle Use",			optionBOOL2,	formatNONE,		"NONE" }, 
	{ "Stop Time",			optionNONE,		formatDIGIT,	"min" },
	{ "Run Time",			optionNONE,		formatDIGIT,	"sec" },
	{ "Upper RB1 DIR",		optionBOOL4,	formatNONE,		"NONE" },
	{ "Lower RB1 DIR",		optionBOOL4,	formatNONE,		"NONE" },
	{ "Upper RB2 DIR",		optionBOOL4,	formatNONE,		"NONE" },
	{ "Lower RB2 DIR",		optionBOOL4,	formatNONE,		"NONE" },
	{ "Upper RB1 Speed",	optionNONE,		formatDIGIT,	"rpm" },
	{ "Lower RB1 Speed",	optionNONE,		formatDIGIT,	"rpm" },
	{ "Upper RB2 Speed",	optionNONE,		formatDIGIT,	"rpm" },
	{ "Lower RB2 Speed",	optionNONE,		formatDIGIT,	"rpm" },
};

//--------------------------------------------------------------------
//--------------------------------------------------------------------
CString CSetupItems::m_sNameTankLevel[] = 
{
	"DI Tank H Level",
	"DI Tank M Level",
	"DI Tank L Level",
	"DI Tank LL Level",
};

CString CSetupItems::m_sItemBathCoverIntr[] = 
{
	"R/B(SBJ) Unit Bath Cover 1 Open",
	"R/B(SBJ) Unit Bath Cover 2 Open",
	"F/R Unit Bath Cover 1 Open",
	"F/R Unit Bath Cover 2 Open",
	"A/K Unit Bath Cover 1 Open",		
	"A/K Unit Bath Cover 2 Open",		
};
CString CSetupItems::m_sItemDoorIntr[] = 
{
	"LD Unit Front Door Open",
	"LD Unit Lower Front Door Open", 
	"LD Unit Rear Door Open",
	"LD Unit Lower Rear Door Open",
	"LD Unit Center Door Open",
	"EUV Unit Front Door Open",
	"EUV Unit Rear Door Open",
	"UL Unit Front Door Open",
	"UL Unit Lower Front Door Open", 
	"UL Unit Rear Door Open",
	"UL Unit Lower Rear Door Open",
	"LD Upper Unit Front Door Open",
	"LD Upper Unit Rear Door Open",
	"EUV Upper Unit Front Door Open",
	"EUV Upper Unit Rear Door Open",
	"R/B Upper Unit Front Door Open",
	"R/B Upper Unit Rear Door Open",
	"F/R Upper Unit Front Door Open",
	"F/R Upper Unit Rear Door Open",
	"A/K Upper Unit Front Door Open",
	"A/K Upper Unit Rear Door Open",
	"UL Upper Unit Front Door Open",
	"UL Upper Unit Rear Door Open",
};
CString CSetupItems::m_sItemLeakDetectIntr[] = 
{
	"EUV Unit Leak Detect",	
	"R/B Unit Leak Detect",				
	"F/R Unit Leak Detect",			
	"A/K Unit Leak Detect",
};

CString CSetupItems::m_sItemFFUAlarmIntr[] = 
{
	"LD Unit FFU 1",
/*	"LD Unit FFU 2", */
	"BUF3 Unit FFU",
	"BUF2 Unit FFU",
	"UP LD Unit FFU 1",
	"UP LD Unit FFU 2",
	"BUF1 Unit FFU",
	"UL Unit FFU 1",
	"UL Unit FFU 2",
	"A/K Unit Hepa",
};

CString CSetupItems::m_sItemBrokenIntr[] = 
{
	"LD Unit Broken1",	
	"LD Unit Broken2",
	"LD Unit Broken3",
	"LD Unit Broken4",
	"LD Unit Broken All",
	"UL Unit Broken Scan",
};

CString CSetupItems::m_sItemETCIntr[] = 
{
	"Ionizer Alarm",
	"EUV N2 Low LEVEL",
	"EUV PCW Low LEVEL",
	"EUV CDA Low LEVEL",
};
//--------------------------------------------------------------------
//--------------------------------------------------------------------
SETUP_INFO CSetupItems::m_infoGaugeLimit[] = 
{
	{ 	"EUV Unit HEAT Exhaust Press",	optionBOOL3, formatDIGIT, "Pa" },		// 1
	{ 	"EUV Unit ACID Exhaust Press",	optionBOOL3, formatDIGIT, "Pa" }, 		// 2
	{ 	"EUV Unit CDA IN Press",		optionBOOL3, formatDIGIT, "kPa"	},		// 3
	{ 	"R/B Unit Exhaust1 Press",		optionBOOL3, formatDIGIT, "Pa"	},		// 4
	{ 	"R/B Unit Exhaust2 Press",		optionBOOL3, formatDIGIT, "Pa" },		// 5
	{ 	"R/B Unit Upper SHW Flow",		optionBOOL3, formatDIGIT, "lpm" },		// 6
	{ 	"R/B Unit Lower SHW Flow",		optionBOOL3, formatDIGIT, "lpm" },		// 7
	{ 	"R/B Unit SBJ1 DI Flow",		optionBOOL3, formatDIGIT, "lpm" },		// 8
	{ 	"F/R Unit Exhaust1 Press",		optionBOOL3, formatDIGIT, "Pa" },		// 9
	{ 	"F/R Unit Exhaust2 Press",		optionBOOL3, formatDIGIT, "Pa" },		// 10
	{ 	"F/R Unit SBJ2 DI Flow",		optionBOOL3, formatDIGIT, "lpm" },		// 11
	{ 	"F/R Unit SBJ3 DI Flow",		optionBOOL3, formatDIGIT, "lpm" },		// 12
	{ 	"F/R Unit Pump Lower SHW Flow",	optionBOOL3, formatDIGIT, "lpm" },		// 13
	{ 	"F/R Unit Main DI SHW Flow",	optionBOOL3, formatDIGIT, "lpm"	},		// 14
	{ 	"F/R Unit AQK SHW Flow",		optionBOOL3, formatDIGIT, "lpm"	}, 		// 15
	{ 	"F/R Unit Tank DI Resistivity",	optionBOOL3, formatDIGIT, "Moh" },		// 16
	{	"F/R Unit Main DI Resistivity",	optionBOOL3, formatDIGIT, "Moh" },		// 17
	{	"A/K Unit Upper Exhaust Press",	optionBOOL3, formatDIGIT, "Pa" },		// 18
	{	"A/K Unit Lower Exhaust Press",	optionBOOL3, formatDIGIT, "Pa"	},		// 19
	{	"A/K Unit Upper AK CDA Press",	optionBOOL3, formatDIGIT, "kPa"	},		// 20
	{	"A/K Unit Lower AK CDA Press",	optionBOOL3, formatDIGIT, "kPa" },		// 21
	{	"A/K Unit Upper AK CDA Flow",	optionBOOL3, formatDIGIT, "lpm" },		// 22
	{	"A/K Unit Lower AK CDA Flow",	optionBOOL3, formatDIGIT, "lpm" },		// 23
	{	"UL Unit SBJ1 CDA Press",		optionBOOL3, formatDIGIT, "kPa" },		// 24
	{	"UL Unit SBJ2 CDA Press",		optionBOOL3, formatDIGIT, "kPa" },		// 25
	{	"UL Unit SBJ3 CDA Press",		optionBOOL3, formatDIGIT, "kPa" },		// 26
	{	"DRIVING AIR PRESSURE",			optionBOOL3, formatDIGIT, "kPa" },		// 27
};

//--------------------------------------------------------------------
//			- optionBOOL5 : ACTIVE / PASSIVE
//--------------------------------------------------------------------
SETUP_INFO CSetupItems::m_infoInterfacePara[] = 
{
	{ "MelsecNet Slot No",									optionNONE, formatDIGIT, "" },
	{ "Network Number",										optionNONE, formatDIGIT, "" },
	{ "Station Number",										optionNONE, formatDIGIT, "" },
	{ "T1 Timeout",											optionNONE, formatDIGIT, "Sec" },
	{ "T3 Timeout",											optionNONE, formatDIGIT, "Sec" },
	{ "T4 Timeout",											optionNONE, formatDIGIT, "Sec" },
	{ "T6 Timeout",											optionNONE, formatDIGIT, "Sec" },
	{ "T8 Timeout",											optionNONE, formatDIGIT, "Sec" },
};

//--------------------------------------------------------------------
//			- optionBOOL5 : ACTIVE / PASSIVE
//--------------------------------------------------------------------
SETUP_INFO CSetupItems::m_infoHsmsPara[] = 
{
	{ "Initial Comm. State",				optionBOOL6, formatSTRING, "" },
	{ "Initial Control State",				optionTRI_STATE2, formatSTRING, "" },
	{ "Establish Comm. Timeout",			optionNONE, formatDIGIT, "sec" },
	{ "Heart Beat",							optionNONE, formatDIGIT, "sec" },
	{ "T3 Replay Timeout",					optionNONE, formatDIGIT, "sec" },
	{ "T5 Separation Timeout",				optionNONE, formatDIGIT, "sec" },
	{ "T6 Transaction Timeout",				optionNONE, formatDIGIT, "sec" },
	{ "T7 NOT SELECTED Timeout",			optionNONE, formatDIGIT, "sec" },
	{ "T8 Network Inter-character Timeout",	optionNONE, formatDIGIT, "sec" },
	{ "T9 Conversation Timeout",			optionNONE, formatDIGIT, "sec" },
	{ "Link Test Timer (sec)",				optionNONE, formatDIGIT, "sec" },
	{ "Device ID",							optionNONE, formatDIGIT, "" },
	{ "Port Number (Remote)",				optionNONE, formatDIGIT, "" },
	{ "IP ADDRESS (Remote)",				optionNONE, formatFLOAT, "" },
	{ "Connection Mode",					optionBOOL5, formatSTRING, "" },
	{ "EQP ID",								optionNONE, formatSTRING, "" },
	{ "PROCESS ID",							optionNONE, formatSTRING, "" },
	{ "INDEX ID",							optionNONE, formatSTRING, "" },
};

SETUP_INFO CSetupItems::m_infoPartsLifeTimePara[] = 
{
#ifndef _NO_RB
	{ "RB Unit R/B1 Up Brush",		optionNONE, formatDIGIT, "H" },
	{ "RB Unit R/B1 Lo Brush",		optionNONE, formatDIGIT, "H" },
	{ "RB Unit R/B2 Up Brush",		optionNONE, formatDIGIT, "H" },
	{ "RB Unit R/B2 Lo Brush",		optionNONE, formatDIGIT, "H" },
#endif
	{ "FR Unit Pump DI Filter",		optionNONE, formatDIGIT, "H" },
	{ "FR Unit Main DI Filter",		optionNONE, formatDIGIT, "H" },
	{ "SBJ 1 CDA Filter",			optionNONE, formatDIGIT, "H" },
	{ "SBJ 2 CDA Filter",			optionNONE, formatDIGIT, "H" },
	{ "SBJ 3 CDA Filter",			optionNONE, formatDIGIT, "H" },
};

//--------------------------------------------------------------------
//			- optionBOOL5 : ACTIVE / PASSIVE
//--------------------------------------------------------------------
SETUP_INFO CSetupItems::m_infoHsmsPara1[] = 
{
	{ "Initial Comm. State",				optionBOOL6, formatSTRING, "" },
	{ "Initial Control State",				optionTRI_STATE2, formatSTRING, "" },
	{ "Establish Comm. Timeout",			optionNONE, formatDIGIT, "sec" },
	{ "Heart Beat",							optionNONE, formatDIGIT, "sec" },
	{ "T3 Replay Timeout",					optionNONE, formatDIGIT, "sec" },
	{ "T5 Separation Timeout",				optionNONE, formatDIGIT, "sec" },
	{ "T6 Transaction Timeout",				optionNONE, formatDIGIT, "sec" },
	{ "T7 NOT SELECTED Timeout",			optionNONE, formatDIGIT, "sec" },
	{ "T8 Network Inter-character Timeout",	optionNONE, formatDIGIT, "sec" },
	{ "T9 Conversation Timeout",			optionNONE, formatDIGIT, "sec" },
	{ "Link Test Timer (sec)",				optionNONE, formatDIGIT, "sec" },
	{ "Device ID",							optionNONE, formatDIGIT, "" },
	{ "Port Number (Remote)",				optionNONE, formatDIGIT, "" },
	{ "IP ADDRESS (Remote)",				optionNONE, formatFLOAT, "" },
	{ "Connection Mode",					optionBOOL5, formatSTRING, "" },
	{ "EQP ID",								optionNONE, formatSTRING, "" },
	{ "PROCESS ID",							optionNONE, formatSTRING, "" },
	{ "INDEX ID",							optionNONE, formatSTRING, "" },
};
//--------------------------------------------------------------------
//--------------------------------------------------------------------
CString CSetupItems::m_sItemCvLength[] = 
{
	"UP LD Unit In Sensor ~ UP LD Unit Out Sensor",
	"UP LD Unit Out Sensor ~ BUF1 Unit In Sensor",
	"BUF1 Unit In Sensor ~ BUF1 Unit Out Sensor",
	"BUF1 Unit Out Sensor ~ BUF2 Unit In Sensor",
	"BUF2 Unit In Sensor ~ BUF2 Unit Out Sensor",
	"BUF2 Unit Out Sensor ~ BUF3 Unit In Sensor",
	"BUF3 Unit In Sensor ~ BUF3 Unit Out Sensor",
	"BUF3 Unit Out Sensor ~ LD Unit Out Sensor",
	"LD Unit Out Sensor ~ LD Unit In Sensor",
	"LD Unit In Sensor ~ LD Unit Out Sensor",
	"LD Unit Out Sensor ~ EUV Unit In Sensor",
	"EUV Unit In Sensor ~ EUV Unit Out Sensor",
	"EUV Unit Out Sensor ~ RB Unit In Sensor",
	"RB Unit In Sensor ~ RB Unit Out Sensor",
	"RB Unit Out Sensor ~ FR Unit In Sensor",
	"FR Unit In Sensor ~ FR Unit Out Sensor",
	"FR Unit Out Sensor ~ AK Unit In Sensor",
	"AK Unit In Sensor ~ AK Unit Out Sensor",
	"AK Unit Out Sensor ~ UL Unit In Sensor",
	"UL Unit In Sensor ~ UL Unit Out Sensor",
};

CV_INFO CSetupItems::m_infoCvMotorPara[] =
{
	{ "UP_LD Unit C/V Motor",	formatDIGIT, formatDIGIT, formatDIGIT },
	{ "BUF1 Unit C/V Motor",	formatDIGIT, formatDIGIT, formatDIGIT },
	{ "BUF2 Unit C/V Motor",	formatDIGIT, formatDIGIT, formatDIGIT },
	{ "BUF3 Unit C/V Motor",	formatDIGIT, formatDIGIT, formatDIGIT },
	{ "LD Unit C/V Motor",		formatDIGIT, formatDIGIT, formatDIGIT },
	{ "EUV Unit C/V Motor",		formatDIGIT, formatDIGIT, formatDIGIT },
	{ "RB Unit C/V Motor1",		formatDIGIT, formatDIGIT, formatDIGIT },
	{ "RB Unit C/V Motor2",		formatDIGIT, formatDIGIT, formatDIGIT },
	{ "FR Unit C/V Motor",		formatDIGIT, formatDIGIT, formatDIGIT },
	{ "AK Unit C/V Motor1",		formatDIGIT, formatDIGIT, formatDIGIT },
	{ "AK Unit C/V Motor2",		formatDIGIT, formatDIGIT, formatDIGIT },
	{ "UL Unit C/V Motor",		formatDIGIT, formatDIGIT, formatDIGIT },
};

//--------------------------------------------------------------------
CString CSetupItems::m_sItemDvName[] = 
{
	"GLS START TIME",
	"GLS END TIME",
	"EUV PCW IN PRE",
	"EUV PCW OUT PRE",
	"EUV HEAT EXT",
	"EUV ACID EXT",
	"RB SHOW FLOW",
	"RB A/C PRE",
	"SBJ DI FLOW",
	"SBJ1 CDA PRE",
	"SBJ2 CDA PRE",
	"AK UP CDA PRE",
	"AK LO CDA PRE",
	"AK UP CDA FLOW",
	"AK LO CDA FLOW",
	"AK UPPER EXT",
	"AK LOWER EXT",
	"DRV AIR PRE",
};
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSetupItems::CSetupItems()
{

}

void CSetupItems::InitSetupItems()
{
	// Setup Info
	m_nItemNoSetup = sizeof( m_infoSetup ) / sizeof( SETUP_INFO );
	m_nValueSetup_Option = new int[m_nItemNoSetup];
	m_sValueSetup = new CString[m_nItemNoSetup];
	m_nValueSetup_OptionTemp = new int[m_nItemNoSetup];
	m_sValueSetupTemp = new CString[m_nItemNoSetup];

	// DI Tank Level
	m_nItemNoTankLevel = sizeof( m_sNameTankLevel ) / sizeof( CString );
	m_nValueTankLevel = new int[m_nItemNoTankLevel];
	m_nValueTankLevelTemp = new int[m_nItemNoTankLevel];

	// Idle Run Info
	m_nItemNoIdleRun = sizeof( m_infoIdleRun ) / sizeof( SETUP_INFO );
	m_nValueIdleRun = new int[m_nItemNoIdleRun];
	m_nValueIdleRunTemp = new int[m_nItemNoIdleRun];

	// InSensor Off TimeOut Interlock
	m_nItemNoInSensorTimeOut		= sizeof( m_sItemInSensorOffTimeOut ) / sizeof( CString );
	m_nValueInSensorOffTimeOut		= new int[m_nItemNoInSensorTimeOut];
	m_nValueInSensorOffTimeOutTemp	= new int[m_nItemNoInSensorTimeOut];

	// OutSensor Off TimeOut Interlock
	m_nItemNoOutSensorTimeOut		= sizeof( m_sItemOutSensorOffTimeOut ) / sizeof( CString );
	m_nValueOutSensorOffTimeOut		= new int[m_nItemNoOutSensorTimeOut];
	m_nValueOutSensorOffTimeOutTemp	= new int[m_nItemNoOutSensorTimeOut];

	// Gauge Limit
	m_nItemNoGaugeLimit = m_pEqpAssy->m_AnalogInput.GetAiSize(); // sizeof( m_infoGaugeLimit ) / sizeof( SETUP_INFO );

	// i = 0 : // MIN
	// i = 1 : // Warning MIN
	// i = 2 : // Warning MAX
	// i = 3 : // MAX
	for( int i=0; i<4; i++ ) 
	{
		m_nValueGaugeLimit[i]		= new int[m_nItemNoGaugeLimit];
		m_nValueGaugeLimitTemp[i]	= new int[m_nItemNoGaugeLimit];
	}
	m_nValueGaugeLimit_Option		= new int[m_nItemNoGaugeLimit];
	m_nValueGaugeLimit_OptionTemp	= new int[m_nItemNoGaugeLimit];

	// Sensor Interlock
	m_nItemNoBathCoverIntr    = sizeof( m_sItemBathCoverIntr ) / sizeof( CString );
	m_nValueBathCoverIntr	   = new int[m_nItemNoBathCoverIntr];
	m_nValueBathCoverIntrTemp = new int[m_nItemNoBathCoverIntr];

	m_nItemNoDoorIntr    = sizeof( m_sItemDoorIntr ) / sizeof( CString );
	m_nValueDoorIntr	   = new int[m_nItemNoDoorIntr];
	m_nValueDoorIntrTemp = new int[m_nItemNoDoorIntr];

	m_nItemNoLeakDetectIntr    = sizeof( m_sItemLeakDetectIntr ) / sizeof( CString );
	m_nValueLeakDetectIntr	   = new int[m_nItemNoLeakDetectIntr];
	m_nValueLeakDetectIntrTemp = new int[m_nItemNoLeakDetectIntr];

	m_nItemNoFFUAlarmIntr    = sizeof( m_sItemFFUAlarmIntr ) / sizeof( CString );
	m_nValueFFUAlarmIntr	   = new int[m_nItemNoFFUAlarmIntr];
	m_nValueFFUAlarmIntrTemp = new int[m_nItemNoFFUAlarmIntr];

	m_nItemNoBrokenIntr    = sizeof( m_sItemBrokenIntr ) / sizeof( CString );
	m_nValueBrokenIntr	   = new int[m_nItemNoBrokenIntr];
	m_nValueBrokenIntrTemp = new int[m_nItemNoBrokenIntr];

	m_nItemNoETCIntr    = sizeof( m_sItemETCIntr ) / sizeof( CString );
	m_nValueETCIntr	   = new int[m_nItemNoETCIntr];
	m_nValueETCIntrTemp = new int[m_nItemNoETCIntr];

	// HSMS Parameter
	m_nItemNoHsmsPara		= sizeof( m_infoHsmsPara ) / sizeof( SETUP_INFO );
	m_sValueHsmsPara		= new CString[m_nItemNoHsmsPara];
	m_sValueHsmsParaTemp	= new CString[m_nItemNoHsmsPara];

	// HSMS1 Parameter
	m_nItemNoHsmsPara1		= sizeof( m_infoHsmsPara1 ) / sizeof( SETUP_INFO );
	m_sValueHsmsPara1		= new CString[m_nItemNoHsmsPara1];
	m_sValueHsmsParaTemp1	= new CString[m_nItemNoHsmsPara1];

	// Interface Parameter
	m_nItemNoInterfacePara		= sizeof( m_infoInterfacePara ) / sizeof( SETUP_INFO );
	m_sValueInterfacePara		= new CString[m_nItemNoInterfacePara];
	m_sValueInterfaceParaTemp	= new CString[m_nItemNoInterfacePara];

	// Parts LifeTime Parameter
	m_nItemNoPartsLifeTimePara		= sizeof( m_infoPartsLifeTimePara ) / sizeof( SETUP_INFO );
	for( i = 0; i < 2; i++ )
	{
		m_nValuePartsLifeTimePara[i]		= new int[m_nItemNoPartsLifeTimePara];
		m_nValuePartsLifeTimeParaTemp[i] 	= new int[m_nItemNoPartsLifeTimePara];
	}

	// CV Length
	m_nItemNoCvLength		= sizeof( m_sItemCvLength ) / sizeof( CString );
	m_fValueCvLength		= new double[m_nItemNoCvLength];
	m_fValueCvLengthTemp	= new double[m_nItemNoCvLength];

	// CV Motor Parameter
	m_nItemNoCvMotorPara		= sizeof( m_infoCvMotorPara ) / sizeof( CV_INFO );	// ljy_050401 : change CString->CV_INFO
	m_fValueCvMotorRatio		= new double[m_nItemNoCvMotorPara];
	m_fValueCvMotorRatioTemp	= new double[m_nItemNoCvMotorPara];
	m_fValueCvMotorDia				= new double[m_nItemNoCvMotorPara];
	m_fValueCvMotorDiaTemp			= new double[m_nItemNoCvMotorPara];
	m_fValueCvMotorVelRatio			= new double[m_nItemNoCvMotorPara];
	m_fValueCvMotorVelRatioTemp		= new double[m_nItemNoCvMotorPara];

	m_nItemNoDvName			= sizeof( m_sItemDvName ) / sizeof( CString );
	m_sValueDvName			= new CString[m_nItemNoDvName];
	m_sValueDvNameTemp		= new CString[m_nItemNoDvName];

	// Clear the flag
	m_bCalReq	= FALSE;
	m_bCalCancel = FALSE;
}

CSetupItems::~CSetupItems()
{
	delete []m_nValueSetup_Option;
	delete []m_sValueSetup;
	delete []m_nValueSetup_OptionTemp;
	delete []m_sValueSetupTemp;

	delete []m_nValueIdleRun;
	delete []m_nValueIdleRunTemp;

	delete []m_nValueTankLevel;
	delete []m_nValueTankLevelTemp;

	delete []m_nValueInSensorOffTimeOut;
	delete []m_nValueInSensorOffTimeOutTemp;
	delete []m_nValueOutSensorOffTimeOut;
	delete []m_nValueOutSensorOffTimeOutTemp;

	for( int i=0; i<4; i++ ) 
	{
		delete []m_nValueGaugeLimit[i];
		delete []m_nValueGaugeLimitTemp[i];
	}
	delete []m_nValueGaugeLimit_Option;
	delete []m_nValueGaugeLimit_OptionTemp;

	delete []m_nValueBathCoverIntr;
	delete []m_nValueBathCoverIntrTemp;
	delete []m_nValueDoorIntr;
	delete []m_nValueDoorIntrTemp;
	delete []m_nValueLeakDetectIntr;
	delete []m_nValueLeakDetectIntrTemp;
	delete []m_nValueFFUAlarmIntr;
	delete []m_nValueFFUAlarmIntrTemp;
	delete []m_nValueBrokenIntr;
	delete []m_nValueBrokenIntrTemp;
	delete []m_nValueETCIntr;
	delete []m_nValueETCIntrTemp;

	delete []m_sValueHsmsPara;
	delete []m_sValueHsmsParaTemp;
	delete []m_sValueInterfacePara;
	delete []m_sValueInterfaceParaTemp;

	delete []m_sValueHsmsPara1;
	delete []m_sValueHsmsParaTemp1;

	for( i=0; i<2; i++ ) 
	{
		delete []m_nValuePartsLifeTimePara[i];
		delete []m_nValuePartsLifeTimeParaTemp[i];
	}

	delete []m_fValueCvLength;
	delete []m_fValueCvLengthTemp;

	delete [] m_fValueCvMotorRatio;
	delete [] m_fValueCvMotorRatioTemp;
	delete [] m_fValueCvMotorDia;
	delete [] m_fValueCvMotorDiaTemp;
	delete [] m_fValueCvMotorVelRatio;
	delete [] m_fValueCvMotorVelRatioTemp;

	delete []m_sValueDvName;
	delete []m_sValueDvNameTemp;
}

//--------------------------------------------------------------------
// InitTempVarTab1()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabJobCondView()
{
	for( int i=0; i<m_nItemNoSetup; i++ ) 
	{
		m_nValueSetup_OptionTemp[i] = m_nValueSetup_Option[i];
		m_sValueSetupTemp[i] = m_sValueSetup[i];
	}
	for( i=0; i<m_nItemNoIdleRun; i++ ) m_nValueIdleRunTemp[i] = m_nValueIdleRun[i];
	for( i=0; i<m_nItemNoTankLevel; i++ ) m_nValueTankLevelTemp[i] = m_nValueTankLevel[i];

	for( i=0; i<m_nItemNoPartsLifeTimePara; i++ )
	{
		m_nValuePartsLifeTimeParaTemp[0][i] = m_nValuePartsLifeTimePara[0][i];
		m_nValuePartsLifeTimeParaTemp[1][i] = m_nValuePartsLifeTimePara[1][i];
	}
}

//--------------------------------------------------------------------
// InitTempVarTab2()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabInterlockSetView()
{

	for( int i=0; i<m_nItemNoGaugeLimit; i++ ) 
	{
		m_nValueGaugeLimitTemp[0][i] = m_nValueGaugeLimit[0][i];
		m_nValueGaugeLimitTemp[1][i] = m_nValueGaugeLimit[1][i];
		m_nValueGaugeLimitTemp[2][i] = m_nValueGaugeLimit[2][i];
		m_nValueGaugeLimitTemp[3][i] = m_nValueGaugeLimit[3][i];
		
		m_nValueGaugeLimit_OptionTemp[i] = m_nValueGaugeLimit_Option[i];
	}
}

//--------------------------------------------------------------------
// InitTempVarTab2()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabInterlockSet2View()
{
	for( int i=0; i<m_nItemNoBathCoverIntr; i++ )
	{
		m_nValueBathCoverIntrTemp[i] = m_nValueBathCoverIntr[i];
	}
	for( i=0; i<m_nItemNoDoorIntr; i++ )
	{
		m_nValueDoorIntrTemp[i] = m_nValueDoorIntr[i];
	}
	for( i=0; i<m_nItemNoLeakDetectIntr; i++ )
	{
		m_nValueLeakDetectIntrTemp[i] = m_nValueLeakDetectIntr[i];
	}
	for( i=0; i<m_nItemNoFFUAlarmIntr; i++ )
	{
		m_nValueFFUAlarmIntrTemp[i] = m_nValueFFUAlarmIntr[i];
	}
	for( i=0; i<m_nItemNoBrokenIntr; i++ )
	{
		m_nValueBrokenIntrTemp[i] = m_nValueBrokenIntr[i];
	}
	for( i=0; i<m_nItemNoETCIntr; i++ )
	{
		m_nValueETCIntrTemp[i] = m_nValueETCIntr[i];
	}


}

//--------------------------------------------------------------------
// InitTempVarTab3()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabInterfaceParaView()
{
	for( int i=0; i<m_nItemNoHsmsPara; i++ ) m_sValueHsmsParaTemp[i] = m_sValueHsmsPara[i];
	for( i=0; i<m_nItemNoInterfacePara; i++ ) m_sValueInterfaceParaTemp[i] = m_sValueInterfacePara[i];
}

//--------------------------------------------------------------------
// InitTempVarTab3()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabInterfaceParaView1()
{
	for( int i=0; i<m_nItemNoHsmsPara1; i++ )
	{
		m_sValueHsmsParaTemp1[i] = m_sValueHsmsPara1[i];
	}
}

//--------------------------------------------------------------------
// InitTempVarTab4()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabCVDistanceSetView()
{
	int i;
	for( i=0; i<m_nItemNoCvLength; i++ ) m_fValueCvLengthTemp[i] = m_fValueCvLength[i];
	for( i=0; i<m_nItemNoInSensorTimeOut; i++ ) m_nValueInSensorOffTimeOutTemp[i] = m_nValueInSensorOffTimeOut[i];
	for( i=0; i<m_nItemNoOutSensorTimeOut; i++ ) m_nValueOutSensorOffTimeOutTemp[i] = m_nValueOutSensorOffTimeOut[i];
}

//--------------------------------------------------------------------
// InitTempVarTab5()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabCVMotorParaView()
{
	for( int i=0; i<m_nItemNoCvMotorPara; i++ )
	{
		m_fValueCvMotorRatioTemp[i]		= m_fValueCvMotorRatio[i];
		m_fValueCvMotorDiaTemp[i]		= m_fValueCvMotorDia[i];
		m_fValueCvMotorVelRatioTemp[i]	= m_fValueCvMotorVelRatio[i];
	}
}

//--------------------------------------------------------------------
// InitTempVarTab6()
//--------------------------------------------------------------------
void CSetupItems::InitTempVarTabDVParaView()
{
	for( int i=0; i<m_nItemNoDvName; i++ ) m_sValueDvNameTemp[i] = m_sValueDvName[i];
}

//--------------------------------------------------------------------
// IsSetupChangedTab1()
//--------------------------------------------------------------------
BOOL CSetupItems::IsSetupChangedTabJobCondView()
{
	for( int i=0; i<m_nItemNoSetup; i++ )
	{
		if( m_nValueSetup_OptionTemp[i] != m_nValueSetup_Option[i] ) return TRUE;
		if( m_sValueSetupTemp[i] != m_sValueSetup[i] ) return TRUE;
	}

	for( i=0; i<m_nItemNoIdleRun; i++ )
	{
		if( m_nValueIdleRunTemp[i] != m_nValueIdleRun[i] ) return TRUE;
	}

	for( i=0; i<m_nItemNoTankLevel; i++ )
	{
		if( m_nValueTankLevelTemp[i] != m_nValueTankLevel[i] ) return TRUE;
	}

	for( i=0; i<m_nItemNoPartsLifeTimePara; i++ )
	{
		if( m_nValuePartsLifeTimeParaTemp[0][i] != m_nValuePartsLifeTimePara[0][i] ) return TRUE;
		if( m_nValuePartsLifeTimeParaTemp[1][i] != m_nValuePartsLifeTimePara[1][i] ) return TRUE;
	}

	return FALSE;
}

//--------------------------------------------------------------------
// IsSetupChangedTab2()
//--------------------------------------------------------------------
BOOL CSetupItems::IsSetupChangedTabInterlockSetView()
{

	for( int i=0; i<m_nItemNoGaugeLimit; i++ )
	{
		for( int j=0; j<4; j++ )
		{
			if( m_nValueGaugeLimitTemp[j][i] != m_nValueGaugeLimit[j][i] ) return TRUE;
		}
		if( m_nValueGaugeLimit_OptionTemp[i] != m_nValueGaugeLimit_Option[i] ) return TRUE;
	}

	return FALSE;
}

//--------------------------------------------------------------------
// IsSetupChangedTab2()
//--------------------------------------------------------------------
BOOL CSetupItems::IsSetupChangedTabInterlockSet2View()
{

	for( int i=0; i<m_nItemNoBathCoverIntr; i++ )
	{
		if( m_nValueBathCoverIntrTemp[i] != m_nValueBathCoverIntr[i] ) return TRUE;
	}
	for( i=0; i<m_nItemNoDoorIntr; i++ )
	{
		if( m_nValueDoorIntrTemp[i] != m_nValueDoorIntr[i] ) return TRUE;
	}
	for( i=0; i<m_nItemNoLeakDetectIntr; i++ )
	{
		if( m_nValueLeakDetectIntrTemp[i] != m_nValueLeakDetectIntr[i] ) return TRUE;
	}
	for( i=0; i<m_nItemNoFFUAlarmIntr; i++ )
	{
		if( m_nValueFFUAlarmIntrTemp[i] != m_nValueFFUAlarmIntr[i] ) return TRUE;
	}
	for( i=0; i<m_nItemNoBrokenIntr; i++ )
	{
		if( m_nValueBrokenIntrTemp[i] != m_nValueBrokenIntr[i] ) return TRUE;
	}
	for( i=0; i<m_nItemNoETCIntr; i++ )
	{
		if( m_nValueETCIntrTemp[i] != m_nValueETCIntr[i] ) return TRUE;
	}

	return FALSE;
}


//--------------------------------------------------------------------
// IsSetupChangedTab3()
//--------------------------------------------------------------------
BOOL CSetupItems::IsSetupChangedTabCVDistanceSetView()
{
	int i;
	for( i=0; i<m_nItemNoCvLength; i++ )
	{
		if( m_fValueCvLengthTemp[i] != m_fValueCvLength[i] ) return TRUE;
	}

	for( i=0; i<m_nItemNoInSensorTimeOut; i++ )
	{
		if( m_nValueInSensorOffTimeOutTemp[i] != m_nValueInSensorOffTimeOut[i] ) return TRUE;
	}

	for( i=0; i<m_nItemNoOutSensorTimeOut; i++ )
	{
		if( m_nValueOutSensorOffTimeOutTemp[i] != m_nValueOutSensorOffTimeOut[i] ) return TRUE;
	}

	return FALSE;
}

BOOL CSetupItems::IsSetupChangedTabInterfaceParaView()
{
	for( int i=0; i<m_nItemNoHsmsPara; i++ )
	{
		if( m_sValueHsmsParaTemp[i] != m_sValueHsmsPara[i] ) return TRUE;
	}
	for( i=0; i<m_nItemNoInterfacePara; i++ )
	{
		if( m_sValueInterfaceParaTemp[i] != m_sValueInterfacePara[i] ) return TRUE;
	}

	return FALSE;
}

BOOL CSetupItems::IsSetupChangedTabInterfaceParaView1()
{
	for( int i=0; i<m_nItemNoHsmsPara1; i++ )
	{
		if( m_sValueHsmsParaTemp1[i] != m_sValueHsmsPara1[i] ) return TRUE;
	}
	return FALSE;
}
//--------------------------------------------------------------------
// IsSetupChangedTab4()
//--------------------------------------------------------------------
BOOL CSetupItems::IsSetupChangedTabCVMotorParaView()
{
	for( int i=0; i<m_nItemNoCvMotorPara; i++ )
	{
		if( m_fValueCvMotorRatioTemp[i] != m_fValueCvMotorRatio[i] ) return TRUE;
		if( m_fValueCvMotorDiaTemp[i] != m_fValueCvMotorDia[i] ) return TRUE;
		if( m_fValueCvMotorVelRatioTemp[i] != m_fValueCvMotorVelRatio[i] ) return TRUE;
	}

	return FALSE;
}

//--------------------------------------------------------------------
// IsSetupChangedTab5()
//--------------------------------------------------------------------
BOOL CSetupItems::IsSetupChangedTabDVParaView()
{
	for( int i=0; i<m_nItemNoDvName; i++ )
	{
		if( m_sValueDvNameTemp[i] != m_sValueDvName[i] ) return TRUE;
	}

	return FALSE;
}

//--------------------------------------------------------------------
// GetRegistryTab1()
//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabJobCondView()
{
	m_IniSetUpInfo.Open("JobCon","SETUPINFO");

	for( int i=0; i<m_nItemNoSetup; i++ )
	{
		CString sBuf;
		m_nValueSetup_Option[i] = m_IniSetUpInfo.GetIntValue( "JOB CONDITION OPTION", m_infoSetup[i].sName, 0 );
		m_nValueSetup_OptionTemp[i] = m_nValueSetup_Option[i];
		m_sValueSetup[i] = m_IniSetUpInfo.GetStringValue( "JOB CONDITION VALUE", m_infoSetup[i].sName, "10" );
		m_sValueSetupTemp[i] = m_sValueSetup[i];
	}

	for( i=0; i<m_nItemNoIdleRun; i++ )
	{
		m_nValueIdleRun[i] = m_IniSetUpInfo.GetIntValue( "IDLE CONDITION", m_infoIdleRun[i].sName, 0 );
		m_nValueIdleRunTemp[i] = m_nValueIdleRun[i];
	}

	for( i=0; i<m_nItemNoTankLevel; i++ )
	{
		m_nValueTankLevel[i] = m_IniSetUpInfo.GetIntValue( "TANK LEVEL SET", m_sNameTankLevel[i], 0 );
		m_nValueTankLevelTemp[i] = m_nValueTankLevel[i];
	}

	for( i=0; i<m_nItemNoPartsLifeTimePara; i++ )
	{
		m_nValuePartsLifeTimePara[0][i] = 
			m_IniSetUpInfo.GetIntValue( "PARTS LIFE TIME (GLASS COUNT)", m_infoPartsLifeTimePara[i].sName, 10 );
		m_nValuePartsLifeTimeParaTemp[0][i] = m_nValuePartsLifeTimePara[0][i];
		
		m_nValuePartsLifeTimePara[1][i] = 
			m_IniSetUpInfo.GetIntValue( "PARTS LIFE TIME (RUN TIME)", m_infoPartsLifeTimePara[i].sName, 10 );
		m_nValuePartsLifeTimeParaTemp[1][i] = m_nValuePartsLifeTimePara[1][i];
	}
}

//--------------------------------------------------------------------
// GetRegistrySensorIntr()
// m_nValueGaugeLimit[i][j]
//	i : 0 ~ 4 : MIN, W_MIN, W_MAX, MAX
//	j : 0 ~ m_nItemNoGaugeLimit
//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabInterlockSetView()
{
	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		int nReal = m_pEqpAssy->m_AnalogInput.GetAddress( i );
		int nIntrNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nAiIntrNo;
		if( nIntrNo < 0 ) continue;
		m_pDevice->GetInterlockPara( nReal, m_nValueGaugeLimit_Option[nIntrNo], 
			m_nValueGaugeLimit[3][nIntrNo], m_nValueGaugeLimit[0][nIntrNo] );
		m_pDevice->GetWarningPara( nReal, m_nValueGaugeLimit_Option[nIntrNo],
			m_nValueGaugeLimit[2][nIntrNo], m_nValueGaugeLimit[1][nIntrNo] );

		m_nValueGaugeLimit_OptionTemp[nIntrNo] = m_nValueGaugeLimit_Option[nIntrNo];
		for( int j=0; j<4; j++ )
		{
			m_nValueGaugeLimitTemp[j][nIntrNo] = m_nValueGaugeLimit[j][nIntrNo];
		}
	}
}

//--------------------------------------------------------------------
// GetRegistrySensorIntr()
// m_nValueGaugeLimit[i][j]
//	i : 0 ~ 4 : MIN, W_MIN, W_MAX, MAX
//	j : 0 ~ m_nItemNoGaugeLimit
//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabInterlockSet2View()
{
	m_IniSetUpInfo.Open("EqpInterlock","SETUPINFO");

	for( int i=0; i<m_nItemNoBathCoverIntr; i++ )
	{
		m_nValueBathCoverIntr[i] = m_IniSetUpInfo.GetIntValue( "INTERLOCK SET(COVER)", m_sItemBathCoverIntr[i], 0 );
		m_nValueBathCoverIntrTemp[i] = m_nValueBathCoverIntr[i];
	}
	for( i=0; i<m_nItemNoDoorIntr; i++ )
	{
		m_nValueDoorIntr[i] = m_IniSetUpInfo.GetIntValue( "INTERLOCK SET(DOOR)", m_sItemDoorIntr[i], 0 );
		m_nValueDoorIntrTemp[i] = m_nValueDoorIntr[i];
	}
	for( i=0; i<m_nItemNoLeakDetectIntr; i++ )
	{
		m_nValueLeakDetectIntr[i] = m_IniSetUpInfo.GetIntValue( "INTERLOCK SET(LEAK)", m_sItemLeakDetectIntr[i], 0 );
		m_nValueLeakDetectIntrTemp[i] = m_nValueLeakDetectIntr[i];
	}
	for( i=0; i<m_nItemNoFFUAlarmIntr; i++ )
	{
		m_nValueFFUAlarmIntr[i] = m_IniSetUpInfo.GetIntValue( "INTERLOCK SET(FFU)", m_sItemFFUAlarmIntr[i], 0 );
		m_nValueFFUAlarmIntrTemp[i] = m_nValueFFUAlarmIntr[i];
	}
	for( i=0; i<m_nItemNoBrokenIntr; i++ )
	{
		m_nValueBrokenIntr[i] = m_IniSetUpInfo.GetIntValue( "INTERLOCK SET(BROKEN)", m_sItemBrokenIntr[i], 0 );
		m_nValueBrokenIntrTemp[i] = m_nValueBrokenIntr[i];
	}
	for( i=0; i<m_nItemNoETCIntr; i++ )
	{
		m_nValueETCIntr[i] = m_IniSetUpInfo.GetIntValue( "INTERLOCK SET(ETC)", m_sItemETCIntr[i], 0 );
		m_nValueETCIntrTemp[i] = m_nValueETCIntr[i];
	}
}

//--------------------------------------------------------------------
// GetRegistryTab4()
//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabInterfaceParaView()
{
	m_IniSetUpInfo.Open("Interface","SETUPINFO");

	for( int i=0; i<m_nItemNoHsmsPara; i++ )
	{
		m_sValueHsmsPara[i] = m_IniSetUpInfo.GetStringValue( "HSMS PARAMETER", m_infoHsmsPara[i].sName, "10" );
		m_sValueHsmsParaTemp[i] = m_sValueHsmsPara[i];
	}

	for( i=0; i<m_nItemNoInterfacePara; i++ )
	{
		m_sValueInterfacePara[i] = m_IniSetUpInfo.GetStringValue( "I/F PARAMETER", m_infoInterfacePara[i].sName, "10" );
		m_sValueInterfaceParaTemp[i] = m_sValueInterfacePara[i];
	}
}

//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabInterfaceParaView1()
{
	m_IniSetUpInfo.Open("Interface1","SETUPINFO");

	for( int i=0; i<m_nItemNoHsmsPara1; i++ )
	{
		m_sValueHsmsPara1[i] = m_IniSetUpInfo.GetStringValue( "HSMS PARAMETER(2)", m_infoHsmsPara1[i].sName, "10" );
		m_sValueHsmsParaTemp1[i] = m_sValueHsmsPara1[i];
	}
}
// GetRegistryTab5()
//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabCVDistanceSetView()
{
	m_IniSetUpInfo.Open("CvDistancePara","SETUPINFO");

	int i;	
	for( i=0; i<m_nItemNoCvLength; i++ )
	{
		CString sBuf = m_IniSetUpInfo.GetStringValue( "C/V DISTANCE", (LPCTSTR)m_sItemCvLength[i], "100" );
		m_fValueCvLength[i] = atof( sBuf );
		m_fValueCvLengthTemp[i] = m_fValueCvLength[i];
	}
	
	for( i=0; i<m_nItemNoInSensorTimeOut; i++ )
	{
		m_nValueInSensorOffTimeOut[i] = m_IniSetUpInfo.GetIntValue( "IN SENSOR OFF TIMEOUT", (LPCTSTR)m_sItemInSensorOffTimeOut[i], 0 );
		m_nValueInSensorOffTimeOutTemp[i] = m_nValueInSensorOffTimeOut[i];
	}

	for( i=0; i<m_nItemNoOutSensorTimeOut; i++ )
	{
		m_nValueOutSensorOffTimeOut[i] = m_IniSetUpInfo.GetIntValue( "OUT SENSOR OFF TIMEOUT", (LPCTSTR)m_sItemOutSensorOffTimeOut[i], 0 );
		m_nValueOutSensorOffTimeOutTemp[i] = m_nValueOutSensorOffTimeOut[i];
	}
}

//--------------------------------------------------------------------
// GetRegistryTab6()
//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabCVMotorParaView() // minhanx 080922 ̰Ŵ ̻..eqpassy cvmotor setting.
{
/*	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	CString sBuf;
	for( int i=0; i<m_nItemNoCvMotorPara; i++ )
	{
		CString sBuf;
		sBuf = m_IniSetUpInfo.GetStringValue( "C/V MOTOR RATIO", m_infoCvMotorPara[i].sName, "10" );
		m_fValueCvMotorRatio[i] = atof( sBuf );
		m_fValueCvMotorRatioTemp[i] = m_fValueCvMotorRatio[i];

		sBuf = m_IniSetUpInfo.GetStringValue( "C/V MOTOR DIAMETER", m_infoCvMotorPara[i].sName, "60" );
		m_fValueCvMotorDia[i] = atof( sBuf );
		m_fValueCvMotorDiaTemp[i] = m_fValueCvMotorDia[i];

		sBuf = m_IniSetUpInfo.GetStringValue( "C/V MOTOR VELOCITY", m_infoCvMotorPara[i].sName, "1" );
		m_fValueCvMotorVelRatio[i] = atof( sBuf );
		m_fValueCvMotorVelRatioTemp[i] = m_fValueCvMotorVelRatio[i];
	}
*/
}

//--------------------------------------------------------------------
// GetRegistryTab7()
//--------------------------------------------------------------------
void CSetupItems::GetRegistryTabDVParaView()
{
	m_IniSetUpInfo.Open("DV PARA","SETUPINFO");

	for( int i=0; i<m_nItemNoDvName; i++ )
	{
		m_sValueDvName[i] = m_IniSetUpInfo.GetStringValue( "D/V PARAMETER", m_sItemDvName[i], "" );
		m_sValueDvNameTemp[i] = m_sValueDvName[i];
	}
}

//--------------------------------------------------------------------
// SetRegistrySensorIntr()
//--------------------------------------------------------------------
void CSetupItems::SetRegistryTabJobCondView()
{
	m_IniSetUpInfo.Open("JobCon","SETUPINFO");

	for( int i=0; i<m_nItemNoSetup; i++ )
	{
		m_nValueSetup_Option[i] = m_nValueSetup_OptionTemp[i];
		m_sValueSetup[i] = m_sValueSetupTemp[i];

		m_IniSetUpInfo.SetIntValue( "JOB CONDITION OPTION", m_infoSetup[i].sName, m_nValueSetup_Option[i], TRUE );
		m_IniSetUpInfo.SetStringValue( "JOB CONDITION VALUE", m_infoSetup[i].sName, m_sValueSetup[i], TRUE );
	}

	for( i=0; i<m_nItemNoIdleRun; i++ )
	{
		m_nValueIdleRun[i] = m_nValueIdleRunTemp[i];
		m_IniSetUpInfo.SetIntValue( "IDLE CONDITION", m_infoIdleRun[i].sName, m_nValueIdleRun[i], TRUE );
	}

		for( i=0; i<m_nItemNoTankLevel; i++ )
	{
		m_nValueTankLevel[i] = m_nValueTankLevelTemp[i];
		m_IniSetUpInfo.SetIntValue( "TANK LEVEL SET", m_sNameTankLevel[i], m_nValueTankLevel[i], TRUE );
	}

	for( i=0; i<m_nItemNoPartsLifeTimePara; i++ )
	{
		m_nValuePartsLifeTimePara[0][i] = m_nValuePartsLifeTimeParaTemp[0][i];
		m_IniSetUpInfo.SetIntValue( "PARTS LIFE TIME (GLASS COUNT)", 
			m_infoPartsLifeTimePara[i].sName, m_nValuePartsLifeTimePara[0][i], TRUE );

		m_nValuePartsLifeTimePara[1][i] = m_nValuePartsLifeTimeParaTemp[1][i];
		m_IniSetUpInfo.SetIntValue( "PARTS LIFE TIME (RUN TIME)", 
			m_infoPartsLifeTimePara[i].sName, m_nValuePartsLifeTimePara[1][i], TRUE );
	}
}

//--------------------------------------------------------------------
// SetRegistrySensorIntr()
//--------------------------------------------------------------------
void CSetupItems::SetRegistryTabInterlockSetView()
{
	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		int nReal = m_pEqpAssy->m_AnalogInput.GetAddress( i );
		int nIntrNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nAiIntrNo;
		if( nIntrNo < 0 ) continue;
		
		m_nValueGaugeLimit_Option[nIntrNo] = m_nValueGaugeLimit_OptionTemp[nIntrNo];
		for( int j=0; j<4; j++ )
		{
			m_nValueGaugeLimit[j][nIntrNo] = m_nValueGaugeLimitTemp[j][nIntrNo];
		}

		m_pDevice->SetInterlockPara( nReal, m_nValueGaugeLimit_Option[nIntrNo], 
			m_nValueGaugeLimit[3][nIntrNo], m_nValueGaugeLimit[0][nIntrNo] );
		m_pDevice->SetWarningPara( nReal, m_nValueGaugeLimit_Option[nIntrNo],
			m_nValueGaugeLimit[2][nIntrNo], m_nValueGaugeLimit[1][nIntrNo] );
	}
}
//--------------------------------------------------------------------
// SetRegistrySensorIntr()
//--------------------------------------------------------------------
void CSetupItems::SetRegistryTabInterlockSet2View()
{
	m_IniSetUpInfo.Open("EqpInterlock","SETUPINFO");

	for( int i=0; i<m_nItemNoBathCoverIntr; i++ )
	{
		m_nValueBathCoverIntr[i] = m_nValueBathCoverIntrTemp[i];
		m_IniSetUpInfo.SetIntValue( "INTERLOCK SET(COVER)", m_sItemBathCoverIntr[i], m_nValueBathCoverIntr[i], TRUE );
	}
	for( i=0; i<m_nItemNoDoorIntr; i++ )
	{
		m_nValueDoorIntr[i] = m_nValueDoorIntrTemp[i];
		m_IniSetUpInfo.SetIntValue( "INTERLOCK SET(DOOR)", m_sItemDoorIntr[i], m_nValueDoorIntr[i], TRUE );
	}
	for( i=0; i<m_nItemNoLeakDetectIntr; i++ )
	{
		m_nValueLeakDetectIntr[i] = m_nValueLeakDetectIntrTemp[i];
		m_IniSetUpInfo.SetIntValue( "INTERLOCK SET(LEAK)", m_sItemLeakDetectIntr[i], m_nValueLeakDetectIntr[i], TRUE );
	}
	for( i=0; i<m_nItemNoFFUAlarmIntr; i++ )
	{
		m_nValueFFUAlarmIntr[i] = m_nValueFFUAlarmIntrTemp[i];
		m_IniSetUpInfo.SetIntValue( "INTERLOCK SET(FFU)", m_sItemFFUAlarmIntr[i], m_nValueFFUAlarmIntr[i], TRUE );
	}
	for( i=0; i<m_nItemNoBrokenIntr; i++ )
	{
		m_nValueBrokenIntr[i] = m_nValueBrokenIntrTemp[i];
		m_IniSetUpInfo.SetIntValue( "INTERLOCK SET(BROKEN)", m_sItemBrokenIntr[i], m_nValueBrokenIntr[i], TRUE );
	}
	for( i=0; i<m_nItemNoETCIntr; i++ )
	{
		m_nValueETCIntr[i] = m_nValueETCIntrTemp[i];
		m_IniSetUpInfo.SetIntValue( "INTERLOCK SET(ETC)", m_sItemETCIntr[i], m_nValueETCIntr[i], TRUE );
	}

}
//--------------------------------------------------------------------
// SetRegistryTab3()
//--------------------------------------------------------------------
void CSetupItems::SetRegistryTabCVDistanceSetView()
{
	m_IniSetUpInfo.Open("CvDistancePara","SETUPINFO");

	int i;
	for( i=0; i<m_nItemNoCvLength; i++ )
	{
		CString sBuf;
		m_fValueCvLength[i] = m_fValueCvLengthTemp[i];
		sBuf.Format( "%.1f", m_fValueCvLength[i] );
		m_IniSetUpInfo.SetStringValue( "C/V DISTANCE", m_sItemCvLength[i], sBuf, TRUE );
	}

	for( i=0; i<m_nItemNoInSensorTimeOut; i++ )
	{
		m_nValueInSensorOffTimeOut[i] = m_nValueInSensorOffTimeOutTemp[i];
		m_IniSetUpInfo.SetIntValue( "IN SENSOR OFF TIMEOUT", m_sItemInSensorOffTimeOut[i], m_nValueInSensorOffTimeOut[i], TRUE );
	}

	for( i=0; i<m_nItemNoOutSensorTimeOut; i++ )
	{
		m_nValueOutSensorOffTimeOut[i] = m_nValueOutSensorOffTimeOutTemp[i];
		m_IniSetUpInfo.SetIntValue( "OUT SENSOR OFF TIMEOUT", m_sItemOutSensorOffTimeOut[i], m_nValueOutSensorOffTimeOut[i], TRUE );
	}
}

void CSetupItems::SetRegistryTabInterfaceParaView()
{
	m_IniSetUpInfo.Open("Interface","SETUPINFO");

	for( int i=0; i<m_nItemNoHsmsPara; i++ )
	{
		m_sValueHsmsPara[i] = m_sValueHsmsParaTemp[i];
		m_IniSetUpInfo.SetStringValue( "HSMS PARAMETER", m_infoHsmsPara[i].sName, m_sValueHsmsPara[i], TRUE );
	}

	for( i=0; i<m_nItemNoInterfacePara; i++ )
	{
		m_sValueInterfacePara[i] = m_sValueInterfaceParaTemp[i];
		m_IniSetUpInfo.SetStringValue( "I/F PARAMETER", m_infoInterfacePara[i].sName, m_sValueInterfacePara[i], TRUE );
	}
}

void CSetupItems::SetRegistryTabInterfaceParaView1()
{
	m_IniSetUpInfo.Open("Interface1","SETUPINFO");

	for( int i=0; i<m_nItemNoHsmsPara1; i++ )
	{
		m_sValueHsmsPara1[i] = m_sValueHsmsParaTemp1[i];
		m_IniSetUpInfo.SetStringValue( "HSMS PARAMETER(2)", m_infoHsmsPara1[i].sName, m_sValueHsmsPara1[i], TRUE );
	}
}
//--------------------------------------------------------------------
// SetRegistryTab4()
//--------------------------------------------------------------------
void CSetupItems::SetRegistryTabCVMotorParaView()
{
/*
	for( int i=0; i<m_nItemNoCvMotorPara; i++ )
	{
		CString sBuf1;
		m_fValueCvMotorRatio[i] = m_fValueCvMotorRatioTemp[i];
		sBuf1.Format( "%.1f", m_fValueCvMotorRatio[i] );
		m_IniSetUpInfo.SetStringValue( "C/V MOTOR RATIO", m_infoCvMotorPara[i].sName, sBuf1, TRUE );

		m_fValueCvMotorDia[i] = m_fValueCvMotorDiaTemp[i];
		sBuf1.Format( "%.1f", m_fValueCvMotorDia[i] );
		m_IniSetUpInfo.SetStringValue( "C/V MOTOR DIAMETER", m_infoCvMotorPara[i].sName, sBuf1, TRUE );

		m_fValueCvMotorVelRatio[i] = m_fValueCvMotorVelRatioTemp[i];
		sBuf1.Format( "%.3f", m_fValueCvMotorVelRatio[i] );
		m_IniSetUpInfo.SetStringValue( "C/V MOTOR VELOCITY", m_infoCvMotorPara[i].sName, sBuf1, TRUE );
	}
*/
}

//--------------------------------------------------------------------
// SetRegistryTab5()
//--------------------------------------------------------------------
void CSetupItems::SetRegistryTabDVParaView()
{
	m_IniSetUpInfo.Open("DV PARA","SETUPINFO");

	for( int i=0; i<m_nItemNoDvName; i++ )
	{
		m_sValueDvName[i] = m_sValueDvNameTemp[i];
		m_IniSetUpInfo.SetStringValue( "D/V PARAMETER", m_sItemDvName[i], m_sValueDvName[i], TRUE );
	}
}