// SetupItems.h: interface for the CSetupItems class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SETUPITEMS_H__A849BD0D_9D48_446A_8696_7A26F70C1DE2__INCLUDED_)
#define AFX_SETUPITEMS_H__A849BD0D_9D48_446A_8696_7A26F70C1DE2__INCLUDED_

#include "..\X\XCtlDevice.h"
#include "..\FactoryLib\IniData.h"	// Added by ClassView
#include "..\FactoryLib\EqpAssy.h"	

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSetupItems : public CObject  
{
public:
	CSetupItems();
	virtual ~CSetupItems();
	XCtlDevice * m_pDevice;
	void SetDevice( XCtlDevice * pDevice ){m_pDevice = pDevice;}
	CEqpAssy* m_pEqpAssy;
	void SetEqpAssy( CEqpAssy* pEqpAssy ){m_pEqpAssy = pEqpAssy;}

public:
	CIniData	m_IniSetUpInfo;

	static SETUP_INFO	m_infoSetup[];
	static SETUP_INFO	m_infoIdleRun[];

	static CString		m_sItemBathCoverIntr[];
	static CString		m_sItemDoorIntr[];
	static CString		m_sItemLeakDetectIntr[];
	static CString		m_sItemFFUAlarmIntr[];
	static CString		m_sItemBrokenIntr[];
	static CString		m_sItemETCIntr[];

	static SETUP_INFO	m_infoGaugeLimit[];
	static SETUP_INFO	m_infoInterfacePara[];
	static SETUP_INFO	m_infoHsmsPara[];
	static SETUP_INFO	m_infoHsmsPara1[];
	static SETUP_INFO	m_infoPartsLifeTimePara[];
	static SETUP_INFO	m_infoHpmjPara[];

	static CString		m_sItemCvLength[];
	static CV_INFO		m_infoCvMotorPara[];
	static CString		m_sNameTankLevel[];
	static int			m_nGageLimitAddress[];
	static CString		m_sItemInSensorOffTimeOut[];
	static CString		m_sItemOutSensorOffTimeOut[];
	static CString		m_sItemDvName[];

	int*		m_nValueSetup_Option;
	CString*	m_sValueSetup;
	int*		m_nValueIdleRun;
	int*		m_nValueInSensorOffTimeOut;
	int*		m_nValueOutSensorOffTimeOut;

	int*		m_nValueBathCoverIntr;
	int*		m_nValueDoorIntr;
	int*		m_nValueLeakDetectIntr;
	int*		m_nValueFFUAlarmIntr;
	int*		m_nValueBrokenIntr;
	int*		m_nValueETCIntr;

	int*		m_nValueGaugeLimit[4];
	int*		m_nValueGaugeLimit_Option;
	int*		m_nValueTankLevel;
	int*		m_nValuePartsLifeTimePara[2];
	CString*	m_sValueInterfacePara;
	CString*	m_sValueHsmsParaTemp;
	CString*	m_sValueHsmsParaTemp1;
	double*		m_fValueCvLength;
	double*		m_fValueCvMotorVelRatio;
	double*		m_fValueCvMotorRatio;
	double*		m_fValueCvMotorDia;
	CString*	m_sValueDvName;

	// Save for the calibration of C/V distance
	int m_nCvSpeed;
	BOOL m_bCalReq;
	BOOL m_bCalCancel;

	int*		m_nValueSetup_OptionTemp;
	CString*	m_sValueSetupTemp;
	int*		m_nValueIdleRunTemp;
	int*		m_nValueInSensorOffTimeOutTemp;
	int*		m_nValueOutSensorOffTimeOutTemp;

	int*		m_nValueBathCoverIntrTemp;
	int*		m_nValueDoorIntrTemp;
	int*		m_nValueLeakDetectIntrTemp;
	int*		m_nValueFFUAlarmIntrTemp;
	int*		m_nValueBrokenIntrTemp;
	int*		m_nValueETCIntrTemp;
	
	int*		m_nValueGaugeLimitTemp[4];
	int*		m_nValueGaugeLimit_OptionTemp;
	int*		m_nValueTankLevelTemp;
	int*		m_nValuePartsLifeTimeParaTemp[2];
	CString*	m_sValueHsmsPara;
	CString*	m_sValueHsmsPara1;
	CString*	m_sValueInterfaceParaTemp;
	CString*	m_sValueDvNameTemp;
	double*		m_fValueCvLengthTemp;
	double*		m_fValueCvMotorVelRatioTemp;
	double*		m_fValueCvMotorRatioTemp;
	double*		m_fValueCvMotorDiaTemp;
	double*		m_fValueCvSensorTime;

	int			m_nItemNoSetup;
	int			m_nItemNoIdleRun;
	int         m_nItemNoInSensorTimeOut;
	int         m_nItemNoOutSensorTimeOut;

	int			m_nItemNoBathCoverIntr;
	int			m_nItemNoDoorIntr;
	int			m_nItemNoLeakDetectIntr;
	int			m_nItemNoFFUAlarmIntr;
	int			m_nItemNoBrokenIntr;
	int			m_nItemNoETCIntr;
	
	int			m_nItemNoGaugeLimit;
	int			m_nItemNoInterfacePara;
	int			m_nItemNoPartsLifeTimePara;
	int			m_nItemNoCvLength;
	int			m_nItemNoCvMotorPara;
	int			m_nItemNoTankLevel;

	int			m_nItemNoHsmsPara;
	int			m_nItemNoHsmsPara1;
	int			m_nItemNoDvName;

	static CString    m_sValueHpmjPara[4][MAX_AI_INTR_NO];

	enum { optionPASS_MODE, modePROCESS_MODE };
	enum { optionNO_USE, optionUSE };
	enum { optionNO_CHECK, optionCHECK };

	enum optionSETUP_INFO { optionNONE, optionBOOL1, optionBOOL2, optionBOOL3, optionBOOL4, optionBOOL5, optionBOOL6,
							optionTRI_STATE1, optionTRI_STATE2 };
	enum formatSETUP_INFO  { formatNONE, formatDIGIT, formatFLOAT, formatSTRING, formatHEX };

	enum nameSETUP_INFO
	{
		setupDI_PUMP1_USE,
		setupSBJ_USE,
		setupUP_LD_UNIT_BROKEN_SENSOR,
		setupLD_UNIT_SCAN_SENSOR,
		setupUL_UNIT_SCAN_SENSOR,
		setupBUF_UNIT_SCAN_SENSOR,	// 121002 halesu
		setupUSE_EUV,
		setupEUV1_LIFE_TIME,
		setupEUV2_LIFE_TIME,
		setupEUV3_LIFE_TIME,
		setupEUV4_LIFE_TIME,
		setupUP_CV_NORMAL_SPEED,
		setupUP_CV_HI_SPEED,
		setupUP_CV_DECEL_SPEED,
		setupLD_CV_DECEL_SPEED,
		setupGLASS_SIZE,
		setupMAX_GLASS_NO,
		setupCV_TIMEOUT_DISTANCE,
		setupLD_UNIT_GLASS_STOP_DISTANCE,
		setupUL_UNIT_GLASS_STOP_DISTANCE,
		setupPUMP_INTERLOCK_CHECK_TIME,
		setupPUMP_INTERLOCK_FLOW_RATE,	
		setupRB_SERVO1_USE,
		setupRB_SERVO2_USE,
		setupRB_SERVO3_USE,
		setupRB_SERVO4_USE,
		setupEQP_INITIAL_TIME,
		setupLEVEL_SENSOR_CONFIRM_TIME,
		setupIDLE_WAIT_TIME,
		setupAK_INTERLOCK,
		setupTIMER_RESET_TIME,	// halesu
		setupAK_OUT_WAITING_TIMEOUT,	// 141229 halesu
		setupDI_ECO_USE,	// 240730 halesu
		setupDI_ECO_CEHCK_POS,	// 250208 halesu
		setupAK_ECO_USE,	// 240730 halesu
		setupJOB_MODE,
		setupPLASMA_USED,
		setupPLASMA_POWER_SET,
		setupPLASMA_N2_MFC_SET,
		setupPLASMA_CDA_MFC_SET,
		setupHPMJ_RUN_MODE,
		setupHPMJ_FRQ_SET,
	};

	enum nameNO_USE
	{
		setupHPMJ_USE,
	};

	enum nameTANK_LEVEL
	{
		levelDI_TANK_H,
		levelDI_TANK_M,
		levelDI_TANK_L,
		levelDI_TANK_LL,
	};
	enum namePARTS_LIFETIME
	{
#ifndef _NO_RB
		partsRB_1,
		partsRB_2,
		partsRB_3,
		partsRB_4,
#endif
		partsDI_FILTER1,
		partsDI_FILTER2,
		partsCDA_FILTER1,
		partsCDA_FILTER2,
		partsCDA_FILTER3,
	};
#ifdef _NO_RB
	enum nameEXTRA
	{
		partsRB_1,
		partsRB_2,
		partsRB_3,
		partsRB_4,
	};
#endif
	enum nameIDLERUN_INFO
	{ 
		idleDIW_ZONE_USE,
		idleDIW_IDLE_STOP_TIME,
		idleDIW_IDLE_RUN_TIME,
		idleUPPER_RB1_DIR,
		idleLOWER_RB1_DIR,
		idleUPPER_RB2_DIR,
		idleLOWER_RB2_DIR,
		idleUPPER_RB1_SPEED,
		idleLOWER_RB1_SPEED,
		idleUPPER_RB2_SPEED,
		idleLOWER_RB2_SPEED,
	};

	enum nameCOVER_INTR
	{
		intrCOVER_OPEN1,
		intrCOVER_OPEN2,
		intrCOVER_OPEN3,
		intrCOVER_OPEN4,
		intrCOVER_OPEN5,
		intrCOVER_OPEN6,
	};

	enum nameDOOR_INTR
	{
		intrDOOR_OPEN1,
		intrDOOR_OPEN2,
		intrDOOR_OPEN3,
		intrDOOR_OPEN4,
		intrDOOR_OPEN5,
		intrDOOR_OPEN6,
		intrDOOR_OPEN7,
		intrDOOR_OPEN8,
		intrDOOR_OPEN9,
		intrDOOR_OPEN10,
		intrDOOR_OPEN11,
		intrDOOR_OPEN12,
		intrDOOR_OPEN13,
		intrDOOR_OPEN14,
		intrDOOR_OPEN15,
		intrDOOR_OPEN16,
		intrDOOR_OPEN17,
		intrDOOR_OPEN18,
		intrDOOR_OPEN19,
		intrDOOR_OPEN20,
		intrDOOR_OPEN21,
		intrDOOR_OPEN22,
		intrDOOR_OPEN23,
	};

	enum nameLEAK_INTR
	{
		intrLEAK_SENSOR1, 
		intrLEAK_SENSOR2, 
		intrLEAK_SENSOR3, 
		intrLEAK_SENSOR4, 	
	};

	enum nameFFU_INTR
	{
		intrFFU1,
		intrFFU2,
		intrFFU3,
		intrFFU4,
		intrFFU5,
		intrFFU6,
		intrFFU7,
		intrFFU8,
		intrFFU9,
		intrFFU10,
	};

	enum nameBROKEN_INTR
	{
		intrLD_UNIT_BROKEN_SENSOR1,
		intrLD_UNIT_BROKEN_SENSOR2,
		intrLD_UNIT_BROKEN_SENSOR3,
		intrLD_UNIT_BROKEN_SENSOR4,
		intrLD_UNIT_BROKEN_SENSOR,
		intrUL_UNIT_BROKEN_SENSOR,
	};

	enum nameETC_INTR
	{
		intrIONIZER1,
		intrEUV_LEVEL1,
		intrEUV_LEVEL2,
		intrEUV_LEVEL3,
	};

	enum nameIN_SENSOR_OFF_TIME
	{
		insensorOFF_TIMEOUT_LD_UNIT_FRONT,
		insensorOFF_TIMEOUT_EUV_UNIT_FRONT,
		insensorOFF_TIMEOUT_RB_UNIT_FRONT,
		insensorOFF_TIMEOUT_FR_UNIT_FRONT,
		insensorOFF_TIMEOUT_AK_UNIT_FRONT,
		insensorOFF_TIMEOUT_UL_UNIT_FRONT,
	};

	enum nameOUT_SENSOR_OFF_TIME
	{
		outsensorOFF_TIMEOUT_LD_UNIT_FRONT,
		outsensorOFF_TIMEOUT_EUV_UNIT_FRONT,
		outsensorOFF_TIMEOUT_RB_UNIT_FRONT,
		outsensorOFF_TIMEOUT_FR_UNIT_FRONT,
		outsensorOFF_TIMEOUT_AK_UNIT_FRONT,
		outsensorOFF_TIMEOUT_UL_UNIT_FRONT,
	};

	enum nameGAUGE_LIMIT
	{										
		gaugeEUV_UNIT_ACID_EXT,					//  1
		gaugeRB_UNIT_AC_CDA_PRESS,				//  2
		gaugeRB_UNIT_EXT1_EXT,					//  3
		gaugeRB_UNIT_EXT2_EXT,					//  4
		gaugeFR_UNIT_EXT1_EXT,					//  5
		gaugeFR_UNIT_EXT2_EXT,					//  6
		gaugeRB_UNIT_UP_SHW_FLOW,				//  7
		gaugeRB_UNIT_LO_SHW_FLOW,				//  8
		gaugeRB_UNIT_SBJ1_DI_FLOW,				//  9
		gaugeFR_UNIT_SBJ2_DI_FLOW,				//  10
		gaugeFR_UNIT_SBJ3_DI_FLOW,				//  11
		gaugeFR_UNIT_SBJ_LO_SHW_FLOW,			//  12
		gaugeFR_UNIT_SHW_FLOW,					//  13
		gaugeFR_UNIT_AQU_SHW_FLOW,				//  14
		gaugeFR_UNIT_TANK_DI_RESISTER,			//  15
		gaugeFR_UNIT_DI_RESISTER,				//  16
		gaugeAK_UNIT_UP_AK_EXT1_PRESS,			//  17
		gaugeAK_UNIT_UP_AK_EXT2_PRESS,			//  18
		gaugeAK_UNIT_LO_AK_EXT_PRESS,			//  19
		gaugeAK_UNIT_UP_AK_CDA_PRESS,			//  20
		gaugeAK_UNIT_LO_AK_CDA_PRESS,			//  21
		gaugeAK_UNIT_UP_AK_CDA_FLOW,			//  22
		gaugeAK_UNIT_LO_AK_CDA_FLOW,			//  23
		gaugeUL_UNIT_SBJ1_CDA_PRESS,			//  24
		gaugeUL_UNIT_SBJ2_CDA_PRESS,			//  25
		gaugeUL_UNIT_SBJ3_CDA_PRESS,			//  26
		gaugeUL_UNIT_SBJ1_CDA_FLOW,				//  27
		gaugeUL_UNIT_SBJ2_CDA_FLOW,				//  28
		gaugeUL_UNIT_SBJ3_CDA_FLOW,				//  29
		gaugeUL_UNIT_DRIVING_AIR_PRESS,			//  30
	};

	enum nameHPMJ
	{
		gaugeHPMJ_UNIT_SHOWER_FLOW,
		gaugeHPMJ_UNIT_FILTER_IN_PRESS,
		gaugeHPMJ_UNIT_FILTER_OUT_PRESS,
		gaugeHPMJ_UNIT_MAIN_DI_PRESS,
		gaugeHPMJ_UNIT_RESISTIVITY,		
		gaugeHPMJ_UNIT_CO2_PRESS,
		gaugeHPMJ_UNIT_INVERTER_CURRENT,
		gaugeHPMJ_UNIT_FILTER_DIFFER_PRESS,
	};

	enum nameINTERFACE_PARA
	{ 
		melsecMELSLOT_NO,
		melsecNETWORK_NO,
		melsecSTATION_NO,
		timeoutINTERFACE_T1,	// Cause by UPS - Measure by DWS	: Warning
		timeoutINTERFACE_T3,	// Cause by DWS - Measure by UPS	: Transfer Stop & Recovery
		timeoutINTERFACE_T4,	// Cause by DWS - Measure by UPS	: Transfer Stop & Recovery
		timeoutINTERFACE_T6,	// Cause by UPS - Measure by DWS	: Transfer Stop & Recovery
		timeoutINTERFACE_T8,	// Cause by DWS - Measure by UPS	: Transfer Stop & Recovery
	};

	enum nameHSMS_PARA
	{ 
		hsmsINIT_COMM_STATE,
		hsmsINIT_CONTROL_STATE,
		hsmsCOMM_TIMEOUT,
		hsmsHEART_BEAT,
		hsmsT3,
		hsmsT5,
		hsmsT6,
		hsmsT7,
		hsmsT8,
		hsmsT9,
		hsmsLINK_TEST_TIMER,
		hsmsDEVICE_ID,
		hsmsPORT_NUMBER,
		hsmsIP_ADDRESS,
		hsmsCONNECTION_MODE,
		hsmsEQP_ID,
		hsmsPROCESS_ID,
		hsmsINDEX_ID
//		hsmsMDLN,
//		hsmsSOFTREV,
//		hsmsT3_RETRY_NO,
	};

public:
	void InitSetupItems();
	void InitTempVarTabJobCondView();
	void InitTempVarTabInterlockSetView();
	void InitTempVarTabInterlockSet2View();
	void InitTempVarTabCVDistanceSetView();
	void InitTempVarTabCVMotorParaView();
	void InitTempVarTabInterfaceParaView();
	void InitTempVarTabInterfaceParaView1();
	void InitTempVarTabDVParaView();
	BOOL IsSetupChangedTabJobCondView();
	BOOL IsSetupChangedTabInterlockSetView();
	BOOL IsSetupChangedTabInterlockSet2View();
	BOOL IsSetupChangedTabCVDistanceSetView();
	BOOL IsSetupChangedTabCVMotorParaView();
	BOOL IsSetupChangedTabInterfaceParaView();
	BOOL IsSetupChangedTabInterfaceParaView1();
	BOOL IsSetupChangedTabDVParaView();
	void GetRegistryTabJobCondView();
	void GetRegistryTabInterlockSetView();
	void GetRegistryTabInterlockSet2View();
	void GetRegistryTabCVDistanceSetView();
	void GetRegistryTabCVMotorParaView();
	void GetRegistryTabInterfaceParaView();
	void GetRegistryTabInterfaceParaView1();
	void GetRegistryTabDVParaView();
	void SetRegistryTabJobCondView();
	void SetRegistryTabInterlockSetView();
	void SetRegistryTabInterlockSet2View();
	void SetRegistryTabCVDistanceSetView();
	void SetRegistryTabCVMotorParaView();
	void SetRegistryTabInterfaceParaView();
	void SetRegistryTabInterfaceParaView1();
	void SetRegistryTabDVParaView();
};

#endif // !defined(AFX_SETUPITEMS_H__A849BD0D_9D48_446A_8696_7A26F70C1DE2__INCLUDED_)
